<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

require_once(dirname(dirname(dirname(dirname(__FILE__)))).'/wp-load.php');

require_once(dirname(__FILE__).'/include/amazon.lib.php');
require_once(dirname(__FILE__).'/include/wpbfuncs.php');
require_once(dirname(__FILE__).'/include/keywords_generator.php');

global $query_string;

$advads171_preview = FALSE;
$advads171_preview_kws = '';
$advads171_preview_general = FALSE;
$advads171_tpl_key = 0;

$advads171_is_virtual = FALSE;
if (isset($_GET['is_virtual']) && $_GET['is_virtual'] == 'yes')
{
	$advads171_is_virtual = TRUE;
}


if (isset($_GET['preview_general']) && $_GET['preview_general'] == 'yes') 
{
	$advads171_preview_general = TRUE;
	advads171_clear_js_cache();
}
$advads171_tpls = advads171_active_tpls($advads171_preview_general);
$advads171_tpl_keys = array_keys($advads171_tpls);

if (isset($_GET['tpl']) && is_numeric($_GET['tpl']) && in_array($_GET['tpl'], $advads171_tpl_keys))
{
	$advads171_tpl_key = $_GET['tpl'];
}
$advads171_tpl = $advads171_tpls[$advads171_tpl_key];

//Error. No active amazon templates found
$advads171_real_active_tpls = advads171_active_tpls();
if (isset($_GET['preview']) && $_GET['preview'] == 'yes' && !in_array('tpl_am3across', $advads171_real_active_tpls) && !in_array('tpl_am1product', $advads171_real_active_tpls) && in_array($advads171_tpl_key, array(0, 1)))
{
	exit;
	echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('CClose', $advads171_plugin_slug).'</div>'.__('Error', $advads171_plugin_slug).'! '.__('Please activate at least one of the Amazon templates!', $advads171_plugin_slug)));
}

if (isset($_GET['preview_general']) && $_GET['preview_general'] == 'yes')
{
	$advads171_preview_general = TRUE;
	advads171_clear_js_cache();
}
else
{
	if (isset($_GET['preview']) && $_GET['preview'] == 'yes')
	{
		$advads171_preview = TRUE;
		$advads171_preview_kws = $_POST['preview_keywords'];
	}	
	
	//get post id
	$post_id = '';
	if (isset($_GET['post_id']) && is_numeric($_GET['post_id']))
	{
		$post_id = $_GET['post_id'];
	}
	if ($post_id == '') 
	{	
		if ($advads171_preview === TRUE)
		{
			echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div>'.__('Error! No post id found!', $advads171_plugin_slug).''));
			exit;
		}
		else
		{
			echo json_encode(array('html' => 'error'));
			exit;
		}		
	}

	//does post exist?
	$curr_post = get_post( $post_id, $output );
	if ((!isset($curr_post->ID) || $curr_post->ID != $post_id) && ($advads171_is_virtual === FALSE)) 
	{
		if ($advads171_preview === TRUE)
		{
			//echo '<div onclick="javascript: pbox_close();" class="am_close_advads">Close</div>';
			//exit('Error! Post with post id '.$post_id.' doesn\'t exist.');
		}
		else
		{
			echo json_encode(array('html' => 'error'));
			exit;
		}
	}

	if (in_array($advads171_tpl, array('tpl_am3across', 'tpl_am1product')))
	{
		//do we have kws?
		if ($advads171_preview === TRUE && strlen($advads171_preview_kws) > 0)
		{
			//use preview keywords
			$advads171_kws_str = $advads171_preview_kws;
		}
		else
		{
			//use saved keywords
			$advads171_kws_str = get_post_meta($curr_post->ID, 'advads171_keywords', true);
		}
		
		//use virtual post keywords
		if ($advads171_is_virtual && isset($_GET['s']) && strlen($_GET['s']) > 0)
		{
			$advads171_kws_str = strip_tags(urldecode($_GET['s']));
		}
		
		//use serp keywords
		$advads171_get_serp_kw_str = advads171_get_serp_kw_str();
		if ($advads171_get_serp_kw_str != '') $advads171_kws_str = $advads171_get_serp_kw_str;
		
		//use custom defined keywords		
		if (strlen($advads171_kws_str) < 2)
		{
			//get kws settings
			$advads171_kw_sources = array();
			$advads171_kw_sources_str = advads171_get_option('advads171_kw_sources');
			if (strlen($advads171_kw_sources_str) > 0)
			{
				$advads171_kw_sources = explode(',', $advads171_kw_sources_str);
			}
			
			if (in_array('custom', $advads171_kw_sources) && function_exists('advads171_custom_keyword_source'))
			{				
				$advads171_custom_keywords = advads171_custom_keyword_source('amzn', $post_id);
				if ($advads171_custom_keywords !== FALSE && is_array($advads171_custom_keywords) && count($advads171_custom_keywords) > 0)
				{
					$advads171_kws_str = implode(',', $advads171_custom_keywords);
				}
			}
		}
		
		
		if (strlen($advads171_kws_str) < 2)
		{
			//create kws
			//$advads171_content = strip_tags($curr_post->post_content);
			$custom_query = new WP_Query( array( 'post_type' => $curr_post->post_type, 'post__in' => array( $curr_post->ID ) ) );
			$advads171_i = 0;
			$advads171_post_content = '';
			while($custom_query->have_posts() && $advads171_i == 0)
			{
				$custom_query->the_post();
				$advads171_post_content = apply_filters('the_content',get_the_content());
				$advads171_i++;
			}
			wp_reset_postdata();
			
			if (strlen($advads171_post_content) > 0)
			{
				$advads171_post_content = advads171_remove_html($advads171_post_content);
				$advads171_post_content = strip_tags($advads171_post_content);
			}			
			
			$advads171_content = $advads171_post_content;
			$advads171_post_title = '';
			if (isset($post) && isset($post->post_title))
			{
				$advads171_post_title = $post->post_title;
			}
			$advads171_kws = advads171_gen_kws($advads171_content, $advads171_post_title, $post_id);
			
			if (count($advads171_kws) == 0) 
			{
				if ($advads171_preview === TRUE)
				{
					echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div>'.__('Error! No keywords found.', $advads171_plugin_slug).''));
					exit;
				}
				else
				{
					echo json_encode(array('html' => 'error'));
					exit; //no kws found :(
				}
			}
			if (count($advads171_kws) > 0)
			{
				//save kws in custom meta
				$advads171_kws = array_slice($advads171_kws, 0, 5);
				update_post_meta($post_id, 'advads171_keywords', implode(', ', $advads171_kws));
			}
		}
		else
		{
			//got keywords? lets turn them into an array
			$advads171_kws = explode(',', trim(str_replace(', ', ',', $advads171_kws_str)));
			$advads171_kws = array_slice($advads171_kws, 0, 5);
		}
		//string of all keywords can sometimes return the best results. adding all keywords as a first element of array
		if (stripos(implode(' ', $advads171_kws), 'asin:') === FALSE)
		{
			//$advads171_kws = array_merge(array(implode(' ', $advads171_kws)), $advads171_kws);	//this causes delays
		}
		

		if (count($advads171_kws) == 0) 
		{
			if ($advads171_preview === TRUE)
			{
				echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div>'.__('Error! Looks like there are no keywords.', $advads171_plugin_slug)));
				exit;
			}
			else
			{
				echo json_encode(array('html' => 'error'));
				exit;	//come on, we need kws
			}
		}
	}
	
}

if (in_array($advads171_tpl, array('tpl_am3across', 'tpl_am1product'))):
	
	//get API credentials
	$advads171_locale = advads171_get_locale();
	
	//if user country not supported - show nothing or fallback country listings
	if ($advads171_locale == 'smthelse' && ($advads171_preview === TRUE || $advads171_preview_general === TRUE))
	{
		echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div> '.sprintf(__('Error. Your country %s is not supported or not set up. <br />You can set a fallback country under Advanced settings in Misc. box.', $advads171_plugin_slug), strtoupper(advads171_get_locale(FALSE))).''));
		exit;
	}
	elseif ($advads171_locale == 'smthelse')
	{
		echo json_encode(array('html' => 'error'));
		exit;	//user country not supported and the admin said 'silence!'
	}

	$advads171_am_params = array(
							'key_id' => get_option('advads171_am_key_id'), 
							'access_key' => get_option('advads171_am_access_key'),
							'associate_tag' => advads171_get_locale_tag($advads171_locale)
							);
	advads171_cache_cleanup();

	if ($advads171_preview_general === TRUE)
	{
		$advads171_data = advads171_am_preview_results($advads171_am_params, 1, $advads171_locale);
	}
	else
	{
		$advads171_data = advads171_get_pop_data($post_id, $advads171_kws, $advads171_am_params, $advads171_locale);
		/*echo '<pre>';
		print_r($advads171_data);
		echo '</pre>';*/
	}
		
		if ($advads171_data !== FALSE && count($advads171_data) > 0):

			ob_start();
			if (isset($advads171_data['ad']) && $advads171_data['ad'] == true && isset($advads171_data['html'])): 
				echo $advads171_data['html'];
			else: 
				
				$i = 0;		
				?>
				<div class="pop_title_advads"><?php _e('Check Out These Products!', $advads171_plugin_slug); ?></div>
				<?php if ($advads171_tpl == 'tpl_am3across'): ?>
					<?php $advads171_amzn_cart_enabled = advads171_get_option('amzn_cart_enabled'); ?>
					<?php foreach($advads171_data as $asin => $result): ?>
						<?php 
						if ($i < 3)
						{
							//$advads171_url = site_url('wp-content/plugins/advads171/go.php?url='.urlencode($result['url']));
							//$advads171_url = site_url('wp-content/plugins/advads171/go_advads.php?url_advads='.advads171_base64_url_encode($result['url']));
							$advads171_url = $result['url'];							
							
							if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons) && $advads171_amzn_cart_enabled == 'yes' && isset($result['OfferListingId']) && $result['OfferListingId'] != '')
							{								
								if ($advads171_locale == 'us')	$advads171_url = 'http://www.amazon.com/gp/aws/cart/add.html';
								if ($advads171_locale == 'jp')	$advads171_url = 'http://www.amazon.co.jp/gp/aws/cart/add.html';
								if ($advads171_locale == 'uk' || $advads171_locale == 'gb')	$advads171_url = 'http://www.amazon.co.uk/gp/aws/cart/add.html';
								if ($advads171_locale == 'de')	$advads171_url = 'http://www.amazon.de/gp/aws/cart/add.html';
								if ($advads171_locale == 'fr')	$advads171_url = 'http://www.amazon.fr/gp/aws/cart/add.html';
								if ($advads171_locale == 'ca')	$advads171_url = 'http://www.amazon.ca/gp/aws/cart/add.html';
								if ($advads171_locale == 'it')	$advads171_url = 'http://www.amazon.it/gp/aws/cart/add.html';
								if ($advads171_locale == 'es')	$advads171_url = 'http://www.amazon.es/gp/aws/cart/add.html';
								if ($advads171_locale == 'cn')	$advads171_url = 'http://www.amazon.cn/gp/aws/cart/add.html';
								$advads171_url .= '?AWSAccessKeyId='.$advads171_am_params['key_id'].'&AssociateTag='.$advads171_am_params['associate_tag'];
								$advads171_url .= '&ASIN.1='.$result['asin'].'&Quantity.1=1&OfferListingId.1='.$result['OfferListingId'];
							}
							
							
						?>
						<div class="product_wrap_advads">
							<span class="prod_title_advads">
								<a href="<?=$advads171_url;?>" rel="nofollow external" class="advads171_ext_link" am_asin="<?=$result['asin'];?>" target="_blank"><?=$result['name'];?></a>				
							</span>
							
							<a href="<?=$advads171_url;?>" class="prod_img_link advads171_ext_link" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank"><img src="<?=(strlen($result['image']) > 0?$result['image']:site_url('wp-content/plugins/advads171/images/no_image.gif'));?>" <?=(isset($result['img_width']) && isset($result['img_height']) && $result['img_width'] < 218 && $result['img_height'] < 200 && $result['img_width'] > 0 && $result['img_width'] > 0?'style="width: '.$result['img_width'].'; height: '.$result['img_height'].'; margin-top: '.floor((200 - $result['img_height']) / 2).'px;"':'');?> /></a>
							<span class="price_wrap_advads">
								<?php //if (isset($result['list_price'])): ?>
									<span class="list_price_advads"><?=(isset($result['list_price'])?$result['list_price']:'');?></span>
								<?php //endif; ?>
								<?php if (isset($result['price']) && $result['price'] == 'Too low to display'): ?>
									<span class="real_price_advads"><a href="<?=$advads171_url;?>" rel="nofollow external" class="advads171_ext_link price_link" am_asin="<?=$result['asin'];?>" target="_blank">See Price</a></span>
								<?php else: ?>
									<span class="real_price_advads"><a href="<?=$advads171_url;?>" rel="nofollow external" class="advads171_ext_link price_link" am_asin="<?=$result['asin'];?>" target="_blank"><?=(isset($result['price'])?$result['price']:'');?></a></span>
								<?php endif; ?>								
							</span>
							
						
							<?php if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons) && $advads171_amzn_cart_enabled == 'yes' && isset($result['OfferListingId']) && $result['OfferListingId'] != ''): ?>
							<?php
							$advads171_amzn_cart_btn_text_3prods = advads171_get_option('amzn_cart_btn_text_3prods');
							$advads171_addtocart_tpl1 = advads171_get_option('addtocart_tpl1');
							if ($advads171_amzn_cart_btn_text_3prods === FALSE || strlen(trim($advads171_amzn_cart_btn_text_3prods)) == 0) $advads171_amzn_cart_btn_text_3prods = 'Add To Cart';
							?>
								<a href="<?=$advads171_url;?>" class="buy_now_advads buy_now_advads171_text amzn_buy_now_advads171_text advads171_ext_link" style="display: block;" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank">
									<?php if ($advads171_addtocart_tpl1 !== FALSE && strlen($advads171_addtocart_tpl1) > 0): ?>
										<img src="<?=$advads171_addtocart_tpl1;?>" />
									<?php else: ?>
										<?php echo $advads171_amzn_cart_btn_text_3prods; ?>
									<?php endif; ?>
								</a>
							<?php else: ?>
								<a href="<?=$advads171_url;?>" class="buy_now_advads buy_now_advads171_text amzn_buy_now_advads171_text advads171_ext_link" style="display: block;" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank">Details</a>
							<?php endif; ?>
							
						</div>
						<?php
						}
						$i++;
						?>
					<?php endforeach; ?>
				<?php else: ?>
					<?php $advads171_amzn_cart_enabled = advads171_get_option('amzn_cart_enabled'); ?>
					<?php
					$advads171_product_keys = array_keys($advads171_data);
					$result = $advads171_data[$advads171_product_keys[0]];
					$advads171_url = $result['url'];
					
					if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons) && $advads171_amzn_cart_enabled == 'yes' && isset($result['OfferListingId']) && $result['OfferListingId'] != '')
					{								
						if ($advads171_locale == 'us')	$advads171_url = 'http://www.amazon.com/gp/aws/cart/add.html';
						if ($advads171_locale == 'jp')	$advads171_url = 'http://www.amazon.co.jp/gp/aws/cart/add.html';
						if ($advads171_locale == 'uk' || $advads171_locale == 'gb')	$advads171_url = 'http://www.amazon.co.uk/gp/aws/cart/add.html';
						if ($advads171_locale == 'de')	$advads171_url = 'http://www.amazon.de/gp/aws/cart/add.html';
						if ($advads171_locale == 'fr')	$advads171_url = 'http://www.amazon.fr/gp/aws/cart/add.html';
						if ($advads171_locale == 'ca')	$advads171_url = 'http://www.amazon.ca/gp/aws/cart/add.html';
						if ($advads171_locale == 'it')	$advads171_url = 'http://www.amazon.it/gp/aws/cart/add.html';
						if ($advads171_locale == 'es')	$advads171_url = 'http://www.amazon.es/gp/aws/cart/add.html';
						if ($advads171_locale == 'cn')	$advads171_url = 'http://www.amazon.cn/gp/aws/cart/add.html';
						$advads171_url .= '?AWSAccessKeyId='.$advads171_am_params['key_id'].'&AssociateTag='.$advads171_am_params['associate_tag'];
						$advads171_url .= '&ASIN.1='.$result['asin'].'&Quantity.1=1&OfferListingId.1='.$result['OfferListingId'];
					}
					?>
					<div class="prod_title_large_advads prod_title_advads171_stats"><a href="<?=$advads171_url;?>" class="advads171_ext_link" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank"><?=$result['name'];?></a></div>
					<a href="<?=$advads171_url;?>" class="prod_img_link_large advads171_ext_link" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank"><img src="<?=(strlen($result['large_image']) > 0?$result['large_image']:site_url('wp-content/plugins/advads171/images/no_image.gif'));?>" <?=(isset($result['large_image_width']) && isset($result['large_image_height']) && $result['large_image_width'] < 270 && $result['large_image_height'] < 270 && $result['large_image_width'] > 0 && $result['large_image_width'] > 0?'style="width: '.$result['large_image_width'].'; height: '.$result['large_image_height'].'; margin-top: '.floor((270 - $result['large_image_height']) / 2).'px;"':'');?> /></a>
					<div class="prod_description_advads"><a href="<?=$advads171_url;?>" class="advads171_ext_link" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank"><?=strip_tags($result['description']);?></a></div>
					
					<div class="price_btn_wrap_advads">
						<span class="price_wrap_advads">
							<?php //if (isset($result['list_price'])): ?>
								<span class="list_price_advads"><?=(isset($result['list_price'])?$result['list_price']:'');?></span>
							<?php //endif; ?>
							<?php if (isset($result['price']) && $result['price'] == 'Too low to display'): ?>
								<span class="real_price_advads"><a href="<?=$advads171_url;?>" rel="nofollow external" class="advads171_ext_link price_link" am_asin="<?=$result['asin'];?>" target="_blank">See Price</a></span>
							<?php else: ?>
								<span class="real_price_advads"><a href="<?=$advads171_url;?>" rel="nofollow external" class="advads171_ext_link price_link" am_asin="<?=$result['asin'];?>" target="_blank">Price: <?=(isset($result['price'])?$result['price']:'');?></a></span>
							<?php endif; ?>								
						</span>
					
					
						<?php if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons) && $advads171_amzn_cart_enabled == 'yes' && isset($result['OfferListingId']) && $result['OfferListingId'] != ''): ?>
							<?php
							$advads171_amzn_cart_btn_text_1prod = advads171_get_option('amzn_cart_btn_text_1prod');
							$advads171_addtocart_tpl2 = advads171_get_option('addtocart_tpl2');
							if ($advads171_amzn_cart_btn_text_1prod === FALSE || strlen(trim($advads171_amzn_cart_btn_text_1prod)) == 0) $advads171_amzn_cart_btn_text_1prod = 'Add To Cart';
							?>
								<a href="<?=$advads171_url;?>" class="buy_now_large_advads buy_now_large_advads171_text amzn_buy_now_large_advads171_text advads171_ext_link" style="display: block;" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank">
									<?php if ($advads171_addtocart_tpl2 !== FALSE && strlen($advads171_addtocart_tpl2) > 0): ?>
										<img src="<?=$advads171_addtocart_tpl2;?>" />
									<?php else: ?>
										<?php echo $advads171_amzn_cart_btn_text_1prod; ?>
									<?php endif; ?>
								</a>
						<?php else: ?>
							<a href="<?=$advads171_url;?>" class="buy_now_large_advads buy_now_large_advads171_text amzn_buy_now_large_advads171_text advads171_ext_link" style="display: block;" rel="nofollow external" am_asin="<?=$result['asin'];?>" target="_blank">Details</a>
						<?php endif; ?>
					</div>
				<?php endif; ?>
				<div style="clear: both; height: 1px; display: block;"></div>
				
				<a href="http://www.amazon.com/gp/bestsellers/?ie=UTF8&tag=<?=advads171_get_locale_tag($advads171_locale);?>&linkCode=ur2&camp=1789&creative=390957" class="am_link_advads" target="_blank">Amazon.com</a>
				
				<div onclick="javascript: pbox_close();" class="am_close_advads am_close_btn_advads"><img src="<?=site_url('wp-content/plugins/advads171/blank.gif');?>" /></div>
	
				<div onclick="javascript: pbox_close();" class="am_close_advads am_close_txt">Close</div>
				<div class="advads171_poweredby">Powered by <a href="http://contextazon.com" rel="external nofollow" target="_blank" ><?php echo $advads171_plugin_name; ?></a></div>
				
				<?php 
			endif;
			$advads171_pop_html = ob_get_contents();
			ob_end_clean();
			echo json_encode(array('html' => $advads171_pop_html));
		
		else: 
			if ($advads171_preview === TRUE || $advads171_preview_general === TRUE)
			{
				echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div> '.__('No results found. Try different keywords.', $advads171_plugin_slug)));
				exit;
			}
			else
			{
				echo json_encode(array('html' => 'error'));
				exit; 
			}
		endif;
elseif(in_array($advads171_tpl, array('tpl_custom1', 'tpl_custom2', 'tpl_custom3'))):
	//get custom html
	if (isset($_POST['preview_custom_html_data']) && function_exists('current_user_can') && current_user_can( 'manage_options' ) )
	{
		$advads171_custom_html = $_POST['preview_custom_html_data'];
	}
	else
	{
		$advads171_custom_html = advads171_get_option($advads171_tpl.'_custom_html');
	}
	$advads171_custom_html = stripslashes($advads171_custom_html);
	//extract javasc src
	$advads171_custom_html_check = str_replace("&amp;", "&", $advads171_custom_html);
	$advads171_custom_html_check = str_replace("&", "&amp;", $advads171_custom_html_check);

	$advads171_dom = new DomDocument;
	$advads171_dom->recover = true;
	$advads171_dom->strictErrorChecking = false;
	@$advads171_dom->loadHTML( $advads171_custom_html_check );

	$advads171_elems = $advads171_dom->getElementsByTagName('script');

	$advads171_js_srcs = array();
	$advads171_js_src_loc = '';
	if (count($advads171_elems) > 0)
	{
		foreach ( $advads171_elems as $elm ) {
			$src_val = $elm->getAttribute('src');
			$advads171_js_srcs[] = '<script type="text/javascript" '.(strlen($src_val) > 0?'src="'.$src_val.'"':'').'>'.$elm->nodeValue.'</script>';
		}
		$advads171_custom_html = preg_replace('/<script\b[^>]*>(.*?)<\/script>/is', "", $advads171_custom_html);
		$advads171_custom_html = preg_replace('/<noscript\b[^>]*>(.*?)<\/noscript>/is', "", $advads171_custom_html);	
	
		//cache and prepare javascript	
		if (count($advads171_js_srcs) > 0)
		{
			$js_content_all = implode("", $advads171_js_srcs);
				$cache_file_name = dirname(__FILE__).'/js_cache/'.md5($js_content_all).".html";
				if (!file_exists($cache_file_name))
				{
					$fp = fopen($cache_file_name, 'w');
					fwrite($fp, '<html style="width: 100%; margin: 0; padding: 0; border: 0;"><head></head><body style="width: 100%; margin: 0; padding: 0; border: 0;">'.$js_content_all.'</body></html>');
					fclose($fp);
				}
				$advads171_js_src_loc = plugins_url( 'js_cache/'.md5($js_content_all).".html" , __FILE__ );
			
		}
	}
	//print_r($advads171_js_srcs);
	ob_start();
	?>
	<div class="pop_title_advads">Check Out These Products!</div>
	<div class="advads171_custom_html_wrap">
		<?php echo $advads171_custom_html;?>
	</div>
	<div style="clear: both; height: 1px; display: block;"></div>
	
	<div onclick="javascript: pbox_close();" class="am_close_advads am_close_btn_advads"><img src="<?=site_url('wp-content/plugins/advads171/blank.gif');?>" /></div>
	
	<div onclick="javascript: pbox_close();" class="am_close_advads am_close_txt">Close</div>
	<div id="advads171_js_content"></div>
	<?php //if (advads171_get_option('license') == 'free' || get_option('advads171_branding') == 'yes' || $advads171_preview_general === TRUE): ?>
	<div class="advads171_poweredby">Powered by <a href="http://contextazon.com" rel="external nofollow" target="_blank" ><?php echo $advads171_plugin_name; ?></a></div><?php //endif; ?>
	
	<?php
	$advads171_pop_html = ob_get_contents();
	ob_end_clean();
	echo json_encode(array('html' => $advads171_pop_html, 'jscripts' => $advads171_js_src_loc));

endif;
