<?php
if(!defined('ABSPATH')) die('Direct access not permitted');


require_once(dirname(dirname(__FILE__)).'/libraries/validation.php');
$validation = new advads171_validation;
//banners
require_once(dirname(dirname(__FILE__)).'/models/banners.php');
$banner = new advads171_banners;
$available_sizes = $banner->available_sizes();
$available_positions = $banner->available_positions();
$available_animations = $banner->available_animations(FALSE, '');
$available_templates = $banner->available_templates();
$available_search_methods = $banner->available_search_methods();
$banners_data = $banner->banners_data();

$advads171_subpage = 'list';
if (isset($_GET['subpage']) && in_array($_GET['subpage'], array('add', 'edit', 'delete'))) $advads171_subpage = $_GET['subpage'];

if ( !empty($_POST ) && '' == $error ) {
	/*echo '<div id="message" class="updated fade"><p><strong>'
	. __('Settings saved.') ;
	if (isset($advads171_additional_success) && $advads171_additional_success != '')
	{
		echo "<br />".$advads171_additional_success;
	}
	echo '</strong></p></div>';*/
	if (isset($advads171_wpfooter_warning) && $advads171_wpfooter_warning != '')
	{
		echo '<div id="message" class="error"><p><strong>'
	. __($advads171_wpfooter_warning) . '</strong></p></div>';
	}
}

if ($advads171_subpage == 'list')
{		
	
	include(dirname(dirname(__FILE__)).'/views/ad_units.php');
}
elseif ($advads171_subpage == 'add')
{
	//Add New Ad Unit Page
	
	//declare validation rules
	$validation->set_rule('ad_unit_name', 'Name', 'trim|required');
	$validation->set_rule('advads171_size', 'Banner Size', 'required');
	$validation->set_rule('advads171_template', 'Color Scheme', 'required');
	$validation->set_rule('advads171_position', 'Banner Placement', 'required|check_sticky');
	$validation->set_rule('advads171_animation', 'Banner Animation', 'required');
	$validation->set_rule('advads171_salebadge', 'Sale Badge', 'required');
	$validation->set_rule('advads171_amlink', 'Amazon Link', 'required');
	$validation->set_rule('advads171_interval', 'Animation Interval', 'required');
	$validation->set_rule('advads171_search_method', 'Product Search Method', 'required');
	$validation->set_rule('advads171_active', 'Active Status', 'required');
	$validation->set_rule('advads171_banner_keyword', 'Banner Keyword', '');
	$validation->set_rule('advads171_single_only', 'Restrict to Post/Page View', 'required');
	$validation->set_rule('advads171_alignment', 'Alignment', 'required');
	$validation->set_rule('advads171_margin_top', 'Margin Top', 'trim|is_numeric');
	$validation->set_rule('advads171_margin_right', 'Margin Right', 'trim|is_numeric');
	$validation->set_rule('advads171_margin_bottom', 'Margin Bottom', 'trim|is_numeric');
	$validation->set_rule('advads171_margin_left', 'Margin Left', 'trim|is_numeric');
	if (in_array($_POST['advads171_size'], array(3, 5, 6)))
	{
		$validation->set_rule('advads171_btn_text', 'Button Text', 'required');
	}
	//$validation->show_rules();
	
	if ($validation->run() === TRUE)
	{
		$new_banner = array(
						'name' => $_POST['ad_unit_name'],
						'active' => $_POST['advads171_active'],
						'size' => $_POST['advads171_size'],
						'template' => $_POST['advads171_template'],
						'position' => $_POST['advads171_position'],
						'animation' => $_POST['advads171_animation'],
						'salebadge' => $_POST['advads171_salebadge'],
						'amlink' => $_POST['advads171_amlink'],
						'interval' => $_POST['advads171_interval'],
						'search_method' => $_POST['advads171_search_method'],
						'keyword' => $_POST['advads171_banner_keyword'],
						'single_only' => $_POST['advads171_single_only'],
						'alignment' => $_POST['advads171_alignment'],
						'btn_text' => $_POST['advads171_btn_text'],
						'margin_top' => $_POST['advads171_margin_top'],
						'margin_right' => $_POST['advads171_margin_right'],
						'margin_bottom' => $_POST['advads171_margin_bottom'],
						'margin_left' => $_POST['advads171_margin_left']
						);
		$new_banner_id = $banner->add_new($new_banner);
		
		echo '<div id="message" class="updated fade"><p><strong>'
		. sprintf(__('Banner Added.<br /><a href="admin.php?page=advads171-ad_units&subpage=edit&banner_id=%s">Click Here to Edit the Banner.</a>', $advads171_plugin_slug), $new_banner_id);
		echo '</strong></p></div>';
		exit;
		
		//echo 'Save here!';
	}
	else
	{
		$available_animations = $banner->available_animations(FALSE, $_POST['advads171_size']);
	}
	//$validation->debug();
	include(dirname(dirname(__FILE__)).'/views/ad_unit_add.php');
}
elseif ($advads171_subpage == 'edit')
{
	//Edit Ad Unit Page
	$banner_id = FALSE;
	if (isset($_GET['banner_id']) && is_numeric($_GET['banner_id']) && isset($banners_data['banners'][$_GET['banner_id']]))
	{
		$banner_id = $_GET['banner_id'];
	}
	if ($banner_id === FALSE)
	{
		include(dirname(dirname(__FILE__)).'/views/ad_units.php');
	}
	else
	{
		$edit_banner_default = $banners_data['banners'][$_GET['banner_id']];
		
		//declare validation rules
		$validation->set_rule('ad_unit_name', 'Name', 'trim|required');
		$validation->set_rule('advads171_size', 'Banner Size', 'required');
		$validation->set_rule('advads171_template', 'Color Scheme', 'required');
		$validation->set_rule('advads171_position', 'Banner Placement', 'required|check_sticky');
		$validation->set_rule('advads171_animation', 'Banner Animation', 'required');
		$validation->set_rule('advads171_salebadge', 'Sale Badge', 'required');
		$validation->set_rule('advads171_amlink', 'Amazon Link', 'required');
		$validation->set_rule('advads171_interval', 'Animation Interval', 'required');
		$validation->set_rule('advads171_search_method', 'Product Search Method', 'required');
		$validation->set_rule('advads171_active', 'Active Status', 'required');
		$validation->set_rule('advads171_banner_keyword', 'Banner Keyword', '');
		$validation->set_rule('advads171_single_only', 'Restrict to Post/Page View', 'required');
		$validation->set_rule('advads171_alignment', 'Alignment', 'required');
		$validation->set_rule('advads171_margin_top', 'Margin Top', 'trim|is_numeric');
		$validation->set_rule('advads171_margin_right', 'Margin Right', 'trim|is_numeric');
		$validation->set_rule('advads171_margin_bottom', 'Margin Bottom', 'trim|is_numeric');
		$validation->set_rule('advads171_margin_left', 'Margin Left', 'trim|is_numeric');
		if (in_array($_POST['advads171_size'], array(3, 5, 6)))
		{
			$validation->set_rule('advads171_btn_text', 'Button Text', 'required');
		}
		//$validation->show_rules();
		
		$available_animations = $banner->available_animations(FALSE, $edit_banner_default['size']);
		
		if ($validation->run() === TRUE)
		{
			$edit_banner = array(
							'name' => $_POST['ad_unit_name'],
							'active' => $_POST['advads171_active'],
							'size' => $_POST['advads171_size'],
							'template' => $_POST['advads171_template'],
							'position' => $_POST['advads171_position'],
							'animation' => $_POST['advads171_animation'],
							'salebadge' => $_POST['advads171_salebadge'],
							'amlink' => $_POST['advads171_amlink'],
							'interval' => $_POST['advads171_interval'],
							'search_method' => $_POST['advads171_search_method'],
							'keyword' => $_POST['advads171_banner_keyword'],
							'single_only' => $_POST['advads171_single_only'],
							'alignment' => $_POST['advads171_alignment'],
							'btn_text' => $_POST['advads171_btn_text'],
							'margin_top' => $_POST['advads171_margin_top'],
							'margin_right' => $_POST['advads171_margin_right'],
							'margin_bottom' => $_POST['advads171_margin_bottom'],
							'margin_left' => $_POST['advads171_margin_left']
							
							);
			$banner->edit($banner_id, $edit_banner);
			echo '<div id="message" class="updated fade"><p><strong>'
			. __('Changes saved.') ;
			if (isset($advads171_additional_success) && $advads171_additional_success != '')
			{
				echo "<br />".$advads171_additional_success;
			}
			echo '</strong></p></div>';
			//echo 'Save here!';
			$banners_data = $banner->banners_data();
			$edit_banner_default = $banners_data['banners'][$_GET['banner_id']];
			$available_animations = $banner->available_animations(FALSE, $edit_banner_default['size']);
		}
		else
		{
			if (isset($_POST['advads171_size']))
			{
				$available_animations = $banner->available_animations(FALSE, $_POST['advads171_size']);
			}
		}
		
		
		include(dirname(dirname(__FILE__)).'/views/ad_unit_edit.php');
	}
}
elseif ($advads171_subpage == 'delete')
{
	$banner_id = FALSE;
	if (isset($_GET['banner_id']) && is_numeric($_GET['banner_id']) && isset($banners_data['banners'][$_GET['banner_id']]))
	{
		$banner_id = $_GET['banner_id'];
		unset($banners_data['banners'][$banner_id]);
		advads171_update_option('ad_units', serialize($banners_data));
		echo '<div id="message" class="updated fade"><p><strong>'.__('Banner Deleted.') ;
		echo '<br /><a href="admin.php?page=advads171-ad_units">'.__('Go Back to Banners').'</a>';
		echo '</strong></p></div>';
				
	}
	else
	{
		echo '<div id="message" class="updated fade"><p><strong>'.__('Banner Not Found.') ;
		echo '<br /><a href="admin.php?page=advads171-ad_units">'.__('Go Back to Banners').'</a>';
		echo '</strong></p></div>';
		
	}	
}