<?php
if(!defined('ABSPATH')) die('Direct access not permitted');

$per_page = 20;
$page_num = 1;

require_once(dirname(dirname(__FILE__)).'/libraries/pagination.php');
$p = new advads_pagination;
$p->parameterName('paging');

require_once(dirname(dirname(__FILE__)).'/models/banners.php');
$banners_model = new advads171_banners;
$banners_data = $banners_model->banners_data();
$available_sizes = $banners_model->available_sizes();

$sql_where_arr = array();

//date ranges
$range_from_raw = date('U', strtotime('- 14 days'));
$range_to_raw = date('U');

if (isset($_GET['range_from']))
{
	$from_arr = explode('-', $_GET['range_from']);
	if (count($from_arr) == 3)
	{
		$range_from_raw = date('U', mktime(0, 0, 0, $from_arr[1], $from_arr[0], substr($from_arr[2], 2, 2)));
	}
}
if (isset($_GET['range_to']))
{
	$to_arr = explode('-', $_GET['range_to']);
	if (count($to_arr) == 3)
	{
		$range_to_raw = date('U', mktime(23, 59, 59, $to_arr[1], $to_arr[0], substr($to_arr[2], 2, 2)));
	}
}

$sql_where_arr[] = "timestamp > '".$wpdb->escape($range_from_raw)."'";
$sql_where_arr[] = "timestamp < '".$wpdb->escape($range_to_raw)."'";

$filter_banner_id = 'all';
if (isset($_GET['banner_id']) && is_numeric($_GET['banner_id']) && isset($banners_data['banners'][$_GET['banner_id']]))
{
	$filter_banner_id = $_GET['banner_id'];
	$sql_where_arr[] = "banner_id = ".$wpdb->escape($filter_banner_id);
}

$filter_action = 'all';
if (isset($_GET['filter_action']) && in_array($_GET['filter_action'], array('views', 'clicks')))
{
	$filter_action = $_GET['filter_action'];
	if ($filter_action == 'views')
	{
		$sql_where_arr[] = "collect_type = '0'";
	}
	elseif ($filter_action == 'clicks')
	{
		$sql_where_arr[] = "collect_type = '1'";
	}
}

if (isset($_GET[$p->parameterName]) && is_numeric($_GET[$p->parameterName]))
{
	$page_num = $_GET[$p->parameterName];
	if ($page_num < 1) $page_num = 1;
}

$order_by = " ORDER BY timestamp DESC";
$sql_where = " 1 ";
if (count($sql_where_arr) > 0)
{
	$sql_where = implode(" AND ", $sql_where_arr)." ";
}

$sql_limit = " LIMIT ".(($page_num - 1) * $per_page).",".$per_page;
$sql = "SELECT * FROM ".$wpdb->prefix."advads171_stats_detailed WHERE ".$sql_where.$order_by.$sql_limit;

$items = $wpdb->get_results($sql);

$total_res = $wpdb->get_row("SELECT COUNT(*) as total FROM ".$wpdb->prefix."advads171_stats_detailed WHERE ".$sql_where);
$total = 0;
if (isset($total_res->total) && is_numeric($total_res->total))
{
	$total = $total_res->total;
}
 
if($total > 0) {
        
        $p->items($total);
        $p->limit($per_page); // Limit entries per page
        $p->target("admin.php?page=advads171-visitor-log&banner_id=".$filter_banner_id."&filter_action=".$filter_action."&range_from=".date('d-m-Y', $range_from_raw)."&range_to=".date('d-m-Y', $range_to_raw).""); 
        $p->currentPage($_GET[$p->parameterName]); // Gets and validates the current page
        $p->calculate(); // Calculates what to show
        
        $p->adjacents(1); //No. of page away from the current page
                 
        if(!isset($_GET[$p->parameterName])) {
            $p->page = 1;
        } else {
            $p->page = $_GET[$p->parameterName];
        }
         
        //Query for limit paging
        $limit = "LIMIT " . ($p->page - 1) * $p->limit  . ", " . $p->limit;
         
} else {
    echo "No Record Found";
}

require_once(dirname(dirname(__FILE__)).'/views/visitor_log/list.php');