<?php
class advads171_banners
{
	
    public function __construct()
	{

	}
	
	public function available_sizes()
	{
		$sizes = array(
						'1' => '468 x 60',
						'2' => '728 x 90',
						'3' => '250 x 250',
						'4' => '200 x 200',
						'5' => '336 x 280',
						'6' => '300 x 250',
						'7' => '120 x 600',
						'8' => '160 x 600',
						'12' => '468 x 220',
						/*'51' => '180 x 500',*/
						);
		return $sizes;
	}
	
	public function available_positions()
	{
		$positions = array(						
						'1' => 'Widget',
						'2' => 'Short Code',
						'3' => 'Before Content',
						'4' => 'After Content',
						'5' => 'PHP Tag',				
						'7' => 'HTML Code'				
						);
		if (advads171_module_installed('amasticky_banner')) $positions['6'] = 'Sticky';
		return $positions;
	}
	
	/*public function available_animations()
	{
		$animations = array(
						'1' => 'None',
						'2' => 'Top to Bottom',
						//'3' => 'Bottom to Top',
						//'4' => 'Top to Top',
						//'5' => 'Bottom to Bottom',
						'6' => 'Left to Left',
						'7' => 'Right to Right',
						'8' => 'Mixed Directions',
						'9' => 'Bingo',
						'10' => 'Fade Out - Fade In'
						);
		return $animations;
	}*/
	
	public function available_animations($return_full = FALSE, $parent_id = 0)
	{
		$animations = array(
						'1' => array(
								'name' => 'None',
								'parents' => array(0)
								),
						'2' => array(
								'name' => 'Drop From the Top',
								'parents' => array(1, 2, 12)
								),
						/*'3' => 'Bottom to Top',*/
						/*'4' => 'Top to Top',
						'5' => 'Bottom to Bottom',*/
						'6' => array(
								'name' => 'Left to Left',
								'parents' => array(1, 2, 7, 8, 9, 12)
								),
						'7' => array(
								'name' => 'Right to Right',
								'parents' => array(1, 2, 7, 8, 9, 12)
								),
						'8' => array(
								'name' => 'Mixed Directions',
								'parents' => array(1, 2, 12)
								),
						'9' => array(
								'name' => 'Up - Down - (Up)',
								'parents' => array(1, 2, 12)
								),
						'10' => array(
								'name' => 'Fade Out - Fade In',
								'parents' => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 12)
								),
						'21' => array(
								'name' => 'Spin In/Out',
								'parents' => array(3, 4, 5, 6)
								),
						'22' => array(
								'name' => 'Drop from the Top',
								'parents' => array(3, 4, 5, 6)
								),
						'23' => array(
								'name' => 'Slide-In',
								'parents' => array(3, 4, 5, 6)
								),
						'30' => array(
								'name' => 'Left/Right Mix Up',
								'parents' => array(7, 8, 9)
								),
						);
		if ($return_full === TRUE)
		{
			return $animations;
		}
		else
		{
			//make a simple array
			$new_animations = array();
			foreach($animations as $key => $val)
			{
				if ($parent_id == 0 || in_array($parent_id, $val['parents']) || in_array(0, $val['parents']))
				{
					$new_animations[$key] = $val['name'];
				}
			}
			return $new_animations;
		}		
	}
	
	public function available_templates()
	{
		$templates = array(
						'1' => 'Blue',
						'2' => 'Red',
						'3' => 'Purple',
						'4' => 'Golden/Yellow',
						'5' => 'Brown',
						'6' => 'Green'
						);
		return $templates;
	}
	
	//amazon product search method
	public function available_search_methods()
	{
		$search_methods = array(
						'1' => 'Keywords Only',
						'2' => 'Similar Products',
						'3' => 'Accessories',

						);
		return $search_methods;
	}
	
	
	public function add_new($banner = '')
	{
		if (is_array($banner))
		{			
			$banners_data = $this->banners_data();
			$banner['id'] = $banners_data['last_id'] + 1;
			$banners_data['last_id'] = $banner['id'];
			//$banners_data['banners'] = array_merge($banners_data['banners'], array($banner['id'] => $banner));
			$banners_data['banners'][$banner['id']] = $banner;

			if (function_exists('advads171_update_option'))
			{
				advads171_update_option('ad_units', serialize($banners_data));
			}
			return $banner['id'];
		}
		return FALSE;
	}
	
	public function edit($banner_id = '0', $banner = '')
	{
		if (is_array($banner))
		{			
			$banners_data = $this->banners_data();
			$banner['id'] = $banner_id;
			$banners_data['banners'][$banner_id] = $banner;

			if (function_exists('advads171_update_option'))
			{
				advads171_update_option('ad_units', serialize($banners_data));
			}
			return TRUE;
		}
		return FALSE;
	}
	
	public function banners_data()
	{
		if (function_exists('advads171_get_option'))
		{
			$current_banners_str = advads171_get_option('ad_units');
			$banners_data = unserialize($current_banners_str);
			if (is_array($banners_data) && is_array($banners_data['banners'])) return $banners_data;
		}
		return array(
				'banners' => array(),
				'last_id' => 1
				);
	}
	
	public function get_by_id($banner_id = 0)
	{
		if ($banner_id != 0)
		{
			$banners_data = $this->banners_data();
			if (isset($banners_data['banners'][$banner_id]))
			{
				return $banners_data['banners'][$banner_id];
			}
		}
		return FALSE;
	}
	
	public function banner_html_init($banner_id = FALSE, $banner = FALSE, $post_id = 0, $content = '')
	{
		global $advads171_unique_banner_id;
		$debugg_advads = FALSE;
		if ($banner_id === FALSE) return '';
		if ($banner === FALSE)
		{
			$banners_data = $this->banners_data();
			if (is_array($banners_data) && is_array($banners_data['banners'])) $banner = $banners_data['banners'][$banner_id];
		}
		
		if (!isset($banner['active']) || $banner['active'] == 'no') return '';
		
		//check if restrict to single
		if (isset($banner['single_only']) && $banner['single_only'] == 'yes' && $post_id != 0 && !is_single($post_id)) return '';
		
		//check if hide on certain post types		
		$advads171_posttypes = explode(',', get_option('advads171_posttypes'));
		if ($post_id != 0)
		{			
			$post_type = get_post_type($post_id);
			if (!in_array($post_type, $advads171_posttypes))
			{
				return '';
			}			
		}
		//check if hide on front page
		if (!in_array('front_page', $advads171_posttypes) && is_front_page())
		{
			return '';
		}
		
		
		$html = '<div class="advads171_banner advads171_banner_'.$banner_id.' advads171_banner_unq_'.$advads171_unique_banner_id.'" style="';
		
		if ($banner['size'] == '1') $html .= 'width: 468px; height: 60px;';
		if ($banner['size'] == '2') $html .= 'width: 728px; height: 90px;';
		if ($banner['size'] == '3') $html .= 'width: 250px; height: 250px;';
		if ($banner['size'] == '4') $html .= 'width: 200px; height: 200px;';
		if ($banner['size'] == '5') $html .= 'width: 336px; height: 280px;';
		if ($banner['size'] == '6') $html .= 'width: 300px; height: 250px;';
		if ($banner['size'] == '7') $html .= 'width: 120px; height: 600px;';
		if ($banner['size'] == '8') $html .= 'width: 160px; height: 600px;';
		if ($banner['size'] == '12') $html .= 'width: 468px; height: 220px;';
		
		//margins
		if ($banner['position'] != '6') $html .= ' margin-top: '.$banner['margin_top'].'px;';
		if ($banner['position'] != '6') $html .= ' margin-bottom: '.$banner['margin_bottom'].'px;';
		if ($banner['alignment'] != 'center') $html .= ' margin-left: '.$banner['margin_left'].'px;';
		if ($banner['alignment'] != 'center') $html .= ' margin-right: '.$banner['margin_right'].'px;';
		
		//alignment settings
		if ($banner['alignment'] == 'left') $html .= ' float: left; clear: left;';
		if ($banner['alignment'] == 'right') $html .= ' float: right; clear: right;';
		if ($banner['alignment'] == 'center') $html .= ' margin-left: auto; margin-right: auto; clear: both;';
		
		//sticky banner
		if ($banner['position'] == '6') {
			$html .= ' position: fixed; top: 50px;';
			if ($banner['alignment'] == 'left') $html .= ' left: 10px;';
			if ($banner['alignment'] == 'right') $html .= ' right: 10px;';
		}
		
		$html .= '"></div>';
		/*echo '<pre>';
		print_r($banner);
		print_r($banners_data);
		echo '</pre>';*/
		
		//is plugin enabled through settings?
		$plugin_enabled = get_option('advads171_active');
		if (is_numeric($plugin_enabled) && $plugin_enabled == '1') 
		{
		}
		else
		{
			return '';
		}
		
		//check if selected to hide banners on this page/post
		$meta_disable = get_post_meta($post_id, 'advads171_disable', true);
		if ($meta_disable == 'on') return '';
		
		$epn_enabled = advads171_get_option('epn_enabled');
		$amzn_enabled = advads171_get_option('advads171_amzn_active');
		if (is_numeric($amzn_enabled) && $amzn_enabled == '1') 
		{
			$aff_network = 'amz';
			if ($debugg_advads) echo '<br />advads: '.__LINE__;
		}
		else
		{
			$aff_network = 'epn';
			if ($debugg_advads) echo '<br />advads: '.__LINE__;
		}
		//both amzn and epn disabled
		if (is_numeric($epn_enabled) && $epn_enabled == '0' && is_numeric($amzn_enabled) && $amzn_enabled == '0')
		{
			return '';
		}
		
		//get network
		
		if (advads171_module_installed('epn'))
		{
			$epn_enabled = advads171_get_option('epn_enabled');
			if (is_numeric($epn_enabled) && $epn_enabled == '1')
			{
				$source_sequence = advads171_get_option('source_sequence');
				$epn_pops_share = advads171_get_option('epn_pops_share');
				if (($source_sequence + ($advads171_unique_banner_id * 10)) <= $epn_pops_share)
				{
					$aff_network = 'epn';
					if ($debugg_advads) echo '<br />advads: '.__LINE__;
				}
			}
		}
		//check if epn or amzn turned off for the category
		$categories = get_the_category($post_id);
		/*echo '<pre>';
		print_r($categories);
		echo '</pre>';*/		
		$cat_epn_off = false;
		$cat_amzn_off = false;
		if (is_array($categories) && count($categories) > 0)
		{
			$amzn_disabled_categories = explode(',', get_option('advads171_amzn_disabled_categories'));
			$epn_disabled_categories = explode(',', get_option('advads171_epn_disabled_categories'));
			foreach($categories as $curr_category)
			{
				if (in_array($curr_category->term_id, $amzn_disabled_categories))
				{
					$cat_amzn_off = true;
				}
				if (in_array($curr_category->term_id, $epn_disabled_categories))
				{
					$cat_epn_off = true;
				}
			}
			
			//amzn off but epn on
			
			if ($cat_amzn_off === TRUE && advads171_module_installed('epn') && is_numeric($epn_enabled) && $epn_enabled == '1' && $cat_epn_off === FALSE)
			{
				$aff_network = 'epn';
				if ($debugg_advads) echo '<br />advads: '.__LINE__;
			}
			//epn off but amzn on
			
			if ($cat_epn_off === TRUE && is_numeric($amzn_enabled) && $amzn_enabled == '1' && $cat_amzn_off === FALSE)
			{
				$aff_network = 'amz';
				if ($debugg_advads) echo '<br />advads: '.__LINE__;
			}
			//both amzn and epn off
			if ($cat_epn_off === TRUE && $cat_amzn_off === TRUE)
			{
				return '';
			}
			//amzn disabled but epn unchecked
			if (is_numeric($amzn_enabled) && $amzn_enabled == '0' && $cat_epn_off === TRUE)
			{
				return '';
			}
			//epn disabled but amzn unchecked
			if (is_numeric($epn_enabled) && $epn_enabled == '0' && $cat_amzn_off === TRUE)
			{
				return '';
			}
		}
		
		//trying epn but capmaign id not set up
		if ($aff_network == 'epn')
		{
			$epn_campaign_id = advads171_get_option('epn_campaign_id');
			if (strlen($epn_campaign_id) == 0)
			{
				$aff_network = 'amz';
				if ($debugg_advads) echo '<br />advads: '.__LINE__;
			}
		}
		
		//epn is disabled for the country but amz is on
		$user_country = advads171_get_locale();
		if ($user_country == 'gb') $user_country = 'uk';
		$epn_country_enabled = advads171_get_option('epn_country_enabled_'.$user_country);
		if (is_numeric($epn_country_enabled) && $epn_country_enabled == '1')
		{
			$epn_country_enabled = TRUE;
		}
		else
		{
			$epn_country_enabled = FALSE;
		}
		$amz_assoc_tag_option = 'advads171_am_associate_tag';
		if ($user_country != 'us')
		{
			$amz_assoc_tag_option = 'advads171_locale_tag_'.$user_country;
		}
		$amz_country_tag = get_option($amz_assoc_tag_option);
		$amz_country_enabled = FALSE;		
		if ($amz_country_tag !== FALSE && strlen($amz_country_tag) > 1)
		{
			$amz_country_enabled = TRUE;
		}
		//Country specific: epn off - amz on 
		if ($aff_network == 'epn' && $epn_country_enabled === FALSE && $amz_country_enabled === TRUE)
		{
			$aff_network = 'amz';
			if ($debugg_advads) echo '<br />advads: '.__LINE__;
		}
		//Country specific: epn on - amz off 
		if ($aff_network == 'amz' && $amz_country_enabled === FALSE && $epn_country_enabled === TRUE)
		{
			$aff_network = 'epn';
			if ($debugg_advads) echo '<br />advads: '.__LINE__;
		}
		
		/*echo '<br />user_country:'.$user_country;
		echo '<br />aff_network:'.$aff_network;
		echo '<br />epn_country_enabled:';
		var_dump($epn_country_enabled);
		echo '<br />amz_country_enabled:';
		var_dump($amz_country_enabled);*/
		
		
		//add js
		$interval = intval($banner['interval']);
		if ($interval < 1) $interval = 1; 
		$interval = $interval * 1000;
		$html .= '<script type="text/javascript">jQuery(document).ready(function(){if (window.advads_load_banner) { advads_load_banner(\''.$banner_id.'\', \''.$post_id.'\', \''.$banner['animation'].'\', \''.$interval.'\', \''.$banner['size'].'\', \''.$advads171_unique_banner_id.'\', \''.$aff_network.'\'); } });</script>';
		
		if ($banner['position'] == '6') 
		{
			$curr_height = '600';
			if ($banner['size'] == '1') $curr_height = '60';
			if ($banner['size'] == '2') $curr_height = '90';
			if ($banner['size'] == '3') $curr_height = '250';
			if ($banner['size'] == '4') $curr_height = '200';
			if ($banner['size'] == '5') $curr_height = '280';
			if ($banner['size'] == '6') $curr_height = '250';

			$html .= '<script type="text/javascript">jQuery(document).ready(function(){ var top_diff = (jQuery(window).height() - '.$curr_height.'); if ( top_diff < 0) { top_diff = "20";} jQuery(".advads171_banner_'.$banner_id.'").css("top", (top_diff / 2)); jQuery(window).resize(function() {  var top_diff = (jQuery(window).height() - '.$curr_height.'); if ( top_diff < 0) { top_diff = "20";} jQuery(".advads171_banner_'.$banner_id.'").css("top", (top_diff / 2)); }); });</script>';
		}
		
		//$html .= '<script type="text/javascript">if (window.advads_load_banner) { advads_load_banner(\''.$banner_id.'\', \''.$post_id.'\', \''.$banner['animation'].'\', \''.$interval.'\'); };</script>';
		$advads171_unique_banner_id++;
		
		return $html;
	}
	
	
	
}