<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

if(!defined('ABSPATH')) die('Direct access not premitted');

echo '<div class="wrap"><img src="'.plugin_dir_url( dirname(dirname(__FILE__)) ).'images/'.advads171_branding_img().'" style="display: block; float: right;" /><h2>' . __('Add New Banner', $advads171_plugin_slug) . '</h2>';

$validation->show_errors();
?>

<form method="post" action="" id="important_stuff_form" name="important_stuff_form" >
	<table class="form-table" style="width:750px;">
		<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php _e('If you have any questions check out our <a href="http://contextazon.com/faq" target="_blank">FAQ</a>', $advads171_plugin_slug);?></td></tr>
		<?php if (strlen($error) > 0): ?>
			<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
		<?php endif; ?>
		<tr><td colspan="2">
			<div class="metabox-holder">
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug ); ?>"><br /></div>
					<h3 class="hndle">Banner Settings</h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">			
							<tr class="form-field"><th style="width:150px;"><label for="ad_unit_name"><?php _e('Banner Name', $advads171_plugin_slug);?>:</label></th>
								<td>
									<input type="text" name="ad_unit_name" style="width:220px;" value="<?php echo $validation->set_value('ad_unit_name'); ?>" id="ad_unit_name" />
									<span class="description"><?php _e('Not visible on the site', $advads171_plugin_slug); ?></span>
									<?php $validation->show_error('ad_unit_name'); ?>
								</td></tr>
							<tr class="form-field"><th style="width:150px;"><label for="advads171_size"><?php _e('Banner Size', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_size" id="advads171_size" onchange="javascript: advads_replace_anim_options(this.value); if (this.value == '3' || this.value == '5' || this.value == '6') {jQuery('.advads_btntxt_option').removeClass('advads_hide_option');} else {jQuery('.advads_btntxt_option').addClass('advads_hide_option');}">
									<option value=""><?php _e('-- Select Banner Size --', $advads171_plugin_slug); ?> &nbsp; </option>
									<?php foreach($available_sizes as $size_id => $size): ?>
										<option value="<?php echo $size_id; ?>"  <?php echo $validation->set_select('advads171_size', $size_id); ?>><?php echo $size; ?> px &nbsp; </option>
									<?php endforeach; ?>
								</select>
								<?php $validation->show_error('advads171_size'); ?>
								
							</td></tr>
							<tr class="form-field"><th style="width:150px;"><label for="advads171_position"><?php _e('Placement', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_position" id="advads171_position">
									<option value=""><?php _e('-- Select Banner Placement --', $advads171_plugin_slug); ?> &nbsp; </option>
									<?php foreach($available_positions as $position_id => $position_name): ?>
										<option value="<?php echo $position_id; ?>" <?php echo $validation->set_select('advads171_position', $position_id); ?>><?php echo $position_name; ?> &nbsp; </option>
									<?php endforeach; ?>
								</select>
								<?php $validation->show_error('advads171_position'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_template"><?php _e('Color Scheme', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_template" id="advads171_template">
									<option value=""><?php _e('-- Select Color Scheme --', $advads171_plugin_slug); ?> &nbsp; </option>
									<?php foreach($available_templates as $template_id => $template_name): ?>
										<option value="<?php echo $template_id; ?>"  <?php echo $validation->set_select('advads171_template', $template_id); ?>><?php echo $template_name; ?> &nbsp; </option>
									<?php endforeach; ?>
								</select>
								<?php $validation->show_error('advads171_template'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_animation"><?php _e('Animation', $advads171_plugin_slug); ?>:</label></th>
							<td>
								<div id="advads171_animation_wrap">
									<select name="advads171_animation" id="advads171_animation"  onchange="javascript: if (this.value == '1' || this.value == '') {jQuery('.advads_animint_option').addClass('advads_hide_option');} else {jQuery('.advads_animint_option').removeClass('advads_hide_option');}">
										<option value=""><?php _e('-- Select Banner Animation --', $advads171_plugin_slug); ?> &nbsp; </option>
										<?php foreach($available_animations as $animation_id => $animation_name): ?>
											<option value="<?php echo $animation_id; ?>" <?php echo $validation->set_select('advads171_animation', $animation_id); ?>><?php echo $animation_name; ?> &nbsp; </option>
										<?php endforeach; ?>
									</select>
								</div>
								<?php $validation->show_error('advads171_animation'); ?>								
							</td></tr>
							
							<tr class="form-field advads_animint_option <?php echo ($validation->set_select('advads171_animation', '1') == 'selected' || $validation->set_select('advads171_animation', '') == 'selected'?'advads_hide_option':'' ); ?>"><th style="width:150px;"><label for="advads171_interval"><?php _e('Animation Interval', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" name="advads171_interval" style="width:220px;" value="<?php echo $validation->set_value('advads171_interval', $edit_banner_default['interval']); ?><?php if ($validation->set_value('advads171_interval', $edit_banner_default['interval']) == '') { echo '4'; } ?>" id="ad_unit_name" />
									
								<span class="description"><?php _e('Interval between animations in seconds', $advads171_plugin_slug); ?></span>
								<?php $validation->show_error('advads171_interval'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_salebadge"><?php _e('Show Sale Badge', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_salebadge" id="advads171_salebadge">
										<option value="yes" <?php echo $validation->set_select('advads171_salebadge', 'yes'); ?>>On &nbsp; </option>
										<option value="no" <?php echo $validation->set_select('advads171_salebadge', 'no'); ?>>Off &nbsp; </option>
								</select>
								<span class="description"><?php _e('Show "percentage off" amount if available (not supported by IE)', $advads171_plugin_slug); ?></span>
								<?php $validation->show_error('advads171_salebadge'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_amlink"><?php _e('Show Amazon Link', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_amlink" id="advads171_amlink">
										<option value="yes" <?php echo $validation->set_select('advads171_amlink', 'yes'); ?>>Yes &nbsp; </option>
										<option value="no" <?php echo $validation->set_select('advads171_amlink', 'no'); ?>>No &nbsp; </option>
								</select>
								<span class="description"><a href="#" class="advads_tooltip" title="<?php esc_attr_e('Small amazon.com link usually on the bottom right of an ad. <br />Visitors must know that you are sending them to amazon. If you disclose this info on your page you can select "No"', $advads171_plugin_slug); ?>"><?php _e('( ? )', $advads171_plugin_slug); ?></a></span>
								<?php $validation->show_error('advads171_amlink'); ?>
								
							</td></tr>
							
							<tr class="form-field advads_btntxt_option <?php echo ((isset($_POST['advads171_size']) && in_array($_POST['advads171_size'], array(3, 5, 6)))?'':'advads_hide_option' ); ?>"><th style="width:150px;"><label for="advads171_btn_text"><?php _e('"Buy Now" Button Text', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" name="advads171_btn_text" style="width:220px;" value="<?php echo $validation->set_value('advads171_btn_text', (strlen($edit_banner_default['btn_text']) > 0?$edit_banner_default['btn_text']:'Buy Now')); ?>" id="advads171_btn_text" />
								<span class="description"> <a href="#" class="advads_tooltip" title="<?php esc_attr_e("Some banner sizes have a 'Buy Now' button. You can change button text here.", $advads171_plugin_slug); ?>"><?php _e('( ? )', $advads171_plugin_slug); ?></a></span>
								<?php $validation->show_error('advads171_btn_text'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_search_method"><?php _e('Products Search Method', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_search_method" id="advads171_search_method">
									<?php foreach($available_search_methods as $method_id => $method_name): ?>
										<option value="<?php echo $method_id; ?>" <?php echo $validation->set_select('advads171_search_method', $method_id); ?>><?php echo $method_name; ?> &nbsp; </option>
									<?php endforeach; ?>
								</select>
								<span class="description"></span>
								<?php $validation->show_error('advads171_search_method'); ?>								
							</td></tr>
							
							<tr class="form-field "><th style="width:150px;"><label for="advads171_banner_keyword"><?php _e('Banner Keyword', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" name="advads171_banner_keyword" style="width:220px;" value="<?php echo $validation->set_value('advads171_banner_keyword'); ?>" id="advads171_banner_keyword" />
									
								<span class="description"><?php _e('(optional) enter keyword for pulling products', $advads171_plugin_slug); ?> <a href="#" class="advads_tooltip" title="<?php esc_attr_e("If you enter keywords here the plugin will NOT generate keywords from content and use these keywords instead.", $advads171_plugin_slug); ?>"><?php _e('( ? )', $advads171_plugin_slug); ?></a></span>
								<?php $validation->show_error('advads171_banner_keyword'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_single_only"><?php _e('Restrict to Post/Page View', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_single_only" id="advads171_single_only">
										<option value="no" <?php echo $validation->set_select('advads171_single_only', 'no'); ?>>No &nbsp; </option>
										<option value="yes" <?php echo $validation->set_select('advads171_single_only', 'yes'); ?>>Yes &nbsp; </option>
								</select>
								<span class="description"><?php _e('If "yes" - hides from category, archive pages, etc', $advads171_plugin_slug); ?> <a href="#" class="advads_tooltip" title="<?php esc_attr_e("This is useful if for example you're using a shortcode in the post and you don't want the banner to appear in the post excerpt on the category pages.", $advads171_plugin_slug); ?>"><?php _e('( ? )', $advads171_plugin_slug); ?></a></span>
								<?php $validation->show_error('advads171_single_only'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_alignment"><?php _e('Alignment', $advads171_plugin_slug); ?>:</label></th>
							<td>									
								<select name="advads171_alignment" id="advads171_alignment">
										<option value="none" <?php echo $validation->set_select('advads171_alignment', 'none'); ?>>None &nbsp; </option>
										<option value="left" <?php echo $validation->set_select('advads171_alignment', 'left'); ?>>Left &nbsp; </option>
										<option value="center" <?php echo $validation->set_select('advads171_alignment', 'center'); ?>>Center &nbsp; </option>
										<option value="right" <?php echo $validation->set_select('advads171_alignment', 'right'); ?>>Right &nbsp; </option>

								</select>
								<span class="description"><?php _e('If not sure try each and see what looks best on the page', $advads171_plugin_slug); ?> <a href="#" class="advads_tooltip" title="<?php esc_attr_e("Note: Text doesn't wrap around center aligned banners (no text to the left or right of the banner).", $advads171_plugin_slug); ?>"><?php _e('( ? )', $advads171_plugin_slug); ?></a></span>
								<?php $validation->show_error('advads171_alignment'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_margin_top"><?php _e('Margins', $advads171_plugin_slug); ?> <?php _e('(optional)', $advads171_plugin_slug); ?> <a href="#" class="advads_tooltip" title="<?php esc_attr_e("If your banner is too close to the text or to other elements you can adjust margins here.<br />Note: If the banner alignment is set to Center - left and right margins are ignored (they are automatically set to 'auto')", $advads171_plugin_slug); ?>"> <?php _e('( ? )', $advads171_plugin_slug); ?></a>:</label></th>
							<td>	
								<table class="advads_skinny_tbl">
									<tr>
										<td>&nbsp;</td>
										<td class="tbl_cntrd">top:<input type="text" name="advads171_margin_top" value="<?php echo $validation->set_value('advads171_margin_top', '0'); ?>" style="width: 30px;" /> px</td>
										<td>&nbsp;</td>
									</tr>
									<tr>
										<td>left:<input type="text" name="advads171_margin_left" value="<?php echo $validation->set_value('advads171_margin_left', '0'); ?>" style="width: 30px;" />px</td>
										<td><div style="width: 90px; height: 40px; background-color: #d8d8d8; border: 1px solid #787575; margin: 2px; text-align: center; line-height: 40px; color: #a3a3a3;">banner</div></td>
										<td>right:<input type="text" name="advads171_margin_right" value="<?php echo $validation->set_value('advads171_margin_right', '0'); ?>" style="width: 30px;" />px</td>
									</tr>
									<tr>
										<td>&nbsp;</td>
										<td class="tbl_cntrd">btm:<input type="text" name="advads171_margin_bottom" value="<?php echo $validation->set_value('advads171_margin_bottom', '0'); ?>" style="width: 30px;" /> px</td>
										<td>&nbsp;</td>
									</tr>
								</table>
								<?php $validation->show_error('advads171_margin_top'); ?>
								<?php $validation->show_error('advads171_margin_right'); ?>
								<?php $validation->show_error('advads171_margin_bottom'); ?>
								<?php $validation->show_error('advads171_margin_left'); ?>
								
							</td></tr>
							
						</table>
					</div>
				</div>
			</div>
				
			</td>
		</tr>
	</table>
		
	<table>
	<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $advads171_plugin_slug); ?>" class="button-primary" /></td></tr>
	</table>
	
	<input type="hidden" name="advads171_hidden_patch_footer" id="advads171_hidden_patch_footer" value="no" />
	<input type="hidden" name="advads171_active" value="yes" />
	<input type="hidden" name="advads171_form_submitted" value="yes" />
</form>

<?php //BOF animation options for a swap ?>
<div style="display: none;">
	<?php
	foreach($available_sizes as $size_id => $size):
	$avail_options = $banner->available_animations(FALSE, $size_id);
	?>
	<div id="size_anim_wrap_<?php echo $size_id; ?>">
		<select name="advads171_animation" onchange="javascript: if (this.value == '1' || this.value == '') {jQuery('.advads_animint_option').addClass('advads_hide_option');} else {jQuery('.advads_animint_option').removeClass('advads_hide_option');}">
			<option value=""><?php _e('-- Select Banner Animation --', $advads171_plugin_slug); ?> &nbsp; </option>
			<?php foreach($avail_options as $key => $val): ?>			
				<option value="<?php echo $key; ?>"><?php echo $val; ?></option>
			<?php endforeach; ?>
		</select>
	</div>
	<?php
	endforeach; 
	?>
	<div id="size_anim_wrap_none">
		<select name="advads171_animation" onchange="javascript: if (this.value == '1' || this.value == '') {jQuery('.advads_animint_option').addClass('advads_hide_option');} else {jQuery('.advads_animint_option').removeClass('advads_hide_option');}">
				<option value=""><?php _e('-- Select Banner Size --', $advads171_plugin_slug); ?> &nbsp;</option>
		</select>
	</div>
</div>

<script type="text/javascript">
function advads_replace_anim_options(size_id)
{
	if (size_id == '')
	{
		//jQuery('#advads171_animation option').detach();
		//var curr_opts = jQuery('#size_anim_options_none option');
		//console.log(curr_opts);
		jQuery('#advads171_animation_wrap').html(jQuery('#size_anim_wrap_none').html());
	}
	else
	{
		jQuery('#advads171_animation_wrap').html(jQuery('#size_anim_wrap_' + size_id).html());
	}

}
</script>
<?php //EOF animation options for a swap ?>

<style>
.advads_hide_option {
display: none;
}
.advads_skinny_tbl td {
padding: 0px;
font-style: italic;
}
.tbl_cntrd {
text-align: center;
}
</style>