<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

require_once(dirname(dirname(dirname(dirname(__FILE__)))).'/wp-load.php');

require_once(dirname(__FILE__).'/include/amazon.lib.php');
require_once(dirname(__FILE__).'/include/wpbfuncs.php');
require_once(dirname(__FILE__).'/include/keywords_generator.php');
require_once(dirname(__FILE__).'/app/models/banners.php');

global $query_string;

$advads171_banners = new advads171_banners;
$advads171_curr_banner = FALSE;
if (isset($_GET['banner_id']) && is_numeric($_GET['banner_id']))
{
	$advads171_curr_banner = $advads171_banners->get_by_id($_GET['banner_id']);
}



if ($advads171_curr_banner === FALSE)
{
	echo json_encode(array('html' => '', 'error' => 'yes'));
	exit;
}

$advads171_search_method = $advads171_curr_banner['search_method'];
$advads171_search_method_real = '1';
/*echo '<pre>';
print_r($advads171_curr_banner);
echo '</pre>';
exit;*/
//echo $advads171_search_method; exit;


$advads171_preview = FALSE;
$advads171_preview_kws = '';
$advads171_preview_general = FALSE;
$advads171_tpl_key = 0;

$advads171_is_virtual = FALSE;
if (isset($_GET['is_virtual']) && $_GET['is_virtual'] == 'yes')
{
	$advads171_is_virtual = TRUE;
}


if (isset($_GET['preview_general']) && $_GET['preview_general'] == 'yes') 
{
	$advads171_preview_general = TRUE;
}

$advads171_kws_str = '';

//Error. No active amazon templates found
//$advads171_real_active_tpls = advads171_active_tpls();
/*if (isset($_GET['preview']) && $_GET['preview'] == 'yes' && !in_array('tpl_am3across', $advads171_real_active_tpls) && !in_array('tpl_am1product', $advads171_real_active_tpls) && in_array($advads171_tpl_key, array(0, 1)))
{
	exit;
	echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div>'.__('Error', $advads171_plugin_slug).'! '.__('Please activate at least one of the Amazon templates!', $advads171_plugin_slug)));
}*/

if (isset($_GET['preview_general']) && $_GET['preview_general'] == 'yes')
{
	$advads171_preview_general = TRUE;
}
else
{
	if (isset($_GET['preview']) && $_GET['preview'] == 'yes')
	{
		$advads171_preview = TRUE;
		$advads171_preview_kws = $_POST['preview_keywords'];
	}	
	
	//get post id
	$post_id = '';
	if (isset($_GET['post_id']) && is_numeric($_GET['post_id']))
	{
		$post_id = $_GET['post_id'];
	}
	if ($post_id == '' && $advads171_is_virtual !== TRUE) 
	{	
		if ($advads171_preview === TRUE)
		{
			echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div>'.__('Error! No post id found!', $advads171_plugin_slug).''));
			exit;
		}
		else
		{
			echo json_encode(array('html' => 'error'));
			exit;
		}		
	}

	//does post exist?
	$curr_post = get_post( $post_id, $output );
	if ((!isset($curr_post->ID) || $curr_post->ID != $post_id) && ($advads171_is_virtual === FALSE)) 
	{
		if ($advads171_preview === TRUE)
		{
			//echo '<div onclick="javascript: pbox_close();" class="am_close_advads">Close</div>';
			//exit('Error! Post with post id '.$post_id.' doesn\'t exist.');
		}
		else
		{
			echo json_encode(array('html' => 'error'));
			exit;
		}
	}
	
	//use serp keywords
	$advads171_get_serp_kw_str = advads171_get_serp_kw_str();
	if ($advads171_get_serp_kw_str != '')
	{
		$advads171_kws_str = $advads171_get_serp_kw_str;
		$advads171_search_method = 1;
		$advads171_search_method_real = 4;
	}


	//other search methods failed - switch to kws
	if (strlen($advads171_kws_str) == 0)  $advads171_search_method = 1;
	
	//use banner keyword if entered
	if ((($advads171_search_method == 1 && $advads171_search_method_real != 4) || strlen($advads171_kws_str) < 1) && strlen($advads171_curr_banner['keyword']) > 0)
	{
		$advads171_kws_str = $advads171_curr_banner['keyword'];
		$advads171_search_method = 1;
		$advads171_search_method_real = 5;
	}


	//do we have kws?
	if ($advads171_preview === TRUE && strlen($advads171_preview_kws) > 0)
	{
		//use preview keywords
		$advads171_kws_str = $advads171_preview_kws;
	}
	elseif(strlen($advads171_kws_str) == 0 && $advads171_search_method == 1)
	{
		//use saved keywords
		$advads171_kws_str = get_post_meta($curr_post->ID, 'advads171_keywords', true);
	}
	
	//use virtual post keywords
	if (!in_array($advads171_search_method, array(2, 3, 4)) && $advads171_is_virtual && isset($_GET['s']) && strlen($_GET['s']) > 0)
	{
		$advads171_kws_str = strip_tags(urldecode($_GET['s']));
		$advads171_search_method = 1;
		$advads171_search_method_real = 6;
	}
	
	//use custom defined keywords		
	if (strlen($advads171_kws_str) < 2 && $advads171_search_method == 1)
	{
		//get kws settings
		$advads171_kw_sources = array();
		$advads171_kw_sources_str = advads171_get_option('advads171_kw_sources');
		if (strlen($advads171_kw_sources_str) > 0)
		{
			$advads171_kw_sources = explode(',', $advads171_kw_sources_str);
		}
		
		if (in_array('custom', $advads171_kw_sources) && function_exists('advads171_custom_keyword_source'))
		{				
			$advads171_custom_keywords = advads171_custom_keyword_source('amzn', $post_id);
			if ($advads171_custom_keywords !== FALSE && is_array($advads171_custom_keywords) && count($advads171_custom_keywords) > 0)
			{
				$advads171_kws_str = implode(',', $advads171_custom_keywords);
				$advads171_search_method = 1;
				$advads171_search_method_real = 7;
			}
		}
	}
		
	if (strlen($advads171_kws_str) < 2 && $advads171_search_method == 1)
	{
		//create kws from post content
		//$advads171_content = strip_tags($curr_post->post_content);
		$custom_query = new WP_Query( array( 'post_type' => $curr_post->post_type, 'post__in' => array( $curr_post->ID ), 'ignore_sticky_posts' => TRUE ) );
		$advads171_i = 0;
		//re-use post content if available
		if (!isset($advads171_post_content) || strlen($advads171_post_content) == 0)
		{
			$advads171_post_content = '';
			while($custom_query->have_posts() && $advads171_i == 0)
			{
				$custom_query->the_post();
				$advads171_post_content = apply_filters('the_content',get_the_content());
				$advads171_i++;
			}
			wp_reset_postdata();
			
			if (strlen($advads171_post_content) > 0)
			{
				$advads171_post_content = advads171_remove_html($advads171_post_content);
				$advads171_post_content = strip_tags($advads171_post_content);
			}	
		}
		
		$advads171_content = $advads171_post_content;
		$advads171_post_title = '';
		if (isset($post) && isset($post->post_title))
		{
			$advads171_post_title = $post->post_title;
		}
		$advads171_kws = advads171_gen_kws($advads171_content, $advads171_post_title, $post_id);
		
		if (count($advads171_kws) == 0) 
		{
			if ($advads171_preview === TRUE)
			{
				echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div>'.__('Error! No keywords found.', $advads171_plugin_slug).''));
				exit;
			}
			else
			{
				echo json_encode(array('html' => 'error'));
				exit; //no kws found :(
			}
		}
		if (count($advads171_kws) > 0)
		{
			//save kws in custom meta
			$advads171_kws = array_slice($advads171_kws, 0, 5);
			update_post_meta($post_id, 'advads171_keywords', implode(', ', $advads171_kws));
		}
		$advads171_search_method_real = 1;
	}
	elseif ($advads171_search_method == 1)
	{
		//got keywords? lets turn them into an array
		$advads171_kws = explode(',', trim(str_replace(', ', ',', $advads171_kws_str)));
		//$advads171_kws = array_slice($advads171_kws, 0, 5);
	}

	

	if (count($advads171_kws) == 0) 
	{
		if ($advads171_preview === TRUE)
		{
			echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div>'.__('Error! Looks like there are no keywords.', $advads171_plugin_slug)));
			exit;
		}
		else
		{
			echo json_encode(array('html' => 'error (no keywords found)'));
			exit;	//come on, we need kws
		}
	}
	
	
}

	
	//get API credentials
	$advads171_locale = advads171_epn_get_locale();
	
	//if user country not supported - show nothing or fallback country listings
	if ($advads171_locale == 'smthelse' && ($advads171_preview === TRUE || $advads171_preview_general === TRUE))
	{
		echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div> '.sprintf(__('Error. Your country %s is not supported or not set up. <br />You can set a fallback country under Advanced settings in Misc. box.', $advads171_plugin_slug), strtoupper(advads171_get_locale(FALSE)))));
		exit;
	}
	elseif ($advads171_locale == 'smthelse')
	{
		echo json_encode(array('html' => 'error'));
		exit;	//user country not supported and the admin said 'silence!'
	}
	

	$advads171_epn_params = array(
							'epn_campaign_id' => advads171_get_option('epn_campaign_id'), 
							'epn_custom_id' => advads171_get_option('epn_custom_id'),
							'epn_min_price' => advads171_get_option('epn_min_price'),
							'epn_max_price' => advads171_get_option('epn_max_price'),
							'epn_sort_order' => advads171_get_option('epn_sort_order'),
							'epn_listing_type' => advads171_get_option('epn_listing_type'),
							'epn_free_shipping' => advads171_get_option('epn_free_shipping'),
							'epn_min_bids' => advads171_get_option('epn_min_bids'),
							'epn_max_bids' => advads171_get_option('epn_max_bids'),
							'epn_feedback_score_min' => advads171_get_option('epn_feedback_score_min'),
							'epn_feedback_score_max' => advads171_get_option('epn_feedback_score_max'),
							);
	//conditions
	$epn_conditions = '';
	$epn_conditions_str = advads171_get_option('epn_conditions');
	if ($epn_conditions_str !== FALSE && strlen($epn_conditions_str) > 0)
	{
		$epn_conditions_arr = explode(',', $epn_conditions_str);
		$epn_conditions_uri_arr = array();
		$i = 1;
		foreach($epn_conditions_arr as $curr_cond)
		{
			$epn_conditions_uri_arr[] = 'condition'.$i.'='.$curr_cond;
			$i++;
		}
		$epn_conditions = implode('&', $epn_conditions_uri_arr);
	}
	$advads171_epn_params['epn_conditions'] = $epn_conditions;
	//category id
	$advads171_maybe_cat = advads171_get_option('epn_category_'.$advads171_locale);
	if ($advads171_maybe_cat !== FALSE)
	{
		$advads171_maybe_cat_arr = explode('|', $advads171_maybe_cat);
		if (count($advads171_maybe_cat_arr) > 0)
		{
			$advads171_epn_params['category_id'] = end($advads171_maybe_cat_arr);
		}
	}
	

	advads171_cache_cleanup();
	
	$advads171_data = advads171_epn_get_pop_data($post_id, $advads171_kws, $advads171_epn_params, $advads171_locale);
		
		if ($advads171_data !== FALSE && count($advads171_data) > 0):

			ob_start();
			if (isset($advads171_data['ad']) && $advads171_data['ad'] == true && isset($advads171_data['html'])): 
				echo $advads171_data['html'];
			else: 
				
				include('app/views/epn/banner_size_'.$advads171_curr_banner['size'].'.php');
				
			endif;
			$advads171_pop_html = ob_get_contents();
			ob_end_clean();
			//echo $advads171_pop_html;exit;
			
			echo json_encode(array('html' => $advads171_pop_html, 'search_method' => $advads171_search_method, 'search_method_real' => $advads171_search_method_real, 'advads_kws' => implode(',', $advads171_kws)));
		
		else: 
			if ($advads171_preview === TRUE || $advads171_preview_general === TRUE)
			{
				echo json_encode(array('html' => '<div onclick="javascript: pbox_close();" class="am_close_advads">'.__('Close', $advads171_plugin_slug).'</div> '.__('No results found. Try different keywords.', $advads171_plugin_slug)));
				exit;
			}
			else
			{
				echo json_encode(array('html' => 'error'));
				exit; 
			}
		endif;

