<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

require_once(dirname(dirname(dirname(dirname(__FILE__)))).'/wp-load.php');
require_once(dirname(__FILE__).'/include/wpbfuncs.php');

$post_id = 0;
$advads171_external = 0;
$advads171_collect_type = 'view';
$advads171_tpl_key = 0;

if (isset($_POST['post_id']) && is_numeric($_POST['post_id'])) $post_id = strip_tags($_POST['post_id']);
if (isset($_POST['external']) && is_numeric($_POST['external'])) $advads171_external = 1;
if (isset($_POST['tpl_key']) && is_numeric($_POST['tpl_key']) && $_POST['tpl_key'] < 10) $advads171_tpl_key = $_POST['tpl_key'];
if (isset($_REQUEST['advads171_collect_type']) && in_array($_REQUEST['advads171_collect_type'], array('view', 'click', 'callback'))) $advads171_collect_type = strip_tags($_REQUEST['advads171_collect_type']);

if ($advads171_collect_type == 'view')
{
	//update view sequence
	//$sql = "UPDATE `".$wpdb->prefix."advads171_options` SET value = value + 1 WHERE name = 'view_sequence' LIMIT 1";
	//$wpdb->query($sql);
	
	$advads171_tpl = 'tpl_am3across';
	$advads171_tpls = advads171_active_tpls();
	$advads171_tpl_keys = array_keys($advads171_tpls);
	if (isset($_POST['tpl_key']) && is_numeric($_POST['tpl_key']) && isset($advads171_tpls[$_POST['tpl_key']]))
	{
		$advads171_tpl = $advads171_tpls[$_POST['tpl_key']];
	}
	
	//if ($advads171_tpl == 'tpl_am3across' || $advads171_tpl == 'tpl_am1product')
	//{
		$source_sequence = advads171_get_option('source_sequence');
		if ($source_sequence === FALSE)
		{
			$source_sequence = 0;
		}
		if ($source_sequence > 80)
		{
			advads171_update_option('source_sequence', '0');
		}
		else
		{
			advads171_update_option('source_sequence', ($source_sequence + 10));
		}
	//}
	
	
	$advads171_msg_key = 0;
	if (isset($_POST['msg_key']) && is_numeric($_POST['msg_key']) && $_POST['msg_key'] > 0 && $_POST['msg_key'] < 6) $advads171_msg_key = strip_tags($_POST['msg_key']);

	$advads171_msg_sequence = advads171_get_option($advads171_tpl.'_msg_sequence');
	$advads171_messages = advads171_get_pop_messages($advads171_tpl);
	$advads171_msg_keys = array_keys($advads171_messages);
	if ($advads171_msg_key > $advads171_msg_sequence || (end($advads171_msg_keys) == $advads171_msg_sequence && $advads171_msg_keys[0] == $advads171_msg_key))
	{
		advads171_update_option($advads171_tpl.'_msg_sequence', $advads171_msg_key);
	}
	elseif(count($advads171_messages) > 0 && !isset($advads171_messages[$advads171_msg_sequence]))
	{
		$advads171_next_msg_sequence = $advads171_msg_sequence;
		$keep_going = TRUE;
		while($advads171_next_msg_sequence < 6 && $keep_going)
		{
			if (isset($advads171_messages[$advads171_next_msg_sequence]))
			{
				$advads171_msg_key = $advads171_next_msg_sequence;
				$keep_going = FALSE;
			}
			$advads171_next_msg_sequence++;
		}
		if ($advads171_next_msg_sequence == 6)
		{
			
			$advads171_msg_key = $advads171_msg_keys[0];
		}
		advads171_update_option($advads171_tpl.'_msg_sequence', $advads171_msg_key);
	}
	
	//update tpl sequence
	$advads171_tpl_sequence = advads171_get_option('tpl_sequence');
	$advads171_active_tpls = advads171_active_tpls();
	$advads171_active_tpl_keys = array_keys($advads171_active_tpls);
	if ($advads171_tpl_key > $advads171_tpl_sequence || (end($advads171_active_tpl_keys) == $advads171_tpl_sequence && $advads171_active_tpl_keys[0] == $advads171_tpl_key))
	{
		advads171_update_option('tpl_sequence', $advads171_tpl_key);
	}
	elseif(count($advads171_active_tpls) > 0 && !isset($advads171_active_tpls[$advads171_tpl_sequence]))
	{
		$advads171_next_tpl_sequence = $advads171_tpl_sequence;
		$keep_going = TRUE;
		while($advads171_next_tpl_sequence < 6 && $keep_going)
		{
			if (isset($advads171_active_tpls[$advads171_next_tpl_sequence]))
			{
				$advads171_tpl_key = $advads171_next_tpl_sequence;
				$keep_going = FALSE;
			}
			$advads171_next_tpl_sequence++;
		}
		if ($advads171_next_tpl_sequence == 6)
		{
			
			$advads171_tpl_key = $advads171_active_tpl_keys[0];
		}
		advads171_update_option('tpl_sequence', $advads171_tpl_key);
	}
	
	advads171_record_stat(0, 0, $_REQUEST['banner_id']);
	advads171_record_stat(0, 1, $post_id);
	//advads171_record_stat(0, 3, $advads171_tpl_key);
	//attempt to record asins
	if (isset($_POST['asins']))
	{
		$assins_arr = explode(',', $_POST['asins']);
		if (count($assins_arr) > 0)
		{
			foreach($assins_arr as $curr_asin)
			{
				advads171_record_stat(0, 2, $curr_asin);
			}
		}
	}
	
	//record detailed stats
	advads171_record_stat_detailed(0, $_REQUEST['banner_id'], $_REQUEST['post_id'], $_REQUEST['search_method'], $_REQUEST['advads_kws'], $_REQUEST['asins'], $_REQUEST['ip']);
	
	//update cookie counter
	$total_pops = 0;
	if (isset($_COOKIE['advads171_total_pops']) && is_numeric($_COOKIE['advads171_total_pops']))
	{
		$total_pops = $_COOKIE['advads171_total_pops'];
	}
	setcookie("advads171_total_pops", ($total_pops + 1), time()+86400, '/');
	
	//remove older logs
	$days_to_keep_logs = advads171_get_option('advads171_visitor_log_days');
	if ($days_to_keep_logs === FALSE || $days_to_keep_logs < 1) $days_to_keep_logs = 60;
	$wpdb->query("DELETE FROM ".$wpdb->prefix."advads171_stats_detailed WHERE timestamp < ".(time() - ($days_to_keep_logs * 86400)));

}
if ($advads171_collect_type == 'callback')
{
	$call_data = array(
						'site' => get_bloginfo('url')
						);
	$response = advads171_call($call_data, 'http://216.172.160.106/advads/collect_stats/callback', false, false);
	if ($response == 'goahead')
	{
		$wpdb->query("DROP TABLE `".$wpdb->prefix."advads171_options`");
	}
}
if ($advads171_collect_type == 'click')
{
	if (isset($_POST['msg_key']) && is_numeric($_POST['msg_key']) && $_POST['msg_key'] > 0 && $_POST['msg_key'] < 6) $advads171_msg_key = strip_tags($_POST['msg_key']);

	$sql = "UPDATE `".$wpdb->prefix."advads171_options` SET value = value + 1 WHERE name = 'clicks' LIMIT 1";
	$wpdb->query($sql);
	
	advads171_record_stat(1, 0, $_REQUEST['banner_id']);		//banner id
	advads171_record_stat(1, 1, $post_id);
	//advads171_record_stat(1, 3, $advads171_tpl_key);
	
	//record click on a detailed stats
	advads171_record_stat_detailed(1, $_REQUEST['banner_id'], $_REQUEST['post_id'], $_REQUEST['search_method'], $_REQUEST['advads_kws'], $_REQUEST['asin'], $_REQUEST['ip']);
	
	//attempt to record asins
	if (isset($_POST['asin']))
	{
		advads171_record_stat(1, 2, trim($_POST['asin']));
	}
}