<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/
function advads171_stats() {
	global $am_indexes, $advads171_plugin_slug, $advads171_plugin_name;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?'));
	
	if (advads171_license_type() === FALSE)
	{
		advads171_license();
		return;
	}
	//which tab?
	$tab = 'banners';
	if (isset($_GET['tab']) && in_array($_GET['tab'], array('banners', 'posts', 'products', 'templates')))
	{
		$tab = $_GET['tab'];
	}
	
	echo '<div class="wrap"><img src="'.plugin_dir_url( dirname(__FILE__) ).'images/'.advads171_branding_img().'" style="display: block; float: right;" /><h2>' . sprintf(__('%s Stats', $advads171_plugin_slug), $advads171_plugin_name) . '</h2>';
	
	
	$tabs = array(
		'banners' => __('Banners', $advads171_plugin_slug),
		'posts' => __('Pages/Posts', $advads171_plugin_slug),
		'products' => __('Products', $advads171_plugin_slug),	
		/*'templates' => __('Templates', $advads171_plugin_slug)	*/
		);

	echo '<h2 class="nav-tab-wrapper">';

	if ( isset( $redir_tab ) && array_key_exists( $redir_tab, $tabs ) ) {
		$current = $redir_tab;
	} elseif ( isset( $_GET['tab'] ) && array_key_exists( $_GET['tab'], $tabs ) ) {
		$current = $_GET['tab'];
	} else {
		$keys = array_keys( $tabs );
		$current = array_shift( $keys );
	}

	foreach ( $tabs as $callback => $text ) {
		$class = ' class="nav-tab"';

		if ( $current == $callback )
			$class = ' class="nav-tab nav-tab-active"';

		$href = add_query_arg( array( 'tab' => $callback, 's' => false, 'paged' => false, 'post_mime_type' => false, 'm' => false ) );
		$href = remove_query_arg( 'isocode', $href );
		$href = wp_nonce_url( $href, "tab-$callback" );
		$link = "<a href='" . esc_url( $href ) . "'$class>$text</a>";

		echo $link;
	}
	echo '</h2>';
	
	if ($tab == 'banners' || $tab == 'posts' || $tab == 'products' || $tab == 'templates')
	{
		?>
		
		<a href="javascript: void(0);" onclick="javascript: jQuery('#date_picker_wrap').toggle();" class="advads171_date_dropdown">+ Date: <span id="startDate"><?=date('m/d/Y', strtotime('-'.(date('w')*24).' hours'));?></span> - <span id="endDate"><?=date('m/d/Y');?></span></a>
		<div class="stat_actions_wrap">
			<?php _e('Display', $advads171_plugin_slug); ?>: <select onchange="javascript: advads171_load_stats(this.value, jQuery('#curr_stat_type').val(), jQuery('#curr_stat_page').val());" id="advads171_stat_action">
				<option value="0" selected><?php _e('Views', $advads171_plugin_slug); ?></option>
				<option value="1"><?php _e('Clicks', $advads171_plugin_slug); ?></option>
				<option value="2"><?php _e('CTR%', $advads171_plugin_slug); ?></option>
			</select>
		</div>
		<div style="position: absolute; display: none; z-index: 900;" id="date_picker_wrap">
			<div class="week-picker"></div>
		</div>
		<br style="clear: both;" />
		
		<div class="advads171_graph_wrap">
		
		</div>
		
		


<script type="text/javascript"> 
var temp_tbl_holder = '';
jQuery(function(){
            
           //jQuery("#advads171_graph").graphix({ width: 1000, height: 500, type:'line' }); 
            temp_tbl_holder = jQuery('.advads171_graph_wrap').html();
           });
jQuery(function() {
    var startDate;
    var endDate;

    var selectCurrentWeek = function() {
        window.setTimeout(function () {
            jQuery('.week-picker').find('.ui-datepicker-current-day a').addClass('ui-state-active')
        }, 1);		
    }

    jQuery('.week-picker').datepicker( {
        showOtherMonths: true,
        selectOtherMonths: true,
		maxDate: 0,
        onSelect: function(dateText, inst) { 
            var date = jQuery(this).datepicker('getDate');
            startDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() - date.getDay());
            endDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() - date.getDay() + 6);
            var dateFormat = inst.settings.dateFormat || jQuery.datepicker._defaults.dateFormat;
            jQuery('#startDate').text(jQuery.datepicker.formatDate( dateFormat, startDate, inst.settings ));
            jQuery('#endDate').text(jQuery.datepicker.formatDate( dateFormat, endDate, inst.settings ));

            selectCurrentWeek();
			
			jQuery('#date_picker_wrap').hide();
			advads171_load_stats(jQuery('#curr_stat_action').val(), jQuery('#curr_stat_type').val(), 0);
			//jQuery('.advads171_graph_wrap').html(temp_tbl_holder);
			
        },
        beforeShowDay: function(date) {
            var cssClass = '';
            if(date >= startDate && date <= endDate)
                cssClass = 'ui-datepicker-current-day';
            return [true, cssClass];
        },
        onChangeMonthYear: function(year, month, inst) {
            selectCurrentWeek();
        }
    });

    jQuery('.week-picker .ui-datepicker-calendar tr').live('mousemove', function() { jQuery(this).find('td a').addClass('ui-state-hover'); });
    jQuery('.week-picker .ui-datepicker-calendar tr').live('mouseleave', function() { jQuery(this).find('td a').removeClass('ui-state-hover'); });
});

jQuery(document).ready(function() {
  <?php if ($tab == 'banners'): ?>
	advads171_load_stats(0, 0, 0);
  <?php elseif ($tab == 'posts'): ?>
	advads171_load_stats(0, 1, 0);
  <?php elseif ($tab == 'templates'): ?>
	advads171_load_stats(0, 3, 0);
  <?php else: ?>
	advads171_load_stats(0, 2, 0);
  <?php endif; ?>
});

function advads171_load_stats(stat_action, stat_type, page_num)
{
	startDate = jQuery('#startDate').text();
	endDate = jQuery('#endDate').text();
	
	jQuery('.advads171_graph_wrap').html('<img src="<?=site_url("wp-content/plugins/advads171/images/ajax-loader_bar.gif");?>" style="width: 128px; height: 15px; margin: 250px auto; display: block;" />');
	jQuery('.advads171_graph_wrap').load('<?=site_url("wp-content/plugins/advads171/admin_stats.php");?>', {stat_action: stat_action, stat_variation_type: stat_type, start_date: startDate, end_date: endDate, page_num: page_num }, function () {
		if (stat_action == 2)
		{
			jQuery("#advads171_graph").graphix({ width: 1000, height: 500, type:'line', divide_by: 1000 });
		}
		else
		{
			jQuery("#advads171_graph").graphix({ width: 1000, height: 500, type:'line' });
		}
		
	});
	
}

</script> 
<style>
.advads171_graph {

}
.advads171_graph_wrap {
margin-top: 5px;
min-width: 1000px;
min-height: 500px;
}
.advads171_date_dropdown {display: block; text-decoration: none; font-weight: bold; margin-top: 5px; width: 300px; float: left;}
.stat_actions_wrap {float: left; clear: right;}
</style>
		<?php
	}
	
	
}

function advads171_prepare_kws_pop_preview()
{
	global $advads171_addons, $advads171_plugin_slug, $advads171_plugin_name;
?>
		<?php
		//BOF include advads171 js for preview
		//wp_enqueue_style( 'advads171', plugins_url( 'advads171/style.css' , dirname(__FILE__) ), false, '1.0');
		?>
		<div id="am_popbox" style="display: none;">
			<div id="am_interior">
				<?php _e('Thank you for visiting our site.', $advads171_plugin_slug); ?>
				<br /><a href="javascript:void(0);" class="close"><?php _e('Close', $advads171_plugin_slug); ?></a>			
			</div>		
		</div>
		
		<?php
		$advads171_preview_tpl = 'tpl_am3across';
		if (advads171_get_option('tpl_am3across_enabled') != 1 && advads171_get_option('tpl_am1product_enabled') == 1)
		{
			$advads171_preview_tpl = 'tpl_am1product';
		}
		$advads171_msgs = advads171_get_pop_messages($advads171_preview_tpl);
		$advads171_preview_msg = $advads171_msgs[array_rand($advads171_msgs)];
		?>
		<script type="text/javascript">		
		  var advads171_preview_loaded = false;
		  function advads171_perview(keywords, source)
		  {
			var loading_script = 'ampop_results.php';
			if (source == undefined)
			{
				source = '0';
			}
			if (source == '1')
			{
				loading_script = 'epnpop_results.php';
			}
			jQuery('.advads171_preview_set').removeClass('active');
			jQuery('.advads171_preview_loading').addClass('active');
			//jQuery("#am_interior").html('');
			if (advads171_preview_loaded == false)
			{
				<?php
				//fix calls from www. to non-www etc
				$advads171_ampop_results_url = site_url('wp-content/plugins/'.$advads171_plugin_slug.'/');				
				if (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' && substr($advads171_ampop_results_url, 0, 11) != 'http://www.' && substr($advads171_ampop_results_url, 0, 12) != 'https://www.')
				{
					if (substr($advads171_ampop_results_url, 0, 7) == 'http://') $advads171_ampop_results_url = str_replace('http://', 'http://www.', $advads171_ampop_results_url);
					if (substr($advads171_ampop_results_url, 0, 8) == 'https://') $advads171_ampop_results_url = str_replace('https://', 'https://www.', $advads171_ampop_results_url);
				}
				elseif (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) != 'www.' && (substr($advads171_ampop_results_url, 0, 11) == 'http://www.' || substr($advads171_ampop_results_url, 0, 12) == 'https://www.'))
				{
					if (substr($advads171_ampop_results_url, 0, 7) == 'http://') $advads171_ampop_results_url = str_replace('http://', 'http://www.', $advads171_ampop_results_url);
					if (substr($advads171_ampop_results_url, 0, 8) == 'https://') $advads171_ampop_results_url = str_replace('https://', 'https://www.', $advads171_ampop_results_url);
				}
				?>
				var handling_script = "<?=$advads171_ampop_results_url;?>" + loading_script;
				//jQuery("#am_interior").load("<?=$advads171_ampop_results_url;?>?post_id=9999&preview=yes&tpl=<?=($advads171_preview_tpl == 'tpl_am3across'?0:1);?>", {preview_keywords: keywords}, function () {
				jQuery.ajax({
				  url: handling_script + "?post_id=9999&preview=yes&tpl=<?=($advads171_preview_tpl == 'tpl_am3across'?0:1);?>",
				  type: "POST",
				  data:  {preview_keywords: keywords},
				  success: function(data) {
					//var obj = jQuery.parseJSON(data);
					var obj = JSON.parse(data);
					var pop_html = obj.html;
					jQuery("#am_interior").html(pop_html);
					
					if (obj.jscripts != undefined && obj.jscripts.length > 0)
					{
						jQuery("#advads171_js_content").html("<iframe src=\""+ obj.jscripts +"\" style='border: 0px; widht: <?=advads171_get_option($advads171_preview_tpl."_pop_width");?>px; height: <?=(advads171_get_option($advads171_preview_tpl."_pop_height") - 80);?>px;' width='<?=advads171_get_option($advads171_preview_tpl."_pop_width");?>' height='<?=(advads171_get_option($advads171_preview_tpl."_pop_height") - 80);?>' scrolling='no' border='0'></iframe>");
					}
				am_loaded = true;
				//advads171_preview_loaded = true;
				advads171_preview_pop();		
				}
				});
			}
			else
			{
				advads171_preview_pop();
			}
		  }
			function advads171_preview_pop()
			{
				jQuery('.prod_img_link_epn img').css('visibility', 'hidden');
				jQuery('#am_interior').css('width', '<?=advads171_get_option($advads171_preview_tpl."_pop_width");?>' + 'px');
				jQuery('#am_interior').css('height', '<?=advads171_get_option($advads171_preview_tpl."_pop_height");?>' + 'px');
				jQuery('#am_interior').css('border-width', '<?=advads171_get_option($advads171_preview_tpl."_border_width");?>' + 'px');
				jQuery('#am_interior').css('border-style', '<?=advads171_get_option($advads171_preview_tpl."_border_type");?>');
				jQuery('#am_interior').css('border-color', '<?=advads171_get_option($advads171_preview_tpl."_border_color");?>');
				jQuery('.pop_title_advads').html('<?=addslashes($advads171_preview_msg);?>');
				jQuery('.pop_title_advads').css('font-size', '<?=advads171_get_option($advads171_preview_tpl."_message_fontsize");?>' + 'px');
				jQuery('.pop_title_advads').css('min-height', '<?=advads171_get_option($advads171_preview_tpl."_message_fontsize");?>' + 'px');
				jQuery('.pop_title_advads').css('color', '<?=advads171_get_option($advads171_preview_tpl."_message_color");?>');
				<?php if (advads171_get_option($advads171_preview_tpl."_branding") == 'no'): ?>
					jQuery('.advads171_poweredby').css('display', 'none');
				<?php else: ?>
					jQuery('.advads171_poweredby').css('display', 'block');
				<?php endif; ?>
				<?php
				$advads171_amzn_button_img = advads171_get_option($advads171_preview_tpl."_amzn_button_img");
				$advads171_epn_button_img = advads171_get_option($advads171_preview_tpl."_epn_button_img");
				$advads171_epn_bid_button_img = advads171_get_option($advads171_preview_tpl."_epn_bid_button_img");
				?>
				if (((jQuery('.amzn_buy_now_advads171_text').length > 0 || jQuery('.amzn_buy_now_large_advads171_text').length > 0) && '<?=$advads171_amzn_button_img;?>' != '' && '<?=$advads171_amzn_button_img;?>' != ' ') || ((jQuery('.epn_buy_now_advads171_text').length > 0 || jQuery('.epn_buy_now_large_advads171_text').length > 0) && '<?=$advads171_epn_button_img;?>' != '' && '<?=$advads171_epn_button_img;?>' != ' ') || ((jQuery('.epn_bid_now_advads171_text').length > 0 || jQuery('.epn_bid_now_large_advads171_text').length > 0) && '<?=$advads171_epn_bid_button_img;?>' != '' && '<?=$advads171_epn_bid_button_img;?>' != ' '))
				{
					jQuery('.amzn_buy_now_advads171_text, .amzn_buy_now_large_advads171_text').html('<img src="' + '<?=$advads171_amzn_button_img;?>' + '" />').addClass('advads171_image_button_link');
					jQuery('.epn_buy_now_advads171_text, .epn_buy_now_large_advads171_text').html('<img src="' + '<?=$advads171_epn_button_img;?>' + '" />').addClass('advads171_image_button_link');
					jQuery('.epn_bid_now_advads171_text, .epn_bid_now_large_advads171_text').html('<img src="' + '<?=$advads171_epn_bid_button_img;?>' + '" />').addClass('advads171_image_button_link');
				}
				else
				{
					jQuery('.buy_now_advads171_text, .buy_now_large_advads171_text').text('<?=advads171_get_option($advads171_preview_tpl."_button_text");?>');
					//button css
					jQuery('.buy_now_advads, .buy_now_large_advads').css('color', '<?=advads171_get_option($advads171_preview_tpl."_button_text_color");?>');
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background-color', '<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>');
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>');
					if (jQuery.browser.mozilla && jQuery.browser.version > 3.5)
					{
						jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-moz-linear-gradient(top,  '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>' +' 1%, '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%, '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>' +' 52%, '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>' +' 100%)');
					}
					else if (jQuery.browser.opera && jQuery.browser.version > 11.1)
					{
						jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-o-linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
					}
					else if ((jQuery.browser.chrome && jQuery.browser.version < 10) || (jQuery.browser.safari && (jQuery.browser.version < 5.1 && jQuery.browser.version > 3.9)))
					{
						jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-webkit-gradient(linear, left top, left bottom, color-stop(1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+'), color-stop(50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+'), color-stop(52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+'), color-stop(100%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+'))');
					}
					else if ((jQuery.browser.chrome && jQuery.browser.version > 9.9) || (jQuery.browser.safari &&  jQuery.browser.version > 5) || jQuery.browser.webkit)
					{
						jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-webkit-linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
					}
					else if ((jQuery.browser.msie && jQuery.browser.version > 9.9))
					{
						jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-ms-linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
					}
					else if ((jQuery.browser.msie && jQuery.browser.version > 5.9 && jQuery.browser.version < 10))
					{
						jQuery('.buy_now_advads, .buy_now_large_advads').css('filter', 'progid:DXImageTransform.Microsoft.gradient( startColorstr=\''+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+'\', endColorstr=\''+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+'\',GradientType=0 )');
					}
					else
					{
						jQuery('.buy_now_advads, .buy_now_large_advads').css('background', 'linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
					}
				}
				
				<?php if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons) && advads171_get_option('amzn_cart_enabled') == 'yes'): ?>
					<?php
					if ($advads171_preview_tpl == 'tpl_am3across')
					{
						$advads171_amzn_cart_btn_text = advads171_get_option("amzn_cart_btn_text_3prods");
						$advads171_addtocart_image = advads171_get_option("addtocart_tpl1");
					}
					elseif ($advads171_preview_tpl == 'tpl_am1product')
					{
						$advads171_amzn_cart_btn_text = advads171_get_option("amzn_cart_btn_text_1prod");
						$advads171_addtocart_image = advads171_get_option("addtocart_tpl2");
					}
					if ($advads171_amzn_cart_btn_text === FALSE || strlen(trim($advads171_amzn_cart_btn_text)) == 0)
					{
						$advads171_amzn_cart_btn_text = 'Add To Cart';
					}
					?>
						jQuery('.buy_now_advads171_text, .buy_now_large_advads171_text').removeClass('advads171_image_button_link');
						jQuery('.buy_now_advads171_text, .buy_now_large_advads171_text').text('<?=$advads171_amzn_cart_btn_text;?>');

					<?php if ($advads171_addtocart_image !== FALSE && strlen($advads171_addtocart_image) > 0): ?>
						jQuery('.amzn_buy_now_advads171_text, .amzn_buy_now_large_advads171_text').html('<img src="<?=$advads171_addtocart_image;?>" />').addClass('advads171_image_button_link');
					<?php endif; ?>

				<?php endif; ?>
				
				if ( '<?=advads171_get_option($advads171_preview_tpl."_close_btn");?>' == 'xbtn')
				{
					jQuery('.am_close_btn_advads').css('display', 'block');
					jQuery('.am_close_txt').css('display', 'none');				
				}
				else
				{
					jQuery('.am_close_txt').css('display', 'block');
					jQuery('.am_close_btn_advads').css('display', 'none');
				}
				
				jQuery("#am_popbox").fadeIn(1000);
				align_product_images();
				advads171_play_audio();
				
				jQuery('.advads171_preview_set').removeClass('active');
				jQuery('.advads171_preview_link').addClass('active');
			}
			function pbox_close()
			{
				jQuery("#am_popbox").hide(function(){jQuery(this).unbind()});
			}
			function align_product_images()
			{
				if (jQuery('.prod_img_link_epn').length > 0)
				{
					jQuery('.prod_img_link_epn img').each(function() {
						var img_height = jQuery(this).height();
						if (img_height == 0 || img_height == undefined)
						{
							img_height = 140;
						}
						if (jQuery(this).hasClass('epn_image_oneprod'))
						{
							var margin_top = Math.floor((270 - img_height) / 2);
						}
						else
						{
							var margin_top = Math.floor((190 - img_height) / 2);
						}
						jQuery(this).css('margin-top', margin_top);
					});
				}
				jQuery('.prod_img_link_epn img').css('visibility', 'visible');
			}
			<?php
			$advads171_audio = advads171_get_option($advads171_preview_tpl.'_audio');
			?>
			var advads171_audio_plays = 0;
			function advads171_play_audio()
			{
				<?php if ($advads171_audio !== FALSE && strlen(trim($advads171_audio)) > 0): ?>
				var advads171_audio_mp3 = '<?php echo $advads171_audio; ?>';
				if (advads171_audio_mp3 != '')
				{
					jQuery("#advads171_audio_player").jPlayer({
					  ready: function () {
					   jQuery(this).jPlayer("setMedia", {
						mp3: advads171_audio_mp3,
					   }).jPlayer('play');
					   advads171_audio_plays = advads171_audio_plays + 1;
					  },
					  swfPath: '<?=plugins_url( $advads171_plugin_slug.'/js/' , dirname(dirname(__FILE__)) );?>',
					  supplied: "mp3"
					 });
					 if (advads171_audio_plays != 0)
					 {
						jQuery('#advads171_audio_player').jPlayer('play');
					 }
				 }
				//jQuery('#advads171_audio_player').jPlayer('play');		
				<?php endif; ?>
			}
			  </script>
			  <div id="advads171_audio_player"></div>
			<style>
			.advads171_preview_set {display: none;}
			.advads171_preview_set.active {display: inline-block;}
			</style>
<?php
	
	if ($advads171_audio !== FALSE && strlen(trim($advads171_audio)) > 0)
	{
		wp_enqueue_script($advads171_plugin_slug.'_audio', plugins_url( $advads171_plugin_slug.'/js/jquery.jplayer.min.js' , dirname(dirname(__FILE__)) ), array('jquery'), '1.0', true);
	}
}


function advads171_promo_msg_bind_clicks_javascript() {
wp_enqueue_style('thickbox');
wp_enqueue_script('thickbox');
advads171_add_json_support();
?>
<script type="text/javascript" >
function advads171_promo_msg_bind_clicks()
{
	jQuery('.advads171_admin_msg a.advads171_promo_msg_link_a').click(function() {
	  advads171_promo_msg_click('link');
	});
	jQuery('.advads171_admin_msg a.advads171_promo_msg_hide_a').click(function() {
	  advads171_promo_msg_click('hide');
	});
	tb_init('a.advads171_thickbox');
}

jQuery(document).ready(function($) {
	advads171_promo_msg_bind_clicks();
});

function advads171_promo_msg_click(link_or_hide)
{
	var data = {
		action: 'advads171_promo_msg_click',
		link_or_hide: link_or_hide
	};
	jQuery('.advads171_admin_msg').fadeOut(500);

	jQuery.post(ajaxurl, data, function(response) {
	
	});
}
</script>
<?php
}


function advads171_promo_msg_javascript() {
advads171_add_json_support();
?>
<script type="text/javascript" >
jQuery(document).ready(function($) {

	var data = {
		action: 'advads171_promo_msg'
	};

	jQuery.post(ajaxurl, data, function(response) {
		//alert('Got this from the server: ' + response);
		if (response != '')
		{
			//var obj = jQuery.parseJSON(response);
			var obj = JSON.parse(response);
			if (obj.html != undefined)
			{
				jQuery(".advads171_admin_msg").css('display', 'none');
				if (jQuery(".advads171_admin_msg").length == 0)
				{
					
					jQuery(".wrap").prepend(obj.html);
				}
				else
				{
					jQuery(".advads171_admin_msg").replaceWith(obj.html);
				}
				jQuery('div.wrap h2:first').nextAll('div.updated, div.error').addClass('below-h2');
				jQuery('div.updated, div.error').not('.below-h2, .inline').insertAfter( jQuery('div.wrap h2:first') );
				jQuery(".advads171_admin_msg").css('display', 'none');
				jQuery(".advads171_admin_msg").fadeIn(500);
				advads171_promo_msg_bind_clicks();
			}
		}
	});
});
</script>
<?php
}

add_action('wp_ajax_advads171_promo_msg_click', 'advads171_promo_msg_click');

//$advads171_promo_msgs_click_url = 'http://216.172.160.106/advads/promo_msg/get_promo_msg';
$advads171_promo_msgs_click_url = 'http://216.172.160.106/advads/promo_msg/get_promo_msg';
function advads171_promo_msg_click() {
	global $wpdb, $_POST, $advads171_promo_msgs_click_url, $advads171_current_plugin_version;

	//get current message
	$advads171_promo_msg_raw = advads171_get_option('advads171_promo_msg', is_multisite());
	if ($advads171_promo_msg_raw === FALSE)
	{
		//generate a default msg arr
		$advads171_promo_msg = array(
					'msg_id' => 0,
					'html' => "",
					'clicked_hide' => 0,
					'clicked_link' => 0,
					'views' => 0,
					'expires' => 0
				);
	}
	else
	{
		$advads171_promo_msg = unserialize($advads171_promo_msg_raw);
	}
		//save locally first
		if (isset($_POST['link_or_hide']) && $_POST['link_or_hide'] == 'link')
		{
			$advads171_promo_msg['clicked_link'] = 1;
		}
		else
		{
			$advads171_promo_msg['clicked_hide'] = 1;
		}
		advads171_update_option('advads171_promo_msg', serialize($advads171_promo_msg), is_multisite());
		
		//register already clicked
		$args = new stdClass;
		$args->advads171_promo_msg = serialize($advads171_promo_msg);
		$args->version = $advads171_current_plugin_version;
		$request_string = advads171_prepare_request('msg_check', $args);
		$request = wp_remote_post($advads171_promo_msgs_click_url, $request_string);
		
		if (!is_wp_error($request)) 
		{
			$res = unserialize($request['body']);
			if ($res !== FALSE)
			{				
				//do nothing
			}
		}

	die(); // this is required to return a proper result
}



add_action('wp_ajax_advads171_promo_msg', 'advads171_promo_msg_update');

//$advads171_promo_msgs_url = 'http://216.172.160.106/advads/promo_msg/get_promo_msg';
$advads171_promo_msgs_url = 'http://216.172.160.106/advads/promo_msg/get_promo_msg';
function advads171_promo_msg_update() {
	global $wpdb, $_POST, $advads171_promo_msgs_url, $advads171_current_plugin_version, $advads171_plugin_slug, $advads171_plugin_name;

	//update last time check
	advads171_update_option('advads171_promo_msg_last_check', time(), is_multisite());
	
	//get current message
	$advads171_promo_msg_raw = advads171_get_option('advads171_promo_msg', is_multisite());
	if ($advads171_promo_msg_raw === FALSE)
	{
		//generate a default msg arr
		$advads171_promo_msg = array(
					'msg_id' => 0,
					'html' => "",
					'clicked_hide' => 0,
					'clicked_link' => 0,
					'views' => 0,
					'expires' => 0
				);
		//advads171_update_option('advads171_promo_msg', serialize($advads171_promo_msg));
	}
	else
	{
		$advads171_promo_msg = unserialize($advads171_promo_msg_raw);
	}		
		
		//grab new one
		$args = new stdClass;
		$args->advads171_promo_msg = serialize($advads171_promo_msg);
		$args->version = $advads171_current_plugin_version;
		$request_string = advads171_prepare_request('msg_check', $args);
		$request = wp_remote_post($advads171_promo_msgs_url, $request_string);
		
		/*echo '<pre>';
		print_r($request);
		echo '<pre>';*/
		
		if (!is_wp_error($request)) 
		{
			$res = unserialize($request['body']);
			/*echo '<pre>';
			print_r($res);
			echo '<pre>';
			exit;*/
			if ($res !== FALSE)
			{
				//update advads171 with new msg
				if (isset($res['msg_id']))
				{
					advads171_update_option('advads171_promo_msg', serialize($res), is_multisite());
					//echo $res['html'];					
					$msg_html = $res['html'];
					
					if (stripos($msg_html, "#update_details_link#") || stripos($msg_html, "#update_install_link#"))
					{
						//update plugins update data
						$current = get_site_transient( 'update_plugins' );	//Get the current update info
						$current->last_checked = 0;						//wp_update_plugins() checks this value when determining  
						set_site_transient( 'update_plugins', $current );	//whether to actually check for updates, so we reset it to zero.
						wp_update_plugins();
						//double check if we have everything to init update
						$current = get_site_transient( 'update_plugins' );
						if (!isset($current->checked) || !in_array($advads171_plugin_slug.'/'.$advads171_plugin_slug.'.php', $current->checked))
						{
							wp_update_plugins();
						}
					}
					
					//update with correct 'update details' links
					$msg_html = str_replace("#update_details_link#", network_admin_url('plugin-install.php?tab=plugin-information&plugin='.$advads171_plugin_slug.'&TB_iframe=true&width=640&height=341'), $msg_html);
					$msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$advads171_plugin_slug.'%2F'.$advads171_plugin_slug.'.php'), "upgrade-plugin_".$advads171_plugin_slug."/".$advads171_plugin_slug.".php"), $msg_html);
					
					echo json_encode(array('html' => $msg_html));
				}
				else
				{
					advads171_update_option('advads171_promo_msg', '', is_multisite());
				}
			}
		}

	die(); // this is required to return a proper result
}

function advads171_addons_check_javascript() {
?>
<script type="text/javascript" >
jQuery(document).ready(function($) {

	var data = {
		action: 'advads171_check_for_addons'
	};

	jQuery.post(ajaxurl, data, function(response) {
		//alert('Got this from the server: ' + response);
		if (response != '')
		{
			//var obj = jQuery.parseJSON(response);
			var obj = JSON.parse(response);
			if (obj.html != undefined)
			{
				jQuery('#advads171_addons_receiving_wrap').removeClass('advads171_loading');
				jQuery('#advads171_addons_receiving_wrap').html(obj.html);
				tb_init('a.advads171_thickbox');
			}
		}
	});
});
</script>
<?php
}
add_action('wp_ajax_advads171_check_for_addons', 'advads171_check_for_addons');
//$advads171_addons_check_url = 'http://216.172.160.106/advads/addons_check/get_addons';
$advads171_addons_check_url = 'http://216.172.160.106/advads/addons_check/get_addons';
function advads171_check_for_addons() {
	global $wpdb, $_POST, $advads171_addons_check_url, $advads171_current_plugin_version, $advads171_plugin_slug, $advads171_plugin_name;
	
	//grab new one
	$args = new stdClass;
	$args->version = $advads171_current_plugin_version;
	$request_string = advads171_prepare_request('msg_check', $args);
	$request = wp_remote_post($advads171_addons_check_url, $request_string);

	if (!is_wp_error($request)) 
	{
		$res = unserialize($request['body']);
		
		if ($res !== FALSE)
		{				
			
			//update advads171 with new msg
			if (isset($res['html']))
			{
				$msg_html = $res['html'];
				
				
				
				if (stripos($msg_html, "#update_details_link#") || stripos($msg_html, "#update_install_link#"))
				{
					//update plugins update data
					$current = get_site_transient( 'update_plugins' );	//Get the current update info
					$current->last_checked = 0;						//wp_update_plugins() checks this value when determining  
					set_site_transient( 'update_plugins', $current );	//whether to actually check for updates, so we reset it to zero.
					wp_update_plugins();
					//double check if we have everything to init update
					$current = get_site_transient( 'update_plugins' );
					if (!isset($current->checked) || !in_array($advads171_plugin_slug.'/'.$advads171_plugin_slug.'.php', $current->checked))
					{
						wp_update_plugins();
					}
				}
				
				$msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$advads171_plugin_slug.'%2F'.$advads171_plugin_slug.'.php'), "upgrade-plugin_".$advads171_plugin_slug."/".$advads171_plugin_slug.".php"), $msg_html);
					
					
				echo json_encode(array('html' => $msg_html));
			}
		}
	}
	if (is_wp_error($request)) {
		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
	}

	die(); // this is required to return a proper result
}


if (isset($_GET['page']) && $_GET['page'] == 'advads171-more-plugins')
{
	add_action('admin_head', 'advads171_more_plugins_check_javascript');
}

function advads171_more_plugins()
{
	global $wpdb, $advads171_plugin_name, $advads171_plugin_slug;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $advads171_plugin_slug));
	
	$curr_email = advads171_get_option('license_email');
	
	?>
	<div class="wrap">
		<h2><?php __("Get More Plugins", $advads171_plugin_slug); ?></h2>
		<p><?php __("You can find awesome new plugins on this page!", $advads171_plugin_slug); ?></p>
		
		<div id="advads171_addons_receiving_wrap" class="advads171_loading">&nbsp;</div>

	</div>
	<style>
	.advads171_loading {
	width: 128px; 
	height: 15px; 
	margin: 250px auto; 
	display: block;
	background: url(<?=site_url('wp-content/plugins/'.$advads171_plugin_slug.'/images/ajax-loader_bar.gif');?>) no-repeat center center;
	}
	</style>
	<?php
}

function advads171_more_plugins_check_javascript() {
?>
<script type="text/javascript" >
jQuery(document).ready(function($) {

	var data = {
		action: 'advads171_check_for_plugins'
	};

	jQuery.post(ajaxurl, data, function(response) {
		//alert('Got this from the server: ' + response);
		if (response != '')
		{
			//var obj = jQuery.parseJSON(response);
			var obj = JSON.parse(response);
			if (obj.html != undefined)
			{
				jQuery('#advads171_addons_receiving_wrap').removeClass('advads171_loading');
				jQuery('#advads171_addons_receiving_wrap').html(obj.html);
				tb_init('a.advads171_thickbox');
			}
		}
	});
});
</script>
<?php
}
add_action('wp_ajax_advads171_check_for_plugins', 'advads171_check_for_plugins');
//$advads171_addons_check_url = 'http://216.172.160.106/advads/addons_check/get_addons';
$advads171_plugins_check_url = 'http://216.172.160.106/caller/more_plugins_check/get_plugins';
function advads171_check_for_plugins() {
	global $wpdb, $_POST, $advads171_plugins_check_url, $advads171_current_plugin_version, $advads171_plugin_slug, $advads171_plugin_name;
	
	//grab new one
	$args = new stdClass;
	$args->version = $advads171_current_plugin_version;
	$request_string = advads171_prepare_request('msg_check', $args);
	$request = wp_remote_post($advads171_plugins_check_url, $request_string);

	if (!is_wp_error($request)) 
	{
		$res = unserialize($request['body']);
		
		if ($res !== FALSE)
		{				
			
			//update advads171 with new msg
			if (isset($res['html']))
			{
				$msg_html = $res['html'];
				
				
				
				if (stripos($msg_html, "#update_details_link#") || stripos($msg_html, "#update_install_link#"))
				{
					//update plugins update data
					$current = get_site_transient( 'update_plugins' );	//Get the current update info
					$current->last_checked = 0;						//wp_update_plugins() checks this value when determining  
					set_site_transient( 'update_plugins', $current );	//whether to actually check for updates, so we reset it to zero.
					wp_update_plugins();
					//double check if we have everything to init update
					$current = get_site_transient( 'update_plugins' );
					if (!isset($current->checked) || !in_array($advads171_plugin_slug.'/'.$advads171_plugin_slug.'.php', $current->checked))
					{
						wp_update_plugins();
					}
				}
				
				$msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$advads171_plugin_slug.'%2F'.$advads171_plugin_slug.'.php'), "upgrade-plugin_".$advads171_plugin_slug."/".$advads171_plugin_slug.".php"), $msg_html);
					
					
				echo json_encode(array('html' => $msg_html));
			}
		}
	}
	if (is_wp_error($request)) {
		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
	}

	die(); // this is required to return a proper result
}



//BOF custom news feed widget
add_action('wp_network_dashboard_setup', 'advads171_dashboard_widgets');
add_action('wp_dashboard_setup', 'advads171_dashboard_widgets');

function advads171_dashboard_widgets() {
	global $wp_meta_boxes, $advads171_plugin_slug, $advads171_plugin_name;
	$dashboard_key = 'dashboard';
	if (isset($wp_meta_boxes['dashboard-network']))
	{
		$dashboard_key = 'dashboard-network';
	}
	wp_add_dashboard_widget( 'advads171_dashboard_custom_feed', sprintf(__('%s Recent News & Updates', $advads171_plugin_slug), $advads171_plugin_name) , 'advads171_dashboard_custom_feed_output' );
	// Get the regular dashboard widgets array 
	// (which has our new widget already but at the end)
	$normal_dashboard = $wp_meta_boxes[$dashboard_key]['normal']['core'];	

	// Backup and delete our new dashboard widget from the end of the array
	$example_widget_backup = array('advads171_dashboard_custom_feed' => $normal_dashboard['advads171_dashboard_custom_feed']);
	unset($normal_dashboard['advads171_dashboard_custom_feed']);
	// Merge the two arrays together so our widget is at the beginning
	$sorted_dashboard = array_merge($example_widget_backup, $normal_dashboard);

	// Save the sorted array back into the original metaboxes 
	$wp_meta_boxes[$dashboard_key]['normal']['core'] = $sorted_dashboard;
	
}


function advads171_dashboard_custom_feed_output() {
	global $advads171_plugin_slug, $advads171_plugin_name;
	echo '<div>';
	wp_widget_rss_output(array(
	'url' => 'http://contextazon.com/category/recent-news-updates/feed/',
	'title' => sprintf(__('%s Recent News & Updates', $advads171_plugin_slug), $advads171_plugin_name),
	'items' => 2,
	'show_summary' => 1,
	'show_author' => 0,
	'show_date' => 1
	));
	echo '</div>';
}
//EOF custom news feed widget

function advads171_ad_units() {
	global $am_indexes, $advads171_plugin_slug, $advads171_plugin_name;
	//if (!wp_verify_nonce($_REQUEST['_wpnonce'], dirname(plugin_basename(__FILE__)))) exit('Unauthorized access');
	require_once(dirname(dirname(__FILE__)).'/app/controllers/manage_banners.php');	
}


function advads171_prepare_postboxes()
{
wp_enqueue_script( 'postbox' );		
?>
<script type="text/javascript">
jQuery(document).ready( function() {
	jQuery('.postbox h3, .postbox .handlediv').click( function() {
		jQuery(jQuery(this).parent().get(0)).toggleClass('closed');
	});
});
</script>
<style>
	.postbox .hndle {cursor: pointer;}
	.advanced_tab_wrap {width: 80%;}
	.advads171_form_error {
	margin: 5px 0 15px;
	background-color: #FFEBE8;
	border-color: #CC0000;
	padding: 0 0.6em;
	border-radius: 3px 3px 3px 3px;
	border-style: solid;
	border-width: 1px;
	color: #333;
	}
</style>
<?php
}

function advads171_add_json_support()
{
	global $_SERVER, $advads171_plugin_slug, $advads171_plugin_name;
	//add json support for jquery older than 1.4.1
	$advads171_json_js_url = plugins_url( $advads171_plugin_slug.'/js/json2_min.js' , dirname(dirname(__FILE__)) );				
	if (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' && substr($advads171_json_js_url, 0, 11) != 'http://www.' && substr($advads171_json_js_url, 0, 12) != 'https://www.')
	{
		if (substr($advads171_json_js_url, 0, 7) == 'http://') $advads171_json_js_url = str_replace('http://', 'http://www.', $advads171_json_js_url);
		if (substr($advads171_json_js_url, 0, 8) == 'https://') $advads171_json_js_url = str_replace('https://', 'https://www.', $advads171_json_js_url);
	}
	elseif (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) != 'www.' && (substr($advads171_json_js_url, 0, 11) == 'http://www.' || substr($advads171_json_js_url, 0, 12) == 'https://www.'))
	{
		if (substr($advads171_json_js_url, 0, 7) == 'http://') $advads171_json_js_url = str_replace('http://', 'http://www.', $advads171_json_js_url);
		if (substr($advads171_json_js_url, 0, 8) == 'https://') $advads171_json_js_url = str_replace('https://', 'https://www.', $advads171_json_js_url);
	}
	wp_enqueue_script($advads171_plugin_slug.'_json', $advads171_json_js_url, array(), '1.0', true);
}

add_action('admin_print_scripts', 'advads171_jplayer_js');
function advads171_jplayer_js()
{
	global $advads171_plugin_slug;
	wp_register_script('advads171_audio', WP_PLUGIN_URL.'/'.$advads171_plugin_slug.'/js/jquery.jplayer.min.js', array('jquery'));
	wp_enqueue_script('advads171_audio');
}

function advads171_tpledit_admin_scripts() {
	global $advads171_plugin_slug;
	wp_enqueue_script('media-upload');
	wp_enqueue_script('thickbox');
	wp_register_script('advads171_tpledit_upload', WP_PLUGIN_URL.'/'.$advads171_plugin_slug.'/js/edit_tpl.js', array('jquery','media-upload','thickbox'));
	wp_enqueue_script('advads171_tpledit_upload');
}
 
function advads171_tpledit_admin_styles() {
	wp_enqueue_style('thickbox');
}
 
if (isset($_GET['page']) && $_GET['page'] == 'advads171-config' && isset($_GET['tab']) && ($_GET['tab'] == 'appearance' || $_GET['tab'] == 'amazon')) {
	add_action('admin_print_scripts', 'advads171_tpledit_admin_scripts');
	add_action('admin_print_styles', 'advads171_tpledit_admin_styles');
}

function advads171_visitor_log()
{
	global $wpdb, $advads171_plugin_slug;
	require_once(dirname(dirname(__FILE__)).'/app/controllers/visitor_log.php');
	
}