<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://www.advads171.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

class advads171_amazon_api
{

    function advads171_amazon_api($params)
	{
		//Amazon API keys
		$this->api_keys['key_id'] = $params['key_id'];
		$this->api_keys['access_key'] = $params['access_key'];
		$this->associate_tag = $params['associate_tag'];
	}

    
    function search_amazon($keywords = '', $search_index = 'All', $item_page = 1, $locale = 'us', $preview_general = FALSE, $response_groups = '', $adtnl_url_params = array())
    {
		//You Amazon API keys
		$aws_access_key_id = $this->api_keys['key_id'];
		$aws_secret_access_key = $this->api_keys['access_key'];
		$locale_search_indexes['uk'] = array('All', 'Apparel', 'Appliances', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'Classical', 'DVD', 'Electronics', 'Grocery', 'HealthPersonalCare', 'HomeGarden', 'HomeImprovement', 'Jewelry', 'KindleStore', 'Kitchen', 'Lighting', 'MP3Downloads', 'Music', 'MusicalInstruments', 'OfficeProducts', 'OutdoorLiving', 'PetSupplies', 'PCHardware', 'Shoes', 'Software', 'SportingGoods', 'Tools', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['de'] = array('All', 'Apparel', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'Classical', 'DVD', 'Electronics', 'Grocery', 'HealthPersonalCare', 'HomeGarden', 'Jewelry', 'KindleStore', 'Kitchen', 'Lighting', 'Magazines', 'MP3Downloads', 'Music', 'MusicalInstruments', 'OfficeProducts', 'OutdoorLiving', 'PCHardware', 'PetSupplies', 'Photo', 'Shoes', 'Software', 'SportingGoods', 'Tools', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['jp'] = array('All', 'Apparel', 'Appliances', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'DVD', 'Electronics', 'ForeignBooks', 'Grocery', 'HealthPersonalCare', 'Hobbies', 'Jewelry', 'Kitchen', 'Music', 'MusicalInstruments', 'OfficeProducts', 'PCHardware', 'PetSupplies', 'Shoes', 'Software', 'SportingGoods', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['fr'] = array('All', 'Apparel', 'Appliances', 'Baby', 'Blended', 'Books', 'DVD', 'Electronics', 'ForeignBooks', 'HealthPersonalCare', 'Jewelry', 'KindleStore', 'Kitchen', 'Lighting', 'Music', 'MusicalInstruments', 'OfficeProducts', 'PCHardware', 'Shoes', 'Software', 'SportingGoods', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['ca'] = array('All', 'Baby', 'Blended', 'Books', 'Classical', 'Electronics', 'Kitchen', 'Music', 'SportingGoods', 'Software', 'Tools', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['it'] = array('All', 'Books', 'DVD', 'Electronics', 'ForeignBooks', 'KindleStore', 'Kitchen', 'Music', 'Garden', 'Shoes', 'SportingGoods', 'Software', 'Toys', 'VideoGames', 'Watches');
		$locale_search_indexes['cn'] = array('All', 'Apparel', 'Appliances', 'Automotive', 'Baby', 'Beauty', 'Books', 'Electronics', 'Grocery', 'HealthPersonalCare', 'Home', 'HomeImprovement', 'Jewelry', 'Misc', 'Music', 'OfficeProducts', 'Photo', 'Shoes', 'Software', 'SportingGoods', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['es'] = array('All', 'Books', 'DVD', 'Electronics', 'ForeignBooks' ,'KindleStore', 'Kitchen', 'Music', 'Software', 'Toys', 'VideoGames', 'Watches');
		
		//find locale and correct searchindex
		if ($locale != 'us')
		{
			if (!in_array($search_index, $locale_search_indexes[$locale]))
			{
				if (in_array('Blended', $locale_search_indexes[$locale]))
				{
					$search_index = 'Blended';
				}
				else
				{
					$search_index = 'All';
				}
			}
		}

		
		$endpoints['us'] = 'ecs.amazonaws.com';
		$endpoints['ca'] = 'ecs.amazonaws.ca';
		$endpoints['uk'] = 'ecs.amazonaws.co.uk';
		$endpoints['jp'] = 'ecs.amazonaws.jp';
		$endpoints['it'] = 'webservices.amazon.it';
		$endpoints['fr'] = 'ecs.amazonaws.fr';
		$endpoints['es'] = 'webservices.amazon.es';
		$endpoints['de'] = 'ecs.amazonaws.de';
		$endpoints['cn'] = 'webservices.amazon.cn';		
		
		$base_url = 'http://'.$endpoints[$locale].'/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=' . $aws_access_key_id . '&';
		
		//Set parameters for API search, see AWS documentation for a detailed list of parameters
		
		$extra_response_groups = '';
		if (is_array($response_groups) && count($response_groups) > 0)
		{
			$extra_response_groups = ','.implode(',', $response_groups);
		}
		if ($preview_general === FALSE)
		{
			$url_params = array(
				'Operation'=>'ItemSearch',
				'ItemPage'=>$item_page,
				'AssociateTag'=>$this->associate_tag,
				'Version'=>'2011-08-01',
				'ResponseGroup'=>'Medium'.$extra_response_groups,
				'SearchIndex'=> $search_index,
				'Keywords'=>rawurlencode($keywords)
			 );


			 if (count($adtnl_url_params) > 0)
			 {
				$url_params = array_merge($url_params, $adtnl_url_params);
			 }
			 //$url_params['Condition'] = 'New';
			 /*echo '<pre>';
			 print_r($url_params);
			 echo '</pre>';*/
			 //exit;
		}
		else
		{
			$url_params = array(
				'Operation'=>'ItemSearch',
				'ItemPage'=>$item_page,
				'AssociateTag'=>$this->associate_tag,
				'Version'=>'2011-08-01',
				'ResponseGroup'=>'Medium'.$extra_response_groups,
				'SearchIndex'=> 'All',
				'Keywords'=>rawurlencode('ipod')
			 );
		}
		 
		//Sort the URL parameters
		$url_parts = array();
		foreach(array_keys($url_params) as $key)
		    $url_parts[] = $key."=".$url_params[$key];
		sort($url_parts);
		
		//Build and encode the request URL
		$url = $base_url . implode('&',$url_parts);
		$host = parse_url($base_url . implode('&',$url_parts),PHP_URL_HOST);
		$timestamp = gmstrftime('%Y-%m-%dT%H:%M:%S.000Z');
		$url = $url. '&Timestamp=' . $timestamp;
		$paramstart = strpos($url,'?');
		$workurl = substr($url,$paramstart+1);
		$workurl = str_replace(",","%2C",$workurl);
		$workurl = str_replace(":","%3A",$workurl);
		$params = explode("&",$workurl);
		sort($params);
		$signstr = "GET\n" . $host . "\n/onca/xml\n" . implode("&",$params);
		$signstr = base64_encode(hash_hmac('sha256', $signstr, $aws_secret_access_key, true));
		$signstr = urlencode($signstr);
		$signedurl = $url . "&Signature=" . $signstr;
		$request = $signedurl;	
		
		//echo $request;
		//exit;
		
		//Send request to AWS
		$session = curl_init($request);
		curl_setopt($session, CURLOPT_HEADER, false);
		curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
		$response = curl_exec($session);
		curl_close($session); 
		$parsed_xml = simplexml_load_string($response);
		
		/*echo '<pre>';
		print_r($parsed_xml);
		echo '</pre>';
		exit;*/

		//Return parsed Amazon data
		return $parsed_xml;				
    }
	
	
	function asin_lookup($item_id = '', $locale = 'us', $response_groups = '')
    {
		//You Amazon API keys
		$aws_access_key_id = $this->api_keys['key_id'];
		$aws_secret_access_key = $this->api_keys['access_key'];
		
		$endpoints['us'] = 'ecs.amazonaws.com';
		$endpoints['ca'] = 'ecs.amazonaws.ca';
		$endpoints['uk'] = 'ecs.amazonaws.co.uk';
		$endpoints['jp'] = 'ecs.amazonaws.jp';
		$endpoints['it'] = 'webservices.amazon.it';
		$endpoints['fr'] = 'ecs.amazonaws.fr';
		$endpoints['es'] = 'webservices.amazon.es';
		$endpoints['de'] = 'ecs.amazonaws.de';
		$endpoints['cn'] = 'webservices.amazon.cn';		
		
		$base_url = 'http://'.$endpoints[$locale].'/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=' . $aws_access_key_id . '&';
		
		$extra_response_groups = '';
		if (is_array($response_groups) && count($response_groups) > 0)
		{
			$extra_response_groups = ','.implode(',', $response_groups);
		}
		//Set parameters for API search, see AWS documentation for a detailed list of parameters
		$url_params = array(
			'Operation'=>'ItemLookup',
			'AssociateTag'=>$this->associate_tag,
			'Version'=>'2011-08-01',
			'ResponseGroup'=>'Medium'.$extra_response_groups,
		 	/*'SearchIndex'=> $search_index,*/
		 	'ItemId'=>rawurlencode($item_id)
		 );
		 
		//Sort the URL parameters
		$url_parts = array();
		foreach(array_keys($url_params) as $key)
		    $url_parts[] = $key."=".$url_params[$key];
		sort($url_parts);
		
		//Build and encode the request URL
		$url = $base_url . implode('&',$url_parts);
		$host = parse_url($base_url . implode('&',$url_parts),PHP_URL_HOST);
		$timestamp = gmstrftime('%Y-%m-%dT%H:%M:%S.000Z');
		$url = $url. '&Timestamp=' . $timestamp;
		$paramstart = strpos($url,'?');
		$workurl = substr($url,$paramstart+1);
		$workurl = str_replace(",","%2C",$workurl);
		$workurl = str_replace(":","%3A",$workurl);
		$params = explode("&",$workurl);
		sort($params);
		$signstr = "GET\n" . $host . "\n/onca/xml\n" . implode("&",$params);
		$signstr = base64_encode(hash_hmac('sha256', $signstr, $aws_secret_access_key, true));
		$signstr = urlencode($signstr);
		$signedurl = $url . "&Signature=" . $signstr;
		$request = $signedurl;	
		
		//Send request to AWS
		$session = curl_init($request);
		curl_setopt($session, CURLOPT_HEADER, false);
		curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
		$response = curl_exec($session);
		curl_close($session); 
		$parsed_xml = simplexml_load_string($response);
		
		/*echo '<pre>';
		print_r($parsed_xml);
		echo '</pre>';
		exit;*/
		
		//Return parsed Amazon data
		return $parsed_xml;				
    }
	
	function similar_lookup($item_id = '', $locale = 'us', $response_groups = '')
    {
		//You Amazon API keys
		$aws_access_key_id = $this->api_keys['key_id'];
		$aws_secret_access_key = $this->api_keys['access_key'];
		
		$endpoints['us'] = 'ecs.amazonaws.com';
		$endpoints['ca'] = 'ecs.amazonaws.ca';
		$endpoints['uk'] = 'ecs.amazonaws.co.uk';
		$endpoints['jp'] = 'ecs.amazonaws.jp';
		$endpoints['it'] = 'webservices.amazon.it';
		$endpoints['fr'] = 'ecs.amazonaws.fr';
		$endpoints['es'] = 'webservices.amazon.es';
		$endpoints['de'] = 'ecs.amazonaws.de';
		$endpoints['cn'] = 'webservices.amazon.cn';		
		
		$base_url = 'http://'.$endpoints[$locale].'/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=' . $aws_access_key_id . '&';
		
		$extra_response_groups = '';
		if (is_array($response_groups) && count($response_groups) > 0)
		{
			$extra_response_groups = ','.implode(',', $response_groups);
		}
		//Set parameters for API search, see AWS documentation for a detailed list of parameters
		$url_params = array(
			'Operation'=>'ItemLookup',
			'AssociateTag'=>$this->associate_tag,
			'Version'=>'2011-08-01',
			'ResponseGroup'=>$extra_response_groups,
		 	/*'SearchIndex'=> $search_index,*/
		 	'ItemId'=>rawurlencode($item_id)
		 );
		 
		//Sort the URL parameters
		$url_parts = array();
		foreach(array_keys($url_params) as $key)
		    $url_parts[] = $key."=".$url_params[$key];
		sort($url_parts);
		
		//Build and encode the request URL
		$url = $base_url . implode('&',$url_parts);
		$host = parse_url($base_url . implode('&',$url_parts),PHP_URL_HOST);
		$timestamp = gmstrftime('%Y-%m-%dT%H:%M:%S.000Z');
		$url = $url. '&Timestamp=' . $timestamp;
		$paramstart = strpos($url,'?');
		$workurl = substr($url,$paramstart+1);
		$workurl = str_replace(",","%2C",$workurl);
		$workurl = str_replace(":","%3A",$workurl);
		$params = explode("&",$workurl);
		sort($params);
		$signstr = "GET\n" . $host . "\n/onca/xml\n" . implode("&",$params);
		$signstr = base64_encode(hash_hmac('sha256', $signstr, $aws_secret_access_key, true));
		$signstr = urlencode($signstr);
		$signedurl = $url . "&Signature=" . $signstr;
		$request = $signedurl;	
		
		//Send request to AWS
		$session = curl_init($request);
		curl_setopt($session, CURLOPT_HEADER, false);
		curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
		$response = curl_exec($session);
		curl_close($session); 
		$parsed_xml = simplexml_load_string($response);
		
		/*echo '<pre>';
		print_r($parsed_xml);
		echo '</pre>';
		exit;*/
		
		//Return parsed Amazon data
		return $parsed_xml;				
    }
	
	function browse_node($locale = 'us', $parent_node = 0)
    {
		//You Amazon API keys
		$aws_access_key_id = $this->api_keys['key_id'];
		$aws_secret_access_key = $this->api_keys['access_key'];

		$locale_search_indexes['uk'] = array('All', 'Apparel','Appliances', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'Classical', 'DVD', 'Electronics', 'Grocery', 'HealthPersonalCare', 'HomeGarden', 'HomeImprovement', 'Jewelry', 'KindleStore', 'Kitchen', 'Lighting', 'MP3Downloads', 'Music', 'MusicalInstruments', 'OfficeProducts', 'OutdoorLiving', 'PetSupplies', 'PCHardware', 'Shoes', 'Software', 'SportingGoods', 'Tools', 'Toys', 'Video', 'VideoGames', 'Watches');
		
		
		$locale_search_indexes['de'] = array('All', 'Apparel', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'Classical', 'DVD', 'Electronics', 'Grocery', 'HealthPersonalCare', 'HomeGarden', 'Jewelry', 'KindleStore', 'Kitchen', 'Lighting', 'Magazines', 'MP3Downloads', 'Music', 'MusicalInstruments', 'OfficeProducts', 'OutdoorLiving', 'PCHardware', 'PetSupplies', 'Photo', 'Shoes', 'Software', 'SportingGoods', 'Tools', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['jp'] = array('All', 'Apparel', 'Appliances', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'DVD', 'Electronics', 'ForeignBooks', 'Grocery', 'HealthPersonalCare', 'Hobbies', 'Jewelry', 'Kitchen', 'Music', 'MusicalInstruments', 'OfficeProducts', 'PCHardware', 'PetSupplies', 'Shoes', 'Software', 'SportingGoods', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['fr'] = array('All', 'Apparel', 'Appliances', 'Baby', 'Blended', 'Books', 'DVD', 'Electronics', 'ForeignBooks', 'HealthPersonalCare', 'Jewelry', 'KindleStore', 'Kitchen', 'Lighting', 'Music', 'MusicalInstruments', 'OfficeProducts', 'OfficeProducts', 'PCHardware', 'Shoes', 'Software', 'SportingGoods', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['ca'] = array('All', 'Baby', 'Blended', 'Books', 'Classical', 'Electronics', 'Kitchen', 'Music', 'SportingGoods', 'Software', 'Tools', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['it'] = array('All', 'Books', 'DVD', 'Electronics', 'ForeignBooks', 'KindleStore', 'Kitchen', 'Music', 'Garden', 'Shoes', 'SportingGoods', 'Software', 'Toys', 'VideoGames', 'Watches');
		$locale_search_indexes['cn'] = array('All', 'Apparel', 'Appliances', 'Automotive', 'Baby', 'Beauty', 'Books', 'Electronics', 'Grocery', 'HealthPersonalCare', 'Home', 'HomeImprovement', 'Jewelry', 'Misc', 'Music', 'OfficeProducts', 'Photo', 'Shoes', 'Software', 'SportingGoods', 'Toys', 'Video', 'VideoGames', 'Watches');
		$locale_search_indexes['es'] = array('All', 'Books', 'DVD', 'Electronics', 'ForeignBooks', 'KindleStore', 'Kitchen', 'Music', 'Software', 'Toys', 'VideoGames', 'Watches');
		
		$endpoints['us'] = 'ecs.amazonaws.com';
		$endpoints['ca'] = 'ecs.amazonaws.ca';
		$endpoints['uk'] = 'ecs.amazonaws.co.uk';
		$endpoints['jp'] = 'ecs.amazonaws.jp';
		$endpoints['it'] = 'webservices.amazon.it';
		$endpoints['fr'] = 'ecs.amazonaws.fr';
		$endpoints['es'] = 'webservices.amazon.es';
		$endpoints['de'] = 'ecs.amazonaws.de';
		$endpoints['cn'] = 'webservices.amazon.cn';		
		
		$base_url = 'http://'.$endpoints[$locale].'/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=' . $aws_access_key_id . '&';
		
		//Set parameters for API search, see AWS documentation for a detailed list of parameters
		
		$extra_response_groups = '';
		if (is_array($response_groups) && count($response_groups) > 0)
		{
			$extra_response_groups = ','.implode(',', $response_groups);
		}

		$url_params = array(
			'Operation'=>'BrowseNodeLookup',
			'AssociateTag'=>$this->associate_tag,
			'Version'=>'2011-08-01',
			'ResponseGroup'=>'BrowseNodeInfo',
			'BrowseNodeId'=> $parent_node
		 );
		 
		//Sort the URL parameters
		$url_parts = array();
		foreach(array_keys($url_params) as $key)
		    $url_parts[] = $key."=".$url_params[$key];
		sort($url_parts);
		
		//Build and encode the request URL
		$url = $base_url . implode('&',$url_parts);
		$host = parse_url($base_url . implode('&',$url_parts),PHP_URL_HOST);
		$timestamp = gmstrftime('%Y-%m-%dT%H:%M:%S.000Z');
		$url = $url. '&Timestamp=' . $timestamp;
		$paramstart = strpos($url,'?');
		$workurl = substr($url,$paramstart+1);
		$workurl = str_replace(",","%2C",$workurl);
		$workurl = str_replace(":","%3A",$workurl);
		$params = explode("&",$workurl);
		sort($params);
		$signstr = "GET\n" . $host . "\n/onca/xml\n" . implode("&",$params);
		$signstr = base64_encode(hash_hmac('sha256', $signstr, $aws_secret_access_key, true));
		$signstr = urlencode($signstr);
		$signedurl = $url . "&Signature=" . $signstr;
		$request = $signedurl;	
		
		//echo $request;
		//exit;
		
		//Send request to AWS
		$session = curl_init($request);
		curl_setopt($session, CURLOPT_HEADER, false);
		curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
		$response = curl_exec($session);
		curl_close($session); 
		$parsed_xml = simplexml_load_string($response);
		
		/*echo '<pre>';
		print_r($parsed_xml);
		echo '</pre>';
		exit;*/

		//Return parsed Amazon data
		return $parsed_xml;				
    }
	
	function get_top_node_id($country = 'us', $search_index = 'All')
	{
		$locale_search_indexes['us'] = array('All' => '0', 'Apparel' => '1036682', 'Appliances' => '2619526011', 'ArtsAndCrafts' => '2617942011', 'Automotive' => '15690151', 'Baby' => '165797011', 'Beauty' => '11055981', 'Blended' => '0', 'Books' => '1000', 'Classical' => '301668', 'Collectibles' => '4991426011', 'DVD' => '2625374011', 'Electronics' => '493964', 'Grocery' => '16310211', 'HealthPersonalCare' => '3760931', 'HomeGarden' => '3238155011', 'Industrial' => '16310161', 'Jewelry' => '3880591', 'KindleStore' => '133141011', 'Kitchen' => '1063498', 'Magazines' => '599872', 'Miscellaneous' => '10304191', 'MobileApps' => '2350150011', 'MP3Downloads' => '624868011', 'Music' => '301668', 'MusicalInstruments' => '11965861', 'OfficeProducts' => '1084128', 'OutdoorLiving' => '3375301', 'PCHardware' => '541966', 'PetSupplies' => '2619534011', 'Photo' => '502394', 'Shoes' => '672124011', 'Software' => '409488', 'SportingGoods' => '3375301', 'Tools' => '468240', 'Toys' => '165795011', 'Video' => '2625374011', 'VideoGames' => '11846801', 'Watches' => '378516011');
		$locale_search_indexes['uk'] = array('All' => '0', 'Apparel' => '83451031', 'Appliances' => '908799031', 'Automotive' => '248878031', 'Baby' => '60032031', 'Beauty' => '66280031', 'Blended' => '0', 'Books' => '1025612', 'Classical' => '505510', 'DVD' => '573406', 'Electronics' => '560800', 'Grocery' => '344155031', 'HealthPersonalCare' => '66280031', 'HomeGarden' => '11052591', 'HomeImprovement' => '79904031', 'Jewelry' => '193717031', 'KindleStore' => '341678031', 'Kitchen' => '3147411', 'Lighting' => '213078031', 'MP3Downloads' => '77198031', 'Music' => '505510', 'MusicalInstruments' => '340838031', 'OfficeProducts' => '192414031', 'OutdoorLiving' => '319530011', 'PetSupplies' => '340841031', 'PCHardware' => '340832031', 'Shoes' => '362350011', 'Software' => '1025614', 'SportingGoods' => '319530011', 'Tools' => '84124031', 'Toys' => '712832', 'Video' => '573406', 'VideoGames' => '1025616', 'Watches' => '328229011');
		$locale_search_indexes['de'] = array('All' => '0', 'Apparel' => '78689031', 'Automotive' => '79899031', 'Baby' => '357577011', 'Beauty' => '64257031', 'Blended' => '0', 'Books' => '541686', 'Classical' => '542676', 'DVD' => '547664', 'Electronics' => '569604', 'Grocery' => '340847031', 'HealthPersonalCare' => '64257031', 'HomeGarden' => '10925241', 'Jewelry' => '327473011', 'KindleStore' => '530485031', 'Kitchen' => '3169011', 'Lighting' => '213084031', 'Magazines' => '1161660', 'MP3Downloads' => '180529031', 'Music' => '542676', 'MusicalInstruments' => '340850031', 'OfficeProducts' => '192417031', 'OutdoorLiving' => '16435121', 'PCHardware' => '340844031', 'PetSupplies' => '340853031', 'Photo' => '569604', 'Shoes' => '361139011', 'Software' => '542064', 'SportingGoods' => '16435121', 'Tools' => '80085031', 'Toys' => '12950661', 'Video' => '761254', 'VideoGames' => '541708', 'Watches' => '193708031');
		$locale_search_indexes['jp'] = array('All' => '0', 'Apparel' => '361299011', 'Appliances' => '2277725051', 'Automotive' => '2017305051', 'Baby' => '13331821', 'Beauty' => '52391051', 'Blended' => '0', 'Books' => '465610', 'DVD' => '562002', 'Electronics' => '3210991', 'ForeignBooks' => '465610', 'Grocery' => '57240051', 'HealthPersonalCare' => '161669011', 'Hobbies' => '13331821', 'Jewelry' => '85896051', 'Kitchen' => '3839151', 'Music' => '562032', 'MusicalInstruments' => '2123630051', 'OfficeProducts' => '86732051', 'PetSupplies' => '2127213051', 'PCHardware' => '2127210051', 'Shoes' => '2016927051', 'Software' => '637630', 'SportingGoods' => '14315361', 'Toys' => '13331821', 'Video' => '561972', 'VideoGames' => '637872', 'Watches' => '14315361');
		$locale_search_indexes['fr'] = array('All' => '0', 'Apparel' => '340856031', 'Appliances' => '908827031', 'Baby' => '206618031', 'Blended' => '0', 'Books' => '301130', 'DVD' => '409392', 'Electronics' => '13910671', 'ForeignBooks' => '69633011', 'HealthPersonalCare' => '197859031', 'Jewelry' => '193711031', 'Kitchen' => '57686031', 'KindleStore' => '672109031', 'Music' => '206442031', 'MusicalInstruments' => '340862031', 'OfficeProducts' => '192420031', 'PCHardware' => '340859031', 'Shoes' => '215935031', 'Software' => '547972', 'SportingGoods' => '325615031', 'Toys' => '322088011', 'Video' => '409392', 'VideoGames' => '548014', 'Watches' => '60937031');
		$locale_search_indexes['ca'] = array('All' => '0', 'Baby' => '3561347011', 'Blended' => '0', 'Books' => '927726', 'Classical' => '962454', 'Electronics' => '677211011', 'Kitchen' => '2206276011', 'Music' => '962454', 'Software' => '3234171', 'SportingGoods' => '2242990011', 'Tools' => '3006903011', 'Video' => '952768', 'VideoGames' => '110218011', 'Watches' => '2235621011');
		$locale_search_indexes['it'] = array('All' => '0', 'Books' => '411664031', 'DVD' => '412607031', 'Electronics' => '412610031', 'ForeignBooks' => '433843031', 'KindleStore' => '818939031', 'Kitchen' => '524016031', 'Music' => '412601031', 'Garden' => '635017031', 'Shoes' => '524007031', 'SportingGoods' => '524013031', 'Software' => '412613031', 'Toys' => '523998031', 'VideoGames' => '412604031', 'Watches' => '524010031');
		$locale_search_indexes['cn'] = array('All' => '0', 'Apparel' => '2016157051', 'Appliances' => '80208071', 'Automotive' => '1947900051', 'Baby' => '42693071', 'Beauty' => '746777051', 'Books' => '658391051', 'Electronics' => '2016117051', 'Grocery' => '2127216051', 'HealthPersonalCare' => '852804051', 'Home' => '2016127051', 'HomeImprovement' => '1952921051', 'Jewelry' => '816483051', 'Misc' => '899281051', 'Music' => '754387051', 'OfficeProducts' => '2127222051', 'Photo' => '755653051', 'Shoes' => '2029190051', 'Software' => '863873051', 'SportingGoods' => '836313051', 'Toys' => '647071051', 'Video' => '2016137051', 'VideoGames' => '897416051', 'Watches' => '1953165051');
		$locale_search_indexes['es'] = array('All' => '0', 'Books' => '599365031', 'DVD' => '599380031', 'Electronics' => '667050031', 'ForeignBooks' => '599368031', 'KindleStore' => '818938031',  'Kitchen' => '599392031', 'Music' => '599374031', 'Software' => '599377031', 'Toys' => '599386031', 'VideoGames' => '599383031', 'Watches' => '599389031');
		if (isset($locale_search_indexes[$country]) && isset($locale_search_indexes[$country][$search_index]))
		{
			return $locale_search_indexes[$country][$search_index];
		}
		return '0';
	}
	
	function get_indexes($country = 'us')
	{
		$locale_search_indexes['us'] = array('All' => 'All', 'Apparel' => 'Apparel', 'Appliances' => 'Appliances', 'ArtsAndCrafts' => 'Arts And Crafts', 'Automotive' => 'Automotive', 'Baby' => 'Baby', 'Beauty' => 'Beauty', 'Blended' => 'Blended', 'Books' => 'Books', 'Classical' => 'Classical', 'Collectibles' => 'Collectibles', 'DVD' => 'DVD', 'Electronics' => 'Electronics', 'Grocery' => 'Grocery & Gourmet Food', 'HealthPersonalCare' => 'Health & Personal Care', 'HomeGarden' => 'Home & Garden', 'Industrial' => 'Industrial & Scientific', 'Jewelry' => 'Jewelry', 'KindleStore' => 'KindleStore', 'Kitchen' => 'Home & Kitchen', 'Magazines' => 'Magazines', 'Miscellaneous' => 'Miscellaneous', 'MobileApps' => 'MobileApps', 'MP3Downloads' => 'MP3 Downloads', 'Music' => 'Music', 'MusicalInstruments' => 'Musical Instruments', 'OfficeProducts' => 'Office Products', 'OutdoorLiving' => 'Outdoor Living', 'PCHardware' => 'PC Hardware', 'PetSupplies' => 'Pet Supplies', 'Photo' => 'Photo', 'Shoes' => 'Shoes & Accessories', 'Software' => 'Software', 'SportingGoods' => 'Sporting Goods', 'Tools' => 'Tools', 'Toys' => 'Toys', 'Video' => 'Movies & TV', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		$locale_search_indexes['uk'] = array('All' => 'All', 'Apparel' => 'Apparel', 'Appliances' => 'Large Appliances', 'Automotive' => 'Automotive', 'Baby' => 'Baby', 'Beauty' => 'Beauty', 'Blended' => 'Blended', 'Books' => 'Books', 'Classical' => 'Classical', 'DVD' => 'DVD', 'Electronics' => 'Electronics', 'Grocery' => 'Grocery', 'HealthPersonalCare' => 'Health & Personal Care', 'HomeGarden' => 'Home Garden', 'HomeImprovement' => 'Home Improvement', 'Jewelry' => 'Jewelry', 'KindleStore' => 'Kindle Store', 'Kitchen' => 'Kitchen', 'Lighting' => 'Lighting', 'MP3Downloads' => 'MP3 Downloads', 'Music' => 'Music', 'MusicalInstruments' => 'Musical Instruments', 'OfficeProducts' => 'Office Products', 'OutdoorLiving' => 'Outdoor Living', 'PetSupplies' => 'PetSupplies', 'PCHardware' => 'Computers & Accessories', 'Shoes' => 'Shoes', 'Software' => 'Software', 'SportingGoods' => 'Sporting Goods', 'Tools' => 'Tools', 'Toys' => 'Toys', 'Video' => 'Video', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		$locale_search_indexes['de'] = array('All' => 'All', 'Apparel' => 'Apparel', 'Automotive' => 'Automotive', 'Baby' => 'Baby', 'Beauty' => 'Beauty', 'Blended' => 'Blended', 'Books' => 'Books', 'Classical' => 'Classical', 'DVD' => 'DVD', 'Electronics' => 'Electronics', 'Grocery' => 'Grocery', 'HealthPersonalCare' => 'Health & Personal Care', 'HomeGarden' => 'Home Garden', 'Jewelry' => 'Jewelry', 'KindleStore' => 'Kindle Store', 'Kitchen' => 'Kitchen', 'Lighting' => 'Lighting', 'Magazines' => 'Magazines', 'MP3Downloads' => 'MP3 Downloads', 'Music' => 'Music', 'MusicalInstruments' => 'Musical Instruments', 'OfficeProducts' => 'Office Products', 'OutdoorLiving' => 'Outdoor Living', 'PCHardware' => 'PC Hardware', 'PetSupplies' => 'Pet Supplies', 'Photo' => 'Photo', 'Shoes' => 'Shoes', 'Software' => 'Software', 'SportingGoods' => 'Sporting Goods', 'Tools' => 'Tools', 'Toys' => 'Toys', 'Video' => 'Video', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		$locale_search_indexes['jp'] = array('All' => 'All', 'Apparel' => 'Apparel', 'Appliances' => 'Appliances', 'Automotive' => 'Automotive', 'Baby' => 'Baby', 'Beauty' => 'Beauty', 'Blended' => 'Blended', 'Books' => 'Books', 'DVD' => 'DVD', 'Electronics' => 'Electronics', 'ForeignBooks' => 'Foreign Books', 'Grocery' => 'Grocery', 'HealthPersonalCare' => 'Health & Personal Care', 'Hobbies' => 'Hobbies', 'Jewelry' => 'Jewelry', 'Kitchen' => 'Kitchen', 'Music' => 'Music', 'MusicalInstruments' => 'Musical Instruments', 'OfficeProducts' => 'Office Products', 'PCHardware' => 'PC Hardware', 'PetSupplies' => 'Pet Supplies', 'Shoes' => 'Shoes', 'Software' => 'Software', 'SportingGoods' => 'Sporting Goods', 'Toys' => 'Toys', 'Video' => 'Video', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		$locale_search_indexes['fr'] = array('All' => 'All', 'Apparel' => 'Apparel', 'Appliances' => 'Large Appliances', 'Baby' => 'Baby', 'Blended' => 'Blended', 'Books' => 'Books', 'DVD' => 'DVD', 'Electronics' => 'Electronics', 'ForeignBooks' => 'Foreign Books', 'HealthPersonalCare' => 'Health & Personal Care', 'Jewelry' => 'Jewelry', 'KindleStore' => 'Kindle Store', 'Kitchen' => 'Kitchen', 'Music' => 'Music', 'MusicalInstruments' => 'Musical Instruments', 'OfficeProducts' => 'OfficeProducts', 'PCHardware' => 'PCHardware', 'Shoes' => 'Shoes', 'Software' => 'Software', 'SportingGoods' => 'Sporting Goods', 'Toys' => 'Toys', 'Video' => 'Video', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		$locale_search_indexes['it'] = array('All' => 'All', 'Books' => 'Books', 'DVD' => 'DVD', 'Electronics' => 'Electronics', 'ForeignBooks' => 'Foreign Books', 'KindleStore' => 'Kindle Store', 'Kitchen' => 'Kitchen', 'Music' => 'Music', 'Garden' => 'Garden', 'Shoes' => 'Shoes', 'SportingGoods' => 'Sport & Leisure', 'Software' => 'Software', 'Toys' => 'Toys', 'VideoGames' => 'VideoGames', 'Watches' => 'Watches');
		$locale_search_indexes['ca'] = array('All' => 'All', 'Baby' => 'Baby', 'Blended' => 'Blended', 'Books' => 'Books', 'Classical' => 'Classical', 'Electronics' => 'Electronics', 'Kitchen' => 'Kitchen, Home & Garden', 'Music' => 'Music', 'Software' => 'Software', 'SportingGoods' => 'Sports & Outdoors', 'Tools' => 'Tools & Building Supplies', 'Video' => 'Video', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		$locale_search_indexes['cn'] = array('All' => 'All', 'Apparel' => 'Apparel', 'Appliances' => 'Appliances', 'Automotive' => 'Automotive', 'Baby' => 'Baby', 'Beauty' => 'Beauty', 'Books' => 'Books', 'Electronics' => 'Electronics', 'Grocery' => 'Grocery', 'HealthPersonalCare' => 'Health & Personal Care', 'Home' => 'Home', 'HomeImprovement' => 'Home Improvement', 'Jewelry' => 'Jewelry', 'Misc' => 'Misc', 'Music' => 'Music', 'OfficeProducts' => 'Office Products', 'Photo' => 'Photo', 'Shoes' => 'Shoes', 'Software' => 'Software', 'SportingGoods' => 'Sporting Goods', 'Toys' => 'Toys', 'Video' => 'Video', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		$locale_search_indexes['es'] = array('All' => 'All', 'Books' => 'Books', 'DVD' => 'DVD', 'Electronics' => 'Electronics', 'ForeignBooks' => 'Foreign Books', 'KindleStore' => 'Kindle Store', 'Kitchen' => 'Kitchen', 'Music' => 'Music', 'Software' => 'Software', 'Toys' => 'Toys', 'VideoGames' => 'Video Games', 'Watches' => 'Watches');
		if (isset($locale_search_indexes[$country]))
		{
			return $locale_search_indexes[$country];
		}
		return array();
	}

}
?>