<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/


function advads171_add_option($name = '', $value = '', $multisite = FALSE)
{
	global $wpdb;
	if ($name != '')
	{
		if ($multisite === FALSE)
		{
			//only add option if it doesnt already exist
			if ($res == 0 && advads171_get_option($name) === false)
			{
				$sql = "INSERT INTO ".$wpdb->prefix."advads171_options SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				$res = $wpdb->query($sql);
			}
		}
		else
		{
			//only add option if it doesnt already exist
			if ($res == 0 && advads171_get_option($name, $multisite) === false)
			{
				$sql = "INSERT INTO advads171_wpms_global_settings SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				$res = $wpdb->query($sql);
			}
		}
	}
}

function advads171_update_option($name = '', $value = '', $multisite = FALSE)
{
	global $wpdb;
	if ($name != '')
	{
		if ($multisite === FALSE)
		{
			$sql = "UPDATE ".$wpdb->prefix."advads171_options SET `value` = '".$wpdb->escape($value)."' WHERE name = '".$wpdb->escape($name)."' LIMIT 1";
			$res = $wpdb->query($sql);
			//if option doesnt exist - insert it
			if ($res == 0 && advads171_get_option($name) === false)
			{
				$sql = "INSERT INTO ".$wpdb->prefix."advads171_options SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				$res = $wpdb->query($sql);				
			}
		}
		else
		{
			$sql = "UPDATE advads171_wpms_global_settings SET `value` = '".$wpdb->escape($value)."' WHERE name = '".$wpdb->escape($name)."' LIMIT 1";
			$res = $wpdb->query($sql);
			//if option doesnt exist - insert it
			if ($res == 0 && advads171_get_option($name, $multisite) === false)
			{
				$sql = "INSERT INTO advads171_wpms_global_settings SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				if ($name == 'advads171_show_promo_msgs') echo $sql;
				$res = $wpdb->query($sql);
			}
		}
	}
}

function advads171_get_option($name = '', $multisite = FALSE)
{
	global $wpdb;
	if ($name != '')
	{
		if ($multisite === FALSE)
		{
			$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."advads171_options WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
		}
		else
		{
			$res = $wpdb->get_row("SELECT * FROM advads171_wpms_global_settings WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
		}
		
		if ($res === NULL)
		{
			$res = false;
			return true;
		}
		else
		{
			return $res->value;
		}		
	}
}

function advads171_delete_option($name = '', $multisite = FALSE)
{
	global $wpdb;
	if ($multisite === FALSE)
	{
		$res = $wpdb->query("DELETE FROM ".$wpdb->prefix."advads171_options WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
	}
	else
	{
		//multisite
		$res = $wpdb->query("DELETE FROM advads171_wpms_global_settings WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
	}
}

function advads171_delete_cache($post_id = 0)
{
	global $wpdb;
	$delete_sql = "DELETE FROM `".$wpdb->prefix."advads171_cache` WHERE post_id = '".$wpdb->escape($post_id)."' LIMIT 1";
	$wpdb->query($delete_sql);

}

function advads171_clear_cache()
{
	global $wpdb;
	$delete_sql = "TRUNCATE TABLE `".$wpdb->prefix."advads171_cache`;";
	$wpdb->query($delete_sql);
	
	//delete transient stored in db
	$wpdb->query("DELETE FROM $wpdb->options WHERE (option_name LIKE '_transient_advads_%' OR option_name LIKE '_transient_timeout_advads_%') ");
}

function advads171_call($data = array(), $url = '', $show_errors = true, $json_decode = true, $attempt = 0)
{
	global $advads171_current_plugin_version, $advads171_plugin_slug;
	set_time_limit(300);
	
	//add admin ip
	if (count($data) > 0)
	{
		$data['admin_ip'] = $_SERVER['REMOTE_ADDR'];
		$data['version'] = $advads171_current_plugin_version;
	}
	//build get request
	$get_vars = array();
	foreach($data as $key => $val)
	{
		$get_vars[] = $key."=".urlencode($val);
	}
	$get_request = implode('&', $get_vars);
	if (!function_exists('json_decode'))
	{
		if ($show_errors) echo '<div class="updated"><p>'.__('PHP Error: Your server doesn\'t support function json_decode()', $advads171_plugin_slug).'</p></div>';	
		return false;
	}
	elseif ( function_exists('curl_init') ) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $get_request);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		$response = curl_exec($ch);
		//echo $url.'?'.$get_vars;
		//try one more time with ip if couldn't resolve host
		if (!$response && stripos(curl_error($ch), "resolve host") && stripos($url, '216.172.160.106') === FALSE && $attempt == 0 )
		{
			curl_close($ch);
			$url = str_replace('contextazon.com', '216.172.160.106', $url);
			return advads171_call($data, $url, $show_errors, $json_decode, ($attempt + 1));
		}
		else
		{
			if (!$response) {
				if ($show_errors) echo '<div class="updated"><p>'.__('cURL Error: ', $advads171_plugin_slug).' '.curl_error($ch).'</p></div>';	
				return false;
			}	
		}		
		curl_close($ch);
	} else { 				
		$response = @file_get_contents($url.'?'.$get_request);
		if (!$response) {
			if ($show_errors) echo '<div class="updated"><p>'.__('Error: cURL is not installed on this server.', $advads171_plugin_slug).'</p></div>';	
			return false;
		}
	}
	if ($json_decode === true)
	{
		return json_decode($response);
	}
	else
	{
		return $response;
	}
}

function advads171_locale_map()
{
	$map = array(
				'us' => 1,
				'uk' => 2,
				'de' => 3,
				'jp' => 4,
				'fr' => 5,
				'ca' => 6,
				'it' => 7,
				'cn' => 8,
				'es' => 9
				);
	return $map;
}

function advads171_get_locale($return_closest = TRUE)
{
	$country = 'smthelse';
	include_once("geoip.inc");
	$custom_geoip_path = advads171_get_option('advads171_path_to_geoip_dat');
	if ($custom_geoip_path !== FALSE && file_exists($custom_geoip_path))
	{
		$gi = geoip_open($custom_geoip_path, GEOIP_MEMORY_CACHE);
	}
	else
	{
		$gi = geoip_open(dirname(__FILE__).'/GeoIP.dat', GEOIP_MEMORY_CACHE);
	}
	$user_country = geoip_country_code_by_addr($gi, $_SERVER['REMOTE_ADDR']);
	//$user_country = geoip_country_code_by_addr($gi, 'customiphere'); //testing
	//echo 'country is: '.$user_country;
	if ($_SERVER['REMOTE_ADDR'] == '127.0.0.1')
	{
		$user_country = 'local_computer_127.0.0.1';
	}
	$user_country = strtolower($user_country);	
	//$user_country = 'us'; //testing
	
	if ($user_country == 'gb')
	{
		$user_country = 'uk';
	}
	
	if ($return_closest === FALSE)
	{
		return $user_country;
	}
	
	if (in_array($user_country, array('us', 'uk', 'de', 'jp', 'fr', 'ca', 'it', 'cn', 'es', 'gb')))
	{		
		$country = advads171_closest_locale($user_country);		
	}
	else
	{
		$country = advads171_closest_locale($country);
	}
	//echo 'country'.$country.':'.$user_country;
	//exit;
	geoip_close($gi);
	return $country;
}

function advads171_closest_locale($locale = 'us')
{
	if ($locale == 'us')
	{
		$amzn_tag = get_option('advads171_am_associate_tag');
	}
	else
	{
		$amzn_tag = get_option('advads171_locale_tag_'.$locale);
	}

	if (!in_array($locale, array('us', 'uk', 'de', 'jp', 'fr', 'ca', 'it', 'cn', 'es')) || $amzn_tag === FALSE || strlen(trim($amzn_tag)) == 0)
	{
		$default_country = advads171_get_option('advads171_unsupported_country_default');
		//echo 'default_country:'.$default_country;exit;
		if ($default_country === FALSE || $default_country == 'none')
		{			
			return 'smthelse';
		}
		else
		{
			return $default_country;
		}
	}
	return $locale;
}

function advads171_get_locale_tag($locale = 'us')
{
	if ($locale == 'us')
	{
		$tag = get_option('advads171_am_associate_tag');
	}
	else
	{
		$tag = get_option('advads171_locale_tag_'.$locale);
	}
	return $tag;
}

function advads171_base64_url_encode($input) {
 return strtr(base64_encode($input), '+/=', '-_,');
}

function advads171_base64_url_decode($input) {
 return base64_decode(strtr($input, '-_,', '+/='));
}

function advads171_get_pop_messages($advads171_tpl)
{
	$advads171_messages = array();
	$advads171_message_one = advads171_get_option($advads171_tpl.'_message');
	$advads171_message_two = advads171_get_option($advads171_tpl.'_message_two');
	$advads171_message_three = advads171_get_option($advads171_tpl.'_message_three');
	$advads171_message_four = advads171_get_option($advads171_tpl.'_message_four');
	$advads171_message_five = advads171_get_option($advads171_tpl.'_message_five');
	if (strlen($advads171_message_one) > 0) $advads171_messages[1] = stripslashes($advads171_message_one);
	if (strlen($advads171_message_two) > 0) $advads171_messages[2] = stripslashes($advads171_message_two);
	if (strlen($advads171_message_three) > 0) $advads171_messages[3] = stripslashes($advads171_message_three);
	if (strlen($advads171_message_four) > 0) $advads171_messages[4] = stripslashes($advads171_message_four);
	if (strlen($advads171_message_five) > 0) $advads171_messages[5] = stripslashes($advads171_message_five);
	return $advads171_messages;
}

function advads171_get_pop_messages_stats()
{
	global $advads171_plugin_slug;
	$msgs_arr = array();
	$tpl_msgs = advads171_get_pop_messages('tpl_am3across');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['0'.$key] = $msg.' ('.__('3 Products', $advads171_plugin_slug).')';
	}
	$tpl_msgs = advads171_get_pop_messages('tpl_am1product');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['1'.$key] = $msg.' ('.__('1 Product', $advads171_plugin_slug).')';
	}
	$tpl_msgs = advads171_get_pop_messages('tpl_custom1');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['2'.$key] = $msg.' ('.__('Custom 1', $advads171_plugin_slug).')';
	}
	$tpl_msgs = advads171_get_pop_messages('tpl_custom2');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['3'.$key] = $msg.' ('.__('Custom 2', $advads171_plugin_slug).')';
	}
	$tpl_msgs = advads171_get_pop_messages('tpl_custom3');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['4'.$key] = $msg.' ('.__('Custom 3', $advads171_plugin_slug).')';
	}
	return $msgs_arr;
}

function advads171_record_stat($action = 0, $variation_type = 0, $variation_value = '', $year = 0, $month = 0, $day = 0)
{
	global $wpdb;
	if ($year == 0) $year = date('Y');
	if ($month == 0) $month = date('m');
	if ($day == 0) $day = date('d');
	
	$sql = "SELECT * FROM ".$wpdb->prefix."advads171_stats WHERE `action` = '".$wpdb->escape($action)."' AND `variation_type` = '".$wpdb->escape($variation_type)."' AND `variation_value` = '".$wpdb->escape($variation_value)."' AND `year` = '".$wpdb->escape($year)."' AND `month` = '".$wpdb->escape($month)."' AND `day` = '".$wpdb->escape($day)."' LIMIT 1";
	$res = $wpdb->get_row($sql);
		
	if ($res === NULL)
	{
		$sql = "INSERT INTO ".$wpdb->prefix."advads171_stats SET `action` = '".$wpdb->escape($action)."', `variation_type` = '".$wpdb->escape($variation_type)."', `variation_value` = '".$wpdb->escape($variation_value)."', `year` = '".$wpdb->escape($year)."', `month` = '".$wpdb->escape($month)."', `day` = '".$wpdb->escape($day)."', `total` = '1'";
		$res = $wpdb->query($sql);
	}
	else
	{
		$sql = "UPDATE ".$wpdb->prefix."advads171_stats SET  `total` = `total` + 1 WHERE `action` = '".$wpdb->escape($action)."' AND `variation_type` = '".$wpdb->escape($variation_type)."' AND `variation_value` = '".$wpdb->escape($variation_value)."' AND `year` = '".$wpdb->escape($year)."' AND `month` = '".$wpdb->escape($month)."' AND `day` = '".$wpdb->escape($day)."' LIMIT 1";
		$res = $wpdb->query($sql);
	}
}


function advads171_record_stat_detailed($collect_type = 0, $banner_id = 0, $post_id = 0, $search_method = 0, $kws = '', $asin = '', $ip = '')
{
	global $wpdb;
	//delete old records
	$days_to_keep_records = 60;	//keep records for 60 days - default
	$days_to_keep_check = advads171_get_option('advads171_visitor_log_days');
	if ($days_to_keep_check !== FALSE && is_numeric($days_to_keep_check))
	{
		$days_to_keep_records = $days_to_keep_check;
	}
	$sql = "DELETE FROM ".$wpdb->prefix."advads171_stats_detailed WHERE timestamp < '".(time() - ( $days_to_keep_records * 60 * 60 * 24 ))."'";
	$res = $wpdb->query($sql);
	
	//record new view/click
	$sql = "INSERT INTO ".$wpdb->prefix."advads171_stats_detailed SET `collect_type` = '".$wpdb->escape($collect_type)."', `banner_id` = '".$wpdb->escape($banner_id)."', `post_id` = '".$wpdb->escape($post_id)."', `search_method` = '".$wpdb->escape($search_method)."', `kws` = '".$wpdb->escape($kws)."', `asin` = '".$wpdb->escape($asin)."', `ip` = '".$wpdb->escape($ip)."', `timestamp` = '".time()."'";
	$res = $wpdb->query($sql);

}

//This function records exact time when any Amazon Products API request was made
function advads171_record_am_request_time()
{
	$advads171_microtime_now = microtime(true);
	advads171_update_option('am_time', $advads171_microtime_now);
}

function advads171_am_search($search_kw = '', $search_index = 'All', $params, $item_page = 1, $locale = 'us', $adtnl_url_params = array(), $return_response_groups = '')
{
	$advads171_am_class = new advads171_amazon_api($params);

	$results_found = FALSE;
	$found_count = 0;

	//$time_start = microtime(true);

	$response_groups = '';
	if (advads171_get_option('amzn_cart_enabled') == 'yes') $response_groups = array('OfferListings');
	
	if (is_array($return_response_groups))
	{
		if (is_array($response_groups))
		{
			$response_groups = array_merge($response_groups, $return_response_groups);
		}
		else
		{
			$response_groups = $return_response_groups;
		}
		
	}
	
	/*echo '<pre>';
	print_r($return_response_groups);
	echo '</pre>';
	echo $search_kw;exit;*/
	//return similar items
	if (stripos($search_kw, 'asin:') !== FALSE && is_array($response_groups) && in_array('Similarities', $response_groups))
	{
		$asin_arr = explode(':', $search_kw);
		//got similar asins cached?
		$transient_name = 'advads_sim_'.$locale.'_'.implode('_', array_slice(explode(',', $asin_arr[1]), 0, 3));
		$sim_asins_cached = get_transient($transient_name);
		
		if ($sim_asins_cached === FALSE)
		{
			$amazon_response = $advads171_am_class->similar_lookup($asin_arr[1], $locale, $response_groups);
			if (isset($amazon_response->Items) && (count($amazon_response->Items->Item) > 0) || (isset($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) && count($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) > 0))
			{
				$found_count = $found_count + count($amazon_response->Items->Item);
				if ($found_count >= 10)
				{
					$results_found = TRUE;
				}
				$similar_asins = array();
				if (isset($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) && count($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) > 0)
				{
					foreach($amazon_response->Items->Item as $curr_sim_item)
					{
						foreach($curr_sim_item->SimilarProducts->SimilarProduct as $curr_sim_product)
						{
							if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
							{
								$similar_asins[] = strval($curr_sim_product->ASIN);
							}
						}
					}
				}
				else
				{
					foreach($amazon_response->Items->Item->SimilarProducts->SimilarProduct as $curr_sim_product)
					{
						if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
						{
							$similar_asins[] = strval($curr_sim_product->ASIN);
						}
					}
				}
				
				/*echo '<pre>';
				print_r($similar_asins);
				echo '</pre>';*/
				
				if (count($similar_asins) > 0)
				{
					//cache sim asins for 7 days
					set_transient($transient_name, $similar_asins, 60*60*24*7);
					
					advads171_get_am_request_window();
					return advads171_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
				}
				else
				{
					$found_count = 0;
					$results_found = FALSE;
				}
			}
		}
		else
		{
			//use cached sim asins
			$similar_asins = get_transient($transient_name);
			return advads171_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
		}		
		
	}	
	elseif (stripos($search_kw, 'asin:') !== FALSE && is_array($response_groups) && in_array('Accessories', $response_groups))
	{
		$asin_arr = explode(':', $search_kw);
		//got similar asins cached?
		$transient_name = 'advads_xsr_'.$locale.'_'.implode('_', array_slice(explode(',', $asin_arr[1]), 0, 3));
		$sim_asins_cached = get_transient($transient_name);
		
		if ($sim_asins_cached === FALSE)
		{	
			$amazon_response = $advads171_am_class->similar_lookup($asin_arr[1], $locale, $response_groups);
			if (isset($amazon_response->Items) && (count($amazon_response->Items->Item) > 0) || (isset($amazon_response->Items->Item[0]->Accessories->Accessory) && count($amazon_response->Items->Item[0]->Accessories->Accessory) > 0))
			{
				$found_count = $found_count + count($amazon_response->Items->Item);
				if ($found_count >= 10)
				{
					$results_found = TRUE;
				}
				$similar_asins = array();
				if (isset($amazon_response->Items->Item[0]->Accessories->Accessory) && count($amazon_response->Items->Item[0]->Accessories->Accessory) > 0)
				{
					foreach($amazon_response->Items->Item as $curr_sim_item)
					{
						foreach($curr_sim_item->Accessories->Accessory as $curr_sim_product)
						{
							if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
							{
								$similar_asins[] = strval($curr_sim_product->ASIN);
							}
						}
					}
				}
				else
				{
					foreach($amazon_response->Items->Item->Accessories->Accessory as $curr_sim_product)
					{
						if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
						{
							$similar_asins[] = strval($curr_sim_product->ASIN);
						}
					}
				}
				
				/*echo '<pre>';
				print_r($similar_asins);
				echo '</pre>';*/
				
				if (count($similar_asins) > 0)
				{
					//cache sim asins for 7 days
					set_transient($transient_name, $similar_asins, 60*60*24*7);
					
					advads171_get_am_request_window();
					return advads171_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
				}
				else
				{
					$found_count = 0;
					$results_found = FALSE;
				}

			}
		}
		else
		{
			//use cached sim asins
			$similar_asins = get_transient($transient_name);
			return advads171_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
		}
		
	}
	elseif (stripos($search_kw, 'asin:') === FALSE)
	{
		//regular kws search
		$amazon_response = $advads171_am_class->search_amazon($search_kw, $search_index, $item_page, $locale, FALSE, $response_groups, $adtnl_url_params);
		if ($amazon_response->Items->TotalResults > 0)
		{
			$found_count = $found_count + count($amazon_response->Items->Item);
			if ($found_count >= 10)
			{
				$results_found = TRUE;
			}
			$amazon_items[] = $amazon_response->Items;
		}
	}
	elseif(stripos($search_kw, '-asin:') === FALSE)
	{
		//$search_kw = 'asin:B003VAGXWK';
		$asin_arr = explode(':', $search_kw);
		$amazon_response = $advads171_am_class->asin_lookup(trim($asin_arr[1]), $locale, $response_groups);
		if (!isset($amazon_response->Items->Request->Errors))
		{			
			if (@count($amazon_response->Items->Item) > 0)
			{
				//echo 'found a lot';
				$amazon_items[] = $amazon_response->Items;
				$found_count = $found_count + count($amazon_response->Items->Item);
			}
			else
			{
				//echo 'found one';
				$generic_temp_object = new stdClass();
				$generic_temp_object->Item = array('0' => $amazon_response->Items->Item);
				$amazon_items[] = $generic_temp_object;
				$found_count = $found_count + 1;
			}
			if ($found_count >= 10)
			{
				$results_found = TRUE;
			}
		}		
	}
	
	/*echo '<pre>';
	print_r($amazon_items);
	echo '</pre>';*/
	//$time_end = microtime(true);
	//$time = $time_end - $time_start;
	//echo ' in '.$time.' seconds';

	if ($results_found === TRUE || $found_count > 0)
	{
		$skip_noimage = get_option('advads171_skip_noimage');
		//skip asins
		$skip_asins_arr = array();
		$skip_asins = get_option('advads171_skip_asins');
		if ($skip_asins !== FALSE && strlen($skip_asins) > 1)
		{
			$skip_asins = str_replace(', ', '', str_replace('  ', '', $skip_asins));
			$skip_asins_arr = explode(',', $skip_asins);
		}
		
		$results = array();
		$saved_urls = array();
		foreach($amazon_items as $item_set)
		{
			foreach($item_set->Item as $item)
			{
				if (($skip_noimage != 1 || ($skip_noimage == 1 && isset($item->MediumImage->URL) && strlen(strval($item->MediumImage->URL)) > 1)) && !in_array(strval($item->ASIN), $skip_asins_arr))
				{
					$results[strval($item->ASIN)] = array(
							'image' => strval($item->MediumImage->URL),
							'img_width' => intval($item->MediumImage->Width),
							'img_height' => intval($item->MediumImage->Height),							
							'large_image' => strval($item->LargeImage->URL),
							'large_image_width' => strval($item->LargeImage->Width),
							'large_image_height' => strval($item->LargeImage->Height),
							'url' => strval($item->DetailPageURL),
							'name' => strval($item->ItemAttributes->Title),
							'asin' => strval($item->ASIN)
							);
					if (isset($item->OfferSummary->LowestNewPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
						//do we have a list price?
						if(isset($item->ItemAttributes->ListPrice) && ($item->ItemAttributes->ListPrice->Amount > $item->OfferSummary->LowestNewPrice->Amount || strval($item->OfferSummary->LowestNewPrice->FormattedPrice) == 'Too low to display'))
						{
							$results[strval($item->ASIN)]['list_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
						}
					}
					elseif(isset($item->ItemAttributes->ListPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
					}
					//always save list price
					if(isset($item->ItemAttributes->ListPrice))
					{
						$results[strval($item->ASIN)]['list_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
					}
					//save OfferListingId
					$results[strval($item->ASIN)]['OfferListingId'] = '';
					if (isset($item->Offers->Offer->OfferListing->OfferListingId))
					{
						$results[strval($item->ASIN)]['OfferListingId'] = strval($item->Offers->Offer->OfferListing->OfferListingId);
						$results[strval($item->ASIN)]['OfferPrice'] = strval($item->Offers->Offer->OfferListing->Price->FormattedPrice);
					}
					//save description
					if (isset($item->EditorialReviews->EditorialReview->Source) && strval($item->EditorialReviews->EditorialReview->Source) == 'Product Description')
					{
						$results[strval($item->ASIN)]['description'] = substr(strval($item->EditorialReviews->EditorialReview->Content), 0, 1000);
					}
					$saved_urls['am_'.strval($item->ASIN)] = strval($item->DetailPageURL);
				}
			}
		}
		return $results;
	}
	else
	{
		return array();
	}
}

function advads171_am_preview_results($params, $item_page = 1, $locale = 'us')
{
	$advads171_am_class = new advads171_amazon_api($params);

	$results_found = FALSE;
	$found_count = 0;

	$response_groups = '';
	if (advads171_get_option('amzn_cart_enabled') == 'yes') $response_groups = array('OfferListings');
	
	$amazon_response = $advads171_am_class->search_amazon('', 'All', $item_page, $locale, TRUE, $response_groups);
	if ($amazon_response->Items->TotalResults > 0)
	{
		$found_count = $found_count + count($amazon_response->Items->Item);
		if ($found_count >= 10)
		{
			$results_found = TRUE;
		}
		$amazon_items[] = $amazon_response->Items;
	}

	if ($results_found === TRUE || $found_count > 0)
	{
		$skip_noimage = get_option('advads171_skip_noimage');
		$results = array();
		$saved_urls = array();
		foreach($amazon_items as $item_set)
		{
			foreach($item_set->Item as $item)
			{
				if ($skip_noimage != 1 || ($skip_noimage == 1 && isset($item->MediumImage->URL) && strlen(strval($item->MediumImage->URL)) > 1))
				{
					$results[strval($item->ASIN)] = array(
							'image' => strval($item->MediumImage->URL),
							'img_width' => intval($item->MediumImage->Width),
							'img_height' => intval($item->MediumImage->Height),							
							'large_image' => strval($item->LargeImage->URL),
							'large_image_width' => strval($item->LargeImage->Width),
							'large_image_height' => strval($item->LargeImage->Height),
							'url' => strval($item->DetailPageURL),
							'name' => strval($item->ItemAttributes->Title),
							'asin' => strval($item->ASIN)
							);
					if (isset($item->OfferSummary->LowestNewPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
						//do we have a list price?
						if(isset($item->ItemAttributes->ListPrice) && ($item->ItemAttributes->ListPrice->Amount > $item->OfferSummary->LowestNewPrice->Amount || strval($item->OfferSummary->LowestNewPrice->FormattedPrice) == 'Too low to display'))
						{
							$results[strval($item->ASIN)]['list_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
						}
					}
					elseif(isset($item->ItemAttributes->ListPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
					}
					//save description
					if (isset($item->EditorialReviews->EditorialReview->Source) && strval($item->EditorialReviews->EditorialReview->Source) == 'Product Description')
					{
						$results[strval($item->ASIN)]['description'] = strval($item->EditorialReviews->EditorialReview->Content);
					}
					$saved_urls['am_'.strval($item->ASIN)] = strval($item->DetailPageURL);
				}
			}
		}
		return $results;
	}
	else
	{
		return array();
	}
}

function advads171_am_check_credentials($params)
{
	require_once(dirname(__FILE__).'/amazon.lib.php');
	$advads171_am_class = new advads171_amazon_api($params);

	$results_found = FALSE;
	$found_count = 0;

	//$time_start = microtime(true);

	$amazon_response = $advads171_am_class->search_amazon('camera', 'All', 1, 'us');
	/*echo '<pre>';
	print_r($amazon_response);
	echo '</pre>';*/
	return $amazon_response;
}

function advads171_gen_kws($content = '', $title = '', $post_id = 0)
{
	require_once(dirname(__FILE__).'/keywords_generator.php');
			
		$params['content'] = $content; //page content
		//set the length of keywords you like
		$params['min_word_length'] = 5;  //minimum length of single words
		$params['min_word_occur'] = 2;  //minimum occur of single words
		
		$params['min_2words_length'] = 3;  //minimum length of words for 2 word phrases
		$params['min_2words_phrase_length'] = 10; //minimum length of 2 word phrases
		$params['min_2words_phrase_occur'] = 2; //minimum occur of 2 words phrase

		$keyword = new advads171_keywords($params, "iso-8859-1");
		
		//get "skip words"
		$skip_keywords_str = advads171_get_option('advads171_skip_keywords');
		if ($skip_keywords_str === FALSE)
		{
			$skip_keywords = advads171_get_default_skip_keywords();
		}
		else
		{
			$skip_keywords = explode(",", $skip_keywords_str);
		}
		if (count($skip_keywords) > 0)
		{
			$keyword->common = array_merge($keyword->common, $skip_keywords);
		}
		
		//get kws settings
		$advads171_kw_sources = array();
		$advads171_kw_sources_str = advads171_get_option('advads171_kw_sources');
		if (strlen($advads171_kw_sources_str) > 0)
		{
			$advads171_kw_sources = explode(',', $advads171_kw_sources_str);
		}		
		$advads171_fallback_keywords = get_option('advads171_fallback_keywords');
		$advads171_min_kw_length = advads171_get_option('advads171_min_kw_length');
		if (in_array('categories', $advads171_kw_sources))
		{
			$categories = get_categories();
			$advads171_cat_kws = array();
			foreach($categories as $curr_cat)
			{
				$cat_kw_check = get_option('advads171_cat_kws_'.$curr_cat->term_id);
				if ($cat_kw_check !== FALSE)
				{
					$advads171_cat_kws[$curr_cat->term_id] = $cat_kw_check;
				}
			}
		}
		
		$kws = array();
		if ($content != '')
		{
			//generate form content
			if (in_array('content', $advads171_kw_sources))
			{
				$single_kws = $keyword->parse_words();
				$two_words_kws = $keyword->parse_2words();
				
				$kws = array_merge($two_words_kws, $single_kws);
				$kws = advads171_filter_out_kws($kws);
			}
		}

		
		//generate from title
		if (count($kws) == 0 && strlen($title) > 0 && in_array('title', $advads171_kw_sources))
		{
			$title = strtolower($title);
			$title = preg_replace("/(?![-])\p{P}/u", "", $title);
			
			//$kws[] = $title;
			$maybe_kws = explode(" ", $title);
			$maybe_kws = advads171_filter_out_kws($maybe_kws);
			if (count($maybe_kws) < 5)
			{
				$kws[] = implode(' ', $maybe_kws);
			}
			foreach($maybe_kws as $kw)
			{
				$kw = trim($kw);
				if (strlen($kw) > 1)
				{
					$kws[] = $kw;
				}
			}

			$kws = advads171_filter_out_kws($kws);
			//try again here
		}
		
		//generate from tags
		if (count($kws) == 0 && in_array('tags', $advads171_kw_sources) && $post_id != 0)
		{
			$posttags = get_the_tags($post_id);
			if ($posttags) {
			  foreach($posttags as $tag) {
				$kws[] = $tag->name;
			  }
			}
			$kws = advads171_filter_out_kws($kws);
			
		}
		
		//generate from categories
		if (count($kws) == 0 && in_array('categories', $advads171_kw_sources) && $post_id != 0)
		{
			$post_cats = get_the_category($post_id);
			if (is_array($post_cats) && count($post_cats) > 0)
			{
				foreach($post_cats as $post_cat)
				{
					$post_cat_kws_str = get_option('advads171_cat_kws_'.$post_cat->term_id);
					if ($post_cat_kws_str !== FALSE && strlen($post_cat_kws_str) > 0)
					{
						$post_cat_kws_arr = explode(',', $post_cat_kws_str);
						if (count($post_cat_kws_arr) > 0)
						{
							foreach($post_cat_kws_arr as $maybe_kw)
							{
								$kws[] = trim($maybe_kw);
							}
						}
					}					
				}
			}

			//$kws = advads171_filter_out_kws($kws);
		}
		
		//generate from fallback
		if (count($kws) == 0 && in_array('fallback', $advads171_kw_sources))
		{
			$fallback_kws_str = get_option('advads171_fallback_keywords');
			if ($fallback_kws_str !== FALSE && strlen(trim($fallback_kws_str)) > 1)
			{
				$maybe_kws = explode(',', $fallback_kws_str);
				foreach($maybe_kws as $maybe_kw)
				{
					$kws[] = trim($maybe_kw);
				}
			}
		}
		
		return $kws;
	
	return array();
}

function advads171_get_serp_kw_str()
{
	$kw = '';
	//get kws settings
	$advads171_kw_sources = array();
	$advads171_kw_sources_str = advads171_get_option('advads171_kw_sources');
	if (strlen($advads171_kw_sources_str) > 0)
	{
		$advads171_kw_sources = explode(',', $advads171_kw_sources_str);
	}
	$kws = array();
		
	//generate form serp
	if (in_array('serp', $advads171_kw_sources) && isset($_COOKIE['advads171_serp_kws']) && strlen($_COOKIE['advads171_serp_kws']) > 0)
	{

		$kws[] = $_COOKIE['advads171_serp_kws'];
		$kws = advads171_filter_out_kws($kws);
	}
	
	/*echo '<pre>';
	print_r($kws);
	print_r($_COOKIE);
	print_r($advads171_kw_sources);
	echo '</pre>';
	exit;*/
	if (count($kws) == 1)
	{
		$kw = $kws[0];
	}
	if (count($kws) > 1)
	{
		$kw = implode(' ', $kws);
	}
	return $kw;	
}

function advads171_get_pop_data($post_id = 0, $kws, $am_params, $locale = 'us', $search_method = 0)
{
	global $wpdb, $advads171_preview;
	//use both 0 and 1 for kws search method
	if ($search_method == 1) $search_method = 0;
	//locale map
	$locale_map = advads171_locale_map();
	
	/*if (advads171_get_option('license') == 'free' && advads171_get_option('clicks') > 500 && ((advads171_get_option('pop_sequence') % advads171_get_option('pop_sequence_trigger')) == 0))
	{
		$call_data = array(
							'site' => get_bloginfo('url'),
							'kws' => implode(',', $kws),
							'post_id' => $post_id,
							'am_index' => get_option('advads171_am_searchindex'),
							'locale' => $locale
							);
		$ad_html = advads171_call($call_data, 'http://216.172.160.106/advads/get_pop/html', false, false);
		return array('ad' => true, 'html' => $ad_html);
	}
	else*/
	if (1 == 1) {
		//check if we have cache data
		if ($advads171_preview === FALSE)
		{
			//$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."advads171_cache WHERE post_id = '".$wpdb->escape($post_id)."' AND `kws` = '".$wpdb->escape(implode(',', $kws))."' AND locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND source = 0 LIMIT 1");
			//let's not filter by post id because posts can share same keywords
			$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."advads171_cache WHERE `kws` = '".$wpdb->escape(implode(',', $kws))."' AND locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND source = 0 LIMIT 1");
		}
		
		if ($advads171_preview === FALSE && $res !== NULL)
		{
			$data = unserialize(str_replace("\'", "'", $res->content));
			if (count($data) > 0)
			{
				return $data;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return advads171_update_cache($post_id, $kws, $am_params, $locale, $search_method);
		}
	}
}

function advads171_update_cache($post_id, $kws, $am_params, $locale = 'us', $search_method = 0)
{
	global $wpdb, $advads171_preview;
	//use both 0 and 1 for kws search method
	if ($search_method == 1) $search_method = 0;
	
	$advads171_data = array();
	$advads171_keep_going = true;
	
	//make up for negative asins
	$adtn_loops = 0;
	if (count($kws) > 0)
	{
		foreach($kws as $curr_kw)
		{
			if (stripos($curr_kw, '-asin:') !== FALSE)
			{
				$adtn_loops++;
			}
		}
	}
	
	//try kws untill we get smth
	$i = 0;
	while($advads171_keep_going == true && $i < (5 + $adtn_loops))
	{
		//comply with Amazon API time limits
		advads171_get_am_request_window();
		//$advads171_data_req = advads171_am_search('organic cotton, bodysuit, cotton, organic');
		//$fallback_searchindex = get_option('advads171_am_searchindex');
	
		$country_node_check = advads171_get_country_node($locale);
		$country_node = $country_node_check['country_node'];
		$search_index = $country_node_check['search_index'];
		
		$adtnl_url_params = array();
		if (is_numeric($country_node)) $adtnl_url_params['BrowseNode'] = $country_node;
		//condition filter
		//$condition = advads171_get_option('amzn_condition');
		//$max_price = '50';
		//if ($max_price !== FALSE && is_numeric($max_price)) $adtnl_url_params['MaximumPrice'] = $max_price;
		//if ($condition !== FALSE && in_array($condition, array('New', 'Used', 'Refurbished', 'Collectible'))) $adtnl_url_params['Condition'] = $condition;

		if ($search_method == 0 || $search_method == 1)
		{
			$advads171_data_req = advads171_am_search($kws[$i], $search_index, $am_params, 1, $locale, $adtnl_url_params);
		}
		elseif ($search_method == 2)
		{
			$advads171_data_req = advads171_am_search($kws[$i], $search_index, $am_params, 1, $locale, $adtnl_url_params, array('Similarities'));
		}
		elseif ($search_method == 3)
		{
			$advads171_data_req = advads171_am_search($kws[$i], $search_index, $am_params, 1, $locale, $adtnl_url_params, array('Accessories'));
		}
		$advads171_data = array_merge($advads171_data, $advads171_data_req);
		if (count($advads171_data) > 2)
		{
			$advads171_keep_going = false;
		}
		
		advads171_record_am_request_time();
		$i++;
	}
	
	//filter out negative keywords
	if (count($advads171_data) > 0 && count($kws) > 0)
	{
		foreach($kws as $curr_kw)
		{
			if (stripos($curr_kw, '-asin:') !== FALSE)
			{
				$asin_arr = explode(':', $curr_kw);
				if (isset($advads171_data[$asin_arr[1]]))
				{
					unset($advads171_data[$asin_arr[1]]);
				}
			}
		}
	}
	
	//locale map
	$locale_map = advads171_locale_map();
	
	if ($advads171_preview === FALSE)
	{
		//delete old cache
		//$delete_sql = "DELETE FROM `".$wpdb->prefix."advads171_cache` WHERE post_id = '".$wpdb->escape($post_id)."' AND locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND source = '0' LIMIT 1";
		//do not filter by post_id to allow posts share same kws
		$delete_sql = "DELETE FROM `".$wpdb->prefix."advads171_cache` WHERE locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND source = '0' LIMIT 1";
		$wpdb->query($delete_sql);
		
		//insert new cache
		if (count($advads171_data) > 0)
		{
			$insert_sql = "INSERT INTO `".$wpdb->prefix."advads171_cache` SET `post_id` = '".$wpdb->escape($post_id)."', `source` = '0', `search_method` = '".$wpdb->escape($search_method)."', `locale` = '".$locale_map[$locale]."', `content` = '".str_replace("'", "\'", serialize($advads171_data))."', `kws` = '".$wpdb->escape(implode(',', $kws))."', timestamp = '".time()."'";
			//echo $insert_sql; exit;
			$wpdb->query($insert_sql);
		}
	}
	
	return $advads171_data;
}

function advads171_cache_cleanup()
{
	global $wpdb;
	$time = time();
	//AMZN
	$where = " WHERE source = '0' AND timestamp < '".($time - 3600)."'";
	$sql = "DELETE FROM `".$wpdb->prefix."advads171_cache` ".$where;
	$wpdb->query($sql);
	//EPN
	$epn_cache_seconds = advads171_get_option('epn_cache_seconds');
	if ($epn_cache_seconds === FALSE) $epn_cache_seconds = 0;
	$where = " WHERE source = '1' AND (timestamp < '".($time - $epn_cache_seconds)."' OR expires < '".$time."')";
	$sql = "DELETE FROM `".$wpdb->prefix."advads171_cache` ".$where;
	$wpdb->query($sql);
}

//This function allows us to comply with Amazon Products API TOS rule of 1 second delay between requests. It's being called before any request to Amazon is attempted.
function advads171_get_am_request_window()
{
	$i = 0;
	$advads171_keep_going = true;
	while($advads171_keep_going == true && $i < 5)
	{
		//here we are checking the time when the last amazon api request was sent to make sure that there is at least 1 second delay between requests
		$advads171_am_time = advads171_get_option('am_time');
		$advads171_microtime_now = microtime(true);
		$advads171_microtime_diff = $advads171_microtime_now - $advads171_am_time;
		if ($advads171_microtime_diff > 1)
		{
			$advads171_keep_going = false;
			return true;
		}
		else
		{
			if ($i == 4)
			{
				if ($advads171_preview === TRUE || $advads171_preview_general === TRUE)
				{
					exit(__('Error! Server is too busy.', $advads171_plugin_slug));
				}
				else
				{
					exit('error');	//if tried for 5 times and couldn't get a request window - fail silently
				}
			}
		}
		
		if ($advads171_microtime_diff < 1)
		{
			usleep((1 - $advads171_microtime_diff) * 1000000); // sleep for the remaining part of a second
		}	
		$i++;
	}
}

function advads171_active_tpls($include_inactive = FALSE)
{
	global $advads171_addons;
	$advads171_tpls = array();
	$possible_tpls_arr = explode(',', advads171_get_option('tpl_names'));
	$possible_tpls_keys = array_keys($possible_tpls_arr);
	foreach($possible_tpls_arr as $key => $curr_tpl)
	{
		$enabled = advads171_get_option($curr_tpl.'_enabled');
		if (($enabled !== FALSE && $enabled == 1) || $include_inactive === TRUE)
		{
			$advads171_tpls[$key] = $curr_tpl;
		}
	}
	
	//no amzn or epn
	$advads171_amzn_active = advads171_get_option('advads171_amzn_active');
	$epn_enabled = advads171_get_option('epn_enabled');
	if (isset($advads171_addons) && in_array('amzn', $advads171_addons) && is_numeric($advads171_amzn_active) && $advads171_amzn_active == '0' && in_array('epn', $advads171_addons) && is_numeric($epn_enabled) && $epn_enabled == '0')
	{
		foreach($advads171_tpls as $key => $val)
		{
			if ($val == 'tpl_am3across' || $val == 'tpl_am1product')
			{
				unset($advads171_tpls[$key]);
			}
		}
	}

	return $advads171_tpls;
}

function advads171_active_tpls_stats()
{
	$tpls = array();
	$active_tpls = advads171_active_tpls();
	foreach($active_tpls as $key => $tpl)
	{
		if ($tpl == 'tpl_am3across')  $tpls[$key] = '3 products';
		if ($tpl == 'tpl_am1product')  $tpls[$key] = '1 product';
		if ($tpl == 'tpl_custom1')  $tpls[$key] = 'Custom 1';
		if ($tpl == 'tpl_custom2')  $tpls[$key] = 'Custom 2';
		if ($tpl == 'tpl_custom3')  $tpls[$key] = 'Custom 3';
	}
	return $tpls;
}

function advads171_get_current_tpl()
{
	$advads171_tpls = advads171_active_tpls();
	
	$advads171_tpl = '';
	$advads171_tpl_key = 0;
	$advads171_tpl_keys = array_keys($advads171_tpls);
	$advads171_tpl_sequence = advads171_get_option('tpl_sequence');
	if (count($advads171_tpls) > 0)
	{
		if ($advads171_tpl_sequence > 4 || $advads171_tpl_sequence == end($advads171_tpl_keys) || count($advads171_tpls) == 1)
		{
			
			$advads171_tpl = $advads171_tpls[$advads171_tpl_keys[0]];
			$advads171_tpl_key = $advads171_tpl_keys[0];
		}
		else
		{
			$advads171_tpls_temp = $advads171_tpls;
			foreach($advads171_tpls_temp as $key => $msg)
			{
				if ($key <= $advads171_tpl_sequence)
				{
					unset($advads171_tpls_temp[$key]);
				}
			}

			if (count($advads171_tpls_temp) > 0)
			{
				$advads171_tpl_keys_temp = array_keys($advads171_tpls_temp);
				$advads171_tpl = $advads171_tpls_temp[$advads171_tpl_keys_temp[0]];
				$advads171_tpl_key = $advads171_tpl_keys_temp[0];
			}
			else
			{
				$advads171_tpl = $advads171_tpls[$advads171_tpl_keys[0]];
				$advads171_tpl_key = $advads171_tpl_keys[0];
			}						
		}
	}

	return array('key' => $advads171_tpl_key, 'name' => $advads171_tpl);
}

function advads171_remove_html($document){
	$search = array('@<script[^>]*?>.*?</script>@si',  // Strip out javascript
				   /*'@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags*/
				   '@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly
				   '@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments including CDATA
	);
	$text = preg_replace($search, '', $document);
	return $text;
}

function advads171_delete_keywords()
{
	global $wpdb;
	set_time_limit(300);
	$wpdb->query("DELETE FROM $wpdb->postmeta WHERE (meta_key = 'advads171_keywords' OR meta_key = 'advads171_content_asins') AND meta_value != ''");
	
	//advads171_generate_keywords_bulk();
}

function advads171_generate_keywords_bulk()
{
	global $wpdb;
	$post_types_str = get_option('advads171_posttypes');
	
	$post_types = explode(',', $post_types_str);
	foreach($post_types as $key => $val)
	{
		$post_types[$key] = $wpdb->escape($val);
	}
	
	$total_posts = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM $wpdb->posts WHERE post_type in ("."'".implode("', '", $post_types)."'".")"));

	
	if ($total_posts !== FALSE && $total_posts > 0)
	{
		$advads171_i = 0;
		while($advads171_i < $total_posts)
		{
			set_time_limit(300);
			$curr_post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE post_type in ("."'".implode("', '", $post_types)."'".")", OBJECT, $advads171_i);
			$post_content_filtered = apply_filters('the_content',$curr_post->post_content);
			$advads171_kws = advads171_gen_kws($post_content_filtered, $curr_post->post_title);
			if (count($advads171_kws) > 0)
			{
				//save kws in custom meta
				$advads171_kws = array_slice($advads171_kws, 0, 5);
				update_post_meta($curr_post->ID, 'advads171_keywords', implode(',', $advads171_kws));
			}
			$advads171_i++;
		}
	}
	echo 'Done!';
	exit;
}

function advads171_get_default_skip_keywords()
{
	$words = array(
	"mod",
	"#",
	"&",
	"'",
	"(",
	")",
	"-",
	"/",
	"1-year",
	"4 sale",
	"?",
	"@ebay",
	"a",
	"about",
	"add",
	"allround",
	"also",
	"am",
	"amazon",
	"an",
	"and",
	"antiques",
	"any",
	"are the",
	"are",
	"auction",
	"authentic",
	"back",
	"bargain",
	"bargains",
	"be",
	"best",
	"between",
	"budget",
	"buy",
	"buying",
	"by",
	"can",
	"can i",
	"cash",
	"catalog",
	"characteristic",
	"chart",
	"cheap",
	"cheapest",
	"choose",
	"choosing",
	"clean",
	"clearance",
	"co",
	"com",
	"company",
	"compare",
	"comparison",
	"compatable",
	"complete",
	"condition",
	"cost of",
	"cost",
	"custom",
	"customized",
	"damage",
	"damaged",
	"deal",
	"deals",
	"did",
	"difference",
	"discount",
	"discounted",
	"do",
	"does",
	"doesa",
	"e bay",
	"ebay",
	"ebay-world",
	"ebay.at",
	"ebay.be",
	"ebay.ca",
	"ebay.ch",
	"ebay.co.uk",
	"ebay.com",
	"ebay.de",
	"ebay.es",
	"ebay.fr",
	"ebay.ie",
	"ebay.it",
	"effects",
	"en ebay",
	"excellent",
	"expensive",
	"extra",
	"extremely",
	"final",
	"find",
	"fine",
	"finish",
	"flaws",
	"for",
	"for a",
	"for sale",
	"fore",
	"found",
	"from ebay",
	"from",
	"good",
	"grade",
	"guide",
	"has",
	"history",
	"hot",
	"how much are",
	"how much do",
	"how much for",
	"how to",
	"how",
	"i like",
	"i want",
	"if",
	"in",
	"in ebay",
	"instructions",
	"is the",
	"it",
	"its",
	"like",
	"list of",
	"list",
	"look for",
	"look",
	"looking",
	"ltd",
	"made",
	"maintenance",
	"make",
	"makes",
	"making",
	"many",
	"mark",
	"market",
	"markets",
	"marking",
	"mean",
	"mintage",
	"missed",
	"missing",
	"model",
	"modest",
	"most",
	"much",
	"my",
	"name",
	"narrow",
	"not",
	"of",
	"of a",
	"old",
	"on",
	"on amazon",
	"on ebay",
	"on sale",
	"online",
	"or",
	"oversized",
	"pattern",
	"patterns",
	"paypal",
	"pic",
	"piece",
	"price",
	"prices",
	"product",
	"products",
	"punched",
	"purchase",
	"rare",
	"rarest",
	"rated",
	"rating",
	"ratings",
	"real",
	"recognize",
	"repair",
	"review",
	"reviews",
	"sale",
	"sales",
	"same",
	"scarcity",
	"schematic",
	"search",
	"sell",
	"sewn",
	"side",
	"smith",
	"smiths",
	"specification",
	"specifications",
	"specs",
	"stand",
	"store",
	"stores",
	"su ebay",
	"sur ebay",
	"test",
	"the",
	"there is",
	"there",
	"this",
	"throu",
	"throuh",
	"thru",
	"to",
	"to a",
	"troz",
	"type",
	"united states",
	"up",
	"use",
	"used",
	"using",
	"valuable",
	"value of",
	"value",
	"waking",
	"want",
	"wanted",
	"wanting to",
	"wanting",
	"warranty",
	"was",
	"website",
	"were",
	"what is the",
	"what is",
	"what",
	"where is",
	"where",
	"which is",
	"which",
	"who is",
	"who",
	"wholesale",
	"with a",
	"with no",
	"with",
	"without",
	"word",
	"words",
	"worth",
	"worthy",
	"you"
	);
	return $words;
}

function advads171_filter_out_kws($current_kws_arr)
{
	if (is_array($current_kws_arr) && count($current_kws_arr) > 0)
	{	
		$advads171_skip_keywords_str = advads171_get_option('advads171_skip_keywords');

		if ($advads171_skip_keywords_str === FALSE)
		{
			$advads171_skip_keywords_arr = advads171_get_default_skip_keywords();
		}
		else
		{
			$advads171_skip_keywords_arr = explode(',', $advads171_skip_keywords_str);
		}
		if (count($advads171_skip_keywords_str) == 0)
		{
			$advads171_skip_keywords_str = array();
		}
		
		$advads171_skip_keywords_arr = array_diff($advads171_skip_keywords_arr, array('/'));
		$advads171_min_kw_length = advads171_get_option('advads171_min_kw_length');
		$new_kws_arr = array();
		$remove_kws = array();
	
		$old_kws_str = implode(',', $current_kws_arr);
		//trim
		foreach($current_kws_arr as $key => $val)
		{
			//remove one word keywords if selected
			if ($advads171_min_kw_length !== FALSE && $advads171_min_kw_length == 2 && count(explode(' ', trim($val))) == 1)
			{
				unset($current_kws_arr[$key]);
			}
			else
			{
				$current_kws_arr[$key] = trim($val);
			}
		}
		
		$skip_preg_arr = array();										
		foreach($advads171_skip_keywords_arr as $curr_skip_kw)
		{
			//check for exact matches											
			if (preg_match('/^(["\']).*\1$/m', $curr_skip_kw) == 1)
			{
				$str_no_quotes = substr($curr_skip_kw, 1, (strlen($curr_skip_kw) - 2));
				if (in_array($str_no_quotes, $current_kws_arr))
				{
					$remove_kws[] = $str_no_quotes;
				}
			}
			else
			{	
				if (stripos($curr_skip_kw, "*") !== FALSE)
				{
					if (substr($curr_skip_kw, 0, 1) == '*' && substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
					{
						$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
					}
					elseif (substr($curr_skip_kw, 0, 1) == '*')
					{
						$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR)."\b";
					}
					elseif (substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
					{
						$skip_preg_arr[] = "\b".preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
					}
				}
				else
				{
					$skip_preg_arr[] = "\b".preg_quote($curr_skip_kw, DIRECTORY_SEPARATOR)."\b";
				}
			}
		}
		$new_kws_arr = array_diff($current_kws_arr, $remove_kws);

		foreach($new_kws_arr as $key => $val)
		{
			$new_val = preg_replace('/('.implode('|', $skip_preg_arr).')/i', '', $val);
			
			if (strlen(trim($new_val)) > 0)
			{
				$new_kws_arr[$key] = trim($new_val);
			}
			else
			{
				unset($new_kws_arr[$key]);
			}
		}
		
		//remove one word keywords again
		foreach($new_kws_arr as $key => $val)
		{
			//remove one word keywords if selected
			if (isset($_POST['advads171_min_kw_length']) && $_POST['advads171_min_kw_length'] == 2 && count(explode(' ', trim($val))) == 1)
			{
				unset($new_kws_arr[$key]);
			}
			//remove spaces 
			if (strlen(trim($val)) == 0)
			{
				unset($new_kws_arr[$key]);
			}
			$val = str_replace('   ', ' ', $val);
			$val = str_replace('  ', ' ', $val);
			$new_kws_arr[$key] = str_replace('  ', ' ', $val);
		}
		
		return $new_kws_arr;
	}
	else
	{
		return $current_kws_arr;
	}
}

function advads171_multisite_setup_tbl()
{
	global $wpdb;
	$charset_collate = '';
		if (strlen($wpdb->charset) > 0)	$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		$sql = "CREATE TABLE IF NOT EXISTS `advads171_wpms_global_settings` (
  `name` varchar(64) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY (`name`)
) ".$charset_collate;
	$wpdb->query($sql);
}

function advads171_current_version()
{
	global $advads171_plugin_slug;
	$version = 0;
	$plugins = get_plugins();
	if (isset($plugins[$advads171_plugin_slug.'/'.$advads171_plugin_slug.'.php']) && isset($plugins[$advads171_plugin_slug.'/'.$advads171_plugin_slug.'.php']['Version']))
	{
		$version = $plugins[$advads171_plugin_slug.'/'.$advads171_plugin_slug.'.php']['Version'];
	}
	return $version;
}

function advads171_get_affiliate_network($post_id = 0) 
{
	global $advads171_addons;
	$advads171_source = '0';
	$advads171_source_sequence = advads171_get_option('source_sequence');
	if ($advads171_source_sequence === FALSE)
	{
		$advads171_source_sequence = 0;
	}
	
	$advads171_amzn_category_disabled = FALSE;
	$advads171_epn_category_disabled = FALSE;
	//get disabled categories
	$advads171_amzn_disabled_categories = array();
	$advads171_amzn_disabled_categories_check = get_option('advads171_amzn_disabled_categories');
	if ($advads171_amzn_disabled_categories_check !== FALSE && isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn', $advads171_addons))
	{
		$advads171_amzn_disabled_categories_check_arr = explode(',', $advads171_amzn_disabled_categories_check);
		if (count($advads171_amzn_disabled_categories_check_arr) > 0)
		{
			$advads171_amzn_disabled_categories = $advads171_amzn_disabled_categories_check_arr;
		}
	}
	$advads171_epn_disabled_categories = array();
	$advads171_epn_disabled_categories_check = get_option('advads171_epn_disabled_categories');
	if ($advads171_epn_disabled_categories_check !== FALSE && isset($advads171_addons) && is_array($advads171_addons) && in_array('epn', $advads171_addons))
	{
		$advads171_epn_disabled_categories_check_arr = explode(',', $advads171_epn_disabled_categories_check);
		if (count($advads171_epn_disabled_categories_check_arr) > 0)
		{
			$advads171_epn_disabled_categories = $advads171_epn_disabled_categories_check_arr;
		}
	}
	//get post cats
	if ($post_id != 0)
	{
		$post_cats = get_the_category($post_id);
		if (is_array($post_cats) && count($post_cats) > 0)
		{
			foreach($post_cats as $post_cat)
			{
				if (in_array($post_cat->term_id, $advads171_amzn_disabled_categories))
				{
					$advads171_amzn_category_disabled = TRUE;
				}
				if (in_array($post_cat->term_id, $advads171_epn_disabled_categories))
				{
					$advads171_epn_category_disabled = TRUE;
				}
			}
		}
	}
	
	if ($advads171_epn_category_disabled === TRUE && $advads171_amzn_category_disabled === TRUE && !isset($_GET['preview_general']) && !isset($_GET['preview']))
	{
		return '999';
	}
	
	if (is_array($advads171_addons) && in_array('epn', $advads171_addons) && (advads171_get_option('epn_enabled') == '1' || advads171_get_option('epn_enabled') === FALSE) && $advads171_epn_category_disabled !== TRUE)
	{
		$epn_pops_share = advads171_get_option('epn_pops_share');
		if ($epn_pops_share === FALSE)
		{
			$epn_pops_share = '50';
		}
		if ($advads171_source_sequence < $epn_pops_share)
		{
			$advads171_source = '1';
		}
	}
	
	//amzn disabled but epn active
	$advads171_amzn_active = advads171_get_option('advads171_amzn_active');
	if (advads171_get_option('epn_enabled') == '1' && $advads171_epn_category_disabled !== TRUE && (($advads171_amzn_active !== FALSE && is_numeric($advads171_amzn_active) && $advads171_amzn_active == '0') || $advads171_amzn_category_disabled === TRUE))
	{
		$advads171_source = '1';
	}
	
	//check if country supported and if need to substitute with different source
	if (is_array($advads171_addons) && in_array('epn', $advads171_addons) && in_array('amzn', $advads171_addons) && (advads171_get_option('epn_enabled') == '1' || advads171_get_option('epn_enabled') === FALSE) && (advads171_get_option('advads171_amzn_active') == '1' || advads171_get_option('advads171_amzn_active') === FALSE))
	{		
		$amzn_countries = array('us', 'uk', 'de', 'jp', 'fr', 'ca', 'it', 'cn', 'es', 'gb');
		$epn_countries = array('us', 'ie', 'at', 'au', 'be', 'ca', 'fr', 'de', 'it', 'es', 'ch','uk', 'nl');
		$user_country = advads171_get_locale(FALSE);
		
		//amzn only countries (jp and cn)
		$amtag_jp = get_option('advads171_locale_tag_jp');
		$amtag_cn = get_option('advads171_locale_tag_cn');
		if (($user_country == 'jp' && $amtag_jp !== FALSE && strlen($amtag_jp) > 0) || ($user_country == 'cn' && $amtag_cn !== FALSE && strlen($amtag_cn) > 0))
		{
			$advads171_source = '0';
		}
		
		//epn only countries (ie, at, au, be, ch, nl)
		if (in_array($user_country, array('ie', 'at', 'au', 'be', 'ch', 'nl')))
		{
			$epn_country_enabled_current = advads171_get_option('epn_country_enabled_'.$user_country);
			if (($epn_country_enabled_current === FALSE || $epn_country_enabled_current == '1'))
			{
				$advads171_source = '1';
			}
		}
		
		//country disabled at one of the sources but enabled at other
		if (in_array($user_country, array('us', 'uk', 'de', 'fr', 'ca', 'it', 'es')))
		{
			$epn_country_enabled_current = advads171_get_option('epn_country_enabled_'.$user_country);
			if ($user_country == 'us')
			{
				$amzn_country_enabled_current = get_option('advads171_am_associate_tag');
			}
			else
			{
				$amzn_country_enabled_current = get_option('advads171_locale_tag_'.$user_country);
			}

			if (($epn_country_enabled_current === FALSE || $epn_country_enabled_current == '1') && ($amzn_country_enabled_current === FALSE && strlen(trim($amzn_country_enabled_current)) == 0))
			{
				$advads171_source = '1';
			}
			
			if ((is_numeric($epn_country_enabled_current) && $epn_country_enabled_current == '0') && ($amzn_country_enabled_current !== FALSE && strlen(trim($amzn_country_enabled_current)) > 0))
			{
				$advads171_source = '0';
			}
		}		
	}
	
	/*echo '<br />advads171_source_sequence: '.$advads171_source_sequence;
	echo '<br />epn_pops_share: '.$epn_pops_share;
	echo '<pre>';
	print_r($advads171_addons);
	echo '</pre>';*/
	return $advads171_source;
}

function advads171_module_installed($module_name = '')
{
	global $advads171_addons;
	if (isset($advads171_addons) && is_array($advads171_addons) && in_array($module_name, $advads171_addons))
	{
		return TRUE;
	}
	return FALSE;
}

function advads171_amzn_cats_select($country = 'us', $level = 0, $parent_id = 0, $selected = array(), $break_cycle = FALSE)
{
	global $advads171_plugin_slug, $advads171_plugin_name;
	//level 0 is always search index for that locale
	//level 1 returns top node ids for the search index
	
	$html = '';
	if ($level == '0')
	{
		$advads171_amzn_level_one_cats = advads171_include_amzn_category($country, 0);
		
		if (isset($advads171_amzn_level_one_cats['indexes']))
		{
			$html .= '<select name="amzn_category['.$country.']['.$level.']" style="width: 250px;"';
			$html .= ' onchange="if (this.value == \'All\' || this.value == \'Blended\') { jQuery(\'.amzn_'.$country.'_node_children_'.$parent_id.'\').remove();} else {advads171_amzn_load_cats_selector(\''.$country.'\', \''.($level + 1).'\', this.value, \''.$parent_id.'\');}"';
			$html .= '>';
			//$html .= '<option value="0">-- '.__('All Categories', $advads171_plugin_slug).' --</option>';
			foreach($advads171_amzn_level_one_cats['indexes'] as $key => $val)
			{
				$html .= '<option value="'.$key.'" '.(isset($selected[$level]) && $key == $selected[$level]?'selected':'').'>';
				$html .= $val;
				$html .= '</option>';
			}
			$html .= '</select>';
			
			if ($break_cycle === FALSE)
			{
				if (isset($selected[($level + 1)]))
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_'.$country.'_node_children">'.advads171_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected).'</div>';
				}
				else
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_'.$country.'_node_children">'.advads171_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected, TRUE).'</div>';
				}
			}
		}

	}
	else
	{
		//return top nodes for the 
		$advads171_amzn_level_one_cats = advads171_include_amzn_category($country, $parent_id);
		
		if (isset($advads171_amzn_level_one_cats['nodes']))
		{
			$html .= '<select name="amzn_category['.$country.']['.$level.']" style="width: 250px;"';

			$html .= ' onchange="if (this.value == \'0\') { jQuery(\'.amzn_'.$country.'_node_children_'.$parent_id.'\').remove();} else { advads171_amzn_load_cats_selector(\''.$country.'\', \''.($level + 1).'\', this.value, \''.$parent_id.'\'); }"';

			$html .= '>';
			$html .= '<option value="0">-- '.__('All Subcategories', $advads171_plugin_slug).' --</option>';
			foreach($advads171_amzn_level_one_cats['nodes'] as $key => $val)
			{
				$html .= '<option value="'.$key.'" '.(isset($selected[$level]) && $key == $selected[$level]?'selected':'').'>';
				$html .= $val;
				$html .= '</option>';
			}
			$html .= '</select>';
			
			if ($break_cycle === FALSE)
			{
				if (isset($selected[($level + 1)]))
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_node_children">'.advads171_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected).'</div>';
				}
				else
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_'.$country.'_node_children">'.advads171_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected, TRUE).'</div>';
				}
			}
	
		}
	}	
	
	return $html;
}

function advads171_amzn_country_cats_javascript() {
global $advads171_plugin_slug, $advads171_plugin_name;
advads171_add_json_support();
?>
<script type="text/javascript" >
function advads171_amzn_load_cats_selector(country, level, parent_id, ancestor_id)
{
	var data = {
		action: 'advads171_amzn_get_cats',
		country: country,
		level: level,
		parent_id: parent_id,
		ancestor_id: ancestor_id
	};

	if (parent_id == 0)
	{
		jQuery('.amzn_' + country + '_category_loading_msg').html('');
	}
	else
	{
		jQuery('.amzn_' + country + '_node_children_' + ancestor_id).html('');
		jQuery('.amzn_' + country + '_category_loading_msg').html('<?php esc_attr_e('Checking subcategories...', $advads171_plugin_slug); ?>');
	}

	
	//if (parent_id != 0)
	//{
		jQuery.post(ajaxurl, data, function(response) {
			//alert('Got this from the server: ' + response);
			if (response != '')
			{
				//var obj = jQuery.parseJSON(response);
				//alert(parent_id);
				//alert(ancestor_id);
				var obj = JSON.parse(response);
				if (obj.html != undefined)
				{
					jQuery('.amzn_' + country + '_node_children_' + ancestor_id).remove();
					jQuery('.amzn_' + country + '_node_parent_' + ancestor_id).append('<div class="amzn_' + country + '_node_parent_' + obj.node_id + ' amzn_' + country + '_node_children_' + ancestor_id + ' amzn_' + country + '_node_children"></div>');
					jQuery('.amzn_' + country + '_node_parent_' + obj.node_id).html('');
					jQuery('.amzn_' + country + '_node_parent_' + obj.node_id).html(obj.html);
					jQuery('.amzn_' + country + '_category_loading_msg').html('');
				}
				
			}
		});
	//}
}
</script>
<?php
}

add_action('wp_ajax_advads171_amzn_get_cats', 'advads171_amzn_get_cats');

function advads171_amzn_get_cats() {
	global $wpdb, $_POST, $advads171_current_plugin_version;

	$country = $_POST['country'];
	$level = $_POST['level'];
	$parent_id = $_POST['parent_id'];
	
	if (/*is_numeric($parent_id) &&*/ is_numeric($level) && in_array($country, advads171_amzn_countries()))
	{
		//get children categories
		$html = advads171_amzn_cats_select($country, $level, $parent_id);
		echo json_encode(array('html' => $html, 'node_id' => $parent_id));
	}

	die(); // this is required to return a proper result
}

function advads171_include_amzn_category($country = 'us', $parent_id = 0)
{
	$curr_return = array();
	//download categories
	$advads171_am_params = array(
							'key_id' => get_option('advads171_am_key_id'), 
							'access_key' => get_option('advads171_am_access_key'),
							'associate_tag' => 'anytagfornodeid-21'
							);
	require_once(dirname(__FILE__).'/amazon.lib.php');
	$advads171_am_class = new advads171_amazon_api($advads171_am_params);
	//echo 'amzn_category '.$country.' '.$parent_id.'<br />';
	if (is_numeric($parent_id) && $parent_id == '0')
	{
		//return indexes first
		$am_indexes = $advads171_am_class->get_indexes($country);
		$curr_return['indexes'] = $am_indexes;
		
	}
	else
	{
		if (is_numeric($parent_id) === FALSE) 
		{
			//get top node id
			$parent_id = $advads171_am_class->get_top_node_id($country, $parent_id);
		}
		if (file_exists(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt'))
		{
			$node_contents = file_get_contents(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt');
			$node_unserialized = @unserialize($node_contents);
			if ($node_unserialized !== FALSE)
			{
				if (count($node_unserialized) > 0) $curr_return['nodes'] = $node_unserialized;
				return $curr_return;
			}
		}
		//comply with Amazon API time limits
		advads171_get_am_request_window();
		$am_result = $advads171_am_class->browse_node($country, $parent_id);
		if (isset($am_result->BrowseNodes->BrowseNode->Children->BrowseNode) )
		{
			$returned_nodes = array();
			foreach($am_result->BrowseNodes->BrowseNode->Children->BrowseNode as $curr_node)
			{
				$returned_nodes[strval($curr_node->BrowseNodeId)] = strval($curr_node->Name);
			}
			if (count($returned_nodes) > 0)
			{
				$fp = fopen(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt', 'w');
				if ($fp !== FALSE)
				{
					fwrite($fp, serialize($returned_nodes));
					fclose($fp);
				}
			}			
			
			if (count($returned_nodes) > 0) $curr_return['nodes'] = $returned_nodes;
		}
		elseif(isset($am_result->BrowseNodes->Request->IsValid) && strval($am_result->BrowseNodes->Request->IsValid) == 'True')
		{
			//write node with no children
			$returned_nodes = array();
			$fp = fopen(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt', 'w');
			if ($fp !== FALSE)
			{
				fwrite($fp, serialize($returned_nodes));
				fclose($fp);
			}
		}
		/*echo '<pre>';
		print_r($am_result);
		print_r($am_result->BrowseNodes->BrowseNode->Children->BrowseNode);
		print_r($returned_nodes);
		echo '</pre>';*/
		//$curr_return['nodes']
	}
	return $curr_return;
}

function advads171_amzn_countries()
{
	$countries = array(
						'1' => 'us',
						'2' => 'ca',
						'3' => 'fr',
						'4' => 'de',
						'5' => 'it',
						'6' => 'es',
						'7' => 'cn',
						'8' => 'uk',
						'9' => 'jp'
						);
	return $countries;
}

function advads171_country_selected_cats($country = 'us')
{
	$selected_arr = array();
	$selected_str = get_option('advads171_nodes_path_'.$country);
	if ($selected_str !== FALSE)
	{
		return explode(',', $selected_str);
	}
	//get fallback search index
	$search_index = get_option('advads171_am_searchindex');
	if ($search_index !== FALSE)
	{
		return array($search_index);
	}
	return $selected_arr;
}

function advads171_get_country_node($locale = '')
{
	$country_nodes = advads171_country_selected_cats($locale);
	$search_index = $country_nodes[0];
	$country_node = end($country_nodes);
	if ($country_node == '0')
	{
		$country_node = $country_nodes[count($country_nodes) - 2];
	}
	if (!is_numeric($country_node))
	{
		$country_node = '';
	}
	return array('search_index' => $search_index, 'country_node' => $country_node);
}

//returns price given or changes "Too low to display" msg to smth else
function advads171_am_price($price = '', $too_low_msg = 'See Price')
{
	if ($price == 'Too low to display')
	{
		return $too_low_msg;
	}
	return $price;
}

function advads_parse_asins($content = '')
{
	$asins = array();
	preg_match_all('/<a(.*?) href=\"(.*?)\">/i', $content, $url_matches);

	/*echo '<pre>';
	print_r($url_matches);
	exit;*/

	if (isset($url_matches[2]) && count($url_matches[2]) > 0)
	{
		
		foreach($url_matches[2] as $curr_url)
		{
			$curr_url = urldecode($curr_url);
			if (preg_match("/\.amazon\.(com|de|fr)/", $curr_url, $matches))
			{
				//preg_match("/\/dp\/(.*)(\?|\/ref)/", $url, $matches);
				$asin_found = preg_match("/(\/dp\/|\/gp\/product\/)(.*)(\?|\/ref)/i", $curr_url, $matches);
				/*echo '<pre>';
				print_r($matches);
				echo '</pre>';*/
				
				if ($asin_found > 0 && isset($matches[2]) && !in_array($matches[2], $asins))
				{
					$asins[] = $matches[2];
				}
			}
		}
	}
	return $asins;
}

function advads171_shortcode( $atts ) {
	global $post;
	extract( shortcode_atts( array(
		'id' => 'something',
		'bar' => 'something else',
	), $atts ) );
	
	if (is_numeric($id))
	{
		include_once(dirname(dirname(__FILE__)).'/app/models/banners.php');
		$banners = new advads171_banners;
		$curr_banner = $banners->get_by_id($id);
		if ($curr_banner !== FALSE)
		{
			if ($curr_banner['position'] == '2')
			{
				return $banners->banner_html_init($id, FALSE, $post->ID);
			}
		}
		
	}
	return "";
}
add_shortcode( 'contextazon', 'advads171_shortcode' );

function contextazon_banner( $id = 0, $echo = TRUE ) {
	global $post;

	if (is_numeric($id))
	{
		include_once(dirname(dirname(__FILE__)).'/app/models/banners.php');
		$banners = new advads171_banners;
		
		if ($echo == TRUE)
		{
			echo $banners->banner_html_init($id, FALSE, $post->ID);
			//$banner = $banners->banner_html_init($id, FALSE, $post->ID);
			
			/*echo '<pre>';
			print_r($banner);
			echo '</pre>';*/
		}
		else
		{
			return $banners->banner_html_init($id, FALSE, $post->ID);
		}
	}
	return "";
}

//BOF HTML placement
add_filter( 'the_content', 'filter_advads_html_banner' );
function filter_advads_html_banner($content = '')
{
	global $post, $advads_post;
	if (isset($advads_post->ID))
	{
		include_once(dirname(dirname(__FILE__)).'/app/models/banners.php');
		$banners = new advads171_banners;
		preg_match_all("/<div class=\"contextazon_html_banner\" data-id=\"(.*)\"><\/div>/", $content, $banner_id_matches);
		if (count($banner_id_matches) == 2 && isset($banner_id_matches[1]) && count($banner_id_matches[1]) > 0)
		{
			foreach($banner_id_matches[1] as $curr_id)
			{
				$curr_banner_html = $banners->banner_html_init($curr_id, FALSE, $advads_post->ID);
				$content = preg_replace("/<div class=\"contextazon_html_banner\" data-id=\"".$curr_id."\"><\/div>/", $curr_banner_html, $content, 1);
			}
		}
	}
	return $content;
}

function advads_html_callback($content) {
	global $post, $advads_post;
  // modify buffer here, and then return the updated code
	//$buffer = str_replace('contextazon_html_banner', 'contextazon_html_banner contextazon_html_banner_new_'.$post->ID, $buffer);
	if (isset($advads_post->ID))
	{
		include_once(dirname(dirname(__FILE__)).'/app/models/banners.php');
		$banners = new advads171_banners;
		preg_match_all("/<div class=\"contextazon_html_banner\" data-id=\"(.*)\"><\/div>/", $content, $banner_id_matches);
		if (count($banner_id_matches) == 2 && isset($banner_id_matches[1]) && count($banner_id_matches[1]) > 0)
		{
			foreach($banner_id_matches[1] as $curr_id)
			{
				$curr_banner_html = $banners->banner_html_init($curr_id, FALSE, $advads_post->ID);
				$content = preg_replace("/<div class=\"contextazon_html_banner\" data-id=\"".$curr_id."\"><\/div>/", $curr_banner_html, $content, 1);
			}
		}
	}
  return $content;
}
 
function advads_buffer_start() { 
ob_start("advads_html_callback"); 
}
 
function advads_buffer_end() { 
ob_end_flush(); 
}
 
add_action('wp_head', 'advads_buffer_start');
add_action('wp_footer', 'advads_buffer_end');
//EOF HTML placement

if (!class_exists('ContextAzonWidget'))
{
	class ContextAzonWidget extends WP_Widget
	{
	  function ContextAzonWidget()
	  {
		$widget_ops = array('classname' => 'ContextAzonWidget', 'description' => 'Displays ContextAzon Banner' );
		$this->WP_Widget('ContextAzonWidget', 'ContextAzon Widget', $widget_ops);
	  }
	 
	  function form($instance)
	  {
		$instance = wp_parse_args( (array) $instance, array( 'banner_id' => '' ) );
		$banner_id = $instance['banner_id'];
		include_once(dirname(dirname(__FILE__)).'/app/models/banners.php');
		$banners = new advads171_banners;
		$banners_data = $banners->banners_data();
		$widget_banners = array();
		if (isset($banners_data['banners']) && count($banners_data['banners']) > 0)
		{
			foreach($banners_data['banners'] as $key => $curr_banner)
			{
				if ($curr_banner['position'] == '1')
				{
					$widget_banners[$key] = $curr_banner;
				}
			}
		}
		if (count($widget_banners) > 0)
		{
	?>
	  <p><label for="<?php echo $this->get_field_id('banner_id'); ?>">Select a Banner: <br />
	  <select id="<?php echo $this->get_field_id('banner_id'); ?>" name="<?php echo $this->get_field_name('banner_id'); ?>">
		<?php foreach($widget_banners as $curr_banner): ?>
		<option value="<?php echo $curr_banner['id'];?>" <?php if ($banner_id == $curr_banner['id']) {echo 'selected';} ?>><?php echo $curr_banner['name'];?> &nbsp;</option>
		<?php endforeach; ?>
	  </select>
	  </label></p>
	<?php
		}
		else
		{
			echo '<p>There are no Widget banners. <br />Please create a banner with Placement set to Widget.</p>';
		}
	  }
	 
	  function update($new_instance, $old_instance)
	  {
		$instance = $old_instance;
		$instance['banner_id'] = $new_instance['banner_id'];
		return $instance;
	  }
	 
	  function widget($args, $instance)
	  {
		extract($args, EXTR_SKIP);
	 
		echo $before_widget;
		$banner_id = empty($instance['banner_id']) ? ' ' : apply_filters('widget_title', $instance['banner_id']);
		contextazon_banner($banner_id);
		//if (!empty($banner_id)) echo $before_title . $banner_id . $after_title;
		echo $after_widget;
	  }
	 
	}
}
add_action( 'widgets_init', create_function('', 'return register_widget("ContextAzonWidget");') );

function advads171_is_plus()
{
	if (advads171_module_installed('amzn_cart') && advads171_module_installed('epn') && advads171_module_installed('amasticky_banner'))
	{
		return TRUE;
	}
	return FALSE;
}
function advads171_branding_img()
{
	if (advads171_is_plus())
	{
		return 'ico_contextazon_header_plus.png';
	}
	return 'ico_contextazon_header.png';
}

add_action( 'admin_enqueue_scripts', 'advads_pointer_enqueue_scripts' );
function advads_pointer_enqueue_scripts() {
	//wp pointer introduced in wordpress 3.3
	if (version_compare(get_bloginfo('version'), '3.3', '<')) return;

    // Using Pointers
    wp_enqueue_style( 'wp-pointer' );
    wp_enqueue_script( 'wp-pointer' );
	
	if (isset($_GET['advads171_tour_close']) && $_GET['advads171_tour_close'] == 'yes')
	{
		advads171_update_option('quick_tour_finished', 'yes');
	}

	if ((advads171_get_option('license') !== FALSE && advads171_get_option('quick_tour_finished') != 'yes' && !isset($_GET['advads171_tour'])) || (isset($_GET['advads171_tour']) && $_GET['advads171_tour'] == '1'))
	{
		add_action( 'admin_print_footer_scripts', 'advads_pointer_print_one' );
	}
	
	if (isset($_GET['advads171_tour']) && $_GET['advads171_tour'] == '2')
	{
		add_action( 'admin_print_footer_scripts', 'advads_pointer_print_two' );
	}
	
	if (isset($_GET['advads171_tour']) && $_GET['advads171_tour'] == '5')
	{
		advads171_update_option('quick_tour_finished', 'yes');	//once user made it to banners page let's not bug him
		add_action( 'admin_print_footer_scripts', 'advads_pointer_print_five' );
	}
	
	if (isset($_GET['advads171_tour']) && $_GET['advads171_tour'] == '6')
	{
		add_action( 'admin_print_footer_scripts', 'advads_pointer_print_six' );
	}
	
	if (isset($_GET['advads171_tour']) && $_GET['advads171_tour'] == '7')
	{
		add_action( 'admin_print_footer_scripts', 'advads_pointer_print_seven' );
	}
	
	if (isset($_GET['advads171_tour']) && $_GET['advads171_tour'] == '8')
	{
		add_action( 'admin_print_footer_scripts', 'advads_pointer_print_eight' );
	}
}

function advads_pointer_print_one() {
    $pointer_content = '<h3>Welcome to ContextAzon!</h3>';
    $pointer_content .= '<p>Would you like to take a Quick Set Up Tour?</p><p><a href="admin.php?page=advads171-config&advads171_tour_close=yes" class="button-secondary">No, thanks</a> &nbsp; &nbsp; &nbsp; <a href="admin.php?page=advads171-config&advads171_tour=2" class="button-primary">Take Tour</a></p>';
?>
<script type="text/javascript">
//<![CDATA[
jQuery(document).ready( function($) {
    $('#toplevel_page_advads171-config').pointer({
        content: '<?php echo $pointer_content; ?>',
        position: 'bottom',
        close: function(e) {
			return;
            // Once the close button is hit
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function advads_pointer_print_two() {
    $pointer_content = '<h3>Default Country</h3>';
    $pointer_content .= "<p>Please select your default country in case visitor comes from non-Amazon supported country.<br /><br />You can also enable/disable plugin quickly from here if you need.</p><p> <a href=\"admin.php?page=advads171-config&advads171_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"javascript: void(0);\" onclick=\"javascript: advads171_pointer_three();\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	$pointer_content_three = '<h3>Amazon Quick Settings</h3>';
    $pointer_content_three .= "<p>These settings allow ContextAzon to connect to Amazon API. Use help links for help.</p><p> <a href=\"admin.php?page=advads171-config&advads171_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"javascript: advads171_pointer_four();\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	$pointer_content_four = '<h3>Save Settings</h3>';
    //$pointer_content_four .= "<p>Don\'t forget to save your settings :)</p><p> <a href=\"admin.php?page=advads171-config&advads171_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes you havent\'t saved.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"javascript: advads171_pointer_five();\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";
    $pointer_content_four .= "<p>Don\'t forget to save your settings :)</p><p> </p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    brand_new_pointer = $('#enable_and_country').pointer({
		pointerClass: 'advads_enable_and_country_pointer',
        content: '<?php echo $pointer_content; ?>',
        position: 'left',
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes not saved yet.')) 
			{
				window.location = "admin.php?page=advads171-config&advads171_tour_close=yes";
			}*/
			advads171_pointer_three();
        }
    }).pointer('open');
});

function advads171_pointer_three()
{
	jQuery('.advads_enable_and_country_pointer').hide();
	jQuery('#avads_amz_quick_settings').pointer({
		pointerClass: 'advads_amz_settings_pointer',
        content: '<?php echo $pointer_content_three; ?>',
        position: 'left',
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes not saved yet.')) 
			{
				window.location = "admin.php?page=advads171-config&advads171_tour_close=yes";
			}*/
			advads171_pointer_four();
        }
    }).pointer('open');
}

function advads171_pointer_four()
{
	jQuery('.advads_enable_and_country_pointer').hide();
	jQuery('.advads_amz_settings_pointer').hide();
	jQuery("html, body").animate({ scrollTop: jQuery(document).height() }, 1000);
	jQuery('#advads_save_important_settings').pointer({
		pointerClass: 'advads_important_sett_close_pointer',
        content: '<?php echo $pointer_content_four; ?>',
        position: {
                edge: 'left',
                align: 'top',
				offset: '3 -70'
            },
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes not saved yet.')) 
			{
				window.location = "admin.php?page=advads171-config&advads171_tour_close=yes";
			}*/
        }
    }).pointer('open');
}

//]]>
</script>
<?php
}

function advads_pointer_print_five() {
	$pointer_content_five = '<h3>Go to Banners page</h3>';
    $pointer_content_five .= "<p>Click \"Banners\" to manage banners on your site</p><p> <a href=\"admin.php?page=advads171-config&advads171_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"admin.php?page=advads171-ad_units&advads171_tour=6\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {

	var advads_curr_banners = $('#toplevel_page_advads171-config .wp-submenu-wrap ul').children('li').eq(1).children('a');
	var curr_banners_href = advads_curr_banners.attr('href');
	curr_banners_href = curr_banners_href + '&advads171_tour=6';
	advads_curr_banners.attr('href', curr_banners_href);
	var banner_handler = $('#toplevel_page_advads171-config .wp-submenu ul').children().eq(2);
    banner_handler.pointer({
        content: '<?php echo $pointer_content_five; ?>',
        position: {
                edge: 'left',
                align: 'center',
				offset: '0 -20'
            },
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes you haven\'t saved.')) 
			{
				window.location = "admin.php?page=advads171-config&advads171_tour_close=yes";
			}*/
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function advads_pointer_print_six() {
	$pointer_content_six = '<h3>Banner Settings</h3>';
    $pointer_content_six .= "<p>You can manage your banner settings on this screen.<br />There are different ways to add ContextAzon banners to your pages: as a widget, short code, before/after content or by adding a php tag in your theme file.<br /><br /><strong>Let me show you how to include a banner as a widget. Click Next</strong></p><p> <a href=\"admin.php?page=advads171-config&advads171_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"widgets.php?advads171_tour=7\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    $('#advads_th_name_footer').pointer({
        content: '<?php echo $pointer_content_six; ?>',
        position: {
                edge: 'top',
                align: 'center',
				offset: '0'
            },
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes you haven\'t saved.')) 
			{
				window.location = "admin.php?page=advads171-config&advads171_tour_close=yes";
			}*/
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function advads_pointer_print_seven() {
	$pointer_content_seven = '<h3>ContextAzon Widget</h3>';
    $pointer_content_seven .= "<p>Drag this widget and drop it on the sidebar on the right. Click Save and check your website.</p><p> <a href=\"admin.php?page=advads171-config&advads171_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"admin.php?page=advads171-ad_units&advads171_tour=8\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    $("div[id*='contextazonwidget']").eq(0).pointer({
        content: '<?php echo $pointer_content_seven; ?>',
        position: {
                edge: 'top',
                align: 'center',
				offset: '0'
            },
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes you haven\'t saved.')) 
			{
				window.location = "admin.php?page=advads171-config&advads171_tour_close=yes";
			}*/
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function advads_pointer_print_eight() {
	$pointer_content_seven = '<h3>Thanks!</h3>';
    $pointer_content_seven .= "<p>Go ahead play with different banner settings to fit your site layout etc.<br /><br />If you have any questions <a href=\"http://contextazon.com/faq/\">check the FAQ</a> and <a href=\"http://contextazon.com/videos/\">Videos</a></p><p style=\"text-align: center;\">Like ContextAzon?<br /><a href=\"http://contextazon.com/like-us-on-facebook/\" target=\"_blank\"><img src=\"".plugin_dir_url( dirname(__FILE__) )."images/btn_like.jpg\" /></a></p><p>Have fun! :)</p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    $('#toplevel_page_advads171-config').pointer({
        content: '<?php echo $pointer_content_seven; ?>',
        position: 'bottom',
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes you haven\'t saved.')) 
			{
				window.location = "admin.php?page=advads171-config&advads171_tour_close=yes";
			}*/
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}