<?php

/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

function advads171_epn_init() {
	add_action('admin_menu', 'advads171_epn_config_menu');
	//echo 'adding admin menu'; exit;
}
//add_action('init', 'advads171_epn_init');

function advads171_epn_config_menu() {
	global $advads171_plugin_slug, $advads171_plugin_name;
	 add_submenu_page('advads171-config', __('ePN Settings', $advads171_plugin_slug), __('ePN Settings', $advads171_plugin_slug), 8, 'advads171-epn-settings', 'advads171_epn_config_page');
}

function advads171_epn_config_page()
{	
	global $am_indexes, $blog_id, $wpdb, $advads171_plugin_slug, $advads171_plugin_name;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?'));
	
	if (advads171_license_type() === FALSE)
	{
		advads171_license();
		return;
	}
	
	wp_enqueue_style( $advads171_plugin_slug, plugins_url( $advads171_plugin_slug.'/style.css' , dirname(__FILE__) ), false, '1.0');
	
	//which tab?
	$tab = 'epn';
	if (isset($_GET['tab']) && (in_array($_GET['tab'], array('epn')) ))
	{
		$tab = $_GET['tab'];
	}


	$error = '';
	if ( isset($_POST['btnsubmit']) || (isset($_POST['advads171_form_submitted']) && $_POST['advads171_form_submitted'] == 'yes') ) 
	{
		//BOF Validation

		/*echo '<pre>';
		print_r($_POST);
		echo '</pre>';*/
		
		if($tab == 'epn')
		{
			if (isset($_POST['epn_enabled']))  $epn_enabled  = trim(strip_tags(($_POST['epn_enabled'])));
			if (isset($_POST['epn_campaign_id'])) $epn_campaign_id = trim(strip_tags(($_POST['epn_campaign_id'])));
			if (isset($_POST['epn_custom_id'])) $epn_custom_id = trim(strip_tags(($_POST['epn_custom_id'])));
			
			
	
			/*if ('' == $am_key_id)  $error .= '<div>Please enter your AWS Access Key ID</div>';
			if ('' == $am_access_key)  $error .= '<div>Please enter your AWS Secret Access Key</div>';
			if ('' == $am_associate_tag && '' == $am_associate_tag_uk && '' == $am_associate_tag_de && '' == $am_associate_tag_jp && '' == $am_associate_tag_fr && '' == $am_associate_tag_ca && '' == $am_associate_tag_it && '' == $am_associate_tag_cn && '' == $am_associate_tag_es )  $error .= '<div>Please enter at least one Amazon Associate Tag</div>';
			if ('' == $am_searchindex)  $error .= '<div>Please enter your Amazon Search Index</div>';
			*/
			
		}

		//EOF Validation		
		
		if ('' == $error) {
			
			if ($tab == 'epn')
			{
				if (isset($_POST['epn_enabled'])) {					
					advads171_update_option('epn_enabled', $epn_enabled = trim($_POST['epn_enabled']));
				} else {
					advads171_delete_option('epn_enabled');
				}
				
				if (isset($_POST['epn_campaign_id'])) {
					advads171_update_option('epn_campaign_id', $epn_campaign_id = trim($_POST['epn_campaign_id']));
				} else {
					advads171_delete_option('epn_campaign_id');
				}
				
				if (isset($_POST['epn_custom_id'])) {
					advads171_update_option('epn_custom_id', $epn_custom_id = trim($_POST['epn_custom_id']));
				} else {
					advads171_delete_option('epn_custom_id');
				}
				
				$epn_country_enabled = array();
				foreach(advads171_epn_countries() as $country)
				{
					if (isset($_POST['epn_country_enabled'][$country]) && $_POST['epn_country_enabled'][$country] == '1')
					{
						advads171_update_option('epn_country_enabled_'.$country, $_POST['epn_country_enabled'][$country]);
						$epn_country_enabled[$country] = $_POST['epn_country_enabled'][$country];
					}
					else
					{
						advads171_update_option('epn_country_enabled_'.$country, '0');
						$epn_country_enabled[$country] = '0';
					}
				}
				
				//save country categories
				$epn_country_cats = array();
				if (isset($_POST['epn_category']) && is_array($_POST['epn_category']) && count($_POST['epn_category']) > 0)
				{
					foreach($_POST['epn_category'] as $country => $country_cats)
					{
						if (in_array($country, advads171_epn_countries()))
						{
							if (is_array($country_cats) && count($country_cats) > 0)
							{
								$cat_ids = array();
								foreach($country_cats as $cat_id)
								{
									if ($cat_id != 0)
									{
										$cat_ids[] = $cat_id;
									}
								}
							}
							$epn_country_cats[$country] = implode('|', $cat_ids);
							advads171_update_option('epn_category_'.$country, implode('|', $cat_ids));
						}						
					}
				}
				
				if (isset($_POST['epn_min_price'])) {
					$epn_min_price = '';
					if (isset($_POST['epn_min_price']) && strlen($_POST['epn_min_price']) > 0) $epn_min_price = number_format($_POST['epn_min_price'], 2, '.', '');
					advads171_update_option('epn_min_price', $epn_min_price = $epn_min_price);
				} else {
					advads171_delete_option('epn_min_price');
				}
				if (isset($_POST['epn_max_price'])) {
					$epn_max_price = '';
					if (isset($_POST['epn_max_price']) && strlen($_POST['epn_max_price']) > 0) $epn_max_price = number_format($_POST['epn_max_price'], 2, '.', '');
					advads171_update_option('epn_max_price', $epn_max_price = $epn_max_price);
				} else {
					advads171_delete_option('epn_max_price');
				}
				if (isset($_POST['epn_listing_type'])) {
					advads171_update_option('epn_listing_type', $epn_listing_type = trim($_POST['epn_listing_type']));
				} else {
					advads171_delete_option('epn_listing_type');
				}
				if (isset($_POST['epn_free_shipping'])) {
					advads171_update_option('epn_free_shipping', $epn_free_shipping = trim($_POST['epn_free_shipping']));
				} else {
					advads171_delete_option('epn_free_shipping');
				}
				if (isset($_POST['epn_sort_order'])) {
					advads171_update_option('epn_sort_order', $epn_sort_order = trim($_POST['epn_sort_order']));
				} else {
					advads171_delete_option('epn_sort_order');
				}
				
				if (isset($_POST['epn_cache_seconds'])) {
					advads171_update_option('epn_cache_seconds', $epn_cache_seconds = trim($_POST['epn_cache_seconds']));
				} else {
					advads171_delete_option('epn_cache_seconds');
				}
				
				if (isset($_POST['epn_pops_share'])) {
					advads171_update_option('epn_pops_share', $epn_pops_share = trim($_POST['epn_pops_share']));
				} else {
					advads171_delete_option('epn_pops_share');
				}
				
				if (isset($_POST['epn_min_bids'])) {
					$epn_min_bids = '';
					if (isset($_POST['epn_min_bids']) && strlen($_POST['epn_min_bids']) > 0) $epn_min_bids = $_POST['epn_min_bids'];
					advads171_update_option('epn_min_bids', $epn_min_bids = trim($epn_min_bids));
				} else {
					advads171_delete_option('epn_min_bids');
				}				
				if (isset($_POST['epn_max_bids'])) {
					$epn_max_bids = '';
					if (isset($_POST['epn_max_bids']) && strlen($_POST['epn_max_bids']) > 0) $epn_max_bids = $_POST['epn_max_bids'];
					advads171_update_option('epn_max_bids', $epn_max_bids = trim($epn_max_bids));
				} else {
					advads171_delete_option('epn_max_bids');
				}
				if (isset($_POST['epn_feedback_score_min'])) {
					$epn_feedback_score_min = '';
					if (isset($_POST['epn_feedback_score_min']) && strlen($_POST['epn_feedback_score_min']) > 0) $epn_feedback_score_min = $_POST['epn_feedback_score_min'];
					advads171_update_option('epn_feedback_score_min', $epn_feedback_score_min = trim($epn_feedback_score_min));
				} else {
					advads171_delete_option('epn_feedback_score_min');
				}
				if (isset($_POST['epn_feedback_score_max'])) {
					$epn_feedback_score_max = '';
					if (isset($_POST['epn_feedback_score_max']) && strlen($_POST['epn_feedback_score_max']) > 0) $epn_feedback_score_max = $_POST['epn_feedback_score_max'];
					advads171_update_option('epn_feedback_score_max', $epn_feedback_score_max = trim($epn_feedback_score_max));
				} else {
					advads171_delete_option('epn_feedback_score_max');
				}
				
				if (isset($_POST['epn_conditions'])) {
					$epn_conditions = array();
					$epn_conditions_str = '';
					if ( is_array($_POST['epn_conditions']) && count($_POST['epn_conditions']) > 0) 
					{
						$epn_conditions_str = implode(',', $_POST['epn_conditions']);
						$epn_conditions = $_POST['epn_conditions'];
					}
					advads171_update_option('epn_conditions', $epn_conditions_str = trim($epn_conditions_str));
				} else {
					advads171_delete_option('epn_conditions');
				}
				
				
				
				//delete cache
				$sql = "DELETE FROM `".$wpdb->prefix."advads171_cache` WHERE `source` = 1";
				$wpdb->query($sql);
			}			
		}
		
	}
	else
	{
		if ($tab == 'epn')
		{
			$epn_enabled = advads171_get_option('epn_enabled');
			$epn_campaign_id = advads171_get_option('epn_campaign_id');
			$epn_custom_id = advads171_get_option('epn_custom_id');
			
			$epn_country_cats = array();
			foreach(advads171_epn_countries() as $country)
			{
				if (in_array($country, advads171_epn_countries()))
				{
					$epn_country_cats[$country] = advads171_get_option('epn_category_'.$country);
				}						
			}
			
			$epn_country_enabled = array();
			foreach(advads171_epn_countries() as $country)
			{
				$epn_country_enabled[$country] = advads171_get_option('epn_country_enabled_'.$country);
				if ($epn_country_enabled[$country] === FALSE)
				{
					//$epn_country_enabled[$country] = '0';
				}
			}
			
			$epn_min_price = advads171_get_option('epn_min_price');
			if ($epn_min_price !== FALSE && strlen($epn_min_price) > 0) $epn_min_price = number_format($epn_min_price, 2, '.', '');			
			$epn_max_price = advads171_get_option('epn_max_price');
			if ($epn_max_price !== FALSE && strlen($epn_max_price) > 0) $epn_max_price = number_format($epn_max_price, 2, '.', '');
			$epn_listing_type = advads171_get_option('epn_listing_type');
			$epn_free_shipping = advads171_get_option('epn_free_shipping');
			$epn_sort_order = advads171_get_option('epn_sort_order');
			$epn_cache_seconds = advads171_get_option('epn_cache_seconds');
			
			$epn_min_bids = advads171_get_option('epn_min_bids');
			$epn_max_bids = advads171_get_option('epn_max_bids');
			$epn_feedback_score_min = advads171_get_option('epn_feedback_score_min');
			$epn_feedback_score_max = advads171_get_option('epn_feedback_score_max');
			$epn_conditions_str = advads171_get_option('epn_conditions');
			$epn_conditions = array();
			if ($epn_conditions_str !== FALSE) $epn_conditions = explode(',', $epn_conditions_str);
			
			$epn_pops_share = advads171_get_option('epn_pops_share');
			if ($epn_pops_share === FALSE)
			{
				$epn_pops_share = 50;
			}

		}		
	}

	if ( !empty($_POST ) && '' == $error ) {
		echo '<div id="message" class="updated fade"><p><strong>'
		. __('Settings saved.') ;
		if (isset($advads171_additional_success) && $advads171_additional_success != '')
		{
			echo "<br />".$advads171_additional_success;
		}
		echo '</strong></p></div>';
		if (isset($advads171_wpfooter_warning) && $advads171_wpfooter_warning != '')
		{
			echo '<div id="message" class="error"><p><strong>'
		. __($advads171_wpfooter_warning) . '</strong></p></div>';
		}
	}
	
	
	

	echo '<div class="wrap"><img src="'.plugin_dir_url( dirname(dirname(__FILE__)) ).'images/'.advads171_branding_img().'" style="display: block; float: right;" /><h2>' . sprintf(__('%s Settings', $advads171_plugin_slug), $advads171_plugin_name) . '</h2>';
	
	
		$tabs = array(
			'epn' => __('ePN Settings', $advads171_plugin_slug),
			);

		echo '<h2 class="nav-tab-wrapper">';

		if ( isset( $redir_tab ) && array_key_exists( $redir_tab, $tabs ) ) {
			$current = $redir_tab;
		} elseif ( isset( $_GET['tab'] ) && array_key_exists( $_GET['tab'], $tabs ) ) {
			$current = $_GET['tab'];
		} else {
			$keys = array_keys( $tabs );
			$current = array_shift( $keys );
		}

		foreach ( $tabs as $callback => $text ) {
			$class = ' class="nav-tab"';

			if ( $current == $callback )
				$class = ' class="nav-tab nav-tab-active"';

			$href = add_query_arg( array( 'tab' => $callback, 's' => false, 'paged' => false, 'post_mime_type' => false, 'm' => false ) );
			$href = remove_query_arg( 'isocode', $href );
			$href = wp_nonce_url( $href, "tab-$callback" );
			$link = "<a href='" . esc_url( $href ) . "'$class>$text</a>";

			echo $link;
		}
		echo '</h2>';

	?>
	
	<?php if ($tab == 'epn'): ?>
		<?php advads171_prepare_postboxes(); ?>
		<form method="post" action="" >
		<table class="form-table" style="width:750px;">
			<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php _e('ePN Settings. If you have any questions check out our <a href="http://contextazon.com/faq" target="_blank">FAQ</a>', $advads171_plugin_slug); ?></td></tr>
			<?php if (strlen($error)): ?>
				<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
			<?php endif; ?>
			<tr><td colspan="2">
			<div class="metabox-holder">
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('General', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">
						
							<tr class="form-field"><th style="width:150px;"><label for="epn_enabled"><?php _e('ePN enabled', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="epn_enabled" id="epn_enabled">
										<option value="1" <?=($epn_enabled === FALSE || $epn_enabled == '1'?'selected':'');?> ><?php _e('Yes', $advads171_plugin_slug); ?> &nbsp;</option>
										<option value="0" <?=(is_numeric($epn_enabled) && $epn_enabled == '0'?'selected':'');?> ><?php _e('No', $advads171_plugin_slug); ?> &nbsp;</option>
									</select>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="epn_campaign_id"><?php _e('Campaign ID', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="epn_campaign_id" value="<?=$epn_campaign_id;?>" id="epn_campaign_id" size="25" style="width:220px;" /> <br /><span class="description"><?php _e('used to turn product links into your affiliate links (required)', $advads171_plugin_slug); ?></span> </td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="epn_custom_id"><?php _e('Custom ID', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="epn_custom_id" value="<?=$epn_custom_id;?>" id="epn_custom_id" size="25" style="width:220px;" /> <span class="description"><?php _e('for tracking (optional)', $advads171_plugin_slug); ?></span> </td></tr>
						</table>
					</div>
				</div>
				
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('International', $advads171_plugin_slug); ?></h3>
					<div class="inside">
					
						<table class="form-table" style="width:auto;">	
							
							<?php foreach(advads171_epn_countries() as $program_id => $curr_country): ?>
								<?php
								$curr_country_enabled = $epn_country_enabled[$curr_country];
								?>
								<tr class="form-field"><th style="width:150px;"><label for="epn_<?=$curr_country;?>_enabled"><?php _e('eBay', $advads171_plugin_slug); ?> <?=strtoupper($curr_country);?>:</label></th>
									<td>
									<div style="float: left;">
										<select name="epn_country_enabled[<?=$curr_country;?>]" id="epn_<?=$curr_country;?>_enabled">
											<option value="1" <?=($curr_country_enabled === FALSE || $curr_country_enabled == '1'?'selected':'');?> ><?php _e('Active', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="0" <?=(is_numeric($curr_country_enabled) && $curr_country_enabled == '0'?'selected':'');?> ><?php _e('Disabled', $advads171_plugin_slug); ?> &nbsp;</option>
										</select> 
									</div>
										
										<div style="width: 110px; padding-left: 20px; float: left;">
											<?=strtoupper($curr_country);?> <?php _e('Category Filter', $advads171_plugin_slug); ?>:
										</div>
										<?php
											$selected_cat_level_one = 0;
											$selected_cat_level_two = 0;
											$selected_cat_level_three = 0;
											$selected_cat_level_four = 0;
											if (isset($epn_country_cats) && isset($epn_country_cats[$curr_country]) && $epn_country_cats[$curr_country] !== FALSE)
											{
												if ($epn_country_cats[$curr_country] !== FALSE)
												{
													$curr_levels_arr = explode('|', $epn_country_cats[$curr_country]);
													if (isset($curr_levels_arr[0])) $selected_cat_level_one = $curr_levels_arr[0];
													if (isset($curr_levels_arr[1])) $selected_cat_level_two = $curr_levels_arr[1];
													if (isset($curr_levels_arr[2])) $selected_cat_level_three = $curr_levels_arr[2];
													if (isset($curr_levels_arr[3])) $selected_cat_level_four = $curr_levels_arr[3];
												}
											}
										?>
										<div style="float: left;">
											<div id="epn_<?=$curr_country;?>_category_1_wrap">												
												<?php echo advads171_epn_cats_select($curr_country, 1, 0, $selected_cat_level_one); ?>
											</div>
											<div id="epn_<?=$curr_country;?>_category_2_wrap">
												<?php echo advads171_epn_cats_select($curr_country, 2, $selected_cat_level_one, $selected_cat_level_two); ?>
											</div>
											<div id="epn_<?=$curr_country;?>_category_3_wrap">
												<?php echo advads171_epn_cats_select($curr_country, 3, $selected_cat_level_two, $selected_cat_level_three); ?>
											</div>
											<div id="epn_<?=$curr_country;?>_category_4_wrap">
												<?php echo advads171_epn_cats_select($curr_country, 4, $selected_cat_level_three, $selected_cat_level_four); ?>
											</div>
										</div>
									</td></tr>
							<?php endforeach; ?>
							
						</table>
					</div>
				</div>

				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Other', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">		
							<tr class="form-field"><th style="width:150px;"><label for="epn_min_price"><?php _e('Min price', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="epn_min_price" value="<?=$epn_min_price;?>" id="epn_min_price" size="25" style="width:220px;" /> <span class="description"><?php _e('optional', $advads171_plugin_slug); ?></span> 
								</td></tr>
							<tr class="form-field"><th style="width:150px;"><label for="epn_max_price"><?php _e('Max price', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="epn_max_price" value="<?=$epn_max_price;?>" id="epn_max_price" size="25" style="width:220px;" /> <span class="description"><?php _e('optional', $advads171_plugin_slug); ?></span> 
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="epn_listing_type"><?php _e('Listing Type', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="epn_listing_type" id="epn_listing_type">
											<option value="All" <?=($epn_listing_type == 'All'?'selected':'');?>><?php _e('All', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="Auction" <?=($epn_listing_type == 'Auction'?'selected':'');?>><?php _e('Auction', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="BIN" <?=($epn_listing_type == 'BIN'?'selected':'');?>><?php _e('BIN Only', $advads171_plugin_slug); ?> &nbsp;</option>
									</select>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="epn_free_shipping"><?php _e('Only Free Shipping', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="epn_free_shipping" id="epn_free_shipping">
											<option value="0" <?=($epn_free_shipping == '0'?'selected':'');?>><?php _e('No', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="1" <?=($epn_free_shipping == '1'?'selected':'');?>><?php _e('Yes', $advads171_plugin_slug); ?> &nbsp;</option>
									</select>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="epn_sort_order"><?php _e('Sort Order', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="epn_sort_order" id="epn_sort_order">
											<option value="BestMatch" <?=($epn_sort_order == 'BestMatch'?'selected':'');?>><?php _e('Best Match', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="EndTimeSoonest" <?=($epn_sort_order == 'EndTimeSoonest'?'selected':'');?>><?php _e('Items Endind First', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="StartTimeNewest" <?=($epn_sort_order == 'StartTimeNewest'?'selected':'');?>><?php _e('Newly-Listed Items First', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="PricePlusShippingLowest" <?=($epn_sort_order == 'PricePlusShippingLowest'?'selected':'');?>><?php _e('Price+Shipping: Lowest First', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="PricePlusShippingHighest" <?=($epn_sort_order == 'PricePlusShippingHighest'?'selected':'');?>><?php _e('Price+Shipping: Highest First', $advads171_plugin_slug); ?> &nbsp;</option>
									</select>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="epn_min_bids"><?php _e('Min bids', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="epn_min_bids" value="<?=$epn_min_bids;?>" id="epn_min_bids" size="25" style="width:220px;" /> <span class="description"><?php _e('optional (you would probably want to set \'Listing Type\' to \'Auction\' if using this filter)', $advads171_plugin_slug); ?></span> 
								</td></tr>
							<tr class="form-field"><th style="width:150px;"><label for="epn_max_bids"><?php _e('Max bids', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="epn_max_bids" value="<?=$epn_max_bids;?>" id="epn_max_bids" size="25" style="width:220px;" /> <span class="description"><?php _e('optional', $advads171_plugin_slug); ?></span> 
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="epn_feedback_score_min"><?php _e('Seller\'s Min Feedback Score', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="epn_feedback_score_min" value="<?=$epn_feedback_score_min;?>" id="epn_feedback_score_min" size="25" style="width:220px;" /> <span class="description"><?php _e('optional', $advads171_plugin_slug); ?></span> 
								</td></tr>
							<tr class="form-field"><th style="width:150px;"><label for="epn_feedback_score_max"><?php _e('Seller\'s Max Feedback Score', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="epn_feedback_score_max" value="<?=$epn_feedback_score_max;?>" id="epn_feedback_score_max" size="25" style="width:220px;" /> <span class="description"><?php _e('optional', $advads171_plugin_slug); ?></span> 
								</td></tr>
								
								<?php
								if (!isset($epn_conditions) || !is_array($epn_conditions))
								{
									$epn_conditions = array();
								}
								?>
								
							<tr class="form-field"><th style="width:150px;"><label for="epn_conditions"><?php _e('Conditions Filter (optional; Up to four)', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<div style="display: block; float: left; width: 250px;">
										<input type="checkbox" name="epn_conditions[]" value="New" id="epn_conditions_New" <?=(in_array('New', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_New"><?php _e('New (or the equivalent)', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="1000" id="epn_conditions_1000" <?=(in_array('1000', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_1000"><?php _e('New', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="1500" id="epn_conditions_1500" <?=(in_array('1500', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_1500"><?php _e('New other ("see details")', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="1750" id="epn_conditions_1750" <?=(in_array('1750', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_1750"><?php _e('New with defects', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="Used" id="epn_conditions_Used" <?=(in_array('Used', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_Used"><?php _e('Display', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="2000" id="epn_conditions_2000" <?=(in_array('2000', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_2000"><?php _e('Manufacturer refurbished', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="2500" id="epn_conditions_2500" <?=(in_array('2500', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_2500"><?php _e('Seller refurbished', $advads171_plugin_slug); ?></label><br />
									</div>
									<div style="display: block; float: left; width: 250px;">
										<input type="checkbox" name="epn_conditions[]" value="3000" id="epn_conditions_3000" <?=(in_array('3000', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_3000"><?php _e('Used', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="4000" id="epn_conditions_4000" <?=(in_array('4000', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_4000"><?php _e('Very Good', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="5000" id="epn_conditions_5000" <?=(in_array('5000', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_5000"><?php _e('Good', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="6000" id="epn_conditions_6000" <?=(in_array('6000', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_6000"><?php _e('Acceptable', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="7000" id="epn_conditions_7000" <?=(in_array('7000', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_7000"><?php _e('For parts or not working', $advads171_plugin_slug); ?></label><br />
										<input type="checkbox" name="epn_conditions[]" value="Unspecified" id="epn_conditions_Unspecified" <?=(in_array('Unspecified', $epn_conditions)?'checked':'');?> style="width: 15px;" class="epn_condition_checkbox" /> <label for="epn_conditions_Unspecified"><?php _e('Unspecified', $advads171_plugin_slug); ?></label><br />
									</div>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="epn_cache_seconds"><?php _e('Cache Results', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="epn_cache_seconds" id="epn_cache_seconds">
											<option value="0" <?=($epn_cache_seconds === FALSE || $epn_cache_seconds == '0'?'selected':'');?>><?php _e('Never', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="900" <?=($epn_cache_seconds == '900'?'selected':'');?>><?php _e('15 mins', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="1800" <?=($epn_cache_seconds == '1800'?'selected':'');?>><?php _e('30 mins', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="2700" <?=($epn_cache_seconds == '2700'?'selected':'');?>><?php _e('45 mins', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="3600" <?=($epn_cache_seconds == '3600'?'selected':'');?>><?php _e('1 hour', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="7200" <?=($epn_cache_seconds == '7200'?'selected':'');?>><?php _e('2 hours', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="10800" <?=($epn_cache_seconds == '10800'?'selected':'');?>><?php _e('3 hours', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="14400" <?=($epn_cache_seconds == '14400'?'selected':'');?>><?php _e('4 hours', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="18000" <?=($epn_cache_seconds == '18000'?'selected':'');?>><?php _e('5 hours', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="21600" <?=($epn_cache_seconds == '21600'?'selected':'');?>><?php _e('6 hours', $advads171_plugin_slug); ?> &nbsp;</option>
									</select>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="epn_pops_share"><?php _e('ePN Views Share', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="epn_pops_share" id="epn_pops_share">
										<?php
										$i = 100;
										while($i > -1):
										?>
											<option value="<?=$i;?>" <?=($epn_pops_share == $i?'selected':'');?>><?=$i;?>% &nbsp;</option>
										<?php 
										$i = $i - 10;
										endwhile;?>	
									</select>
									<span class="description"><?php _e('Percentage of banner views to use ePN on (i.e. if 60% - banners will serve 60% ePN and 40% Amazon products)', $advads171_plugin_slug); ?></span>
								</td></tr>
								
						</table>
					</div>
				</div>
			
			</div>
			
			<table class="form-table" style="width:auto;">	
				<tr><td style="width: 150px;">&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $advads171_plugin_slug); ?>" class="button-primary" /></td></tr>
			</table>
			
			</td></tr>
		</table>

		</form>
		
		<script type="text/javascript" type="javascript">
		jQuery(document).ready(function() {
		
			//set initial state.
			//jQuery('.epn_condition_checkbox').val(jQuery(this).is(':checked'));
			
			jQuery('.epn_condition_checkbox').change(function() {
				//jQuery('#textbox1').val(jQuery(this).is(':checked'));
				//alert('clicked');
				var epn_condition_checkboxes = jQuery('input[type=checkbox].epn_condition_checkbox');

               // alert(epn_condition_checkboxes.filter(':checked').length); // works
				
				if (epn_condition_checkboxes.filter(':checked').length > 4)
				{
					alert('<?php esc_attr_e('You can only select up to four condition filters', $advads171_plugin_slug);?>');
					jQuery(this).attr('checked', false);
				}
				return false;
			});

			<?php /*jQuery('#checkbox1').mousedown(function() {
				if (!jQuery(this).is(':checked')) {
					this.checked = confirm("Are you sure?");
					jQuery(this).trigger("change");
				}
			});*/ ?>
		});
		</script>
		
		<?php advads171_epn_country_cats_javascript(); ?>
	
	<?php endif; ?>	
	<?php
	echo '</div>';
}

function advads171_epn_countries()
{
	$countries = array(
						'1' => 'us',
						'2' => 'ie',
						'3' => 'at',
						'4' => 'au',
						'5' => 'be',
						'7' => 'ca',
						'10' => 'fr',
						'11' => 'de',
						'12' => 'it',
						'13' => 'es',
						'14' => 'ch',
						'15' => 'uk',
						'16' => 'nl'
						);
	return $countries;
}

function advads171_epn_cats_select($country = 'us', $level = 1, $parent_id = 0, $selected = 0)
{
	global $advads171_plugin_slug, $advads171_plugin_name;
	$html = '';
	if ($level == 1)
	{
		advads171_include_epn_category($country, 0);
		@include(dirname(__FILE__).'/categories/'.$country.'/0.php');
		//$html .= '<div id="epn_'.$country.'_category_'.$level.'_wrap">';
		$html .= '<select name="epn_category['.$country.']['.$level.']" style="width: 250px;"';
		if ($level != 4)
		{
			$html .= ' onchange="advads171_epn_load_cats_selector(\''.$country.'\', \''.($level + 1).'\', this.value);"';
		}
		$html .= '>';
		$html .= '<option value="0">-- '.__('All Categories', $advads171_plugin_slug).' --</option>';
		foreach($advads171_epn_level_one_cats as $curr_cat)
		{
			$html .= '<option value="'.$curr_cat['id'].'" '.($curr_cat['id'] == $selected?'selected':'').'>';
			if (!in_array($country, array('us', 'ca', 'uk', 'au', 'ie')) && isset($curr_cat['english']) && $curr_cat['english'] !== NULL)
			{
				$html .= $curr_cat['english'].' ('.$curr_cat['name'].')';
			}
			else
			{
				$html .= $curr_cat['name'];
			}
			$html .= '</option>';
		}
		$html .= '</select>';
		//$html .= '</div>';
	}
	else
	{
		//$html .= '<div id="epn_'.$country.'_category_'.$level.'_wrap">';
		if ($parent_id != 0)
		{
		
			advads171_include_epn_category($country, $parent_id);
			@include(dirname(__FILE__).'/categories/'.$country.'/'.$parent_id.'.php');
			
			if (isset($advads171_epn_level_two_cats))
			{
				$advads171_epn_level_cats = $advads171_epn_level_two_cats[$parent_id];
			}
			elseif (isset($advads171_epn_level_three_cats))
			{
				$advads171_epn_level_cats = $advads171_epn_level_three_cats[$parent_id];
			}
			elseif (isset($advads171_epn_level_four_cats))
			{
				$advads171_epn_level_cats = $advads171_epn_level_four_cats[$parent_id];
			}
			
			if (isset($advads171_epn_level_cats) && is_array($advads171_epn_level_cats) && count($advads171_epn_level_cats) > 0)
			{			
				$html .= '<select name="epn_category['.$country.']['.$level.']" style="width: 250px;"';
				if ($level != 4)
				{
					$html .= ' onchange="advads171_epn_load_cats_selector(\''.$country.'\', \''.($level + 1).'\', this.value);"';
				}
				$html .= '>';
				$html .= '<option value="0">-- '.__('All Subcategories', $advads171_plugin_slug).' --</option>';
				
				
				
				foreach($advads171_epn_level_cats as $curr_cat)
				{
					$html .= '<option value="'.$curr_cat['id'].'" '.($curr_cat['id'] == $selected?'selected':'').'>';
					if (!in_array($country, array('us', 'ca', 'uk', 'au', 'ie')) && isset($curr_cat['english']) && $curr_cat['english'] !== NULL)
					{
						$html .= $curr_cat['english'].' ('.$curr_cat['name'].')';
					}
					else
					{
						$html .= $curr_cat['name'];
					}
					$html .= '</option>';
				}
				$html .= '</select>';
			}
		}
		
		//$html .= '</div>';
	}
	
	return $html;
}

function advads171_epn_country_cats_javascript() {
global $advads171_plugin_slug, $advads171_plugin_name;
advads171_add_json_support();
?>
<script type="text/javascript" >
function advads171_epn_load_cats_selector(country, level, parent_id)
{
	var data = {
		action: 'advads171_epn_get_cats',
		country: country,
		level: level,
		parent_id: parent_id
	};

	if (level == 2)
	{
		if (parent_id == 0)
		{
			jQuery('#epn_' + country + '_category_2_wrap').html('');
		}
		else
		{
			jQuery('#epn_' + country + '_category_2_wrap').html('<?php esc_attr_e('Loading Subcategories...', $advads171_plugin_slug); ?>');
		}
		jQuery('#epn_' + country + '_category_3_wrap').html('');
		jQuery('#epn_' + country + '_category_4_wrap').html('');
	}
	if (level == 3)
	{
		if (parent_id == 0)
		{
			jQuery('#epn_' + country + '_category_3_wrap').html('');
		}
		else
		{
			jQuery('#epn_' + country + '_category_3_wrap').html('<?php esc_attr_e('Loading Subcategories...', $advads171_plugin_slug); ?>');
		}
		jQuery('#epn_' + country + '_category_4_wrap').html('');
	}
	if (level == 4)
	{
		if (parent_id == 0)
		{
			jQuery('#epn_' + country + '_category_4_wrap').html('');
		}
		else
		{
			jQuery('#epn_' + country + '_category_4_wrap').html('<?php esc_attr_e('Checking if there are any subcategories...', $advads171_plugin_slug); ?>');
		}
	}
	
	if (parent_id != 0)
	{
		jQuery.post(ajaxurl, data, function(response) {
			//alert('Got this from the server: ' + response);
			if (response != '')
			{
				//var obj = jQuery.parseJSON(response);
				jQuery('#epn_' + country + '_category_' + level + '_wrap').html('');
				var obj = JSON.parse(response);
				if (obj.html != undefined)
				{
					jQuery('#epn_' + country + '_category_' + level + '_wrap').html(obj.html);
				}
				
			}
		});
	}
}
</script>
<?php
}

add_action('wp_ajax_advads171_epn_get_cats', 'advads171_epn_get_cats');

function advads171_epn_get_cats() {
	global $wpdb, $_POST, $advads171_current_plugin_version;

	$country = $_POST['country'];
	$level = $_POST['level'];
	$parent_id = $_POST['parent_id'];
	
	if (is_numeric($parent_id) && is_numeric($level) && in_array($country, advads171_epn_countries()))
	{
		//get children categories
		$html = advads171_epn_cats_select($country, $level, $parent_id);
		echo json_encode(array('html' => $html));
	}

	die(); // this is required to return a proper result
}

function advads171_include_epn_category($country = 'us', $parent_id = 0)
{
	if (!file_exists(dirname(__FILE__).'/categories/'.$country.'/'.$parent_id.'.php'))
	{
		//download categories
		$args = new stdClass;
		$args->epn_cat_id = $parent_id;
		$args->country = $country;
		$request_string = advads171_prepare_request('get_epn_cats', $args);

		//$request = wp_remote_post('http://216.172.160.106/advads/get_epn_categories/get', $request_string);
		$request = wp_remote_post('http://216.172.160.106/caller/get_epn_categories/get', $request_string);
		
		/*echo '<pre>';
		print_r($request);
		echo '</pre>';*/
		
		if (is_wp_error($request)) {
			//$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
			return FALSE;
		} else {
			$res = unserialize($request['body']);
			
			if ($res === false)
				//$res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);
				return FALSE;
			
			if (isset($res['epn_var_name']))
			{
				$res['epn_var_name'] = str_replace('exittr_', 'advads171_', $res['epn_var_name']);
			}
			if (isset($res['epn_cats']) && isset($res['epn_var_name']) && in_array($res['epn_var_name'], array('advads171_epn_level_one_cats', 'advads171_epn_level_two_cats', 'advads171_epn_level_three_cats', 'advads171_epn_level_four_cats')) && isset($res['epn_parent_cat_id']) && is_numeric($res['epn_parent_cat_id']))
			{
				
					$fp = fopen(dirname(__FILE__).'/categories/'.$country.'/'.$res['epn_parent_cat_id'].'.php', 'w');
					if ($fp !== FALSE)
					{
						if ($res['epn_var_name'] == 'advads171_epn_level_one_cats')
						{
							fwrite($fp, "<?\n\$".$res['epn_var_name']. " = ");
						}
						else
						{
							fwrite($fp, "<?\n\$".$res['epn_var_name']."[".$res['epn_parent_cat_id']."] = ");
						}
						fwrite($fp, var_export($res['epn_cats'] , TRUE));
						fwrite($fp, ";\n");
						fclose($fp);
					}
			}
		}

	}	
}


function advads171_epn_get_locale()
{
	$country = 'smthelse';
	//echo dirname(dirname(dirname(__FILE__)))."/include/geoip.inc";exit;
	include_once(dirname(dirname(dirname(__FILE__)))."/include/geoip.inc");
	$custom_geoip_path = advads171_get_option('advads171_path_to_geoip_dat');
	if ($custom_geoip_path !== FALSE && file_exists($custom_geoip_path))
	{
		$gi = geoip_open($custom_geoip_path, GEOIP_MEMORY_CACHE);
	}
	else
	{
		$gi = geoip_open(dirname(dirname(dirname(__FILE__))).'/include/GeoIP.dat', GEOIP_MEMORY_CACHE);
	}
	$user_country = geoip_country_code_by_addr($gi, $_SERVER['REMOTE_ADDR']);
	//$user_country = geoip_country_code_by_addr($gi, '84.31.255.254'); //testing
	
	if ($_SERVER['REMOTE_ADDR'] == '127.0.0.1')
	{
		$user_country = 'local_computer_127.0.0.1';
	}
	//$user_country = 'us';	//testing
	$user_country = strtolower($user_country);
	if ($user_country == 'gb')
	{
		$user_country = 'uk';
	}	
	
	if (in_array($user_country, array('us', 'ie', 'at', 'au', 'be', 'ca', 'fr', 'de', 'it', 'es', 'ch', 'uk', 'nl', 'gb')))
	{
		
		$country = advads171_epn_closest_locale($user_country);		
	}
	else
	{
		$country = advads171_epn_closest_locale($country);
	}
	//$country = 'nl';
	/*echo 'country'.$country.':'.$user_country;
	exit;*/
	geoip_close($gi);
	return $country;
}

function advads171_epn_closest_locale($locale = 'us')
{
	//testing
	//return $locale;
	
	$epn_country_enabled = advads171_get_option('epn_country_enabled_'.$locale);

	if (!in_array($locale, array('us', 'ie', 'at', 'au', 'be', 'ca', 'fr', 'de', 'it', 'es', 'ch', 'uk', 'nl')) || (is_numeric($epn_country_enabled) && $epn_country_enabled == '0'))
	{
		$default_country = advads171_get_option('advads171_unsupported_country_default');
		//echo 'default_country:'.$default_country;exit;
		if ($default_country === FALSE || $default_country == 'none')
		{			
			return 'smthelse';
		}
		else
		{
			return $default_country;
		}
	}
	return $locale;
}

function advads171_epn_preview_results($params, $item_page = 1, $locale = 'us')
{
	return advads171_epn_search('ipod', $params, 1, $locale = 'us');
}

function advads171_epn_get_pop_data($post_id = 0, $kws, $epn_params, $locale = 'us')
{
	global $wpdb, $advads171_preview;
	//locale map
	$locale_map = advads171_epn_locale_map();

	//check if we have cache data
	if ($advads171_preview === FALSE)
	{
		$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."advads171_cache WHERE post_id = '".$wpdb->escape($post_id)."' AND `kws` = '".$wpdb->escape(implode(',', $kws))."' AND locale = '".$locale_map[$locale]."' AND source = '1' LIMIT 1");
	}
	
	if ($advads171_preview === FALSE && $res !== NULL)
	{
		$data = unserialize(str_replace("\'", "'", $res->content));
		if (count($data) > 0)
		{
			return $data;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return advads171_epn_update_cache($post_id, $kws, $epn_params, $locale);
	}	
}

function advads171_epn_locale_map()
{
	$map = array(
				'us' => 1,
				'ie' => 2,
				'at' => 3,
				'au' => 4,
				'be' => 5,
				'ca' => 7,
				'fr' => 10,
				'de' => 11,
				'it' => 12,
				'es' => 13,
				'ch' => 14,
				'uk' => 15,
				'nl' => 16
				);
	return $map;
}

function advads171_epn_update_cache($post_id, $kws, $epn_params, $locale = 'us')
{
	global $wpdb, $advads171_preview;
	$advads171_data = array();
	$advads171_keep_going = true;
	$i = 0;

	//try kws untill we get smth
	while($advads171_keep_going == true && $i < 5)
	{
		if (isset($kws[$i]))
		{
			$advads171_data_req = advads171_epn_search($kws[$i], $epn_params, 1, $locale);
			$advads171_data = array_merge($advads171_data, $advads171_data_req);
			if (count($advads171_data) > 2)
			{
				$advads171_keep_going = false;
			}
		}

		$i++;
	}
	
	//get earliest expiring listing to determine expire date
	$advads171_expires = 0;
	foreach($advads171_data as $advads171_data_curr)
	{
		$expires_check = strtotime($advads171_data_curr['ListingEndTime']);
		if ($advads171_expires == 0 || $expires_check < $advads171_expires)
		{
			$advads171_expires = $expires_check;
		}
	}
	
	//locale map
	$locale_map = advads171_epn_locale_map();
	
	if ($advads171_preview === FALSE)
	{
		//delete old cache
		$delete_sql = "DELETE FROM `".$wpdb->prefix."advads171_cache` WHERE post_id = '".$wpdb->escape($post_id)."' AND locale = '".$locale_map[$locale]."' AND source = 1 LIMIT 1";
		$wpdb->query($delete_sql);
		
		//insert new cache
		if (count($advads171_data) > 0)
		{
			$insert_sql = "INSERT INTO `".$wpdb->prefix."advads171_cache` SET `post_id` = '".$wpdb->escape($post_id)."', `source` = '1', `locale` = '".$locale_map[$locale]."', `content` = '".str_replace("'", "\'", serialize($advads171_data))."', `kws` = '".$wpdb->escape(implode(',', $kws))."', `expires` = '".$advads171_expires."', `timestamp` = '".time()."'";
			$wpdb->query($insert_sql);
		}
	}
	
	return $advads171_data;
}

function advads171_epn_search($search_kw = '', $params, $item_page = 1, $locale = 'us')
{
	$results_found = FALSE;
	$found_count = 0;
	$locale_map = advads171_epn_locale_map();
	
	//$locale = 'be';

	//$time_start = microtime(true);
	
	//echo '<br />KW: '.$search_kw.'<br />';

	if (stripos($search_kw, 'asin:') === FALSE)
	{
		$url = 'http://rest.ebay.com/epn/v1/find/item.rss?keyword='.urlencode($search_kw).
				(isset($params['category_id']) && $params['category_id'] !='0' && $params['category_id'] !=''? '&categoryId1='.$params['category_id']:'') . 
				($params['epn_min_price'] !='0' && $params['epn_min_price'] !='' && $params['epn_min_price'] !== FALSE ? '&minPrice='.$params['epn_min_price']:'') . 
				($params['epn_max_price'] !='0' && $params['epn_max_price'] !='' && $params['epn_max_price'] !== FALSE ? '&maxPrice='.$params['epn_max_price']:'') . 
				($params['epn_campaign_id'] !== FALSE && $params['epn_campaign_id'] != '' ? '&campaignid='.$params['epn_campaign_id']:'') . 
				($params['epn_custom_id'] !== FALSE && $params['epn_custom_id'] != '' ? '&customid='.$params['epn_custom_id']:'') . 
				($params['epn_sort_order'] !== FALSE ? '&sortOrder='.$params['epn_sort_order']:'&sortOrder=BestMatch') . 
				($params['epn_listing_type'] !== FALSE ? ($params['epn_listing_type'] == 'BIN'?'&listingType1=AuctionWithBIN&listingType2=FixedPrice':'&listingType1='.$params['epn_listing_type']):'&listingType1=All') . 
				($params['epn_free_shipping'] !== FALSE && $params['epn_free_shipping'] == '1'? '&freeShipping=true':'') . 
				($locale == 'us'? '&currency=USD':'') . 
				($locale == 'au'? '&currency=AUD':'') . 
				($locale == 'ca'? '&currency=CAD':'') . 
				($locale == 'ch'? '&currency=CHF':'') . 
				($locale == 'uk'? '&currency=GBP':'') . 
				($params['epn_min_bids'] !== FALSE && is_numeric($params['epn_min_bids'])? '&minBids='.$params['epn_min_bids']:'') . 
				($params['epn_max_bids'] !== FALSE && is_numeric($params['epn_max_bids'])? '&maxBids='.$params['epn_max_bids']:'') . 
				($params['epn_conditions'] !== FALSE && strlen($params['epn_conditions']) > 0? '&'.$params['epn_conditions']:'') . 
				($params['epn_feedback_score_min'] !== FALSE && is_numeric($params['epn_feedback_score_min'])? '&feedbackScoreMin='.$params['epn_feedback_score_min']:'') . 
				($params['epn_feedback_score_max'] !== FALSE && is_numeric($params['epn_feedback_score_max'])? '&feedbackScoreMax='.$params['epn_feedback_score_max']:'') . 
				(in_array($locale, array('de', 'at', 'be', 'fr', 'it', 'nl', 'es', 'ie'))? '&currency=EUR':'') . 
				'&toolid=10039&programid='.$locale_map[$locale].'&entriesPerPage=5&hideDuplicateItems=true&lgeo=1&descriptionSearch=true&feedType=rss';

		$epn_items = array();
		
		$xml = simplexml_load_file($url, null, LIBXML_NOCDATA);
		
		/*echo 'url: '.$url.' <br />'; exit;
		echo '<pre>';
		print_r($url);
		echo '<br />';
		print_r($params);
		print_r($xml);
		echo '</pre>';
		exit('here');*/

		

		if (@count($xml->channel->item) > 0)
		{
			foreach ($xml->channel->item as $item) 
			{
				if (strlen(strval($item->guid)) > 0)
				{
				$e = $item->children('http://www.ebay.com/marketplace/search/v1/services');  

				$matches = array();
				preg_match_all('/<img [^>]*src=["|\']([^"|\']+)/i', strval($item->description), $matches);
				$img_src = '';
				if (isset($matches[1]) && isset($matches[1][0]))
				{
					$img_src = $matches[1][0];
				}		
			  
				$epn_items[strval($item->guid)] = array(
								'guid' => strval($item->guid),
								'name' => strval($item->title),
								'url' => strval($item->link),
								'description' => strval($item->description),
								'image' => strval($img_src),
								'price' => strval($e->CurrentPrice),
								'BidCount' => strval($e->BidCount),
								'ListingType' => strval($e->ListingType),
								'BuyItNowPrice' => strval($e->BuyItNowPrice),
								'ListingEndTime' => strval($e->ListingEndTime),
								'ListOrder' => strval($e->ListOrder),
								'PaymentMethod' => strval($e->PaymentMethod),
								);
				}
				
			}
		}
		
		/*echo '<pre>';
		print_r($epn_items);
		echo '</pre>';
		exit;*/
		
		if (count($epn_items) > 0)
		{
			$found_count = $found_count + count($epn_items);
			if ($found_count >= 5)
			{
				$results_found = TRUE;
			}
		}	

		//$time_end = microtime(true);
		//$time = $time_end - $time_start;
		//echo ' in '.$time.' seconds';

		if ($results_found === TRUE || $found_count > 0)
		{
			/*$skip_noimage = get_option('advads171_skip_noimage');
			$results = array();
			$saved_urls = array();
			foreach($amazon_items as $item_set)
			{
				foreach($item_set->Item as $item)
				{
					if ($skip_noimage != 1 || ($skip_noimage == 1 && isset($item->MediumImage->URL) && strlen(strval($item->MediumImage->URL)) > 1))
					{
						$results[strval($item->ASIN)] = array(
								'image' => strval($item->MediumImage->URL),
								'img_width' => intval($item->MediumImage->Width),
								'img_height' => intval($item->MediumImage->Height),							
								'large_image' => strval($item->LargeImage->URL),
								'large_image_width' => strval($item->LargeImage->Width),
								'large_image_height' => strval($item->LargeImage->Height),
								'url' => strval($item->DetailPageURL),
								'name' => strval($item->ItemAttributes->Title),
								'asin' => strval($item->ASIN)
								);
						if (isset($item->OfferSummary->LowestNewPrice))
						{
							$results[strval($item->ASIN)]['price'] = strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
							//do we have a list price?
							if(isset($item->ItemAttributes->ListPrice) && ($item->ItemAttributes->ListPrice->Amount > $item->OfferSummary->LowestNewPrice->Amount || strval($item->OfferSummary->LowestNewPrice->FormattedPrice) == 'Too low to display'))
							{
								$results[strval($item->ASIN)]['list_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
							}
						}
						elseif(isset($item->ItemAttributes->ListPrice))
						{
							$results[strval($item->ASIN)]['price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
						}
						//save description
						if (isset($item->EditorialReviews->EditorialReview->Source) && strval($item->EditorialReviews->EditorialReview->Source) == 'Product Description')
						{
							$results[strval($item->ASIN)]['description'] = strval($item->EditorialReviews->EditorialReview->Content);
						}
						$saved_urls['am_'.strval($item->ASIN)] = strval($item->DetailPageURL);
					}
				}
			}*/
			$results = $epn_items;
			
			/*echo '<pre>';
			print_r($results);
			echo '</pre>';*/
			//exit;

			return $results;
		}
		else
		{
			return array();
		}
	}
}

function advads171_format_price($amount = '0', $advads171_locale = 'us')
{
	if($advads171_locale == 'us')
	{
		return '$'.number_format($amount, 2, '.', ',');
	}
	if($advads171_locale == 'ca')
	{
		return 'C $'.number_format($amount, 2, '.', ',');
	}
	if($advads171_locale == 'ch')
	{
		return 'CHF'.number_format($amount, 2, ',', ' ');
	}
	if(in_array($advads171_locale, array('at', 'be', 'fr', 'de', 'it', 'nl', 'es', 'ie')))
	{
		return number_format($amount, 2, ',', ' ').' EUR';
	}
	if($advads171_locale == 'uk')
	{
		return '&pound; '.number_format($amount, 2, '.', ',');
	}
}

function advads171_epn_localize_text($word = 'Bids', $locale = 'us', $other = '')
{
	if ($word == 'Buy Now')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'Buy Now';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Sofort-Kaufen';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Achat immédiat';
		}
		elseif ($locale == 'it')
		{
			return 'Compralo Subito';
		}
		elseif ($locale == 'nl')
		{
			return 'Nu kopen';
		}
		elseif ($locale == 'es')
		{
			return '¡Cómpralo ya!';
		}		
	}
	elseif ($word == 'Bids')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'Bids';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Gebote';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Enchères';
		}
		elseif ($locale == 'it')
		{
			return 'Offerte';
		}
		elseif ($locale == 'nl')
		{
			return 'Biedingen';
		}
		elseif ($locale == 'es')
		{
			return 'Pujas';
		}		
	}
	elseif ($word == 'Ends')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'Ends';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Angebotsende';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Date de fin';
		}
		elseif ($locale == 'it')
		{
			return 'Finisce';
		}
		elseif ($locale == 'nl')
		{
			return 'Eindigt';
		}
		elseif ($locale == 'es')
		{
			return 'Termina';
		}		
	}
	elseif ($word == 'Bid Now')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'Bid Now';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Jetzt bieten';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Soumissionner maintenant';
		}
		elseif ($locale == 'it')
		{
			return 'Un\'offerta ora';
		}
		elseif ($locale == 'nl')
		{
			return 'Bied nu';
		}
		elseif ($locale == 'es')
		{
			return 'Oferta ahora';
		}		
	}
	elseif ($word == 'Details')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'Details';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Einzelheiten';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Détails';
		}
		elseif ($locale == 'it')
		{
			return 'Dettagli';
		}
		elseif ($locale == 'nl')
		{
			return 'Meer informatie';
		}
		elseif ($locale == 'es')
		{
			return 'Detalles';
		}		
	}
	elseif ($word == 'See Price')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'See Price';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Siehe Preis';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Voir Prix';
		}
		elseif ($locale == 'it')
		{
			return 'Prezzo';
		}
		elseif ($locale == 'nl')
		{
			return 'Zie Prijs';
		}
		elseif ($locale == 'es')
		{
			return 'Leer Más';
		}		
	}
	elseif ($word == 'Buy It Now For Just')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'Buy It Now For Just';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Sofort-Kaufen für nur';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Achat immédiat pour seulement';
		}
		elseif ($locale == 'it')
		{
			return 'Compralo Subito Per solo';
		}
		elseif ($locale == 'nl')
		{
			return 'Nu kopen voor slechts';
		}
		elseif ($locale == 'es')
		{
			return 'Cómpralo ahora por sólo';
		}		
	}
	elseif ($word == 'Price: ')
	{
		if ($locale == 'us' || $locale == 'ca' || $locale == 'uk' || $locale == 'ie' || $locale == 'au')
		{
			return 'Price: ';
		}
		elseif ($locale == 'ch' || $locale == 'at' || $locale == 'de')
		{
			return 'Preis: ';
		}
		elseif ($locale == 'be' || $locale == 'fr')
		{
			return 'Prix: ';
		}
		elseif ($locale == 'it')
		{
			return 'Prezzo: ';
		}
		elseif ($locale == 'nl')
		{
			return 'Prijs: ';
		}
		elseif ($locale == 'es')
		{
			return 'Precio: ';
		}		
	}
}