<?php
/**
Plugin Name: ContextAzon
Plugin URI: http://contextazon.com
Description: <strong>Contextual Amazon Banners</strong>
Author: Igor
Version: 1.2
Author URI: http://contextazon.com
*/

/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

ContextAzon License
http://contextazon.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using ContextAzon you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the ContextAzon software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the ContextAzon software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use ContextAzon on any domain not wholly owned by you. 
b. You may not distribute copies of the ContextAzon software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the ContextAzon software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on ContextAzon's website and the ContextAzon software are provided "as is". ContextAzon makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ContextAzon does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on ContextAzon's web site could include technical, typographical, or photographic errors. ContextAzon does not warrant that any of the materials on its web site are accurate, complete, or current. ContextAzon may make changes to the materials contained on its web site at any time without notice. ContextAzon does not, however, make any commitment to update the materials. 

6. Links 

ContextAzon has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ContextAzon of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

ContextAzon may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to ContextAzon's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

@set_include_path(get_include_path().';.:'.dirname(dirname(dirname(dirname(__FILE__)))));

$advads171_plugin_name = 'ContextAzon';
$advads171_plugin_slug = basename(dirname(__FILE__));

require_once(dirname(__FILE__).'/include/wpbfuncs.php');
require_once(dirname(__FILE__).'/include/admin_include.php');
require_once(dirname(__FILE__).'/add_ons.php');
define('advads171_MENU_PAGE', 'advads171-config');
$advads171_unique_banner_id = 0;

//pick up serp keywords
advads171_pickup_serp_kws();

if ( !function_exists( 'get_plugins' ) )
		require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
$advads171_current_plugin_version = advads171_current_version();

/* Runs when plugin is activated */
register_activation_hook(__FILE__,'advads171_install'); 

/* Runs on plugin deactivation*/
register_deactivation_hook( __FILE__, 'advads171_remove' );

$am_indexes = array('All', 'Apparel', 'Appliances', 'ArtsAndCrafts', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'Classical', 'DigitalMusic', 'DVD', 'Electronics', 'GourmetFood', 'Grocery', 'HealthPersonalCare', 'HomeGarden', 'Industrial', 'Jewelry', 'KindleStore', 'Kitchen', 'Magazines', 'Miscellaneous', 'MobileApps', 'MP3Downloads', 'Music', 'MusicalInstruments', 'MusicTracks', 'OfficeProducts', 'OutdoorLiving', 'PCHardware', 'PetSupplies', 'Photo', 'Shoes', 'Software', 'SportingGoods', 'Tools', 'Toys', 'UnboxVideo', 'VHS', 'Video', 'VideoGames', 'Watches', 'Wireless', 'WirelessAccessories');
$advads171_active = get_option('advads171_active');

if ($advads171_active == 1)
{
	$advads_post = $post;
	add_action('wp_enqueue_scripts', 'advads171_scripts');
	add_action('wp_footer', 'advads171_footer');	
}


add_action('init', 'advads171_localize');
function advads171_localize()
{
	load_plugin_textdomain(dirname(plugin_basename(__FILE__)), false, dirname(plugin_basename(__FILE__)) . '/lang/');
}

add_action( 'admin_print_styles', 'advads171_add_advads171_stylesheet' );
function advads171_add_advads171_stylesheet() {
	global $advads171_plugin_slug;
	wp_enqueue_script($advads171_plugin_slug.'_json', $advads171_json_js_url, array(), '1.0', true);
			
	wp_enqueue_script('jquery');
	
	wp_enqueue_style('jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.1/themes/smoothness/jquery-ui.css');
	wp_enqueue_script('jquery-ui-core');
	wp_enqueue_script('jquery-ui-datepicker', plugins_url( $advads171_plugin_slug.'/js/jquery.ui.datepicker.min.js' , dirname(__FILE__) ), array('jquery', 'jquery-ui-core'));
	wp_register_style( $advads171_plugin_slug, plugins_url( $advads171_plugin_slug.'/style.css' , dirname(__FILE__) ) );
	wp_enqueue_style( $advads171_plugin_slug );
	
	wp_enqueue_script($advads171_plugin_slug.'_raphael', plugins_url( $advads171_plugin_slug.'/js/raphael-min.js' , dirname(__FILE__) ), array('jquery'), '1.0', true);	
	wp_enqueue_script($advads171_plugin_slug.'_graphix', plugins_url( $advads171_plugin_slug.'/js/graphix.0.9.js' , dirname(__FILE__) ), array('jquery'), '1.0', true);
	
	//enqueue tiptip
	wp_enqueue_script('jquery-tiptip-advads', plugins_url( $advads171_plugin_slug.'/js/jquery.tipTip.js' , dirname(__FILE__) ), array('jquery', 'jquery-ui-core'));
	wp_register_style( $advads171_plugin_slug.'_tiptip_css', plugins_url( $advads171_plugin_slug.'/css/tipTip.css' , dirname(__FILE__) ) );
	wp_enqueue_style( $advads171_plugin_slug.'_tiptip_css' );
	
	if (isset($_GET['page']) && $_GET['page'] == 'advads171-visitor-log')
	{
		//enqueue datepicker
		wp_enqueue_script('jquery-datepicker-advads', plugins_url( $advads171_plugin_slug.'/js/datepicker.js' , dirname(__FILE__) ), array('jquery', 'jquery-ui-core'));
		wp_register_style( $advads171_plugin_slug.'_datepicker_base_css', plugins_url( $advads171_plugin_slug.'/css/datepicker/base.css' , dirname(__FILE__) ) );
		wp_enqueue_style( $advads171_plugin_slug.'_datepicker_base_css' );
		wp_register_style( $advads171_plugin_slug.'_datepicker_clean_css', plugins_url( $advads171_plugin_slug.'/css/datepicker/clean.css' , dirname(__FILE__) ) );
		wp_enqueue_style( $advads171_plugin_slug.'_datepicker_clean_css' );
	}
	
}

function advads171_scripts()
{
	global $post, $advads_post, $advads171_addons, $advads171_plugin_slug;
	$advads171_is_virtual = FALSE;
	if (isset($_GET['s']) && strlen($_GET['s']) > 0)
	{
		$advads171_is_virtual = TRUE;
	}
	if (((is_page() || is_single() || (!is_page() && !is_single())) && (isset($post) && is_numeric($post->ID))) || $advads171_is_virtual)
	{
		
		$advads171_post_id = 0;
		if (isset($post) && isset($post->ID))
		{
			$advads171_post_id = $post->ID;
		}
		//filter when to show pops		
			$advads_post = $post;
			if (advads171_init_check($post) === true || $advads171_is_virtual):
			
				
				$advads171_http_url = plugins_url( $advads171_plugin_slug.'' , dirname(__FILE__) );				
				if (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' && substr($advads171_http_url, 0, 11) != 'http://www.' && substr($advads171_http_url, 0, 12) != 'https://www.')
				{
					if (substr($advads171_http_url, 0, 7) == 'http://') $advads171_http_url = str_replace('http://', 'http://www.', $advads171_http_url);
					if (substr($advads171_http_url, 0, 8) == 'https://') $advads171_http_url = str_replace('https://', 'https://www.', $advads171_http_url);
				}
				elseif (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) != 'www.' && (substr($advads171_http_url, 0, 11) == 'http://www.' || substr($advads171_http_url, 0, 12) == 'https://www.'))
				{
					if (substr($advads171_http_url, 0, 7) == 'http://') $advads171_http_url = str_replace('http://', 'http://www.', $advads171_http_url);
					if (substr($advads171_http_url, 0, 8) == 'https://') $advads171_http_url = str_replace('https://', 'https://www.', $advads171_http_url);
				}
				//add json support for jquery older than 1.4.1
				wp_enqueue_script($advads171_plugin_slug.'_json', $advads171_http_url.'/js/json2_min.js', array(), '1.0', true);
			
				wp_enqueue_script('jquery');
				wp_enqueue_style( $advads171_plugin_slug, plugins_url( $advads171_plugin_slug.'/style.css' , dirname(__FILE__) ), false, '1.1');
				
				$userAgent = strtolower($_SERVER['HTTP_USER_AGENT']);
					if (preg_match('/msie/', $userAgent))
					{
						wp_enqueue_style( $advads171_plugin_slug.'_css_ie', plugins_url( $advads171_plugin_slug.'/style_ie.css' , dirname(__FILE__) ), false, '1.1');
					}
				
				//fix calls from www. to non-www etc			

				wp_enqueue_script($advads171_plugin_slug.'_easing', $advads171_http_url.'/js/jquery.easing.1.3.js', array('jquery'), '1.0', true);				
				wp_enqueue_script($advads171_plugin_slug.'_transform', $advads171_http_url.'/js/jquery.transform-0.8.0.min.js', array('jquery'), '1.0', true);				
				wp_enqueue_script($advads171_plugin_slug.'_banner', $advads171_http_url.'/js/jquery.banner.js', array('jquery'), '1.0', true);
				
				wp_enqueue_script($advads171_plugin_slug.'_banner_loader', $advads171_http_url.'/banner_loader.php', array('jquery'), '1.0', true);

				wp_enqueue_style( $advads171_plugin_slug.'_banners', plugins_url( $advads171_plugin_slug.'/css/style.css' , dirname(__FILE__) ), false, '1.1');	

				$advads_get_params = array(
				  'advads171_is_virtual' => 'no'
				  
				);
				if ($advads171_is_virtual)
				{
					$advads_get_params['advads171_is_virtual'] = 'yes';
					$advads_get_params['s'] = urlencode(strip_tags($_GET['s']));
					//come up with unique id
					list($advads171_custom_post_id, ) = explode('E', round(hexdec(md5($advads_get_params['s']))/1000000000000000000000000));
					$advads171_custom_post_id = str_replace('.', '', $advads171_custom_post_id);
					$advads171_custom_post_id = abs($advads171_custom_post_id);
					$advads_get_params['post_id'] = '99999'.substr($advads171_custom_post_id, 0, 5);
					
				}
				wp_localize_script( $advads171_plugin_slug.'_banner_loader', 'advads_params', $advads_get_params );
				
			endif;
	}
}
function advads171_footer() {
	global $post, $advads171_plugin_slug;
	$advads171_is_virtual = FALSE;
	if (isset($_GET['s']) && strlen($_GET['s']) > 0)
	{
		$advads171_is_virtual = TRUE;
	}
	/*if (((is_page() || is_single() || (!is_page() && !is_single())) && (isset($post) && is_numeric($post->ID)) && advads171_init_check($post)) || $advads171_is_virtual)
	{
		?>
		<div id="advads171_am_trigger" style="display: block;">
			<img src="<?=site_url('wp-content/plugins/'.$advads171_plugin_slug.'/blank.gif');?>">
		</div>
		<div id="am_popbox" style="display: none;">
			<div id="am_interior">
				<?php _e('Thank you for visiting our site.', $advads171_plugin_slug); ?>
				<br /><a href="javascript:void(0);" class="close"><?php _e('Close', $advads171_plugin_slug); ?></a>			
			</div>		
		</div>
		<div id="advads171_audio_player"></div>
		<?php
	}*/	
}

function advads171_init_check($post = '')
{
	if ($post != '')
	{
		//filter when to show pops
		$advads171_active = get_option('advads171_active');
		//$advads171_serponly = get_option('advads171_serponly');
		//$advads171_loggedin_hide = get_option('advads171_loggedin_hide');
		//$advads171_posttypes_str = get_option('advads171_posttypes');
		//$advads171_posttypes = explode(',', $advads171_posttypes_str);
		//$advads171_pops_per_user = get_option('advads171_pops_per_user');
		$advads171_default_behavior = get_option('advads171_default_behavior');
		//$advads171_unbounce_enabled = get_option('advads171_unbounce_enabled');
		//$advads171_unbounce_delay = get_option('advads171_unbounce_delay');
		//$advads171_active_tpls = advads171_active_tpls();
			
		if ( $advads171_active == 1 && 
			advads171_get_option('license') != false //&& 
			//($advads171_serponly == false || ($advads171_serponly == 1 && advads171_is_serp_direct())) && 				 //show to users arrived from serp only?
			//($advads171_loggedin_hide == false || ($advads171_loggedin_hide == 1 && !is_user_logged_in()) || current_user_can( 'manage_options' )) && //don't show to logged in users? doesn't affect admin
			//(((is_page() || is_single()) && in_array($post->post_type, $advads171_posttypes)) || (!is_page() && !is_single() && in_array('category_pages', $advads171_posttypes))) && 											 //filter by post type
			//($advads171_pops_per_user == false || (($advads171_pops_per_user > 0 && (!isset($_COOKIE['advads171_total_pops']) || (isset($_COOKIE['advads171_total_pops']) && $_COOKIE['advads171_total_pops'] < $advads171_pops_per_user))) || current_user_can( 'manage_options' ))) && //limit pops per user, no affect on admin
			//count($advads171_active_tpls) > 0				//hide if no active template found
			):
			
			//now check if this belongs on this particular post
			//$meta_enable = get_post_meta($post->ID, 'advads171_enable', true);
			//$meta_disable = get_post_meta($post->ID, 'advads171_disable', true);
			
			//if (($advads171_default_behavior == 'all' && $meta_disable != 'on') || ($advads171_default_behavior == 'manual' && $meta_enable == 'on')):
				//pick up serp keywords
				//advads171_pickup_serp_kws();
				return true;
			//endif;
		endif;		
	}
	return false;
}

if ( advads171_license_type() === FALSE && is_admin()&& !(isset($_GET['page']) && $_GET['page'] == 'advads171-license')) {
	function advads171_warning() {
		global $advads171_plugin_name, $advads171_plugin_slug;
		echo "
		<div id='advads171-warning' class='updated fade'><p><strong>"
		.sprintf(__('The %s plugin is not active yet.', $advads171_plugin_slug), $swzon361_plugin_name)."</strong> "
		.sprintf(
			__('You\'ll need to <a href="%1$s">Activate %2$s license</a> for it to work.', $advads171_plugin_slug)
			, "admin.php?page=advads171-license", $advads171_plugin_name)
		."</p></div>
		";
	}
	add_action('admin_notices', 'advads171_warning');
	//return;
}

function advads171_install()
{
    global $wpdb;
	
	//add plugin options
	advads171_add_options();
	
	if (is_multisite())
	{
		advads171_multisite_setup_tbl();
	}
}

function advads171_add_options()
{
	global $wpdb;
    // plugin options
    add_option("advads171_active", '1', '', 'yes');
    add_option("advads171_activated", '', '', 'yes');
	add_option("advads171_am_key_id", '', '', 'yes');
    add_option("advads171_am_access_key", '', '', 'yes');
    add_option("advads171_am_associate_tag", '', '', 'yes');
    add_option("advads171_am_searchindex", '', '', 'yes');
    add_option("advads171_skip_noimage", '1', '', 'yes');
    //add_option("advads171_serponly", '0', '', 'yes');    
    add_option("advads171_loggedin_hide", '1', '', 'yes');
	add_option("advads171_sensitivity", '10', '', 'yes');
    add_option("advads171_posttypes", 'post,page,front_page', '', 'yes');
    add_option("advads171_pops_per_user", '10000', '', 'yes');
    add_option("advads171_default_behavior", 'all', '', 'yes');
    //add_option("advads171_message", 'Wait! Check Out These Products.', '', 'yes');
    //add_option("advads171_message_fontsize", '24', '', 'yes');
    //add_option("advads171_message_color", '#FF0000', '', 'yes');
    //add_option("advads171_pop_width", '700', '', 'yes');
    //add_option("advads171_pop_height", '400', '', 'yes');
    //add_option("advads171_border_width", '5', '', 'yes');
    //add_option("advads171_border_type", 'dashed', '', 'yes');
    //add_option("advads171_border_color", '#FF0000', '', 'yes');
    //add_option("advads171_branding", 'yes', '', 'yes');
    add_option("advads171_unbounce_enabled", '1', '', 'yes');
    add_option("advads171_unbounce_delay", '10', '', 'yes');

}

$advads171_current_version_from_db = get_option('advads171_version');
if ($advads171_current_version_from_db === FALSE || version_compare($advads171_current_version_from_db, $advads171_current_plugin_version, '<'))
{	
	/*if ($advads_curr_db_version < 2 && advads171_get_option('license') != false)
	{
		//upgrade db version
		$wpdb->query("DROP TABLE `".$wpdb->prefix."advads171_cache`");
		$wpdb->query("CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."advads171_cache` (
		  `cid` int(11) NOT NULL AUTO_INCREMENT,
		  `locale` int(1) NOT NULL DEFAULT '1' COMMENT '1 - us, 2 - uk, 3 - de, 4 - jp, 5 -fr, 6 - ca, 7 - it, 8 - cn, 9 -es',
		  `post_id` int(11) NOT NULL,
		  `content` text NOT NULL,
		  `timestamp` int(15) NOT NULL,
		  PRIMARY KEY (`cid`),
		  KEY `advads171_postid_index` (`post_id`),
		  KEY `advads171_timestamp_index` (`timestamp`)
		) DEFAULT CHARACTER SET ".$wpdb->charset." AUTO_INCREMENT=1 ;");
	}*/
	
	
	
	$current_advads171_kw_sources = advads171_get_option('advads171_kw_sources');
	if ($current_advads171_kw_sources === FALSE)
	{
		advads171_add_option('advads171_kw_sources', 'serp,content,title,fallback');
	}

	add_action('init', 'advads171_upgrade_db_etc');	
}

add_action('admin_init', 'advads171_upgrade_plugin');

function advads171_upgrade_plugin()
{
	global $advads171_current_plugin_version, $advads171_current_version_from_db, $wpdb;
	//if upgrade or first time run do these:
	$advads_curr_db_version = get_option('advads171_db_version');
	
	if ($advads_curr_db_version === FALSE || $advads_curr_db_version < 4)
	{
		$curr_post_types_active = get_option("advads171_posttypes");
		update_option("advads171_posttypes", implode(',', array_unique(array_merge(explode(',', $curr_post_types_active), array('front_page')))));	//added front_page in version 1.2
	}
	
	update_option("advads171_version", '1.2', '', 'yes');
	update_option("advads171_db_version", '4', '', 'yes');	
}

function advads171_upgrade_db_etc()
{
	global $advads171_current_plugin_version, $advads171_current_version_from_db;
	if (is_multisite())
	{
		advads171_multisite_setup_tbl();
	}
	
	//add `source`, `keyword` and `expires` to advads171_cache
	if (version_compare($advads171_current_version_from_db, '1.5.3', '<'))
	{
		//advads171_alter_tbls_v_1_5_3();
	}
	
	//update_option('advads171_version', $advads171_current_plugin_version);
	advads171_update_option('advads171_promo_msg', '', is_multisite());
	advads171_update_option('advads171_promo_msg_last_check', '0', is_multisite());
}

function advads171_remove() {

    /*delete_option("advads171_active");
    delete_option("advads171_serponly");
	delete_option("advads171_am_key_id");
	delete_option("advads171_am_access_key");
	delete_option("advads171_am_associate_tag");
	delete_option("advads171_am_searchindex");
	delete_option("advads171_am_time");
	delete_option("advads171_sequence");
	delete_option("advads171_posttypes");
	delete_option("advads171_loggedin_hide");*/
	
	
}


function advads171_init() {
	if ( current_user_can('administrator') ) {
		add_action('admin_menu', 'advads171_config_page');
	}
}
add_action('init', 'advads171_init');
//add_action('admin_menu', 'advads171_config_page');

//include farbtastic js and css
add_action('init', 'advads171_ilc_farbtastic_script');
function advads171_ilc_farbtastic_script() {
  wp_enqueue_style( 'farbtastic' );
  wp_enqueue_script( 'farbtastic' );
}

function advads171_config_page() {
	global $advads171_addons, $advads171_plugin_name, $advads171_plugin_slug;
	 add_menu_page($advads171_plugin_name, $advads171_plugin_name, 8, 'advads171-config', 'advads171_conf', plugin_dir_url( __FILE__ ).'/images/ico_contextazon2.png');
	 add_submenu_page('advads171-config', __('Settings', $advads171_plugin_slug), __('Settings', $advads171_plugin_slug), 8, 'advads171-config', 'advads171_conf');
	 add_submenu_page('advads171-config', __('Banners', $advads171_plugin_slug), __('Banners', $advads171_plugin_slug), 8, 'advads171-ad_units', 'advads171_ad_units');
	 add_submenu_page('advads171-config', __('Stats', $advads171_plugin_slug), __('Stats', $advads171_plugin_slug), 8, 'advads171-stats', 'advads171_stats');
	 add_submenu_page('advads171-config', __('Visitor Log', $advads171_plugin_slug), __('Visitor Log', $advads171_plugin_slug), 8, 'advads171-visitor-log', 'advads171_visitor_log');
	
	 add_submenu_page('advads171-config', __('License', $advads171_plugin_slug), __('License', $advads171_plugin_slug), 8, 'advads171-license', 'advads171_license');
	 add_submenu_page('advads171-config', __('Clear Cache', $advads171_plugin_slug), __('Clear Cache', $advads171_plugin_slug), 8, 'advads171-clearcache', 'advads171_clearcache');
	 
	if (advads171_get_option('license') == 'premium')
	{
		add_submenu_page('advads171-config', __('Get More Plugins', $advads171_plugin_slug), __('Get More Plugins', $advads171_plugin_slug), 8, 'advads171-more-plugins', 'advads171_more_plugins');
		add_submenu_page('advads171-config', __('Upgrade', $advads171_plugin_slug), __('<span style="color: red; font-weight: bold;">Upgrade</span>', $advads171_plugin_slug), 8, 'advads171-addons', 'advads171_addons');
	}
	elseif (advads171_is_plus() === FALSE)
	{
		add_submenu_page('advads171-config', __('Get More Plugins', $advads171_plugin_slug), __('Get More Plugins', $advads171_plugin_slug), 8, 'advads171-more-plugins', 'advads171_more_plugins');
		add_submenu_page('advads171-config', __('Upgrade', $advads171_plugin_slug), __('<span style="color: red; font-weight: bold;">Upgrade to Plus+</span>', $advads171_plugin_slug), 8, 'advads171-addons', 'advads171_addons');
	}
	else
	{
		add_submenu_page('advads171-config', __('Get More Plugins', $advads171_plugin_slug), __('<span style="color: red; font-weight: bold;">Get More Plugins</span>', $advads171_plugin_slug), 8, 'advads171-more-plugins', 'advads171_more_plugins');
	}
	add_submenu_page('advads171-config', __('Support', $advads171_plugin_slug), __('Support', $advads171_plugin_slug), 8, 'advads171-help', 'advads171_help');
}

//add add-ons
if (is_array($advads171_addons) && count($advads171_addons) > 0)
{
	foreach($advads171_addons as $advads171_addon)
	{
		include_once(dirname(__FILE__).'/modules/'.$advads171_addon.'/functions.php');
		if (function_exists('advads171_'.$advads171_addon.'_init'))
		{
			add_action('init', 'advads171_'.$advads171_addon.'_init');
		}
	}
}

function advads171_clearcache()
{
	global $wpdb, $advads171_plugin_name, $advads171_plugin_slug;
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $advads171_plugin_slug));
	
	if (isset($_POST['advads171_clear_cache']) && $_POST['advads171_clear_cache'] == 'yes')
	{
		advads171_clear_cache();
		if (isset($_POST['clear_keywords']) && $_POST['clear_keywords'] == '1')
		{
			advads171_delete_keywords();
		}
	}
	?>
	<div class="wrap">
		<img src="<?php echo plugin_dir_url( __FILE__ ); ?>images/<?php echo advads171_branding_img(); ?>" style="display: block; float: right;" />
		<h2>Clear Cache</h2>
		<?php echo sprintf(__('%s caches data returned from Amazon API for up to one hour to boost performance.<br />When you change settings like adding new locale associate tag it is advised to clear cache.', $advads171_plugin_slug), $advads171_plugin_name); ?>
		<p></p>
		<?php if (isset($_POST['advads171_clear_cache']) && $_POST['advads171_clear_cache'] == 'yes'): ?>
		<div class="updated">
			<h3><?php echo sprintf(__('%s Cache Cleared', $advads171_plugin_slug), $advads171_plugin_name); ?></h3>
		</div>
		<?php endif; ?>
		
		<form action="" method="post">
			<input type="checkbox" name="clear_keywords" value="1" id="delete_keywords" /><label style="margin-left: 10px;" for="delete_keywords"><?php _e('Delete keywords', $advads171_plugin_slug); ?> (<?php _e('optional', $advads171_plugin_slug); ?>)</label>
			<div class="submit"><input type="submit" value="<?php echo sprintf(__("Clear %s Cache", $advads171_plugin_slug), $advads171_plugin_name); ?>" /></div>
			<input type="hidden" name="advads171_clear_cache" value="yes" />
		</form>
	</div>
	<?php
}

function advads171_help()
{
	global $wpdb, $advads171_plugin_name, $advads171_plugin_slug;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $advads171_plugin_slug));
	?>
	<div class="wrap">
		<h2><?php _e("Help and Support", $advads171_plugin_slug); ?></h2>
		<p><?php echo sprintf(__("Having trouble with %s?", $advads171_plugin_slug), $advads171_plugin_name); ?></p>		
		<p>I feel your pain. It sucks when plugins break. However...</p>
		<p style="font-size: 16px;">You're in luck! Creator of <?php echo $advads171_plugin_name; ?> provides excellent support!</p>

		<p>Please keep in mind:
			<ol>
				<li>In 99% of the cases if there's an issue with <?php echo $advads171_plugin_name; ?> it is caused by an issue with another plugin or a theme.</li>
				<li>Your question may be already answered on the <a href="http://contextazon.com/faq/" target="_blank">FAQ page</a> ==&gt; <a href="http://contextazon.com/faq/" target="_blank">Click Here to go to FAQ page</a></li>
				<li>Check out <a href="http://contextazon.com/videos/" target="_blank">Video Tutorials</a>! You can learn a lot of advanced techniques from these tutorials  ==&gt;  <a href="http://contextazon.com/videos/" target="_blank">Click Here to Watch Video Tutorials</a> </li>
			</ol>
		</p>

		<p>Still need help?</p>
		<p><a href="http://contextazon.com/support/" target="_blank">Click Here to Contact Me</a> and I'll get back to you as soon as possible.</p>
		
	</div>

	<?php
}

if (isset($_GET['page']) && $_GET['page'] == 'advads171-addons')
{
	add_action('admin_head', 'advads171_addons_check_javascript');
}

function advads171_addons()
{
	global $wpdb, $advads171_plugin_name, $advads171_plugin_slug;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $advads171_plugin_slug));
	
	$curr_email = advads171_get_option('license_email');
	
	?>
	<div class="wrap">
		<h2><?php sprintf(__("%s Add-ons", $advads171_plugin_slug), $advads171_plugin_name); ?></h2>
		<p><?php sprintf(__("%s is growing fast! New functionality and new ways to earn money are added all the time!", $advads171_plugin_slug), $advads171_plugin_name); ?></p>
		
		<div id="advads171_addons_receiving_wrap" class="advads171_loading">&nbsp;</div>

	</div>
	<style>
	.advads171_loading {
	width: 128px; 
	height: 15px; 
	margin: 250px auto; 
	display: block;
	background: url(<?=site_url('wp-content/plugins/'.$advads171_plugin_slug.'/images/ajax-loader_bar.gif');?>) no-repeat center center;
	}
	</style>
	<?php
}

function advads171_license()
{
	global $wpdb, $advads171_plugin_name, $advads171_plugin_slug;
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $advads171_plugin_slug));
	
	$user = wp_get_current_user();
	$email = $user->user_email;
	$curr_email = advads171_get_option('license_email');
	if ($curr_email != false)
	{
		$email = $curr_email;
	}
	$name = $user->user_nicename;
	$error = '';
	if ( isset($_POST['btnsubmit']) ) 
	{
		$emailRE = '/^[a-zA-Z0-9_\-\.]+@[a-zA-Z0-9_\-]+\.[a-zA-Z0-9_\-\.]+$/i';
		if (isset($_POST['name']))  $name  = trim(strip_tags(($_POST['name'])));
		if (isset($_POST['email'])) $email = trim(strip_tags(($_POST['email'])));
		if ('' == $name)  $error .= '<div>'.__("Please enter your Name", $advads171_plugin_slug).'</div>';
		if ('' == $email) $error .= '<div>'.__("Please enter your Email", $advads171_plugin_slug).'</div>';
		if ( ! preg_match($emailRE, $email) ) $error .= '<div>'.__("Please enter correct Email address", $advads171_plugin_slug).'</div>';
		if ('' == $error) {
			//send license request
			$call_data = array(
								'email' => $email,
								'name' => $name,
								'site' => get_bloginfo('url')
								);
			$response = advads171_call($call_data, 'http://216.172.160.106/advads/activate/site');
			
			//update db
			if (isset($response->sql) && strlen(trim($response->sql)) > 0)
			{
				$sql_str = str_replace('##TBLPREFIX##', $wpdb->prefix, $response->sql);
				$charset_collate = '';
				if (strlen($wpdb->charset) > 0)	$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
				$sql_str = str_replace('##TBLCHARSET##', $charset_collate, $sql_str);
				
				foreach(explode("##BREAK##", $sql_str) as $curr_sql)
				{					
					$wpdb->query($curr_sql);
				}
			}
			//advads171_add_options();
			echo '<div class="updated">';
			
			echo '<strong>'.ucfirst($response->response).'</strong><br />';
			echo '<strong>'.ucfirst($response->message).'</strong><br />';
			
			echo '</div>';
			
		}
	}
	
	$licensed_email = advads171_get_option('license_email');
	$licensed_name = advads171_get_option('license_name');
	$licensed_license = advads171_get_option('license');
	if ($licensed_name != false) $name = $licensed_name;

	echo '<div class="wrap"><h2>' . sprintf(__('%s License', $advads171_plugin_slug), $advads171_plugin_name) . '</h2>';
	?>
	<div class="advads_license_wrap">
		<h3><?php echo sprintf(__('%s License', $advads171_plugin_slug), $advads171_plugin_name);?></h3>
		<div style="color: red;"><?=$error;?></div>
		<?php if ($licensed_email != false && $licensed_license != false): ?>
		<?php
		$license_real_name = 'Single Domain';
		if ($licensed_license == 'premium_unlimited' && advads171_module_installed('amzn_cart') && advads171_module_installed('epn') && advads171_module_installed('amasticky_banner'))
		{
			$license_real_name = 'Multi-Site Plus+';
		}
		elseif ($licensed_license == 'premium_unlimited')
		{
			$license_real_name = 'Multi-Site';
		}
		?>
		<div style="font-weight: bold;"><?php echo sprintf(__('You are using %s under %s license.', $advads171_plugin_slug), $advads171_plugin_name, $license_real_name);?>
		</div>
		<?php endif; ?>
		<form method="post" action="admin.php?page=advads171-license" onsubmit="return checkLicenseForm(this);">
			<table class="form-table" style="width: 750px;">
			<tr class="form-field"><th style="width:120px;"><label for="ar_name" style="font-weight: bold;"><?php _e('Your Name', $advads171_plugin_slug); ?>:</label></th>
				<td><input type="text" name="name" value="<?=$name;?>" id="ar_name" size="25" style="width:220px;" /></td></tr>
			<tr class="form-field"><th style="width:120px;"><label for="ar_email" style="font-weight: bold;"><?php _e('Email', $advads171_plugin_slug); ?>:</label></th>
				<td><input type="text" name="email" value="<?=$email;?>" id="ar_email" size="25" style="width:220px;" /> &lt;&lt; <strong><?php _e('Email used to purchase license or Paypal Email', $advads171_plugin_slug); ?></strong></td></tr>
			<tr class="form-field"><th style="width:120px;">&nbsp;</th>
				<td style="line-height: 14px;"><input type="checkbox" id="advads171_agree_to_license" name="advads171_agree_to_license" style="float: left; width: 15px; margin-right: 10px;" /> <label for="advads171_agree_to_license" ><?php echo sprintf(__('I agree to %s License Agreement %s', $advads171_plugin_slug), '<a href="http://contextazon.com/license-agreement/" target="_blank">', '</a>'); ?></label> </td></tr>
			<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Activate', $advads171_plugin_slug); ?>" class="button-primary" /></td></tr>
			</table>
		</form>
		<br /><br />		
		- <?php echo sprintf(__('If you used paypal enter the exact Paypal email you have used to purchase your copy of %s.', $advads171_plugin_slug), $advads171_plugin_name); ?><br />
		- <?php _e('If you used clickbank then use the email you entered on the order form.', $advads171_plugin_slug); ?><br />
		- <?php _e('Please note that some Paypal accounts can have several emails associated with them. If this is the case for you try all emails!', $advads171_plugin_slug); ?><br />
		- <?php echo sprintf(__('Do not tell other people your Paypal email or purchase email in order to use it with %s because it will get your license suspended!', $advads171_plugin_slug), $advads171_plugin_name); ?><br />
		- <?php _e('You will need to be able to access the email to get plugin updates or support.', $advads171_plugin_slug); ?><br />
		- <?php _e('If you need to buy more licenses or upgrade for use on more sites', $advads171_plugin_slug); ?> <a href="http://contextazon.com/upgrade-license/?plugin=<?php echo $advads171_plugin_slug; ?>" target="_blank"><?php _e('click here', $advads171_plugin_slug); ?></a><br /><br />
	</div>
	<div style="font-weight: bold; margin-top: 30px;">
	<?php if ($advads171_plugin_slug == 'advancedbannerads'): ?>
		<?php _e('Follow Us on Twitter', $advads171_plugin_slug); ?> <a href="http://twitter.com/advancedbannerads" target="_blank">@advancedbannerads</a> <?php _e('and check us out on Facebook', $advads171_plugin_slug); ?>: <a href="http://facebook.com/AdvancedBannerAds" target="_blank">http://facebook.com/AdvancedBannerAds</a>
	<?php endif; ?>
	</div>
	
	<style>
	.advads_license_wrap {
	margin: 5px 0 15px;
	background-color: #FFFFE0;
    border-color: #E6DB55;
	padding: 0 0.6em;
	border-radius: 3px 3px 3px 3px;
    border-style: solid;
    border-width: 1px;
	}
	.advads_license_wrap a {text-decoration: none;}
	</style>
	
	<script type="text/javascript">
	<!--//
	function checkLicenseForm(theForm) {
		var error = '';
		if (theForm) {
			if (theForm['name']  && '' == theForm['name'].value)  error = '<?php esc_attr_e('Please enter your Name', $advads171_plugin_slug); ?>';
			if (theForm['email'] && '' == theForm['email'].value) error = '<?php esc_attr_e('Please enter your Email', $advads171_plugin_slug); ?>';
			if (jQuery('#advads171_agree_to_license').is(':checked'))
			{
			
			}
			else
			{
				error = '<?php esc_attr_e('Please agree to License Agreement', $advads171_plugin_slug); ?>';
			}
		}
		if ('' != error) {
			alert (error);
			return false;
		}
		return true;
	}
	//-->
	</script>
	<?php
	echo '</div>';
}

function advads171_license_type()
{
	global $wpdb;
	$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."advads171_options WHERE name = 'license' AND value != '' LIMIT 1");
	if ($res === NULL )
	{
		return TRUE;
	}
	else
	{
		return $res->value;
	}
}

function advads171_conf() {
	global $am_indexes, $blog_id, $wpdb, $advads171_addons, $advads171_plugin_name, $advads171_plugin_slug;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $advads171_plugin_slug));
	
	if (advads171_license_type() === FALSE)
	{
		advads171_license();
		return;
	}
	
	wp_enqueue_style( $advads171_plugin_slug, plugins_url( $advads171_plugin_slug.'/style.css' , dirname(__FILE__) ), false, '1.1');
	
	//which tab?
	$tab = 'important_stuff';
	if (isset($_GET['tab']) && (in_array($_GET['tab'], array('important_stuff', 'amazon', 'advanced')) || (defined('MULTISITE') && (MULTISITE === TRUE || MULTISITE == 1) && advads171_get_option('license') == 'premium_unlimited' && $_GET['tab'] == 'wpms')))
	{
		$tab = $_GET['tab'];
	}
	
	//get available post types
	$post_types = get_post_types(array('public' => true));
	if (isset($post_types['attachment'])) unset($post_types['attachment']); 
	if (isset($post_types['video'])) unset($post_types['video']); 
	if (isset($post_types['slideshow'])) unset($post_types['slideshow']);
	if (!isset($post_types['front_page'])) $post_types['front_page'] = 'front_page'; 

	$error = '';
	if ( isset($_POST['btnsubmit']) || (isset($_POST['advads171_form_submitted']) && $_POST['advads171_form_submitted'] == 'yes') ) 
	{
		//BOF Validation
		
		if ($tab == 'important_stuff')
		{
			if (isset($_POST['advads171_amzn_active']))  $advads171_amzn_active = trim(strip_tags(($_POST['advads171_amzn_active'])));
			
			if (isset($_POST['am_key_id']))  $am_key_id  = trim(strip_tags(($_POST['am_key_id'])));
			if (isset($_POST['am_access_key'])) $am_access_key = trim(strip_tags(($_POST['am_access_key'])));
			if (isset($_POST['am_associate_tag'])) $am_associate_tag = trim(strip_tags(($_POST['am_associate_tag'])));
			if (isset($_POST['am_associate_locale'])) $am_associate_locale = trim(strip_tags(($_POST['am_associate_locale'])));
			
			if (isset($_POST['am_searchindex'])) $am_searchindex = trim(strip_tags(($_POST['am_searchindex'])));
			
			if (isset($_POST['advads171_active'])) $advads171_active = trim(strip_tags(($_POST['advads171_active'])));
			
			if (isset($_POST['advads171_unsupported_country_default'])) $advads171_unsupported_country_default = trim(strip_tags(($_POST['advads171_unsupported_country_default'])));
			
			if (isset($_POST['epn_enabled'])) $epn_enabled = trim(strip_tags(($_POST['epn_enabled'])));
			if (isset($_POST['epn_campaign_id'])) $epn_campaign_id = trim(strip_tags(($_POST['epn_campaign_id'])));
			if (isset($_POST['epn_custom_id'])) $epn_custom_id = trim(strip_tags(($_POST['epn_custom_id'])));
			
			if ('0' != $advads171_active)	//no validation if user is just disabling plugin
			{
				if ($advads171_amzn_active == '1')
				{
					//Amazon settings
					if ('' == $am_key_id)  $error .= '<div>'.__('Please enter your AWS Access Key ID', $advads171_plugin_slug).'</div>';
					if ('' == $am_access_key)  $error .= '<div>'.__('Please enter your AWS Secret Access Key', $advads171_plugin_slug).'</div>';
					if ('' == $am_associate_tag)  $error .= '<div>'.__('Please enter your Amazon Associate Tag', $advads171_plugin_slug).'</div>';
					
					
					//if ('' == $am_associate_tag && '' == $am_associate_tag_uk && '' == $am_associate_tag_de && '' == $am_associate_tag_jp && '' == $am_associate_tag_fr && '' == $am_associate_tag_ca && '' == $am_associate_tag_it && '' == $am_associate_tag_cn && '' == $am_associate_tag_es )  $error .= '<div>Please enter at least one Amazon Associate Tag</div>';
					
					//AWS credentials check
					if ($error == '')
					{
						$advads171_am_params = array(
									'key_id' => $am_key_id, 
									'access_key' => $am_access_key,
									'associate_tag' => $am_associate_tag
									);
						$am_credentials_check = advads171_am_check_credentials($advads171_am_params);
						if (isset($am_credentials_check->Error) && isset($am_credentials_check->Error->Code) && isset($am_credentials_check->Error->Message))
						{
							$am_error_code = strval($am_credentials_check->Error->Code);
							if ($am_error_code == 'InvalidClientTokenId')
							{
								$error .= '<div>'.__('The AWS Access Key Id you provided is invalid. Please double check and try again. <a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $advads171_plugin_slug).'</div>';
							}
							elseif ($am_error_code == 'SignatureDoesNotMatch')
							{
								$error .= '<div>'.__('The AWS Secret Access Key you provided is invalid. Please double check and try again. <a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $advads171_plugin_slug).'</div>';
							}
							else
							{
								$am_error_msg = strval($am_credentials_check->Error->Message);
								$error .= '<div>'.__('The AWS Credentials you provided are invalid. Please double check and try again. Amazon answered with this', $advads171_plugin_slug).': '.$am_error_msg.'. '.__('<a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $advads171_plugin_slug).'</div>';
							}
						}
					}
				}			
				
				//patch the footer.php
				if (isset($_POST['advads171_hidden_patch_footer']) && $_POST['advads171_hidden_patch_footer'] == 'yes')
				{
					$advads171_file_handle = fopen(get_template_directory().'/footer.php', "a+");
					if ($advads171_file_handle !== FALSE)
					{
						$advads171_footer_content = '';
						$advads171_i = 0;
						while (!feof($advads171_file_handle) && $advads171_i < 5000) {
						  $advads171_footer_content .= fread($advads171_file_handle, 8192);
						  $advads171_i++;
						}						
						
						if ($advads171_footer_content != '' && stripos($advads171_footer_content, 'wp_footer(') === FALSE && stripos($advads171_footer_content, '</body>') !== FALSE)
						{
							//make backup
							@copy(get_template_directory().'/footer.php', get_template_directory().'/BACKUP_BY_ADVANCEDBANNERADS_'.date('Y_m_d').'_of_footer.php');
							ftruncate($advads171_file_handle, 0);
							$advads171_footer_content = str_replace('</body>', '<?php wp_footer(); ?>'."\n".'</body>', $advads171_footer_content);
							fwrite($advads171_file_handle, $advads171_footer_content);
							$advads171_additional_success = __("Your theme footer.php was patched successfully.", $advads171_plugin_slug);
							
						}
					}
					else
					{
						$error .= '<div>'.__('Unable to patch the theme footer.php file. Please <a href="http://contextazon.com/faq/adding-php-wp_footer-tag-to-your-theme-footer-php-file/" target="_blank">check this guide how to fix this issue manually</a>.', $advads171_plugin_slug).'</div>';
					}
					fclose($advads171_file_handle);
					
				}
				//check if the theme footer.php has wp_footer(); tag
				if (file_exists(get_template_directory().'/footer.php'))
				{
					//can read?
					$advads171_file_handle = fopen(get_template_directory().'/footer.php', "r");
					if ($advads171_file_handle !== FALSE)
					{
						$advads171_footer_content = '';
						$advads171_i = 0;
						while (!feof($advads171_file_handle) && $advads171_i < 5000) {
						  $advads171_footer_content .= fread($advads171_file_handle, 8192);
						  $advads171_i++;
						}
						fclose($advads171_file_handle);
						
						if ($advads171_footer_content != '' && stripos($advads171_footer_content, 'wp_footer(') === FALSE)
						{
							if (isset($advads171_additional_success))
							{
								unset($advads171_additional_success);
							}
							$advads171_wpfooter_warning = sprintf(__('Warning! Your theme footer.php is missing this required tag: &lt;?php wp_footer(); ?&gt;. Without this tag %s will not work.', $advads171_plugin_slug), $advads171_plugin_name);
							//can write?
							$advads171_file_handle = fopen(get_template_directory().'/footer.php', "a+");
							if ($advads171_file_handle !== FALSE && stripos($advads171_footer_content, '</body>') !== FALSE)
							{
								$advads171_wpfooter_warning .= ' <a href="javascript: void(0);" onclick="javascript: if (confirm(\''.esc_attr('Are you sure you want to patch your theme footer.php? It is recommended to backup your files first.', $advads171_plugin_slug).'\')) { document.getElementById(\'advads171_hidden_patch_footer\').value = \'yes\'; document.getElementById(\'important_stuff_form\').submit(); };">'.__('Click here to patch your footer.php', $advads171_plugin_slug).'</a>. '.__('It is recommended to back up your files first and disable any firewall plugins you may have installed.', $advads171_plugin_slug).' <a href="'.__('http://contextazon.com/faq/adding-php-wp_footer-tag-to-your-theme-footer-php-file/', $advads171_plugin_slug).'" target="_blank">'.__('More Info', $advads171_plugin_slug).'</a>';
							}
							else
							{
								$advads171_wpfooter_warning .= '<a href="'.__('http://contextazon.com/faq/adding-php-wp_footer-tag-to-your-theme-footer-php-file/', $advads171_plugin_slug).'" target="_blank">'.__('Click here to learn how to fix this issue', $advads171_plugin_slug).'</a>.';
							}
							
						}
					}
				}
				
				
				if ('' == $am_searchindex)  $error .= '<div>'.__('Please enter your Amazon Search Index', $advads171_plugin_slug).'</div>';
			}
		}
		elseif($tab == 'advanced')
		{
			//make submission with enter work
			if (isset($_POST['submit_all']))
			{
				$_POST['save_all_settings'] = 'Save All Settings';
			}
			/*if (isset($_POST['save_general']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['advads171_serponly'])) $advads171_serponly = trim(strip_tags(($_POST['advads171_serponly'])));
				if (isset($_POST['advads171_sensitivity'])) $advads171_sensitivity = trim(strip_tags(($_POST['advads171_sensitivity'])));
				if (isset($_POST['advads171_loggedin_hide'])) $advads171_loggedin_hide = trim(strip_tags(($_POST['advads171_loggedin_hide'])));
				if (isset($_POST['advads171_posttypes'])) $advads171_posttypes = $_POST['advads171_posttypes'];
				if (isset($_POST['advads171_pops_per_user'])) $advads171_pops_per_user = trim(strip_tags(($_POST['advads171_pops_per_user'])));
				if (isset($_POST['advads171_default_behavior'])) $advads171_default_behavior = trim(strip_tags(($_POST['advads171_default_behavior'])));
			}*/
			/*if (isset($_POST['save_triggers']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['advads171_unbounce_enabled'])) $advads171_unbounce_enabled = trim(strip_tags(($_POST['advads171_unbounce_enabled'])));
				if (isset($_POST['advads171_mouse_trigger_disabled'])) $advads171_mouse_trigger_disabled = trim(strip_tags(($_POST['advads171_mouse_trigger_disabled'])));
				if (isset($_POST['advads171_trapped_trigger_enabled'])) $advads171_trapped_trigger_enabled = trim(strip_tags(($_POST['advads171_trapped_trigger_enabled'])));
				if (isset($_POST['advads171_trapped_trigger_msg'])) $advads171_trapped_trigger_msg = trim(strip_tags(($_POST['advads171_trapped_trigger_msg'])));
				$advads171_trapped_trigger_msg = stripslashes($advads171_trapped_trigger_msg);
				if (isset($_POST['advads171_unbounce_delay'])) $advads171_unbounce_delay = trim(strip_tags(($_POST['advads171_unbounce_delay'])));
			}*/

			if (isset($_POST['save_keywords']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['advads171_skip_keywords']))  
				{
					$advads171_skip_keywords  = trim(strip_tags(($_POST['advads171_skip_keywords'])));
					$advads171_skip_keywords = str_replace("\r\n", "\n", $advads171_skip_keywords);
				}
				$advads171_kw_sources = array();
				if (isset($_POST['advads171_kw_sources']))
				{
					$advads171_kw_sources = $_POST['advads171_kw_sources'];
				}
				if (isset($_POST['advads171_fallback_keywords'])) $advads171_fallback_keywords = trim(strip_tags(($_POST['advads171_fallback_keywords'])));
				if (isset($_POST['advads171_min_kw_length'])) $advads171_min_kw_length = trim(strip_tags(($_POST['advads171_min_kw_length'])));
				//category keywords
				$categories = get_categories();
				$advads171_cat_kws = array();
				foreach($categories as $curr_cat)
				{
					if (isset($_POST['advads171_cat_kws_'.$curr_cat->term_id]))
					{
						$advads171_cat_kws[$curr_cat->term_id] = $_POST['advads171_cat_kws_'.$curr_cat->term_id];
					}
					else
					{
						$advads171_cat_kws[$curr_cat->term_id] = '';
					}				
				}

				$advads171_amzn_disabled_categories = array();
				if (isset($_POST['advads171_amzn_cat_toggle']) && is_array($_POST['advads171_amzn_cat_toggle']) && count($categories) > 0 && advads171_module_installed('amzn'))
				{
					foreach($categories as $curr_cat)
					{
						if (!in_array($curr_cat->term_id, $_POST['advads171_amzn_cat_toggle']))
						{
							$advads171_amzn_disabled_categories[] = $curr_cat->term_id;
						}
					}
				}				
				$advads171_epn_disabled_categories = array();
				if (isset($_POST['advads171_epn_cat_toggle']) && is_array($_POST['advads171_epn_cat_toggle']) && count($categories) > 0 && advads171_module_installed('epn'))
				{
					foreach($categories as $curr_cat)
					{
						if (!in_array($curr_cat->term_id, $_POST['advads171_epn_cat_toggle']))
						{
							$advads171_epn_disabled_categories[] = $curr_cat->term_id;
						}
					}
				}
			}
			if (isset($_POST['save_misc']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['advads171_posttypes'])) $advads171_posttypes = $_POST['advads171_posttypes'];
				if (isset($_POST['advads171_show_promo_msgs'])) $advads171_show_promo_msgs = intval(trim(strip_tags(($_POST['advads171_show_promo_msgs']))));
				if (isset($_POST['advads171_path_to_geoip_dat'])) 
				{
					$advads171_path_to_geoip_dat = trim(strip_tags(($_POST['advads171_path_to_geoip_dat'])));
					if (trim($advads171_path_to_geoip_dat) != '' && !file_exists($advads171_path_to_geoip_dat))
					{
						$error .= __('GeoIP.dat file not found at', $advads171_plugin_slug).': '.$advads171_path_to_geoip_dat;
					}
				}
				
				if (isset($_POST['advads171_visitor_log_days'])) $advads171_visitor_log_days = intval(trim(strip_tags(($_POST['advads171_visitor_log_days']))));
				
				//unsupported country
				if (isset($_POST['advads171_unsupported_country_default'])) $advads171_unsupported_country_default = trim(strip_tags(($_POST['advads171_unsupported_country_default'])));
			
			}
			
			//BOF pull existing options on partial submit
			/*if (!isset($_POST['save_general']) && !isset($_POST['save_all_settings']))
			{				
				$advads171_serponly = get_option('advads171_serponly');
				$advads171_sensitivity = get_option('advads171_sensitivity');
				$advads171_loggedin_hide = get_option('advads171_loggedin_hide');
				$advads171_posttypes_str = get_option('advads171_posttypes');
				$advads171_posttypes = explode(',', $advads171_posttypes_str);
				$advads171_pops_per_user = get_option('advads171_pops_per_user');
				$advads171_default_behavior = get_option('advads171_default_behavior');
			}*/
			/*if (!isset($_POST['save_triggers']) && !isset($_POST['save_all_settings']))
			{	
				$advads171_unbounce_enabled = get_option('advads171_unbounce_enabled');
				$advads171_unbounce_delay = get_option('advads171_unbounce_delay');
				$advads171_mouse_trigger_disabled = advads171_get_option('advads171_mouse_trigger_disabled');
				$advads171_trapped_trigger_enabled = advads171_get_option('advads171_trapped_trigger_enabled');
				$advads171_trapped_trigger_msg = advads171_get_option('advads171_trapped_trigger_msg');
				$advads171_trapped_trigger_msg = stripslashes($advads171_trapped_trigger_msg);
			}*/

			if (!isset($_POST['save_keywords']) && !isset($_POST['save_all_settings']))
			{		
				$advads171_skip_keywords = advads171_get_option('advads171_skip_keywords');
				if ($advads171_skip_keywords === FALSE)
				{
					$advads171_skip_keywords_arr = advads171_get_default_skip_keywords();
					$advads171_skip_keywords = implode("\n", $advads171_skip_keywords_arr);
				}
				else
				{
					$advads171_skip_keywords_arr = explode(',', $advads171_skip_keywords);
					$advads171_skip_keywords = str_replace(",", "\n", $advads171_skip_keywords);
				}
				$advads171_skip_keywords = stripslashes($advads171_skip_keywords);
				$advads171_kw_sources = array();
				$advads171_kw_sources_str = advads171_get_option('advads171_kw_sources');
				if (strlen($advads171_kw_sources_str) > 0)
				{
					$advads171_kw_sources = explode(',', $advads171_kw_sources_str);
				}				
				$advads171_fallback_keywords = get_option('advads171_fallback_keywords');
				$advads171_min_kw_length = advads171_get_option('advads171_min_kw_length');
				$categories = get_categories();
				$advads171_cat_kws = array();
				foreach($categories as $curr_cat)
				{
					$cat_kw_check = get_option('advads171_cat_kws_'.$curr_cat->term_id);
					if ($cat_kw_check !== FALSE)
					{
						$advads171_cat_kws[$curr_cat->term_id] = $cat_kw_check;
					}
				}
				
				$advads171_amzn_disabled_categories = array();
				$advads171_amzn_disabled_categories_check = get_option('advads171_amzn_disabled_categories');
				if ($advads171_amzn_disabled_categories_check !== FALSE && advads171_module_installed('amzn'))
				{
					$advads171_amzn_disabled_categories_check_arr = explode(',', $advads171_amzn_disabled_categories_check);
					if (count($advads171_amzn_disabled_categories_check_arr) > 0)
					{
						$advads171_amzn_disabled_categories = $advads171_amzn_disabled_categories_check_arr;
					}
				}
				$advads171_epn_disabled_categories = array();
				$advads171_epn_disabled_categories_check = get_option('advads171_epn_disabled_categories');
				if ($advads171_epn_disabled_categories_check !== FALSE && advads171_module_installed('epn'))
				{
					$advads171_epn_disabled_categories_check_arr = explode(',', $advads171_epn_disabled_categories_check);
					if (count($advads171_epn_disabled_categories_check_arr) > 0)
					{
						$advads171_epn_disabled_categories = $advads171_epn_disabled_categories_check_arr;
					}
				}

				
				
			}
			if (!isset($_POST['save_misc']) && !isset($_POST['save_all_settings']))
			{	
				$advads171_posttypes_str = get_option('advads171_posttypes');
				$advads171_posttypes = explode(',', $advads171_posttypes_str);
				$advads171_show_promo_msgs = advads171_get_option('advads171_show_promo_msgs', is_multisite());
				$advads171_path_to_geoip_dat = advads171_get_option('advads171_path_to_geoip_dat');
				
				$advads171_visitor_log_days = advads171_get_option('advads171_visitor_log_days');
				
				$advads171_unsupported_country_default = advads171_get_option('advads171_unsupported_country_default');
			}
			//EOF pull existing options on partial submit
		}
		elseif($tab == 'amazon')
		{
			if (isset($_POST['am_key_id']))  $am_key_id  = trim(strip_tags(($_POST['am_key_id'])));
			if (isset($_POST['am_access_key'])) $am_access_key = trim(strip_tags(($_POST['am_access_key'])));
			if (isset($_POST['skip_noimage'])) $skip_noimage = trim(strip_tags(($_POST['skip_noimage'])));
			if (isset($_POST['skip_asins'])) $skip_asins = trim(strip_tags(($_POST['skip_asins'])));
			if (isset($_POST['am_associate_tag'])) $am_associate_tag = trim(strip_tags(($_POST['am_associate_tag'])));
			if (isset($_POST['am_associate_tag_uk'])) $am_associate_tag_uk = trim(strip_tags(($_POST['am_associate_tag_uk'])));
			if (isset($_POST['am_associate_tag_de'])) $am_associate_tag_de = trim(strip_tags(($_POST['am_associate_tag_de'])));
			if (isset($_POST['am_associate_tag_jp'])) $am_associate_tag_jp = trim(strip_tags(($_POST['am_associate_tag_jp'])));
			if (isset($_POST['am_associate_tag_fr'])) $am_associate_tag_fr = trim(strip_tags(($_POST['am_associate_tag_fr'])));
			if (isset($_POST['am_associate_tag_ca'])) $am_associate_tag_ca = trim(strip_tags(($_POST['am_associate_tag_ca'])));
			if (isset($_POST['am_associate_tag_it'])) $am_associate_tag_it = trim(strip_tags(($_POST['am_associate_tag_it'])));
			if (isset($_POST['am_associate_tag_cn'])) $am_associate_tag_cn = trim(strip_tags(($_POST['am_associate_tag_cn'])));
			if (isset($_POST['am_associate_tag_es'])) $am_associate_tag_es = trim(strip_tags(($_POST['am_associate_tag_es'])));
			
			if (isset($_POST['am_searchindex'])) $am_searchindex = trim(strip_tags(($_POST['am_searchindex'])));
			
			
			//save all nodes
			if (isset($_POST['amzn_category']))
			{
				$amzn_category = $_POST['amzn_category'];
			}

			
			if ('' == $am_key_id)  $error .= '<div>'.__('Please enter your AWS Access Key ID', $advads171_plugin_slug).'</div>';
			if ('' == $am_access_key)  $error .= '<div>'.__('Please enter your AWS Secret Access Key', $advads171_plugin_slug).'</div>';
			if ('' == $am_associate_tag && '' == $am_associate_tag_uk && '' == $am_associate_tag_de && '' == $am_associate_tag_jp && '' == $am_associate_tag_fr && '' == $am_associate_tag_ca && '' == $am_associate_tag_it && '' == $am_associate_tag_cn && '' == $am_associate_tag_es )  $error .= '<div>'.__('Please enter at least one Amazon Associate Tag', $advads171_plugin_slug).'</div>';
			if ('' == $am_searchindex)  $error .= '<div>'.__('Please enter your Amazon Search Index', $advads171_plugin_slug).'</div>';
			
			if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons))
			{
				if (isset($_POST['advads171_amzn_cart_enabled'])) $advads171_amzn_cart_enabled = trim(strip_tags(($_POST['advads171_amzn_cart_enabled'])));
				if (isset($_POST['advads171_amzn_cart_btn_text_3prods'])) $advads171_amzn_cart_btn_text_3prods = trim(strip_tags(($_POST['advads171_amzn_cart_btn_text_3prods'])));
			
			}
			
			//AWS credentials check
			if ($error == '')
			{
				$advads171_am_params = array(
							'key_id' => $am_key_id, 
							'access_key' => $am_access_key,
							'associate_tag' => $am_associate_tag
							);
				$am_credentials_check = advads171_am_check_credentials($advads171_am_params);
				if (isset($am_credentials_check->Error) && isset($am_credentials_check->Error->Code) && isset($am_credentials_check->Error->Message))
				{
					$am_error_code = strval($am_credentials_check->Error->Code);
					if ($am_error_code == 'InvalidClientTokenId')
					{
						$error .= '<div>'.__('The AWS Access Key Id you provided is invalid. Please double check and try again. <a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $advads171_plugin_slug).'</div>';
					}
					elseif ($am_error_code == 'SignatureDoesNotMatch')
					{
						$error .= '<div>'.__('The AWS Secret Access Key you provided is invalid. Please double check and try again. <a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $advads171_plugin_slug).'</div>';
					}
					else
					{
						$am_error_msg = strval($am_credentials_check->Error->Message);
						$error .= '<div>'.__('The AWS Credentials you provided are invalid. Please double check and try again. Amazon answered with this:', $advads171_plugin_slug).' '.$am_error_msg.'. '.__('<a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $advads171_plugin_slug).'</div>';
					}
				}
			}
		}
		elseif($tab == 'wpms')
		{
			if (isset($_POST['advads171_default_wpms_blog_id'])) $advads171_default_wpms_blog_id = trim(strip_tags(($_POST['advads171_default_wpms_blog_id'])));
			if (isset($_POST['advads171_wpms_apply_to_all'])) $advads171_wpms_apply_to_all = trim(strip_tags(($_POST['advads171_wpms_apply_to_all'])));

		}

		//EOF Validation		
		
		if ('' == $error) {
			if ($tab == 'important_stuff')
			{
		
				if (isset($_POST['advads171_amzn_active'])) {
					advads171_update_option('advads171_amzn_active', $advads171_amzn_active = trim($_POST['advads171_amzn_active']));
				} else {
					advads171_delete_option('advads171_amzn_active');
				}
				
				if (isset($_POST['advads171_unsupported_country_default']) && trim($_POST['advads171_unsupported_country_default']) != '') {
					advads171_update_option('advads171_unsupported_country_default', $advads171_unsupported_country_default = trim($_POST['advads171_unsupported_country_default']));
				} else {
					advads171_delete_option('advads171_unsupported_country_default');
				}
				
				if (isset($_POST['am_key_id']) && trim($_POST['am_key_id'])) {
					update_option('advads171_am_key_id', $am_key_id = trim($_POST['am_key_id']));
				} else {
					delete_option('advads171_am_key_id');
				}
				
				if (isset($_POST['am_access_key']) && trim($_POST['am_access_key'])) {
					update_option('advads171_am_access_key', $am_access_key = trim($_POST['am_access_key']));
				} else {
					delete_option('advads171_am_access_key');
				}
				
				
				if (isset($_POST['am_access_key']) && trim($_POST['am_access_key'])) {
					update_option('advads171_am_associate_locale', $am_associate_locale = trim($_POST['am_associate_locale']));
				} else {
					delete_option('advads171_am_associate_locale');
				}
				
				if ($am_associate_locale == 'us' && isset($_POST['am_associate_tag'])) {
					update_option('advads171_am_associate_tag', $am_associate_tag = trim($_POST['am_associate_tag']));
				}
				
				if ($am_associate_locale == 'uk' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_uk', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'de' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_de', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'jp' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_jp', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'fr' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_fr', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'ca' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_ca', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'it' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_it', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'cn' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_cn', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'es' && isset($_POST['am_associate_tag'])) { update_option('advads171_locale_tag_es', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				
				
				if (isset($_POST['am_searchindex']) && trim($_POST['am_searchindex'])) {
					update_option('advads171_am_searchindex', $am_searchindex = trim($_POST['am_searchindex']));
				} else {
					delete_option('advads171_am_searchindex');
				}
				
				if (isset($_POST['advads171_active']) && trim($_POST['advads171_active'])) {
					update_option('advads171_active', $advads171_active = trim($_POST['advads171_active']));
				} else {
					delete_option('advads171_active');
				}
				
				if (isset($_POST['epn_enabled'])) {
					advads171_update_option('epn_enabled', $epn_enabled = trim($_POST['epn_enabled']));
				} else {
					advads171_delete_option('epn_enabled');
				}
				
				if (isset($_POST['epn_campaign_id']) && trim($_POST['epn_campaign_id'])) {
					advads171_update_option('epn_campaign_id', $epn_campaign_id = trim($_POST['epn_campaign_id']));
				} else {
					advads171_delete_option('epn_campaign_id');
				}
				
				if (isset($_POST['epn_custom_id']) && trim($_POST['epn_custom_id'])) {
					advads171_update_option('epn_custom_id', $epn_custom_id = trim($_POST['epn_custom_id']));
				} else {
					advads171_delete_option('epn_custom_id');
				}
				
				
			}
			elseif ($tab == 'advanced')
			{
				//make submission with enter work
				if (isset($_POST['submit_all']))
				{
					$_POST['save_all_settings'] = 'Save All Settings';
				}

				/*if (isset($_POST['save_general']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['advads171_serponly']) && trim($_POST['advads171_serponly'])) {
						update_option('advads171_serponly', $advads171_serponly = trim($_POST['advads171_serponly']));
					} else {
						delete_option('advads171_serponly');
					}
					
					if (isset($_POST['advads171_sensitivity']) && trim($_POST['advads171_sensitivity'])) {
						update_option('advads171_sensitivity', $advads171_sensitivity = trim($_POST['advads171_sensitivity']));
					} else {
						delete_option('advads171_sensitivity');
					}
					
					if (isset($_POST['advads171_loggedin_hide']) && trim($_POST['advads171_loggedin_hide'])) {
						update_option('advads171_loggedin_hide', $advads171_loggedin_hide = trim($_POST['advads171_loggedin_hide']));
					} else {
						delete_option('advads171_loggedin_hide');
					}
					
					if (isset($_POST['advads171_posttypes']) && is_array($_POST['advads171_posttypes'])) {
						update_option('advads171_posttypes', implode(',', $_POST['advads171_posttypes']));
						$advads171_posttypes = $_POST['advads171_posttypes'];
					} else {
						delete_option('advads171_posttypes');
						$advads171_posttypes = array();
					}
					
					if (isset($_POST['advads171_pops_per_user']) && trim($_POST['advads171_pops_per_user'])) {
						update_option('advads171_pops_per_user', $advads171_pops_per_user = trim($_POST['advads171_pops_per_user']));
					} else {
						delete_option('advads171_pops_per_user');
					}
					
					if (isset($_POST['advads171_default_behavior']) && trim($_POST['advads171_default_behavior'])) {
						update_option('advads171_default_behavior', $advads171_default_behavior = trim($_POST['advads171_default_behavior']));
					} else {
						delete_option('advads171_default_behavior');
					}
				}
				
				if (isset($_POST['save_triggers']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['advads171_unbounce_enabled']) && trim($_POST['advads171_unbounce_enabled'])) {
						update_option('advads171_unbounce_enabled', $advads171_unbounce_enabled = trim($_POST['advads171_unbounce_enabled']));
					} else {
						delete_option('advads171_unbounce_enabled');
					}
					
					if (isset($_POST['advads171_unbounce_delay']) && trim($_POST['advads171_unbounce_delay'])) {
						update_option('advads171_unbounce_delay', $advads171_unbounce_delay = trim($_POST['advads171_unbounce_delay']));
					} else {
						delete_option('advads171_unbounce_delay');
					}
					
					if (isset($_POST['advads171_mouse_trigger_disabled']) && trim($_POST['advads171_mouse_trigger_disabled'])) {
						advads171_update_option('advads171_mouse_trigger_disabled', $advads171_mouse_trigger_disabled = trim($_POST['advads171_mouse_trigger_disabled']));
					} else {
						advads171_delete_option('advads171_mouse_trigger_disabled');
					}
					if (isset($_POST['advads171_trapped_trigger_enabled']) && trim($_POST['advads171_trapped_trigger_enabled'])) {
						advads171_update_option('advads171_trapped_trigger_enabled', $advads171_trapped_trigger_enabled = trim($_POST['advads171_trapped_trigger_enabled']));
					} else {
						advads171_delete_option('advads171_trapped_trigger_enabled');
					}
					if (isset($_POST['advads171_trapped_trigger_msg']) && trim($_POST['advads171_trapped_trigger_msg'])) {
						advads171_update_option('advads171_trapped_trigger_msg', $advads171_trapped_trigger_msg = stripslashes(trim($_POST['advads171_trapped_trigger_msg'])));
					} else {
						advads171_delete_option('advads171_trapped_trigger_msg');
					}
				}*/

				
				if (isset($_POST['save_keywords']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['advads171_skip_keywords']) && trim($_POST['advads171_skip_keywords'])) {
						$advads171_skip_keywords = trim($_POST['advads171_skip_keywords']);
						$advads171_skip_keywords = str_replace("\r\n", "\n", $advads171_skip_keywords);
						$advads171_skip_keywords = str_replace("\n\n", "\n", $advads171_skip_keywords);
						$advads171_skip_keywords = stripslashes($advads171_skip_keywords);
						$advads171_skip_keywords_arr = explode("\n", $advads171_skip_keywords);
						//trim every element
						foreach($advads171_skip_keywords_arr as $key => $val)
						{
							$advads171_skip_keywords_arr[$key] = trim($val);
						}
						$advads171_skip_keywords_arr = array_diff($advads171_skip_keywords_arr, array('/'));
						advads171_update_option('advads171_skip_keywords', implode(',', $advads171_skip_keywords_arr));
						//update all existing keywords
						set_time_limit(300);
						
						$total_kw_posts = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM $wpdb->postmeta WHERE meta_key = 'advads171_keywords' AND meta_value != ''"));

						if ($total_kw_posts !== FALSE && $total_kw_posts > 0)
						{
							$advads171_i = 0;
							while($advads171_i < $total_kw_posts)
							{
								set_time_limit(300);
								$meta_data_row = $wpdb->get_row("SELECT * FROM $wpdb->postmeta WHERE meta_key = 'advads171_keywords' AND meta_value != ''", OBJECT, $advads171_i);
								if ($meta_data_row !== FALSE && isset($meta_data_row->meta_value))
								{									
									$current_kws_arr = explode(",", $meta_data_row->meta_value);
									$new_kws_arr = array();
									$remove_kws = array();
									if (count($current_kws_arr) > 0)
									{	
										$old_kws_str = implode(',', $current_kws_arr);
										//trim
										foreach($current_kws_arr as $key => $val)
										{
											//remove one word keywords if selected
											if (isset($_POST['advads171_min_kw_length']) && $_POST['advads171_min_kw_length'] == 2 && count(explode(' ', trim($val))) == 1)
											{
												unset($current_kws_arr[$key]);
											}
											else
											{
												$current_kws_arr[$key] = trim($val);
											}
										}
										
										$skip_preg_arr = array();										
										foreach($advads171_skip_keywords_arr as $curr_skip_kw)
										{
											//check for exact matches											
											if (preg_match('/^(["\']).*\1$/m', $curr_skip_kw) == 1)
											{
												$str_no_quotes = substr($curr_skip_kw, 1, (strlen($curr_skip_kw) - 2));
												if (in_array($str_no_quotes, $current_kws_arr))
												{
													$remove_kws[] = $str_no_quotes;
												}
											}
											else
											{	
												if (stripos($curr_skip_kw, "*") !== FALSE)
												{
													if (substr($curr_skip_kw, 0, 1) == '*' && substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
													{
														$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
													}
													elseif (substr($curr_skip_kw, 0, 1) == '*')
													{
														$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR)."\b";
													}
													elseif (substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
													{
														$skip_preg_arr[] = "\b".preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
													}
												}
												else
												{
													$skip_preg_arr[] = "\b".preg_quote($curr_skip_kw, DIRECTORY_SEPARATOR)."\b";
												}
											}
										}
										$new_kws_arr = array_diff($current_kws_arr, $remove_kws);
										foreach($new_kws_arr as $key => $val)
										{
											$new_val = preg_replace('/('.implode('|', $skip_preg_arr).')/i', '', $val);
											
											if (strlen($new_val) > 0)
											{
												$new_kws_arr[$key] = $new_val;
											}
											else
											{
												unset($new_kws_arr[$key]);
											}
										}
										
										//remove one word keywords again
										foreach($new_kws_arr as $key => $val)
										{
											//remove one word keywords if selected
											if (isset($_POST['advads171_min_kw_length']) && $_POST['advads171_min_kw_length'] == 2 && count(explode(' ', trim($val))) == 1)
											{
												unset($new_kws_arr[$key]);
											}
										}
										
										$new_kws_str = implode(',', $new_kws_arr);
										if ($new_kws_str != $old_kws_str)
										{
											$wpdb->query("UPDATE $wpdb->postmeta SET meta_value = '".$wpdb->escape($new_kws_str)."' WHERE meta_id = '".$meta_data_row->meta_id."' LIMIT 1");
										}
									}
								}								
								$advads171_i++;
							}
						}
						$wpdb->flush();					
						
					} else {
						advads171_delete_option('advads171_skip_keywords');
					}
					
					if (isset($_POST['advads171_kw_sources']) && is_array($_POST['advads171_kw_sources'])) {
						$advads171_kw_sources = $_POST['advads171_kw_sources'];
						advads171_update_option('advads171_kw_sources', implode(',', $advads171_kw_sources));
						advads171_delete_keywords();
					} else {
						advads171_delete_option('advads171_kw_sources');
					}

						
					if (isset($_POST['advads171_fallback_keywords']) && trim($_POST['advads171_fallback_keywords'])) {
						update_option('advads171_fallback_keywords', $advads171_fallback_keywords = stripslashes(trim($_POST['advads171_fallback_keywords'])));
					} else {
						delete_option('advads171_fallback_keywords');
					}
					if (isset($_POST['advads171_min_kw_length']) && trim($_POST['advads171_min_kw_length'])) {
						advads171_update_option('advads171_min_kw_length', $advads171_min_kw_length = stripslashes(trim($_POST['advads171_min_kw_length'])));
					} else {
						advads171_delete_option('advads171_min_kw_length');
					}
					//category keywords
					$categories = get_categories();
					$advads171_cat_kws = array();
					foreach($categories as $curr_cat)
					{
						if (isset($_POST['advads171_cat_kws_'.$curr_cat->term_id]))
						{
							$advads171_cat_kws[$curr_cat->term_id] = $_POST['advads171_cat_kws_'.$curr_cat->term_id];
							update_option('advads171_cat_kws_'.$curr_cat->term_id, $advads171_cat_kws[$curr_cat->term_id]);
						}
						else
						{
							$advads171_cat_kws[$curr_cat->term_id] = '';
							delete_option('advads171_cat_kws_'.$curr_cat->term_id);
						}				
					}
					
					if (!isset($_POST['advads171_amzn_cat_toggle']))
					{
						$_POST['advads171_amzn_cat_toggle'] = array();
					}
					if (!isset($_POST['advads171_epn_cat_toggle']))
					{
						$_POST['advads171_epn_cat_toggle'] = array();
					}
					$advads171_amzn_disabled_categories = array();
					if (isset($_POST['advads171_amzn_cat_toggle']) && is_array($_POST['advads171_amzn_cat_toggle']) && count($categories) > 0 && advads171_module_installed('amzn'))
					{
						foreach($categories as $curr_cat)
						{
							if (!in_array($curr_cat->term_id, $_POST['advads171_amzn_cat_toggle']))
							{
								$advads171_amzn_disabled_categories[] = $curr_cat->term_id;
							}
						}						
					}
					update_option('advads171_amzn_disabled_categories', implode(',', $advads171_amzn_disabled_categories));
					$advads171_epn_disabled_categories = array();
					if (isset($_POST['advads171_epn_cat_toggle']) && is_array($_POST['advads171_epn_cat_toggle']) && count($categories) > 0 && advads171_module_installed('epn'))
					{
						foreach($categories as $curr_cat)
						{
							if (!in_array($curr_cat->term_id, $_POST['advads171_epn_cat_toggle']))
							{
								$advads171_epn_disabled_categories[] = $curr_cat->term_id;
							}
						}
					}
					update_option('advads171_epn_disabled_categories', implode(',', $advads171_epn_disabled_categories));
					
					advads171_clear_cache();
				}
				
				if (isset($_POST['save_misc']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['advads171_posttypes']) && is_array($_POST['advads171_posttypes'])) {
						update_option('advads171_posttypes', implode(',', $_POST['advads171_posttypes']));
						$advads171_posttypes = $_POST['advads171_posttypes'];
					} else {
						delete_option('advads171_posttypes');
						$advads171_posttypes = array();
					}
					if (isset($_POST['advads171_show_promo_msgs']) && trim($_POST['advads171_show_promo_msgs']) != '') {
						advads171_update_option('advads171_show_promo_msgs', $advads171_show_promo_msgs = intval(trim($_POST['advads171_show_promo_msgs'])), is_multisite());
					} else {
						advads171_delete_option('advads171_show_promo_msgs', is_multisite());
					}
					if (isset($_POST['advads171_path_to_geoip_dat']) && trim($_POST['advads171_path_to_geoip_dat']) != '') {
						advads171_update_option('advads171_path_to_geoip_dat', $advads171_path_to_geoip_dat = trim($_POST['advads171_path_to_geoip_dat']));
					} else {
						advads171_delete_option('advads171_path_to_geoip_dat');
					}
					
					if (isset($_POST['advads171_visitor_log_days']) && trim($_POST['advads171_visitor_log_days']) != '') {
						advads171_update_option('advads171_visitor_log_days', $advads171_visitor_log_days = trim($_POST['advads171_visitor_log_days']));
					} else {
						advads171_delete_option('advads171_visitor_log_days');
					}
					
					if (isset($_POST['advads171_unsupported_country_default']) && trim($_POST['advads171_unsupported_country_default']) != '') {
						advads171_update_option('advads171_unsupported_country_default', $advads171_unsupported_country_default = trim($_POST['advads171_unsupported_country_default']));
					} else {
						advads171_delete_option('advads171_unsupported_country_default');
					}
				}

				//BOF pull existing options on partial submit
				/*if (!isset($_POST['save_general']) && !isset($_POST['save_all_settings']))
				{				
					$advads171_serponly = get_option('advads171_serponly');
					$advads171_sensitivity = get_option('advads171_sensitivity');
					$advads171_loggedin_hide = get_option('advads171_loggedin_hide');
					$advads171_posttypes_str = get_option('advads171_posttypes');
					$advads171_posttypes = explode(',', $advads171_posttypes_str);
					$advads171_pops_per_user = get_option('advads171_pops_per_user');
					$advads171_default_behavior = get_option('advads171_default_behavior');
				}
				if (!isset($_POST['save_triggers']) && !isset($_POST['save_all_settings']))
				{	
					$advads171_unbounce_enabled = get_option('advads171_unbounce_enabled');
					$advads171_unbounce_delay = get_option('advads171_unbounce_delay');
					$advads171_mouse_trigger_disabled = advads171_get_option('advads171_mouse_trigger_disabled');
					$advads171_trapped_trigger_enabled = advads171_get_option('advads171_trapped_trigger_enabled');
					$advads171_trapped_trigger_msg = advads171_get_option('advads171_trapped_trigger_msg');
					$advads171_trapped_trigger_msg = stripslashes($advads171_trapped_trigger_msg);
				}*/

				if (!isset($_POST['save_keywords']) && !isset($_POST['save_all_settings']))
				{		
					$advads171_skip_keywords = advads171_get_option('advads171_skip_keywords');
					if ($advads171_skip_keywords === FALSE)
					{
						$advads171_skip_keywords_arr = advads171_get_default_skip_keywords();
						$advads171_skip_keywords = implode("\n", $advads171_skip_keywords_arr);
					}
					else
					{
						$advads171_skip_keywords_arr = explode(',', $advads171_skip_keywords);
						$advads171_skip_keywords = str_replace(",", "\n", $advads171_skip_keywords);
					}
					$advads171_skip_keywords = stripslashes($advads171_skip_keywords);
					$advads171_kw_sources = array();
					$advads171_kw_sources_str = advads171_get_option('advads171_kw_sources');
					if ($advads171_kw_sources_str !== FALSE)
					{
						$advads171_kw_sources = explode(',', $advads171_kw_sources_str);
					}
					$advads171_fallback_keywords = get_option('advads171_fallback_keywords');
					$advads171_min_kw_length = advads171_get_option('advads171_min_kw_length');
					$categories = get_categories();
					$advads171_cat_kws = array();
					foreach($categories as $curr_cat)
					{
						$cat_kw_check = get_option('advads171_cat_kws_'.$curr_cat->term_id);
						if ($cat_kw_check !== FALSE)
						{
							$advads171_cat_kws[$curr_cat->term_id] = $cat_kw_check;
						}
					}
					
					$advads171_amzn_disabled_categories = array();
					$advads171_amzn_disabled_categories_check = get_option('advads171_amzn_disabled_categories');
					if ($advads171_amzn_disabled_categories_check !== FALSE && advads171_module_installed('amzn'))
					{
						$advads171_amzn_disabled_categories_check_arr = explode(',', $advads171_amzn_disabled_categories_check);
						if (count($advads171_amzn_disabled_categories_check_arr) > 0)
						{
							$advads171_amzn_disabled_categories = $advads171_amzn_disabled_categories_check_arr;
						}
					}
					$advads171_epn_disabled_categories = array();
					$advads171_epn_disabled_categories_check = get_option('advads171_epn_disabled_categories');
					if ($advads171_epn_disabled_categories_check !== FALSE && advads171_module_installed('epn'))
					{
						$advads171_epn_disabled_categories_check_arr = explode(',', $advads171_epn_disabled_categories_check);
						if (count($advads171_epn_disabled_categories_check_arr) > 0)
						{
							$advads171_epn_disabled_categories = $advads171_epn_disabled_categories_check_arr;
						}
					}

					
				}
				if (!isset($_POST['save_misc']) && !isset($_POST['save_all_settings']))
				{	
					$advads171_posttypes_str = get_option('advads171_posttypes');
					$advads171_posttypes = explode(',', $advads171_posttypes_str);
					$advads171_show_promo_msgs = advads171_get_option('advads171_show_promo_msgs', is_multisite());
					$advads171_path_to_geoip_dat = advads171_get_option('advads171_path_to_geoip_dat');
					$advads171_visitor_log_days = advads171_get_option('advads171_visitor_log_days');
					$advads171_unsupported_country_default = advads171_get_option('advads171_unsupported_country_default');
				}
				//EOF pull existing options on partial submit
				
				
			}
			elseif ($tab == 'amazon')
			{
				if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons))
				{
					if (isset($_POST['advads171_amzn_cart_enabled']) && trim($_POST['advads171_amzn_cart_enabled'])) {
						advads171_update_option('amzn_cart_enabled', $advads171_amzn_cart_enabled = trim($_POST['advads171_amzn_cart_enabled']));
						advads171_clear_cache();
					} else {
						advads171_delete_option('amzn_cart_enabled');
					}
					if (isset($_POST['advads171_amzn_cart_btn_text_3prods']) && trim($_POST['advads171_amzn_cart_btn_text_3prods'])) {
						advads171_update_option('amzn_cart_btn_text_3prods', $advads171_amzn_cart_btn_text_3prods = trim($_POST['advads171_amzn_cart_btn_text_3prods']));
					} else {
						advads171_delete_option('amzn_cart_btn_text_3prods');
					}
					
				}
				
				
				if (isset($_POST['am_key_id']) && trim($_POST['am_key_id'])) {
					update_option('advads171_am_key_id', $am_key_id = trim($_POST['am_key_id']));
				} else {
					delete_option('advads171_am_key_id');
				}
				
				if (isset($_POST['am_access_key']) && trim($_POST['am_access_key'])) {
					update_option('advads171_am_access_key', $am_access_key = trim($_POST['am_access_key']));
				} else {
					delete_option('advads171_am_access_key');
				}
				
				if (isset($_POST['am_associate_tag']) && trim($_POST['am_associate_tag'])) {
					update_option('advads171_am_associate_tag', $am_associate_tag = trim($_POST['am_associate_tag']));
				} else {
					delete_option('advads171_am_associate_tag');
				}
				
				if (isset($_POST['am_searchindex']) && trim($_POST['am_searchindex'])) {
					update_option('advads171_am_searchindex', $am_searchindex = trim($_POST['am_searchindex']));
				} else {
					delete_option('advads171_am_searchindex');
				}
				
				//update all nodes
				if (isset($_POST['amzn_category']) && is_array($_POST['amzn_category'])) {
					foreach(advads171_amzn_countries() as $country)
					{
						if (isset($_POST['amzn_category'][$country]))
						{
							update_option('advads171_nodes_path_'.$country, implode(',', $_POST['amzn_category'][$country]));
						}
						else 
						{
							delete_option('advads171_nodes_path_'.$country);
						}
					}					
				} 
				
				
				if (isset($_POST['skip_noimage']) && trim($_POST['skip_noimage'])) {
					update_option('advads171_skip_noimage', $skip_noimage = trim($_POST['skip_noimage']));
				} else {
					delete_option('advads171_skip_noimage');
				}
				if (isset($_POST['skip_asins']) && trim($_POST['skip_asins'])) {
					update_option('advads171_skip_asins', $skip_asins = trim($_POST['skip_asins']));
				} else {
					delete_option('advads171_skip_asins');
				}
				
				
				if (isset($_POST['am_associate_tag_uk']) && trim($_POST['am_associate_tag_uk'])) { update_option('advads171_locale_tag_uk', $am_associate_tag_uk = trim($_POST['am_associate_tag_uk'])); } 
				else { delete_option('advads171_locale_tag_uk');}
				if (isset($_POST['am_associate_tag_de']) && trim($_POST['am_associate_tag_de'])) { update_option('advads171_locale_tag_de', $am_associate_tag_de = trim($_POST['am_associate_tag_de'])); } 
				else { delete_option('advads171_locale_tag_de');}
				if (isset($_POST['am_associate_tag_jp']) && trim($_POST['am_associate_tag_jp'])) { update_option('advads171_locale_tag_jp', $am_associate_tag_jp = trim($_POST['am_associate_tag_jp'])); } 
				else { delete_option('advads171_locale_tag_jp');}
				if (isset($_POST['am_associate_tag_fr']) && trim($_POST['am_associate_tag_fr'])) { update_option('advads171_locale_tag_fr', $am_associate_tag_fr = trim($_POST['am_associate_tag_fr'])); } 
				else { delete_option('advads171_locale_tag_fr');}
				if (isset($_POST['am_associate_tag_ca']) && trim($_POST['am_associate_tag_ca'])) { update_option('advads171_locale_tag_ca', $am_associate_tag_ca = trim($_POST['am_associate_tag_ca'])); } 
				else { delete_option('advads171_locale_tag_ca');}
				if (isset($_POST['am_associate_tag_it']) && trim($_POST['am_associate_tag_it'])) { update_option('advads171_locale_tag_it', $am_associate_tag_it = trim($_POST['am_associate_tag_it'])); } 
				else { delete_option('advads171_locale_tag_it');}
				if (isset($_POST['am_associate_tag_cn']) && trim($_POST['am_associate_tag_cn'])) { update_option('advads171_locale_tag_cn', $am_associate_tag_cn = trim($_POST['am_associate_tag_cn'])); } 
				else { delete_option('advads171_locale_tag_cn');}
				if (isset($_POST['am_associate_tag_es']) && trim($_POST['am_associate_tag_es'])) { update_option('advads171_locale_tag_es', $am_associate_tag_es = trim($_POST['am_associate_tag_es'])); } 
				else { delete_option('advads171_locale_tag_es');}
			}
			elseif ($tab == 'wpms')
			{
				if (isset($_POST['advads171_wpms_apply_to_all']) && trim($_POST['advads171_wpms_apply_to_all'])) {
					advads171_wpms_apply_to_all();
				}
				
				if (isset($_POST['advads171_default_wpms_blog_id']) && trim($_POST['advads171_default_wpms_blog_id']) && (is_numeric($_POST['advads171_default_wpms_blog_id']) || $_POST['advads171_default_wpms_blog_id'] == 'none')) {
					advads171_wpms_save_default_blog_id($_POST['advads171_default_wpms_blog_id']);
				}				
			}

			
		}
		
	}
	else
	{
		if ($tab == 'important_stuff')
		{
			$advads171_amzn_active = advads171_get_option('advads171_amzn_active');
			$advads171_unsupported_country_default = advads171_get_option('advads171_unsupported_country_default');
			$am_key_id = get_option('advads171_am_key_id');
			$am_access_key = get_option('advads171_am_access_key');
			$am_associate_locale = get_option('advads171_am_associate_locale');
			
			if ($am_associate_locale == '') $am_associate_locale = 'us';
			
			if ($am_associate_locale == 'us') $am_associate_tag = get_option('advads171_am_associate_tag');
			if ($am_associate_locale == 'uk') $am_associate_tag = get_option('advads171_locale_tag_uk');
			if ($am_associate_locale == 'de') $am_associate_tag = get_option('advads171_locale_tag_de');
			if ($am_associate_locale == 'jp') $am_associate_tag = get_option('advads171_locale_tag_jp');
			if ($am_associate_locale == 'fr') $am_associate_tag = get_option('advads171_locale_tag_fr');
			if ($am_associate_locale == 'ca') $am_associate_tag = get_option('advads171_locale_tag_ca');
			if ($am_associate_locale == 'it') $am_associate_tag = get_option('advads171_locale_tag_it');
			if ($am_associate_locale == 'cn') $am_associate_tag = get_option('advads171_locale_tag_cn');
			if ($am_associate_locale == 'es') $am_associate_tag = get_option('advads171_locale_tag_es');
			
			$am_searchindex = get_option('advads171_am_searchindex');
			$advads171_active = get_option('advads171_active');
			
			$epn_enabled = advads171_get_option('epn_enabled');
			$epn_campaign_id = advads171_get_option('epn_campaign_id');
			$epn_custom_id = advads171_get_option('epn_custom_id');
		}
		elseif ($tab == 'advanced')
		{
			/*$advads171_serponly = get_option('advads171_serponly');
			$advads171_sensitivity = get_option('advads171_sensitivity');
			$advads171_loggedin_hide = get_option('advads171_loggedin_hide');
			$advads171_posttypes_str = get_option('advads171_posttypes');
			$advads171_posttypes = explode(',', $advads171_posttypes_str);
			$advads171_pops_per_user = get_option('advads171_pops_per_user');
			$advads171_default_behavior = get_option('advads171_default_behavior');
			$advads171_unbounce_enabled = get_option('advads171_unbounce_enabled');
			$advads171_unbounce_delay = get_option('advads171_unbounce_delay');
			$advads171_mouse_trigger_disabled = advads171_get_option('advads171_mouse_trigger_disabled');
			$advads171_trapped_trigger_enabled = advads171_get_option('advads171_trapped_trigger_enabled');
			$advads171_trapped_trigger_msg = advads171_get_option('advads171_trapped_trigger_msg');
			$advads171_trapped_trigger_msg = stripslashes($advads171_trapped_trigger_msg);*/
			
			$advads171_skip_keywords = advads171_get_option('advads171_skip_keywords');
			if ($advads171_skip_keywords === FALSE)
			{
				$advads171_skip_keywords_arr = advads171_get_default_skip_keywords();
				$advads171_skip_keywords = implode("\n", $advads171_skip_keywords_arr);
			}
			else
			{
				$advads171_skip_keywords_arr = explode(',', $advads171_skip_keywords);
				$advads171_skip_keywords = str_replace(",", "\n", $advads171_skip_keywords);
			}
			$advads171_skip_keywords = stripslashes($advads171_skip_keywords);
			
			$advads171_kw_sources = array();
			$advads171_kw_sources_str = advads171_get_option('advads171_kw_sources');
			if (strlen($advads171_kw_sources_str) > 0)
			{
				$advads171_kw_sources = explode(',', $advads171_kw_sources_str);
			}
			$advads171_fallback_keywords = get_option('advads171_fallback_keywords');
			$advads171_min_kw_length = advads171_get_option('advads171_min_kw_length');

			$categories = get_categories();
			$advads171_cat_kws = array();
			foreach($categories as $curr_cat)
			{
				$cat_kw_check = get_option('advads171_cat_kws_'.$curr_cat->term_id);

				if ($cat_kw_check !== FALSE)
				{
					$advads171_cat_kws[$curr_cat->term_id] = $cat_kw_check;
				}
				else
				{
					$advads171_cat_kws[$curr_cat->term_id] = '';
				}
			}
			
			$advads171_amzn_disabled_categories = array();
			$advads171_amzn_disabled_categories_check = get_option('advads171_amzn_disabled_categories');
			if ($advads171_amzn_disabled_categories_check !== FALSE && advads171_module_installed('amzn'))
			{
				$advads171_amzn_disabled_categories_check_arr = explode(',', $advads171_amzn_disabled_categories_check);
				if (count($advads171_amzn_disabled_categories_check_arr) > 0)
				{
					$advads171_amzn_disabled_categories = $advads171_amzn_disabled_categories_check_arr;
				}
			}
			$advads171_epn_disabled_categories = array();
			$advads171_epn_disabled_categories_check = get_option('advads171_epn_disabled_categories');
			if ($advads171_epn_disabled_categories_check !== FALSE && advads171_module_installed('epn'))
			{
				$advads171_epn_disabled_categories_check_arr = explode(',', $advads171_epn_disabled_categories_check);
				if (count($advads171_epn_disabled_categories_check_arr) > 0)
				{
					$advads171_epn_disabled_categories = $advads171_epn_disabled_categories_check_arr;
				}
			}

			$advads171_posttypes_str = get_option('advads171_posttypes');
			$advads171_posttypes = explode(',', $advads171_posttypes_str);
			$advads171_show_promo_msgs = advads171_get_option('advads171_show_promo_msgs', is_multisite());
			$advads171_path_to_geoip_dat = advads171_get_option('advads171_path_to_geoip_dat');
			$advads171_visitor_log_days = advads171_get_option('advads171_visitor_log_days');
			$advads171_unsupported_country_default = advads171_get_option('advads171_unsupported_country_default');
		}
		elseif ($tab == 'amazon')
		{
			if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons))
			{
				$advads171_amzn_cart_enabled = advads171_get_option('amzn_cart_enabled');
				$advads171_amzn_cart_btn_text_3prods = advads171_get_option('amzn_cart_btn_text_3prods');
			}
			
			$am_key_id = get_option('advads171_am_key_id');
			$am_access_key = get_option('advads171_am_access_key');
			$am_associate_tag = get_option('advads171_am_associate_tag');
			
			$am_associate_tag_uk = get_option('advads171_locale_tag_uk');
			$am_associate_tag_de = get_option('advads171_locale_tag_de');
			$am_associate_tag_jp = get_option('advads171_locale_tag_jp');
			$am_associate_tag_fr = get_option('advads171_locale_tag_fr');
			$am_associate_tag_ca = get_option('advads171_locale_tag_ca');
			$am_associate_tag_it = get_option('advads171_locale_tag_it');
			$am_associate_tag_cn = get_option('advads171_locale_tag_cn');
			$am_associate_tag_es = get_option('advads171_locale_tag_es');
			
			$am_searchindex = get_option('advads171_am_searchindex');
			$skip_noimage = get_option('advads171_skip_noimage');
			$skip_asins = get_option('advads171_skip_asins');
		}
		elseif ($tab == 'wpms')
		{
			$advads171_default_wpms_blog_id = advads171_wpms_get_default_blog_id();
		}
	
	}

	if ( !empty($_POST ) && '' == $error ) {
		echo '<div id="message" class="updated fade"><p><strong>'
		. __('Settings saved.') ;
		if (isset($advads171_additional_success) && $advads171_additional_success != '')
		{
			echo "<br />".$advads171_additional_success;
		}
		echo '</strong></p></div>';
		if (isset($advads171_wpfooter_warning) && $advads171_wpfooter_warning != '')
		{
			echo '<div id="message" class="error"><p><strong>'
		. __($advads171_wpfooter_warning) . '</strong></p></div>';
		}
	}
	
	
	

	echo '<div class="wrap"><img src="'.plugin_dir_url( __FILE__ ).'images/'.advads171_branding_img().'" style="display: block; float: right;" /><h2>' . sprintf(__('%s Settings', $advads171_plugin_slug), $advads171_plugin_name) . '</h2>';
	
	
		$tabs = array(
			'important' => 'Important Stuff',

			);
		
		if (advads171_module_installed('amzn'))	$tabs['amazon'] = 'Amazon';
		$tabs['advanced'] = 'Advanced';
		
		if (defined('MULTISITE') && (MULTISITE === TRUE || MULTISITE == 1) && advads171_get_option('license') == 'premium_unlimited')
		{
			$tabs['wpms'] = __('WPMS Settings', $advads171_plugin_slug);
		}

		echo '<h2 class="nav-tab-wrapper">';

		if ( isset( $redir_tab ) && array_key_exists( $redir_tab, $tabs ) ) {
			$current = $redir_tab;
		} elseif ( isset( $_GET['tab'] ) && array_key_exists( $_GET['tab'], $tabs ) ) {
			$current = $_GET['tab'];
		} else {
			$keys = array_keys( $tabs );
			$current = array_shift( $keys );
		}

		foreach ( $tabs as $callback => $text ) {
			$class = ' class="nav-tab"';

			if ( $current == $callback )
				$class = ' class="nav-tab nav-tab-active"';

			$href = add_query_arg( array( 'tab' => $callback, 's' => false, 'paged' => false, 'post_mime_type' => false, 'm' => false ) );
			$href = remove_query_arg( 'isocode', $href );
			$href = wp_nonce_url( $href, "tab-$callback" );
			$link = "<a href='" . esc_url( $href ) . "'$class>$text</a>";

			echo $link;
		}
		echo '</h2>';

	?>
	<?php if ($tab == 'important_stuff'): ?>
		<?php advads171_prepare_postboxes(); ?>
		
		<form method="post" action="admin.php?page=advads171-config<?php if (isset($_GET['advads171_tour']) && $_GET['advads171_tour'] == '2') { echo '&advads171_tour=5';}; ?>" id="important_stuff_form" name="important_stuff_form" >
		<table class="form-table" style="width:750px;">
			<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php _e('These settings are required for the plugin to work. If you have any questions check out our <a href="http://contextazon.com/faq" target="_blank">FAQ</a>', $advads171_plugin_slug);?></td></tr>
			<?php if (strlen($error) > 0): ?>
				<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
			<?php endif; ?>
			<tr><td colspan="2">
				<div class="metabox-holder">
					<div id="enable_and_country" class="postbox">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug ); ?>"><br /></div>
						<h3 class="hndle"><?php echo $advads171_plugin_name; ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">			
								<tr class="form-field"><th style="width:150px;"><label for="advads171_active"><?php _e('Enable Plugin', $advads171_plugin_slug);?>:</label></th>
									<td>
										<select name="advads171_active" id="advads171_active">
											<option value="0"><?php _e('Disabled', $advads171_plugin_slug);?></option>
											<option value="1" <?=$advads171_active == 1?'selected':'';?>><?php _e('Enabled', $advads171_plugin_slug);?></option>
										</select>
									</td></tr>
								<tr class="form-field"><th style="width:150px;"><label for="advads171_unsupported_country_default"><?php _e('If country not supported then show', $advads171_plugin_slug); ?>:</label></th>
								<td>									
									<select name="advads171_unsupported_country_default" id="advads171_unsupported_country_default">
										<option value="none" <?=$advads171_unsupported_country_default === FALSE || $advads171_unsupported_country_default == 'none'?'selected':'';?>><?php _e('Nothing', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="us" <?=$advads171_unsupported_country_default == 'us'?'selected':'';?>><?php _e('US listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="uk" <?=$advads171_unsupported_country_default == 'uk'?'selected':'';?>><?php _e('UK listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="ca" <?=$advads171_unsupported_country_default == 'ca'?'selected':'';?>><?php _e('CA listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="de" <?=$advads171_unsupported_country_default == 'de'?'selected':'';?>><?php _e('DE listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="fr" <?=$advads171_unsupported_country_default == 'fr'?'selected':'';?>><?php _e('FR listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="it" <?=$advads171_unsupported_country_default == 'it'?'selected':'';?>><?php _e('IT listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="es" <?=$advads171_unsupported_country_default == 'es'?'selected':'';?>><?php _e('ES listings', $advads171_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('If user\'s country not supported do this (set this to your main Amazon country)', $advads171_plugin_slug); ?></span>
								</td></tr>
							</table>
						</div>
					</div>
				</div>
				
			<?php if (advads171_module_installed('amzn')): ?>
				<div class="metabox-holder">
					<div class="postbox" id="avads_amz_quick_settings">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
						<h3 class="hndle"><?php _e('Amazon Quick Settigs', $advads171_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">
								
								<tr class="form-field"><th style="width:150px;"><label for="advads171_amzn_active"><?php _e('Enable Amazon', $advads171_plugin_slug); ?>:</label></th>
									<td>
										<select name="advads171_amzn_active" id="advads171_amzn_active">
											<option value="0" ><?php _e('Disabled', $advads171_plugin_slug); ?></option>
											<option value="1" <?=$advads171_amzn_active === FALSE || $advads171_amzn_active == '1'?'selected':'';?>><?php _e('Enabled', $advads171_plugin_slug); ?></option>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="am_key_id"><?php _e('AWS Access Key ID', $advads171_plugin_slug); ?>:</label></th>
									<td><input type="text" name="am_key_id" value="<?=$am_key_id;?>" id="am_key_id" size="25" style="width:220px;" />  <a href="<?php _e('http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/', $advads171_plugin_slug); ?>" title="<?php esc_attr_e('Click for Help', $advads171_plugin_slug); ?>" target="_blank">?</a> | <a href="<?php _e('https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html', $advads171_plugin_slug); ?>" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a></td></tr>
								
								

									
								<tr class="form-field"><th style="width:150px;"><label for="am_access_key"><?php _e('AWS Secret Access Key', $advads171_plugin_slug); ?>:</label></th>
									<td><input type="text" name="am_access_key" value="<?=$am_access_key;?>" id="am_access_key" size="25" style="width:220px;" />  <a href="<?php _e('http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/', $advads171_plugin_slug); ?>" title="<?php esc_attr_e('Click for Help', $advads171_plugin_slug); ?>" target="_blank">?</a></td></tr>
									
								
									
								<tr class="form-field"><th style="width:150px;"><label for="am_associate_tag"><?php _e('Amazon Associate Tag', $advads171_plugin_slug); ?>:</label></th>
									<td><input type="text" name="am_associate_tag" value="<?=$am_associate_tag;?>" id="am_associate_tag" size="25" style="width:220px;" />  <a href="<?php _e('http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/', $advads171_plugin_slug); ?>" title="<?php esc_attr_e('Click for Help', $advads171_plugin_slug); ?>" target="_blank">?</a> | <a href="<?php _e('https://affiliate-program.amazon.com', $advads171_plugin_slug); ?>" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a></td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="am_associate_locale"><?php _e('Amazon Associate Locale', $advads171_plugin_slug); ?>:</label></th>
									<td>
									<select name="am_associate_locale" id="am_associate_locale" style="width:220px;" >
										<option value="us" <?=$am_associate_locale == 'us'?'selected':'';?>><?php _e('US', $advads171_plugin_slug); ?></option>
										<option value="uk" <?=$am_associate_locale == 'uk'?'selected':'';?>><?php _e('UK', $advads171_plugin_slug); ?></option>
										<option value="de" <?=$am_associate_locale == 'de'?'selected':'';?>><?php _e('DE', $advads171_plugin_slug); ?></option>
										<option value="jp" <?=$am_associate_locale == 'jp'?'selected':'';?>><?php _e('JP', $advads171_plugin_slug); ?></option>
										<option value="fr" <?=$am_associate_locale == 'fr'?'selected':'';?>><?php _e('FR', $advads171_plugin_slug); ?></option>
										<option value="ca" <?=$am_associate_locale == 'ca'?'selected':'';?>><?php _e('CA', $advads171_plugin_slug); ?></option>
										<option value="it" <?=$am_associate_locale == 'it'?'selected':'';?>><?php _e('IT', $advads171_plugin_slug); ?></option>
										<option value="cn" <?=$am_associate_locale == 'cn'?'selected':'';?>><?php _e('CN', $advads171_plugin_slug); ?></option>
										<option value="es" <?=$am_associate_locale == 'es'?'selected':'';?>><?php _e('ES', $advads171_plugin_slug); ?></option>
									</select> <?php _e('You can add more in Amazon settings tab', $advads171_plugin_slug); ?>
									</td>
								</tr>
									
								<tr class="form-field"><th style="width:150px;"><label for="am_searchindex"><?php _e('Amazon Search Index', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="am_searchindex" id="am_searchindex">
										<?php foreach($am_indexes as $am_index): ?>
											<option value="<?=$am_index;?>" <?=($am_searchindex == $am_index?'selected':'');?>><?=$am_index;?> &nbsp;</option>
										<?php endforeach; ?>
									</select> <?php _e('Main category to pull Amazon products from.', $advads171_plugin_slug); ?>
								</td></tr>							
								
							</table>
						</div>
					</div>
				</div>	
			<?php endif; ?>


			<?php if (advads171_module_installed('epn')): ?>							
				<div class="metabox-holder">
					<div class="postbox">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
						<h3 class="hndle"><?php _e('ePN Quick Settigs', $advads171_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">
								
								<tr class="form-field"><th style="width:150px;"><label for="advads171_active"><?php _e('Enable ePN', $advads171_plugin_slug); ?>:</label></th>
									<td>
										<select name="epn_enabled" id="epn_enabled">
											<option value="0" ><?php _e('Disabled', $advads171_plugin_slug); ?></option>
											<option value="1" <?=$epn_enabled === FALSE || $epn_enabled == '1'?'selected':'';?>><?php _e('Enabled', $advads171_plugin_slug); ?></option>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="epn_campaign_id"><?php _e('Campaign ID', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="epn_campaign_id" value="<?=$epn_campaign_id;?>" id="epn_campaign_id" size="25" style="width:220px;" /> <br /><span class="description"><?php _e('used to turn product links into your affiliate links (required)', $advads171_plugin_slug); ?></span> </td></tr>
							
								<tr class="form-field"><th style="width:150px;"><label for="epn_custom_id"><?php _e('Custom ID', $advads171_plugin_slug); ?>:</label></th>
									<td><input type="text" name="epn_custom_id" value="<?=$epn_custom_id;?>" id="epn_custom_id" size="25" style="width:220px;" /> <span class="description"><?php _e('for tracking (optional)', $advads171_plugin_slug); ?></span> </td></tr>
						
							</table>
						</div>
					</div>
				</div>	
			<?php endif; ?>
				
			</td></tr>
		</table>
		
		<table>
		<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $advads171_plugin_slug); ?>" id="advads_save_important_settings" class="button-primary" /></td></tr>
		</table>
		
		<input type="hidden" name="advads171_hidden_patch_footer" id="advads171_hidden_patch_footer" value="no" />
		<input type="hidden" name="advads171_form_submitted" value="yes" />
		</form>
		
	<?php elseif ($tab == 'amazon'): ?>
		<?php advads171_prepare_postboxes(); ?>
		<form method="post" action="" >
		<table class="form-table" style="width:750px;">
			<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php _e('You can set your plugin to work with different locales (countries). If you have any questions check out our <a href="http://contextazon.com/faq" target="_blank">FAQ</a>', $advads171_plugin_slug); ?></td></tr>
			<?php if (strlen($error)): ?>
				<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
			<?php endif; ?>
			<tr><td colspan="2">
			<div class="metabox-holder">
			
				<?php if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons)): ?>
					<?php
					if ($advads171_amzn_cart_btn_text_3prods === FALSE) $advads171_amzn_cart_btn_text_3prods = __('Add To Cart', $advads171_plugin_slug);
					if ($advads171_amzn_cart_btn_text_1prod === FALSE) $advads171_amzn_cart_btn_text_1prod = __('Add To Cart', $advads171_plugin_slug);
					?>
					<div id="submitdiv" class="postbox">
						<div class="handlediv" title="<?php esc_attr_e('Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
						<h3 class="hndle amzn_cart_hndle"><?php _e('Amazon 90 Days Cookie Add-On', $advads171_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">
							
								<tr class="form-field"><th style="width:150px;"><label for="advads171_amzn_cart_enabled"><?php _e('90 Days Cookie Enabled', $advads171_plugin_slug); ?>:</label></th>
									<td>
										<select name="advads171_amzn_cart_enabled" id="advads171_amzn_cart_enabled">
											<option value="yes" <?=($advads171_amzn_cart_enabled !== FALSE && $advads171_amzn_cart_enabled == 'yes'?'selected':'');?>><?php _e('Enabled', $advads171_plugin_slug); ?></option>
											<option value="no" <?=($advads171_amzn_cart_enabled === FALSE || $advads171_amzn_cart_enabled == 'no'?'selected':'');?>><?php _e('Disabled', $advads171_plugin_slug); ?> &nbsp;&nbsp;</option>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="advads171_amzn_cart_btn_text_3prods"><?php _e('"Add To Cart" text', $advads171_plugin_slug); ?>:</label></th>
									<td><input type="text" name="advads171_amzn_cart_btn_text_3prods" value="<?=$advads171_amzn_cart_btn_text_3prods;?>" id="advads171_amzn_cart_btn_text_3prods" size="25" style="width:220px;" />  <span class="description"></span></td></tr>
							
								
							</table>
						</div>
					</div>
					
					<style>
					.amzn_cart_hndle {
					background-color: #166b94!important;
					background-image: none!important;
					color: #fff!important;
					text-shadow: 0 -1px 0 #11506F!important;
					}
					</style>
				
				<?php endif; ?>
				
					<style>
					.advads171_hide {
					display: none;
					}
					</style>
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('AWS Settings', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">
						
							<tr class="form-field"><th style="width:150px;"><label for="am_key_id"><?php _e('AWS Access Key ID', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="am_key_id" value="<?=$am_key_id;?>" id="am_key_id" size="25" style="width:220px;" /> <?php _e('<a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" title="Click for Help" target="_blank">?</a> | <a href="https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html" target="_blank">Sign Up</a>', $advads171_plugin_slug); ?></td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="am_access_key"><?php _e('AWS Secret Access Key', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="am_access_key" value="<?=$am_access_key;?>" id="am_access_key" size="25" style="width:220px;" />  <?php _e('<a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" title="Click for Help" target="_blank">?</a>', $advads171_plugin_slug); ?></td></tr>
						</table>
					</div>
				</div>
				
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('International', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">	
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag"><?php _e('US Amazon Associate Tag', $advads171_plugin_slug); ?>:</label><br />
									  <?php _e('<a href="http://contextazon.com/faq/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" title="Click for Help" target="_blank">Help</a> | <a href="https://affiliate-program.amazon.com" target="_blank">Sign Up</a>', $advads171_plugin_slug); ?>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag" value="<?=$am_associate_tag;?>" id="am_associate_tag" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_us_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_us_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_us_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_us_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
									<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_us_node_parent_catlbl <?=$am_associate_tag === FALSE || $am_associate_tag == ''?'advads171_hide':'';?>">
										<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'US'); ?>:<br />
									</div>
									<div style="float: left;">
										<div id="amzn_us_category_0_wrap" class="amzn_us_node_parent_0 <?=$am_associate_tag === FALSE || $am_associate_tag == ''?'advads171_hide':'';?>">
											<?php echo advads171_amzn_cats_select('us', 0, 0, advads171_country_selected_cats('us')); ?>											
										</div>
										<div class="amzn_us_category_loading_msg"></div>
									</div>
									<?php endif; ?>
								</td></tr>
							

							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_uk"><?php _e('UK Associate Tag', $advads171_plugin_slug); ?>:</label><br />
									(<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://affiliate-program.amazon.co.uk/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_uk" value="<?=$am_associate_tag_uk;?>" id="am_associate_tag_uk" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_uk_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_uk_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_uk_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_uk_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_uk_node_parent_catlbl <?=$am_associate_tag_uk === FALSE || $am_associate_tag_uk == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'UK'); ?>:<br />
										</div>
										<div style="float: left;">
											<div id="amzn_uk_category_0_wrap" class="amzn_uk_node_parent_0 <?=$am_associate_tag_uk === FALSE || $am_associate_tag_uk == ''?'advads171_hide':'';?>">
												
												<?php echo advads171_amzn_cats_select('uk', 0, 0, advads171_country_selected_cats('uk')); ?>											
											</div>
											<div class="amzn_uk_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_ca">CA Associate Tag:</label><br />
									 (<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://associates.amazon.ca/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_ca" value="<?=$am_associate_tag_ca;?>" id="am_associate_tag_ca" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_ca_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_ca_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_ca_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_ca_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_ca_node_parent_catlbl <?=$am_associate_tag_ca === FALSE || $am_associate_tag_ca == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'CA'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_ca_category_0_wrap" class="amzn_ca_node_parent_0 <?=$am_associate_tag_ca === FALSE || $am_associate_tag_ca == ''?'advads171_hide':'';?>">
												
												<?php echo advads171_amzn_cats_select('ca', 0, 0, advads171_country_selected_cats('ca')); ?>											
											</div>
											<div class="amzn_ca_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_de">DE Associate Tag:</label><br />
									 (<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://partnernet.amazon.de/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_de" value="<?=$am_associate_tag_de;?>" id="am_associate_tag_de" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_de_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_de_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_de_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_de_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_de_node_parent_catlbl <?=$am_associate_tag_de === FALSE || $am_associate_tag_de == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'DE'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_de_category_0_wrap" class="amzn_de_node_parent_0 <?=$am_associate_tag_de === FALSE || $am_associate_tag_de == ''?'advads171_hide':'';?>">												
												<?php echo advads171_amzn_cats_select('de', 0, 0, advads171_country_selected_cats('de')); ?>											
											</div>
											<div class="amzn_de_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>							
							<tr class="form-field">
								<th style="width:150px;">
									<label for="am_associate_tag_fr">FR Associate Tag:</label><br />
									(<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://partenaires.amazon.fr/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_fr" value="<?=$am_associate_tag_fr;?>" id="am_associate_tag_fr" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_fr_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_fr_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_fr_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_fr_node_parent_catlbl').removeClass('advads171_hide');}" /> </div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_fr_node_parent_catlbl <?=$am_associate_tag_fr === FALSE || $am_associate_tag_fr == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'FR'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_fr_category_0_wrap" class="amzn_fr_node_parent_0 <?=$am_associate_tag_fr === FALSE || $am_associate_tag_fr == ''?'advads171_hide':'';?>">												
												<?php echo advads171_amzn_cats_select('fr', 0, 0, advads171_country_selected_cats('fr')); ?>											
											</div>
											<div class="amzn_fr_category_loading_msg"></div>
										</div>
									<?php endif; ?>
										
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_it">IT Associate Tag:</label><br />
								 (<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://programma-affiliazione.amazon.it/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_it" value="<?=$am_associate_tag_it;?>" id="am_associate_tag_it" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_it_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_it_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_it_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_it_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_it_node_parent_catlbl <?=$am_associate_tag_it === FALSE || $am_associate_tag_it == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'IT'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_it_category_0_wrap" class="amzn_it_node_parent_0 <?=$am_associate_tag_it === FALSE || $am_associate_tag_it == ''?'advads171_hide':'';?>">												
												<?php echo advads171_amzn_cats_select('it', 0, 0, advads171_country_selected_cats('it')); ?>											
											</div>
											<div class="amzn_it_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_es">ES Associate Tag:</label><br />
									 (<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://afiliados.amazon.es/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_es" value="<?=$am_associate_tag_es;?>" id="am_associate_tag_es" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_es_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_es_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_es_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_es_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_es_node_parent_catlbl <?=$am_associate_tag_es === FALSE || $am_associate_tag_es == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'ES'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_es_category_0_wrap" class="amzn_es_node_parent_0 <?=$am_associate_tag_es === FALSE || $am_associate_tag_es == ''?'advads171_hide':'';?>">
												
												<?php echo advads171_amzn_cats_select('es', 0, 0, advads171_country_selected_cats('es')); ?>											
											</div>
											<div class="amzn_es_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_jp">JP Associate Tag:</label><br />
									 (<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://affiliate.amazon.co.jp/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_jp" value="<?=$am_associate_tag_jp;?>" id="am_associate_tag_jp" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_jp_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_jp_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_jp_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_jp_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_jp_node_parent_catlbl <?=$am_associate_tag_jp === FALSE || $am_associate_tag_jp == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'JP'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_jp_category_0_wrap" class="amzn_jp_node_parent_0 <?=$am_associate_tag_jp === FALSE || $am_associate_tag_jp == ''?'advads171_hide':'';?>">												
												<?php echo advads171_amzn_cats_select('jp', 0, 0, advads171_country_selected_cats('jp')); ?>											
											</div>
											<div class="amzn_jp_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_cn">CN Associate Tag:</label><br />
									 (<?php _e('optional', $advads171_plugin_slug); ?>) <a href="https://associates.amazon.cn/" target="_blank"><?php _e('Sign Up', $advads171_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_cn" value="<?=$am_associate_tag_cn;?>" id="am_associate_tag_cn" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_cn_node_parent_0').addClass('advads171_hide'); jQuery('.amzn_cn_node_parent_catlbl').addClass('advads171_hide');} else {jQuery('.amzn_cn_node_parent_0').removeClass('advads171_hide'); jQuery('.amzn_cn_node_parent_catlbl').removeClass('advads171_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_cn_node_parent_catlbl <?=$am_associate_tag_cn === FALSE || $am_associate_tag_cn == ''?'advads171_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $advads171_plugin_slug), 'CN'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_cn_category_0_wrap" class="amzn_cn_node_parent_0 <?=$am_associate_tag_cn === FALSE || $am_associate_tag_cn == ''?'advads171_hide':'';?>">
												
												<?php echo advads171_amzn_cats_select('cn', 0, 0, advads171_country_selected_cats('cn')); ?>											
											</div>
											<div class="amzn_cn_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							
						</table>
					</div>
				</div>
				
				<?php advads171_amzn_country_cats_javascript(); ?>

				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Other', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">		
							<tr class="form-field"><th style="width:150px;"><label for="am_searchindex"><?php _e('Amazon Search Category (fallback)', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="am_searchindex" id="am_searchindex">
										<?php foreach($am_indexes as $am_index): ?>
											<option value="<?=$am_index;?>" <?=($am_searchindex == $am_index?'selected':'');?>><?=$am_index;?> &nbsp;</option>
										<?php endforeach; ?>
									</select> <?php _e('Main category to pull Amazon products from.', $advads171_plugin_slug); ?>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="skip_noimage"><?php _e('Skip Products with No Picture', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="skip_noimage" id="skip_noimage">
											<option value="0" <?=($skip_noimage == 0?'selected':'');?>><?php _e('No', $advads171_plugin_slug); ?> &nbsp;</option>
											<option value="1" <?=($skip_noimage == 1?'selected':'');?>><?php _e('Yes', $advads171_plugin_slug); ?> &nbsp;</option>
									</select>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="skip_asins"><?php _e('Skip Products With ASINs', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="skip_asins" id="skip_asins" value="<?php echo $skip_asins; ?>" /><span class="description"><?php _e('Comma separated list of ASINs to exclude from banners.', $advads171_plugin_slug); ?></span>
								</td></tr>
						</table>
					</div>
				</div>
			
			</div>
			
			<table class="form-table" style="width:auto;">	
				<tr><td style="width: 150px;">&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $advads171_plugin_slug); ?>" class="button-primary" /></td></tr>
			</table>
			
			</td></tr>
		</table>

		</form>
	
	<?php elseif ($tab == 'wpms'): ?>
		<?php advads171_prepare_postboxes(); ?>
		<?php
		$advads171_curr_user = wp_get_current_user();
		?>
		<?php if (0 != $advads171_curr_user->ID): ?>
		<?php
		$advads171_blogs = get_blogs_of_user($advads171_curr_user->ID);
		$advads171_current_site = get_blog_details($blog_id);
		?>
		<form method="post" action="" >
		<table class="form-table" style="width:750px;">
			<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php echo sprintf(__('You can apply current %s settings to all sites in your network and set default settings for use on future sites. <a href="http://contextazon.com/faq" target="_blank">FAQ</a>', $advads171_plugin_slug), $advads171_plugin_name); ?></td></tr>
			<?php if(strlen($error) > 0): ?>
				<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
			<?php endif; ?>
			<tr><td colspan="2">
				<div class="metabox-holder">
					<div id="submitdiv" class="postbox">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
						<h3 class="hndle"><?php _e('General', $advads171_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">			
								<tr class="form-field"><th style="width:350px;"><label for="advads171_default_wpms_blog_id"><?php echo sprintf(__('New Sites should copy %s settings from this site', $advads171_plugin_slug), $advads171_plugin_name); ?>:</label></th>
									<td>
										<select name="advads171_default_wpms_blog_id" id="advads171_default_wpms_blog_id">
											<option value="none">-- <?php _e('Disabled', $advads171_plugin_slug); ?> --</option>
											<?php foreach($advads171_blogs as $loop_blog): ?>
												<option value="<?=$loop_blog->userblog_id;?>" <?=$advads171_default_wpms_blog_id == $loop_blog->userblog_id?'selected':'';?>><?=$loop_blog->blogname;?></option>
											<?php endforeach; ?>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="advads171_wpms_apply_to_all"><?php echo sprintf(__('Apply current %s settings of <strong>%s</strong> to all existing blogs', $advads171_plugin_slug), $advads171_plugin_name, $advads171_current_site->blogname); ?>:</label></th>
									<td>
										<select name="advads171_wpms_apply_to_all" id="advads171_wpms_apply_to_all">
											<option value="0"><?php _e('No', $advads171_plugin_slug); ?></option>
											<option value="1"><?php _e('Yes', $advads171_plugin_slug); ?></option>
										</select>
									</td></tr>
								
								<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $advads171_plugin_slug); ?>" class="button-primary" /></td></tr>
								
							</table>						
						</div>
					</div>
				</div>
			</td></tr>
		</table>

		</form>
		<?php endif; ?>
	
	<?php elseif ($tab == 'advanced'): ?>
		
		<?php advads171_prepare_postboxes(); ?>
		
		<div class="advanced_tab_wrap">
		
		<p><?php _e('You can change your plugin settings below. If you have any questions check out our <a target="_blank" href="http://contextazon.com/faq">FAQ</a>', $advads171_plugin_slug); ?></p>
		
		<?php if (isset($error) && strlen($error) > 0): ?>
			<div class="advads171_form_error"><?=$error;?></div>
		<?php endif; ?>
		
		<form method="post" action="" >
			
			<input type="submit" name="submit_all" value="submit all" style="display: none;" />
		
			<div class="metabox-holder">
				<?php /*<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('General Pop-Up Settings', $advads171_plugin_slug); ?></h3>
					<div class="inside">
					
						<table class="form-table" style="width:auto;">				
							<tr class="form-field"><th style="width:150px;"><label for="advads171_serponly"><?php _e('SERP referrals only', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="advads171_serponly" id="advads171_serponly">
										<option value="0"><?php _e('No', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$advads171_serponly == 1?'selected':'';?>><?php _e('Yes', $advads171_plugin_slug); ?> &nbsp; </option>
									</select> <span class="description"><?php _e('If Yes - only show pops to users arrived from search engines directly', $advads171_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_loggedin_hide"><?php _e('Show to Logged in Users', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="advads171_loggedin_hide" id="advads171_loggedin_hide">
										<option value="0"><?php _e('Yes', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$advads171_loggedin_hide == 1?'selected':'';?>><?php _e('No', $advads171_plugin_slug); ?> &nbsp; </option>					
									</select> <span class="description"><?php _e('Has no affect on admin user', $advads171_plugin_slug); ?></span>
								</td></tr>
							<tr class="form-field"><th style="width:150px;"><label for="advads171_sensitivity"><?php _e('Sensitivity', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="advads171_sensitivity" id="advads171_sensitivity">
										<option value="3" <?=$advads171_sensitivity == 3?'selected':'';?>>3 &nbsp; </option>
										<option value="4" <?=$advads171_sensitivity == 4?'selected':'';?>>4 &nbsp; </option>
										<option value="5" <?=$advads171_sensitivity == 5?'selected':'';?>>5 &nbsp; </option>
										<option value="6" <?=$advads171_sensitivity == 6?'selected':'';?>>6 &nbsp; </option>
										<option value="7" <?=$advads171_sensitivity == 7?'selected':'';?>>7 &nbsp; </option>
										<option value="8" <?=$advads171_sensitivity == 8?'selected':'';?>>8 &nbsp; </option>
										<option value="9" <?=$advads171_sensitivity == 9?'selected':'';?>>9 &nbsp; </option>
										<option value="10" <?=$advads171_sensitivity == 10?'selected':'';?>>10 &nbsp; </option>
									</select> <span class="description"><?php _e('If top 10 px of your pages have important links try using lower number here.', $advads171_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_posttypes"><?php _e('Use on Post Types', $advads171_plugin_slug); ?>:</label></th>
								<td class="chkboxes">
									<?php foreach($post_types as $post_type): ?>
									<input type="checkbox" value="<?=$post_type;?>" name="advads171_posttypes[]" id="posttype_<?=$post_type;?>" style="width: 25px;" <?=(in_array($post_type, $advads171_posttypes)?'checked':'');?> /><label for="posttype_<?=$post_type;?>"><?=ucfirst($post_type);?></label><br />
									<?php endforeach; ?>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_pops_per_user"><?php _e('Pop ups per user', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="advads171_pops_per_user" value="<?=$advads171_pops_per_user;?>" id="advads171_pops_per_user" size="10" style="width:60px;" /></td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_default_behavior"><?php _e('Default Behavior', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="advads171_default_behavior" id="advads171_default_behavior">
										<option value="all" <?=$advads171_default_behavior == 'all'?'selected':'';?>><?php _e('Show on All Posts', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="manual" <?=$advads171_default_behavior == 'manual'?'selected':'';?>><?php _e('Show on Selected Posts', $advads171_plugin_slug); ?> &nbsp; </option>					
									</select>
								</td></tr>
							
							<tr><td>&nbsp;</td><td class="submit"><input type="submit" value="<?php _e('Save Settings', $advads171_plugin_slug); ?>" name="save_general" class="button-secondary" /></td></tr>
							
						</table>				
						
					</div>
				</div>
	
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Pop-Up Triggers', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">	
							<tr class="form-field"><th style="width:150px;"><label for="advads171_mouse_trigger_disabled"><?php _e('Top page mouse-over', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="advads171_mouse_trigger_disabled" id="advads171_mouse_trigger_disabled">
										<option value="1"><?php _e('Disabled', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="0" <?=$advads171_mouse_trigger_disabled == 0?'selected':'';?>><?php _e('Enabled', $advads171_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('This is a default trigger. Window pops on mouse-over the top of the page.', $advads171_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_trapped_trigger_enabled"><?php _e('Trapped Exit', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<select name="advads171_trapped_trigger_enabled" id="advads171_trapped_trigger_enabled">
										<option value="0"><?php _e('Disabled', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$advads171_trapped_trigger_enabled == 1?'selected':'';?>><?php _e('Enabled', $advads171_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('Use at your own risk. Search engines may dislike this.', $advads171_plugin_slug); ?></span>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="advads171_trapped_trigger_msg"><?php _e('Trapped Exit Message', $advads171_plugin_slug); ?>:</label></th>
								<td>
									<textarea name="advads171_trapped_trigger_msg" id="advads171_trapped_trigger_msg" placeholder="<?php esc_attr_e('Type your alert message here. ie: WAIT! Click Stay on Page', $advads171_plugin_slug); ?>"><?=$advads171_trapped_trigger_msg;?></textarea>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_unbounce_enabled"><strong><?php _e('Delayed Pop Enabled', $advads171_plugin_slug); ?>:</strong></label></th>
								<td>
									<select name="advads171_unbounce_enabled" id="advads171_unbounce_enabled">
										<option value="0"><?php _e('Disabled', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$advads171_unbounce_enabled == 1?'selected':'';?>><?php _e('Enabled', $advads171_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('Show pop after certain amount of seconds spent on page', $advads171_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_unbounce_delay"><?php _e('Delayed Pop Delay (seconds)', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="advads171_unbounce_delay" value="<?=$advads171_unbounce_delay;?>" id="advads171_unbounce_delay" size="10" style="width:60px;" /></td></tr>
						
							
							<tr><td>&nbsp;</td><td class="submit"><input type="submit" value="<?php _e('Save Settings', $advads171_plugin_slug); ?>" name="save_triggers" class="button-secondary" /></td></tr>
							
						</table>
					</div>
				</div>
				*/ ?>
	
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Keywords', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:750px;">
							<tr><td colspan="2">
								<table class="form-table" style="width:auto;">	
									<tr class="form-field"><th ><label><?php _e('Keyword Sources', $advads171_plugin_slug); ?>:</label></th>
										<td class="chkboxes">
					
												<label for="advads171_kw_sources_serp">
													<input type="checkbox" name="advads171_kw_sources[]" id="advads171_kw_sources_serp" <?=(in_array('serp', $advads171_kw_sources)?'checked':'');?> value="serp" style="width: 25px;" /><?php _e('Pick up search engine keywords (if available)', $advads171_plugin_slug); ?>
												</label>
												<br />
												<label for="advads171_kw_sources_custom">
													<input type="checkbox" name="advads171_kw_sources[]" value="custom" id="advads171_kw_sources_custom" <?=(in_array('custom', $advads171_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Custom Keyword Source (<span class="description">For advanced users <a href="http://contextazon.com/faq/custom-keyword-source/" target="_blank">More Info</a>', $advads171_plugin_slug); ?></span>)
												</label>
												<br />												
												<label for="advads171_kw_sources_content">
													<input type="checkbox" name="advads171_kw_sources[]" value="content" id="advads171_kw_sources_content" <?=(in_array('content', $advads171_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Generate based on post/page content', $advads171_plugin_slug); ?>
												</label>
												<br />
												<label for="advads171_kw_sources_title">
													<input type="checkbox" name="advads171_kw_sources[]" value="title" id="advads171_kw_sources_title" <?=(in_array('title', $advads171_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Use post title (<span class="description">Try the whole title if 4 words or less and then try every word in the title</span>)', $advads171_plugin_slug); ?>
												</label>
												<br />
												<label for="advads171_kw_sources_tags">
													<input type="checkbox" name="advads171_kw_sources[]" value="tags" id="advads171_kw_sources_tags" <?=(in_array('tags', $advads171_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Use post tags', $advads171_plugin_slug); ?>
												</label>
												<br />
												<label for="advads171_kw_sources_categories">
													<input type="checkbox" name="advads171_kw_sources[]" value="categories" id="advads171_kw_sources_categories" <?=(in_array('categories', $advads171_kw_sources)?'checked':'');?> style="width: 25px;"  onclick="javascript: if (jQuery('#advads171_kw_sources_categories').is(':checked')) {jQuery('#cat_kws_postbox').removeClass('closed'); jQuery('html, body').animate({scrollTop: (jQuery('#cat_kws_postbox').offset().top - 30)}, 1000);} else {jQuery('#cat_kws_postbox').addClass('closed');} "  /><?php _e('Use specific keywords per category (* enter below)', $advads171_plugin_slug); ?>
												</label>
												<br />
												<label for="advads171_kw_sources_fallback">
													<input type="checkbox" name="advads171_kw_sources[]" value="fallback" id="advads171_kw_sources_fallback" <?=(in_array('fallback', $advads171_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Use fallback keywords (* enter below)', $advads171_plugin_slug); ?>
												</label>
												<br />
												<span class="description"><?php _e('There are 6 ways to pick keywords. The plugin will attempt all checked methods in the same order as outlined above.', $advads171_plugin_slug); ?> <a href="<?php _e('http://contextazon.com/faq/keyword-generating-methods/', $advads171_plugin_slug); ?>" target="_blank" title="<?php esc_attr_e('Click for help', $advads171_plugin_slug); ?>">?</a></span>
											
										</td></tr>
									
									<tr class="form-field"><th ><label for="advads171_fallback_keywords"><?php _e('Fallback keywords', $advads171_plugin_slug); ?></label></th>
										<td>
											<input type="text" name="advads171_fallback_keywords" id="advads171_fallback_keywords" style="width: 390px;" value="<?=$advads171_fallback_keywords;?>" />
												<?php /*if (advads171_module_installed('amzn')): ?>
													<a href="javascript: advads171_perview(jQuery('#advads171_fallback_keywords').val());" style="float: right;" class="advads171_preview_set advads171_preview_link active"><?php _e('Preview AMZN', $advads171_plugin_slug); ?></a>
												<?php endif; ?>
												<?php if (advads171_module_installed('epn')): ?>
													<a href="javascript: advads171_perview(jQuery('#advads171_fallback_keywords').val(), '1');" style="float: right;" class="advads171_preview_set advads171_preview_link active"><?php _e('Preview ePN', $advads171_plugin_slug); ?></a>
												<?php endif;*/ ?>
											
											<span class="advads171_preview_set advads171_preview_loading"><?php _e('Loading...', $advads171_plugin_slug); ?></span>
											<br />
											<span class="description"><?php _e('Used if no other keywords can be generated', $advads171_plugin_slug); ?></span>
										</td></tr>
										
									<tr class="form-field"><th ><label for="advads171_skip_keywords"><?php _e('Skip these words from keywords', $advads171_plugin_slug); ?> <a href="<?php _e('http://contextazon.com/faq/skip-words-in-keywords/', $advads171_plugin_slug); ?>" target="_blank" title="<?php esc_attr_e('Click for help', $advads171_plugin_slug); ?>">?</a></label></th>
										<td>
											<textarea name="advads171_skip_keywords" id="advads171_skip_keywords" rows="10" style="width: 350px;"><?=$advads171_skip_keywords;?></textarea>
										</td></tr>
									
									<tr class="form-field"><th style="width:150px;"><label for="advads171_min_kw_length"><?php _e('Minimum words in a keyword', $advads171_plugin_slug); ?>:</label></th>
										<td>
											<select name="advads171_min_kw_length" id="advads171_min_kw_length">
												<option value="1" <?=($advads171_min_kw_length === FALSE || $advads171_min_kw_length == '1'?'selected':'');?>>1 &nbsp;</option>
												<option value="2" <?=($advads171_min_kw_length == '2'?'selected':'');?>>2 &nbsp;</option>
											</select>
											<span class="description"><?php _e('2 will get better relevancy but return fewer results', $advads171_plugin_slug); ?></span>
										</td></tr>
									
									
									
								</table>
							</td></tr>
						</table>
					
					<div id="cat_kws_postbox" class="postbox <?=(in_array('categories', $advads171_kw_sources)?'':'closed');?>" style="width: 90%; margin-left: 20px;">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug ); ?>"><br /></div>
						<h3 class="hndle"><?php _e('Category Keywords and Programs', $advads171_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:750px;">
								<tr><td colspan="2">
									<table class="form-table" style="width:auto;">	
										
										<?php
										$categories = get_categories();
										if (!isset($advads171_amzn_disabled_categories)) $advads171_amzn_disabled_categories = array();
										if (!isset($advads171_epn_disabled_categories)) $advads171_epn_disabled_categories = array();

										foreach($categories as $curr_cat):
										?>
										
										<tr class="form-field"><th ><label for="advads171_cat_kws_<?=$curr_cat->term_id;?>"><?=$curr_cat->name;?></label></th>
											<td style="width: 450px;">
												<input type="text" name="advads171_cat_kws_<?=$curr_cat->term_id;?>" class="regular-text" style="width: 300px;" id="advads171_cat_kws_<?=$curr_cat->term_id;?>" value="<?=(isset($advads171_cat_kws[$curr_cat->term_id])?$advads171_cat_kws[$curr_cat->term_id]:'');?>" />
												
												<div style="float: right; width: 140px;">													
														<?php if (advads171_module_installed('amzn')): ?>
															<input type="checkbox" name="advads171_amzn_cat_toggle[]" value="<?=$curr_cat->term_id;?>" id="advads171_amzn_cat_toggle_<?=$curr_cat->term_id;?>" style="width: 12px; margin-right: 5px;" <?=(!in_array($curr_cat->term_id, $advads171_amzn_disabled_categories)?'checked':'');?> /><label for="advads171_amzn_cat_toggle_<?=$curr_cat->term_id;?>">AMZN</label>
														<?php endif; ?>
														
														<?php if (advads171_module_installed('epn')): ?>
															<input type="checkbox" name="advads171_epn_cat_toggle[]" value="<?=$curr_cat->term_id;?>" id="advads171_epn_cat_toggle_<?=$curr_cat->term_id;?>" style="width: 12px; margin-right: 5px; margin-left: 15px;" <?=(!in_array($curr_cat->term_id, $advads171_epn_disabled_categories)?'checked':'');?> /><label for="advads171_epn_cat_toggle_<?=$curr_cat->term_id;?>">ePN</label>
														<?php endif; ?>
												</div>
												
													<?php /*if (advads171_module_installed('epn')): ?>
														<a href="javascript: advads171_perview(jQuery('#advads171_cat_kws_<?=$curr_cat->term_id;?>').val(), '1');" style="float: right;" class="advads171_preview_set advads171_preview_link active"><?php _e('Preview ePN', $advads171_plugin_slug); ?></a>
													<?php endif; ?>
													<?php if (advads171_module_installed('amzn') && advads171_module_installed('epn')): ?><span class="advads171_preview_set advads171_preview_link active"  style="float: right; margin: 0 5px;"> | </span><?php endif; ?>
													<?php if (advads171_module_installed('amzn')): ?>
														<a href="javascript: advads171_perview(jQuery('#advads171_cat_kws_<?=$curr_cat->term_id;?>').val());" style="float: right;" class="advads171_preview_set advads171_preview_link active"><?php _e('Preview AMZN', $advads171_plugin_slug); ?></a>
													<?php endif;*/ ?>
												
												
												<span class="advads171_preview_set advads171_preview_loading"><?php _e('Loading...', $advads171_plugin_slug); ?></span>
											</td></tr>
										<?php 
										endforeach;?>

									</table>
								</td></tr>
							</table>

							<div ><?php _e('Use checkboxes to toggle on/off product sources on those categories.', $advads171_plugin_slug); ?></div>
						
						</div>
					</div>	

					<table>
						<tr><td style="width: 188px;">&nbsp;</td><td class="submit"><input type="submit" name="save_keywords" value="<?php esc_attr_e( 'Save Settings', $advads171_plugin_slug); ?>" /></td></tr>
					</table>
				
				</div>
				</div>
				
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $advads171_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Misc', $advads171_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">	
							<tr class="form-field"><th style="width:150px;"><label for="advads171_posttypes"><?php _e('Use on Post Types', $advads171_plugin_slug); ?>:</label></th>
								<td class="chkboxes">
									<?php foreach($post_types as $post_type): ?>
									<input type="checkbox" value="<?=$post_type;?>" name="advads171_posttypes[]" id="posttype_<?=$post_type;?>" style="width: 25px;" <?=(in_array($post_type, $advads171_posttypes)?'checked':'');?> /><label for="posttype_<?=$post_type;?>"><?=ucfirst($post_type);?></label><br />
									<?php endforeach; ?>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="advads171_show_promo_msgs"><?php _e('Admin Notifications', $advads171_plugin_slug); ?></label></th>
								<td>									
									<select name="advads171_show_promo_msgs" id="advads171_show_promo_msgs">
										<option value="0" <?=$advads171_show_promo_msgs == '0'?'selected':'';?>><?php _e('Disabled', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$advads171_show_promo_msgs == '1' || $advads171_show_promo_msgs === FALSE?'selected':'';?>><?php _e('Enabled', $advads171_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('Show me important update notifications, occassional promo messages, messages about new add-ons', $advads171_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_path_to_geoip_dat"><?php _e('Path to GeoIP.dat', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="advads171_path_to_geoip_dat" value="<?=$advads171_path_to_geoip_dat;?>" id="advads171_path_to_geoip_dat" size="10" style="width:400px;" />
									<span class="description"><?php _e('(optional) If you have your own MaxMind&reg; country ip database you can enter the full path here (i.e., /home/web/GeoIP.dat)', $advads171_plugin_slug); ?></span>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="advads171_visitor_log_days"><?php _e('Days to Store Visitor Log', $advads171_plugin_slug); ?>:</label></th>
								<td><input type="text" name="advads171_visitor_log_days" value="<?=($advads171_visitor_log_days === FALSE || $advads171_visitor_log_days < 1?'60':$advads171_visitor_log_days);?>" id="advads171_visitor_log_days" size="10" style="width:60px;" />
									<span class="description"><?php _e('How many days to store visitor log for.', $advads171_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="advads171_unsupported_country_default"><?php _e('If country not supported then show', $advads171_plugin_slug); ?>:</label></th>
								<td>									
									<select name="advads171_unsupported_country_default" id="advads171_unsupported_country_default">
										<option value="none" <?=$advads171_unsupported_country_default === FALSE || $advads171_unsupported_country_default == 'none'?'selected':'';?>><?php _e('Nothing', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="us" <?=$advads171_unsupported_country_default == 'us'?'selected':'';?>><?php _e('US listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="uk" <?=$advads171_unsupported_country_default == 'uk'?'selected':'';?>><?php _e('UK listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="ca" <?=$advads171_unsupported_country_default == 'ca'?'selected':'';?>><?php _e('CA listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="de" <?=$advads171_unsupported_country_default == 'de'?'selected':'';?>><?php _e('DE listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="fr" <?=$advads171_unsupported_country_default == 'fr'?'selected':'';?>><?php _e('FR listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="it" <?=$advads171_unsupported_country_default == 'it'?'selected':'';?>><?php _e('IT listings', $advads171_plugin_slug); ?> &nbsp; </option>
										<option value="es" <?=$advads171_unsupported_country_default == 'es'?'selected':'';?>><?php _e('ES listings', $advads171_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('If user\'s country not supported do this', $advads171_plugin_slug); ?></span>
								</td></tr>
						
							
							<tr><td>&nbsp;</td><td class="submit"><input type="submit" value="<?php _e('Save Settings', $advads171_plugin_slug); ?>" name="save_misc" class="button-secondary" /></td></tr>
							
						</table>
					</div>
				</div>
				
				
			</div><!-- end of keywords postbox -->

		
			<input type="submit" value="<?php _e('Save All Settings', $advads171_plugin_slug); ?>" name="save_all_settings" class="button-primary" />
			
			<input type="hidden" name="advads171_form_submitted" value="yes" />
		</form>
		</div>
		
		<?php advads171_prepare_kws_pop_preview(); ?>	
	<?php endif; ?>	
	<?php
	echo '</div>';
}




$advads171_active_real = get_option('advads171_active');

if ($advads171_active_real == '1')
{
	$advads171_prefix = 'advads171_';

	$advads171_posttypes_str = get_option('advads171_posttypes');
	$advads171_posttypes = explode(',', $advads171_posttypes_str);
	
	$advads171_default_behavior = get_option('advads171_default_behavior');
	/*if ($advads171_default_behavior == 'all')
	{*/
		$advads171_disable_enable = array(
				'name' => __('Hide Banners on this Post/Page', $advads171_plugin_slug),
				'desc' => sprintf(__('Check to disable %s banners on this post/page.', $advads171_plugin_slug), $advads171_plugin_name),
				'id' => $advads171_prefix . 'disable',
				'type' => 'checkbox'
			);
	/*}
	else
	{
		$advads171_disable_enable = array(
				'name' => __('Enable For This Item', $advads171_plugin_slug),
				'desc' => sprintf(__('Enable %s window pop for this item.', $advads171_plugin_slug), $advads171_plugin_name),
				'id' => $advads171_prefix . 'enable',
				'type' => 'checkbox'
			);
	}*/
	

	$advads171_meta_box = array(
		'id' => 'advads171-meta-box',
		'title' => sprintf(__('%s Data', $advads171_plugin_slug), $advads171_plugin_name),
		'pages' => $advads171_posttypes,
		'context' => 'normal',
		'priority' => 'high',
		'fields' => array(
			array(
				'name' => __('Keywords', $advads171_plugin_slug),
				'desc' => __('You can change keywords used for looking up products on Amazon. Comma separated.', $advads171_plugin_slug).' <span class="advads171_preview_set advads171_preview_loading">'.__('Loading...', $advads171_plugin_slug).'</span><br />' //.
					/*(advads171_module_installed('amzn')?'<a href="javascript: advads171_perview();" class="advads171_preview_set advads171_preview_link active">'.__('Preview AMZN', $advads171_plugin_slug).'</a>':'').
					(advads171_module_installed('amzn') && advads171_module_installed('epn')?'<span class="advads171_preview_set advads171_preview_link active" style="margin: 0 5px;"> | </span>':'').
					(advads171_module_installed('epn')?'<a href="javascript: advads171_perview(1);" class="advads171_preview_set advads171_preview_link active">'.__('Preview ePN', $advads171_plugin_slug).'</a>':'')*/,
				'id' => $advads171_prefix . 'keywords',
				'type' => 'text'
			), 
			$advads171_disable_enable	
			
		)
	);

	add_action('admin_init', 'advads171_add_box');

	// Add meta box
	function advads171_add_box() {
		global $advads171_meta_box;
		if ( current_user_can('administrator') ) {
			foreach ($advads171_meta_box['pages'] as $page) {
			add_meta_box($advads171_meta_box['id'], $advads171_meta_box['title'], 'advads171_show_box', $page, $advads171_meta_box['context'], $advads171_meta_box['priority']);
			}
		}
		//add_meta_box($advads171_meta_box['id'], $advads171_meta_box['title'], 'advads171_show_box', $advads171_meta_box['page'], $advads171_meta_box['context'], $advads171_meta_box['priority']);
		//add_meta_box($advads171_meta_box['id'], $advads171_meta_box['title'], 'advads171_show_box', $advads171_meta_box['page'], $advads171_meta_box['context'], $advads171_meta_box['priority']);
	}

	// Callback function to show fields in meta box
	function advads171_show_box() {
		global $advads171_meta_box, $post, $advads171_addons, $advads171_plugin_slug, $advads171_plugin_name;
		
		
		/*echo '<pre>';
		print_r($post);
		echo '</pre>';
		$meta_kw_check = get_post_meta($post->ID, 'advads171_keywords', true);
		echo '<pre>';
		print_r($meta_kw_check);
		echo '</pre>';
		exit;*/
		//check if kw generated
		$meta_kw_check = get_post_meta($post->ID, 'advads171_keywords', true);
		if ($meta_kw_check === FALSE || strlen($meta_kw_check) == 0)
		{
			$advads171_post_content = apply_filters('the_content',$post->post_content);
			$advads171_post_content = advads171_remove_html($advads171_post_content);
			$advads171_post_content = strip_tags($advads171_post_content);
			$advads171_kws = advads171_gen_kws($advads171_post_content, $post->post_title, $post->ID);
			if (count($advads171_kws) > 0)
			{
				update_post_meta($post->ID, 'advads171_keywords', implode(',', $advads171_kws));
			}
		}
		
		//BOF include advads171 js for preview
		wp_enqueue_style( $advads171_plugin_slug, plugins_url( $advads171_plugin_slug.'/style.css' , dirname(__FILE__) ), false, '1.1');
		?>
		<div id="am_popbox" style="display: none;">
			<div id="am_interior">
				<?php _e('Thank you for visiting our site.', $advads171_plugin_slug); ?>
				<br /><a href="javascript:void(0);" class="close"><?php _e('Close', $advads171_plugin_slug); ?></a>			
			</div>		
		</div>
		
		<div id="advads171_audio_player"></div>
		
		<?php
		$advads171_preview_tpl = 'tpl_am3across';
		if (advads171_get_option('tpl_am3across_enabled') != 1 && advads171_get_option('tpl_am1product_enabled') == 1)
		{
			$advads171_preview_tpl = 'tpl_am1product';
		}
		$advads171_msgs = advads171_get_pop_messages($advads171_preview_tpl);
		$advads171_preview_msg = $advads171_msgs[array_rand($advads171_msgs)];
		
		$advads171_audio = advads171_get_option($advads171_preview_tpl.'_audio');
		?>
		<script type="text/javascript">		
		  var advads171_preview_loaded = false;
		  function advads171_perview(source)
		  {
			var loading_script = 'ampop_results.php';
			if (source == undefined)
			{
				source = '0';
			}
			if (source == '1')
			{
				loading_script = 'epnpop_results.php';
			}
			jQuery('.advads171_preview_set').removeClass('active');
			jQuery('.advads171_preview_loading').addClass('active');
			//jQuery("#am_interior").html('');
			if (advads171_preview_loaded == false)
			{
				<?php
				//fix calls from www. to non-www etc
				$advads171_ampop_results_url = site_url('wp-content/plugins/'.$advads171_plugin_slug.'/');				
				if (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' && substr($advads171_ampop_results_url, 0, 11) != 'http://www.' && substr($advads171_ampop_results_url, 0, 12) != 'https://www.')
				{
					if (substr($advads171_ampop_results_url, 0, 7) == 'http://') $advads171_ampop_results_url = str_replace('http://', 'http://www.', $advads171_ampop_results_url);
					if (substr($advads171_ampop_results_url, 0, 8) == 'https://') $advads171_ampop_results_url = str_replace('https://', 'https://www.', $advads171_ampop_results_url);
				}
				elseif (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) != 'www.' && (substr($advads171_ampop_results_url, 0, 11) == 'http://www.' || substr($advads171_ampop_results_url, 0, 12) == 'https://www.'))
				{
					if (substr($advads171_ampop_results_url, 0, 7) == 'http://') $advads171_ampop_results_url = str_replace('http://', 'http://www.', $advads171_ampop_results_url);
					if (substr($advads171_ampop_results_url, 0, 8) == 'https://') $advads171_ampop_results_url = str_replace('https://', 'https://www.', $advads171_ampop_results_url);
				}
				?>
				//jQuery("#am_interior").load("<?=$advads171_ampop_results_url;?>?post_id=<?=$post->ID;?>&preview=yes&tpl=<?=($advads171_preview_tpl == 'tpl_am3across'?0:1);?>", {preview_keywords:jQuery('#advads171_keywords').val()}, function () {
				var handling_script = "<?=$advads171_ampop_results_url;?>" + loading_script;
				jQuery.ajax({
				  url: handling_script + "?post_id=<?=$post->ID;?>&preview=yes&tpl=<?=($advads171_preview_tpl == 'tpl_am3across'?0:1);?>",
				  type: "POST",
				  data:  {preview_keywords:jQuery('#advads171_keywords').val()},
				  success: function(data) {
					//var obj = jQuery.parseJSON(data);
					var obj = JSON.parse(data);
					var pop_html = obj.html;
					jQuery("#am_interior").html(pop_html);
					
					if (obj.jscripts != undefined && obj.jscripts.length > 0)
					{
						jQuery("#advads171_js_content").html("<iframe src=\""+ obj.jscripts +"\" style='border: 0px; widht: <?=advads171_get_option($advads171_preview_tpl."_pop_width");?>px; height: <?=(advads171_get_option($advads171_preview_tpl."_pop_height") - 80);?>px;' width='<?=advads171_get_option($advads171_preview_tpl."_pop_width");?>' height='<?=(advads171_get_option($advads171_preview_tpl."_pop_height") - 80);?>' scrolling='no' border='0'></iframe>");
					}
				am_loaded = true;
				//advads171_preview_loaded = true;
				advads171_preview_pop();	
				}
				});
			}
			else
			{
				advads171_preview_pop();
			}
		  }
		function advads171_preview_pop()
		{
			jQuery('.prod_img_link_epn img').css('visibility', 'hidden');
			jQuery('#am_interior').css('width', '<?=advads171_get_option($advads171_preview_tpl."_pop_width");?>' + 'px');
			jQuery('#am_interior').css('height', '<?=advads171_get_option($advads171_preview_tpl."_pop_height");?>' + 'px');
			jQuery('#am_interior').css('border-width', '<?=advads171_get_option($advads171_preview_tpl."_border_width");?>' + 'px');
			jQuery('#am_interior').css('border-style', '<?=advads171_get_option($advads171_preview_tpl."_border_type");?>');
			jQuery('#am_interior').css('border-color', '<?=advads171_get_option($advads171_preview_tpl."_border_color");?>');
			jQuery('.pop_title_advads').html('<?=addslashes($advads171_preview_msg);?>');
			jQuery('.pop_title_advads').css('font-size', '<?=advads171_get_option($advads171_preview_tpl."_message_fontsize");?>' + 'px');
			jQuery('.pop_title_advads').css('min-height', '<?=advads171_get_option($advads171_preview_tpl."_message_fontsize");?>' + 'px');
			jQuery('.pop_title_advads').css('color', '<?=advads171_get_option($advads171_preview_tpl."_message_color");?>');
			<?php if (advads171_get_option($advads171_preview_tpl."_branding") == 'no'): ?>
				jQuery('.advads171_poweredby').css('display', 'none');
			<?php else: ?>
				jQuery('.advads171_poweredby').css('display', 'block');
			<?php endif; ?>
			<?php
			$advads171_amzn_button_img = advads171_get_option($advads171_preview_tpl."_amzn_button_img");
			$advads171_epn_button_img = advads171_get_option($advads171_preview_tpl."_epn_button_img");
			$advads171_epn_bid_button_img = advads171_get_option($advads171_preview_tpl."_epn_bid_button_img");
			?>
			if (((jQuery('.amzn_buy_now_advads171_text').length > 0 || jQuery('.amzn_buy_now_large_advads171_text').length > 0) && '<?=$advads171_amzn_button_img;?>' != '' && '<?=$advads171_amzn_button_img;?>' != ' ') || ((jQuery('.epn_buy_now_advads171_text').length > 0 || jQuery('.epn_buy_now_large_advads171_text').length > 0) && '<?=$advads171_epn_button_img;?>' != '' && '<?=$advads171_epn_button_img;?>' != ' ') || ((jQuery('.epn_bid_now_advads171_text').length > 0 || jQuery('.epn_bid_now_large_advads171_text').length > 0) && '<?=$advads171_epn_bid_button_img;?>' != '' && '<?=$advads171_epn_bid_button_img;?>' != ' '))
			{
				jQuery('.amzn_buy_now_advads171_text, .amzn_buy_now_large_advads171_text').html('<img src="' + '<?=$advads171_amzn_button_img;?>' + '" />').addClass('advads171_image_button_link');
				jQuery('.epn_buy_now_advads171_text, .epn_buy_now_large_advads171_text').html('<img src="' + '<?=$advads171_epn_button_img;?>' + '" />').addClass('advads171_image_button_link');
				jQuery('.epn_bid_now_advads171_text, .epn_bid_now_large_advads171_text').html('<img src="' + '<?=$advads171_epn_bid_button_img;?>' + '" />').addClass('advads171_image_button_link');
			}
			else
			{
				jQuery('.buy_now_advads171_text, .buy_now_large_advads171_text').text('<?=advads171_get_option($advads171_preview_tpl."_button_text");?>');
				//button css
				jQuery('.buy_now_advads, .buy_now_large_advads').css('color', '<?=advads171_get_option($advads171_preview_tpl."_button_text_color");?>');
				jQuery('.buy_now_advads, .buy_now_large_advads').css('background-color', '<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>');
				jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>');
				if (jQuery.browser.mozilla && jQuery.browser.version > 3.5)
				{
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-moz-linear-gradient(top,  '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>' +' 1%, '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%, '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>' +' 52%, '+ '<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>' +' 100%)');
				}
				else if (jQuery.browser.opera && jQuery.browser.version > 11.1)
				{
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-o-linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
				}
				else if ((jQuery.browser.chrome && jQuery.browser.version < 10) || (jQuery.browser.safari && (jQuery.browser.version < 5.1 && jQuery.browser.version > 3.9)))
				{
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-webkit-gradient(linear, left top, left bottom, color-stop(1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+'), color-stop(50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+'), color-stop(52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+'), color-stop(100%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+'))');
				}
				else if ((jQuery.browser.chrome && jQuery.browser.version > 9.9) || (jQuery.browser.safari &&  jQuery.browser.version > 5) || jQuery.browser.webkit)
				{
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-webkit-linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
				}
				else if ((jQuery.browser.msie && jQuery.browser.version > 9.9))
				{
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background', '-ms-linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
				}
				else if ((jQuery.browser.msie && jQuery.browser.version > 5.9 && jQuery.browser.version < 10))
				{
					jQuery('.buy_now_advads, .buy_now_large_advads').css('filter', 'progid:DXImageTransform.Microsoft.gradient( startColorstr=\''+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+'\', endColorstr=\''+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+'\',GradientType=0 )');
				}
				else
				{
					jQuery('.buy_now_advads, .buy_now_large_advads').css('background', 'linear-gradient(top,  '+'<?=advads171_get_option($advads171_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=advads171_get_option($advads171_preview_tpl."_button_color_bottom");?>'+' 100%)');
				}
			}
			
			<?php if (isset($advads171_addons) && is_array($advads171_addons) && in_array('amzn_cart', $advads171_addons) && advads171_get_option('amzn_cart_enabled') == 'yes'): ?>
				<?php
				if ($advads171_preview_tpl == 'tpl_am3across')
				{
					$advads171_amzn_cart_btn_text = advads171_get_option("amzn_cart_btn_text_3prods");
					$advads171_addtocart_image = advads171_get_option("addtocart_tpl1");
				}
				elseif ($advads171_preview_tpl == 'tpl_am1product')
				{
					$advads171_amzn_cart_btn_text = advads171_get_option("amzn_cart_btn_text_1prod");
					$advads171_addtocart_image = advads171_get_option("addtocart_tpl2");
				}
				if ($advads171_amzn_cart_btn_text === FALSE || strlen(trim($advads171_amzn_cart_btn_text)) == 0)
				{
					$advads171_amzn_cart_btn_text = __('Add To Cart', $advads171_plugin_slug);
				}
				?>
					jQuery('.buy_now_advads171_text, .buy_now_large_advads171_text').removeClass('advads171_image_button_link');
					jQuery('.buy_now_advads171_text, .buy_now_large_advads171_text').text('<?=$advads171_amzn_cart_btn_text;?>');

				<?php if ($advads171_addtocart_image !== FALSE && strlen($advads171_addtocart_image) > 0): ?>
					jQuery('.amzn_buy_now_advads171_text, .amzn_buy_now_large_advads171_text').html('<img src="<?=$advads171_addtocart_image;?>" />').addClass('advads171_image_button_link');
				<?php endif; ?>

			<?php endif; ?>
			
			if ( '<?=advads171_get_option($advads171_preview_tpl."_close_btn");?>' == 'xbtn')
			{
				jQuery('.am_close_btn_advads').css('display', 'block');
				jQuery('.am_close_txt').css('display', 'none');				
			}
			else
			{
				jQuery('.am_close_txt').css('display', 'block');
				jQuery('.am_close_btn_advads').css('display', 'none');
			}
			
			jQuery("#am_popbox").fadeIn(1000);
			align_product_images();
			advads171_play_audio();
			
			jQuery('.advads171_preview_set').removeClass('active');
			jQuery('.advads171_preview_link').addClass('active');
		}
		function align_product_images()
		{
			if (jQuery('.prod_img_link_epn').length > 0)
			{
				jQuery('.prod_img_link_epn img').each(function() {
					var img_height = jQuery(this).height();
					if (img_height == 0 || img_height == undefined)
					{
						img_height = 140;
					}
					if (jQuery(this).hasClass('epn_image_oneprod'))
					{
						var margin_top = Math.floor((270 - img_height) / 2);
					}
					else
					{
						var margin_top = Math.floor((190 - img_height) / 2);
					}
					jQuery(this).css('margin-top', margin_top);
				});
			}
			jQuery('.prod_img_link_epn img').css('visibility', 'visible');
		}
		function pbox_close()
		{
			jQuery("#am_popbox").hide(function(){jQuery(this).unbind()});
		}
		
		var advads171_audio_plays = 0;
		function advads171_play_audio()
		{
			<?php if ($advads171_audio !== FALSE && strlen(trim($advads171_audio)) > 0): ?>
			var advads171_audio_mp3 = '<?php echo $advads171_audio; ?>';
			if (advads171_audio_mp3 != '')
			{
				jQuery("#advads171_audio_player").jPlayer({
				  ready: function () {
				   jQuery(this).jPlayer("setMedia", {
					mp3: advads171_audio_mp3,
				   }).jPlayer('play');
				   advads171_audio_plays = advads171_audio_plays + 1;
				  },
				  swfPath: '<?=plugins_url( $advads171_plugin_slug.'/js/' , dirname(__FILE__) );?>',
				  supplied: "mp3"
				 });
				 if (advads171_audio_plays != 0)
				 {
					jQuery('#advads171_audio_player').jPlayer('play');
				 }
			 }
			//jQuery('#advads171_audio_player').jPlayer('play');		
			<?php endif; ?>
		}
		  </script>
		<style>
		.advads171_preview_set {display: none;}
		.advads171_preview_set.active {display: inline-block;}
		</style>
		
		<?php

		
		// Use nonce for verification
		echo '<input type="hidden" name="mytheme_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
		
		echo '<table class="form-table">';

		foreach ($advads171_meta_box['fields'] as $field) {
			// get current post meta data
			$meta = get_post_meta($post->ID, $field['id'], true);
			
			echo '<tr>',
					'<th style="width:140px;"><label for="', $field['id'], '">', $field['name'], '</label></th>',
					'<td>';
			switch ($field['type']) {
				case 'text':
					echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
					break;
				case 'textsmall':
					echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:70px;" />', '<br />', $field['desc'];
					break;
				case 'textarea':
					echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
					break;
				case 'select':
					echo '<select name="', $field['id'], '" id="', $field['id'], '">';
					foreach ($field['options'] as $option) {
						echo '<option', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
					}
					echo '</select>';
					break;
				case 'radio':
					foreach ($field['options'] as $option) {
						echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
					}
					break;
				case 'checkbox':
					echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
					break;
			}
			echo     '<td>',
				'</tr>';
		}
		
		echo '</table>';
	}


	add_action('save_post', 'advads171_save_data', 90);

	// Save data from meta box
	function advads171_save_data($post_id) {
		global $advads171_meta_box;
		
		// verify nonce
		if (!wp_verify_nonce($_POST['mytheme_meta_box_nonce'], basename(__FILE__))) {
			return $post_id;
		}

		// check autosave
		if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
			return $post_id;
		}

		// check permissions
		if ('page' == $_POST['post_type']) {
			if (!current_user_can('edit_page', $post_id)) {
				return $post_id;
			}
		} elseif (!current_user_can('edit_post', $post_id)) {
			return $post_id;
		}
		
		foreach ($advads171_meta_box['fields'] as $field) {
			$old = get_post_meta($post_id, $field['id'], true);
			$new = $_POST[$field['id']];
			if (strlen($new) > 0 && $new != $old) {
				//echo '<Br />update'.$field['id'].$new;
				update_post_meta($post_id, $field['id'], $new);
			} elseif ('' == $new && $old) {
				delete_post_meta($post_id, $field['id'], $old);
			}
		}
		advads171_delete_cache($post_id);
		//exit;
	}

}

function advads171_is_serp_direct()
{
	$referer = $_SERVER['HTTP_REFERER'];
    $engines = array('aol'      => 'q=',
                     'ask'      => 'q=',
                     'google'   => 'q=',
                     'bing'     => 'q=',
                     'hotbot'   => 'q=',
                     'teoma'    => 'q=',
                     'yahoo'    => 'p=',
                     'altavista'=> 'p=',
                     'lycos'    => 'query=',
                     'kanoodle' => 'query='
                     );
 
    foreach($engines as $engine => $query_param) {
        // Check if the referer is a search engine from our list.
        // Also check if the query parameter is valid.
        if (strpos($referer, $engine.".") !==  false && 
            strpos($referer, $query_param) !==  false) { 
            // Grab the keyword from the referer url
            $referer .= "&";
            $pattern = "/[?&]{$query_param}(.*?)&/si";
            preg_match($pattern, $referer, $matches);
            return true;
        }   
    }
    return false;
}

function advads171_pickup_serp_kws()
{
	$referer = $_SERVER['HTTP_REFERER'];
    $engines = array('aol'      => 'q=',
                     'ask'      => 'q=',
                     'google'   => 'q=',
                     'bing'     => 'q=',
                     'hotbot'   => 'q=',
                     'teoma'    => 'q=',
                     'yahoo'    => 'p=',
                     'altavista'=> 'p=',
                     'lycos'    => 'query=',
                     'kanoodle' => 'query='
                     );
 
    foreach($engines as $engine => $query_param) {
        // Check if the referer is a search engine from our list.
        // Also check if the query parameter is valid.
        if (strpos($referer, $engine.".") !==  false && 
            strpos($referer, $query_param) !==  false) { 
            // Grab the keyword from the referer url
            $referer .= "&";
            $pattern = "/[?&]{$query_param}(.*?)&/si";
            preg_match($pattern, $referer, $matches);
			if (isset($matches[1]) && strlen($matches[1]) > 0)
			{
				setcookie("advads171_serp_kws", urldecode(trim($matches[1])), time()+900, '/');
				return true;
			}            
        }   
    }
}

//WPMS functions
function add_new_blog_advads171($blog_id, $user_id, $domain, $path, $site_id, $meta) {
	global $wpdb;
	set_time_limit(300);
    // Make sure the user can perform this action and the request came from the correct page.
    switch_to_blog($blog_id);
	//just add default options
	advads171_add_options();
	
	//copy settings from default blog
	$default_blog_id = advads171_wpms_get_default_blog_id();
	if ($default_blog_id != 'none')
	{
		restore_current_blog();
		$advads171_current_site = get_blog_details($default_blog_id);
		$advads171_standard_options = advads171_get_general_options_arr();

		//get general options of 'copy from' blog
		$general_options = array();					
		foreach($advads171_standard_options as $loop_option)
		{
			$general_options[$loop_option] = get_option($loop_option);
		}
		//get all advads171 options of 'copy from' blog
		$advads171_options_source = $wpdb->get_results( "SELECT * FROM ".$wpdb->prefix."advads171_options" );

		//search for license name and email in 'copy from' data
		$license_name = '';
		$license_email = '';
		foreach($advads171_options_source as $row)
		{
			if ($row->name == 'license_name')
			{
				$license_name = $row->value;
			}
			if ($row->name == 'license_email')
			{
				$license_email = $row->value;
			}
		}
		
		restore_current_blog();
		//apply setting to just created blog
		switch_to_blog($blog_id);		

		set_time_limit(300);
		//update general options
		foreach($general_options as $key => $val)
		{
			if ($key != '')
			{
				update_option($key, $val);
			}
		}					
		
		//update advads171 options
		if (count($advads171_options_source) > 0)
		{
			//activate current site
			advads171_activate_license_wpms($license_name, $license_email);
			
			foreach($advads171_options_source as $row)
			{
				if ($row->name != 'license')
				{
					advads171_update_option($row->name, $row->value);
				}
			}
		}
	}
	
    restore_current_blog();
}

if (defined('MULTISITE') && (MULTISITE === TRUE || MULTISITE == 1))
{
	add_action( 'wpmu_new_blog', 'add_new_blog_advads171' );
}

function advads171_wpms_apply_to_all()
{
	global $blog_id, $wpdb;
	$advads171_curr_user = wp_get_current_user();
	if (0 != $advads171_curr_user->ID)
	{
		$advads171_blogs = get_blogs_of_user($advads171_curr_user->ID);
		$advads171_current_site = get_blog_details($blog_id);
		$advads171_standard_options = advads171_get_general_options_arr();
		if (count($advads171_blogs) > 0)
		{
			//get general options of 'copy from' blog
			$general_options = array();					
			foreach($advads171_standard_options as $loop_option)
			{
				$general_options[$loop_option] = get_option($loop_option);
			}
			//get all advads171 options of 'copy from' blog
			$advads171_options_source = $wpdb->get_results( "SELECT * FROM ".$wpdb->prefix."advads171_options" );

			//search for license name and email in 'copy from' data
			$license_name = '';
			$license_email = '';
			foreach($advads171_options_source as $row)
			{
				if ($row->name == 'license_name')
				{
					$license_name = $row->value;
				}
				if ($row->name == 'license_email')
				{
					$license_email = $row->value;
				}
			}
			
			foreach($advads171_blogs as $loop_blog)
			{				
				if ($advads171_current_site->blog_id != $loop_blog->userblog_id)
				{
					set_time_limit(300);
					switch_to_blog($loop_blog->userblog_id);
					//update general options
					foreach($general_options as $key => $val)
					{
						if ($key != '')
						{
							update_option($key, $val);
						}
					}					
					
					//update advads171 options
					if (count($advads171_options_source) > 0)
					{
						//activate current site
						advads171_activate_license_wpms($license_name, $license_email);
						
						foreach($advads171_options_source as $row)
						{
							if ($row->name != 'license')
							{
								advads171_update_option($row->name, $row->value);
							}
						}
					}
					//restore_current_blog();
				}
			}
			switch_to_blog($advads171_current_site->blog_id);
			
		}
	}
}

function advads171_get_general_options_arr()
{
	$options = array(
		'advads171_active', 
		'advads171_activated', 
		'advads171_am_key_id', 
		'advads171_am_access_key', 
		'advads171_am_associate_tag', 
		'advads171_am_searchindex', 
		'advads171_skip_noimage',
		'advads171_serponly',
		'advads171_loggedin_hide',
		'advads171_sensitivity',
		'advads171_posttypes',
		'advads171_pops_per_user',
		'advads171_default_behavior',
		'advads171_unbounce_enabled',
		'advads171_unbounce_delay',
		'msg_sequence',
		'advads171_version',
		'advads171_db_version'
		);
		return $options;
}

function advads171_activate_license_wpms($name = '', $email = '')
{
	global $wpdb;
	//send license request
	$call_data = array(
						'email' => $email,
						'name' => $name,
						'site' => get_bloginfo('url')
						);

	$response = advads171_call($call_data, 'http://216.172.160.106/advads/activate/site');
	
	//update db
	if (isset($response->sql) && strlen(trim($response->sql)) > 0)
	{
		$sql_str = str_replace('##TBLPREFIX##', $wpdb->prefix, $response->sql);
		$charset_collate = '';
		if (strlen($wpdb->charset) > 0)	$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		$sql_str = str_replace('##TBLCHARSET##', $charset_collate, $sql_str);
		
		foreach(explode("##BREAK##", $sql_str) as $curr_sql)
		{					
			$wpdb->query($curr_sql);
		}
	}
}

function advads171_wpms_save_default_blog_id($blog_id = 'all')
{
	global $wpdb;
	$sql = "SELECT * FROM advads171_wpms_global_settings WHERE `name` = 'default_blog_id' LIMIT 1";
	$res = $wpdb->get_row($sql);
	if ($res === NULL)
	{
		advads171_multisite_setup_tbl();
		
		$sql = "INSERT INTO `advads171_wpms_global_settings` (`name`, `value`) VALUES ('default_blog_id', '".$wpdb->escape($blog_id)."');";
		$wpdb->query($sql);
	}
	else
	{
		$sql = "UPDATE `advads171_wpms_global_settings` SET `value` = '".$wpdb->escape($blog_id)."' WHERE `name` = 'default_blog_id' LIMIT 1";
		$wpdb->query($sql);
	}
}

function advads171_wpms_get_default_blog_id()
{
	global $wpdb;
	$blog_id = 'none';
	
	$sql = "SELECT * FROM advads171_wpms_global_settings WHERE `name` = 'default_blog_id' LIMIT 1";
	$res = $wpdb->get_row($sql);
	if ($res !== NULL && isset($res->value))
	{
		$blog_id = $res->value;
	}
	return $blog_id;
}

$advads171_show_promo_msgs = advads171_get_option('advads171_show_promo_msgs', is_multisite());
if ($advads171_show_promo_msgs === FALSE || $advads171_show_promo_msgs == '1')
{
	//show the message
	$advads171_promo_msg_raw = advads171_get_option('advads171_promo_msg', is_multisite());
	if ($advads171_promo_msg_raw !== FALSE && $advads171_promo_msg_raw != '')
	{
		$advads171_promo_msg = unserialize($advads171_promo_msg_raw);
		if (isset($advads171_promo_msg['msg_id']))
		{
			if ($advads171_promo_msg['clicked_hide'] == '0' && $advads171_promo_msg['clicked_link'] == '0' && ($advads171_promo_msg['expires'] == '0' || $advads171_promo_msg['expires'] > time()))
			{
				$advads171_promo_msg['views'] = $advads171_promo_msg['views'] + 1;
				advads171_update_option('advads171_promo_msg', serialize($advads171_promo_msg), is_multisite());
				$advads171_promo_msg_html = $advads171_promo_msg['html'];
				add_action('admin_notices', 'advads171_msg_warning');
				add_action('network_admin_notices', 'advads171_msg_warning');				
			}
		}
	}
	wp_enqueue_style('thickbox');
	wp_enqueue_script('thickbox');
	add_action('admin_head', 'advads171_promo_msg_bind_clicks_javascript');
	
	//update with the new msg
	$advads171_promo_msg_last_check = advads171_get_option('advads171_promo_msg_last_check', is_multisite());
	if ($advads171_promo_msg_last_check === FALSE || (time() - $advads171_promo_msg_last_check) > 3600)
	{
		add_action('admin_head', 'advads171_promo_msg_javascript');	
	}
}

function advads171_msg_warning() {
	global $advads171_promo_msg_html, $advads171_plugin_slug;
		$advads171_promo_msg_html = str_replace("#update_details_link#", network_admin_url('plugin-install.php?tab=plugin-information&plugin='.$advads171_plugin_slug.'&TB_iframe=true&width=640&height=341'), $advads171_promo_msg_html);
		$advads171_promo_msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$advads171_plugin_slug.'%2F'.$advads171_plugin_slug.'.php'), "upgrade-plugin_".$advads171_plugin_slug."/".$advads171_plugin_slug.".php"), $advads171_promo_msg_html);

		echo $advads171_promo_msg_html;
	}

//init before/after content filters
function advads171_content_filter($content) 
{
	global $post, $advads171_plugin_slug, $advads171_plugin_name, $advads171_unique_banner_id;
	require_once(dirname(__FILE__).'/app/models/banners.php');
	$banners = new advads171_banners;
	$banners_data = $banners->banners_data();
	
	$before_content = '';
	$after_content = '';

	if (isset($banners_data['banners']) && count($banners_data['banners']) > 0)
	{
		foreach($banners_data['banners'] as $banner_id => $banner)
		{
			if ($banner['position'] == 3)
			{
				$before_content .= $banners->banner_html_init($banner_id, $banner, $post->ID, $content);
			}
			if ($banner['position'] == 4)
			{
				$after_content .= $banners->banner_html_init($banner_id, $banner, $post->ID, $content);
			}
		}
	}
	
	return $before_content.$content.$after_content;
}

add_filter( 'the_content', 'advads171_content_filter', 99999);	




//$api_url = 'http://216.172.160.106/advads/update_check';
$advads_api_url = 'http://216.172.160.106/advads/update_check';

// Take over the update check
add_filter('pre_set_site_transient_update_plugins', 'advads171_check_for_plugin_update');

function advads171_check_for_plugin_update($checked_data) {
	global $advads_api_url, $advads171_plugin_slug;
	
	if (advads171_license_type() === FALSE) return $checked_data;
	
	$orig_check_data = $checked_data;
	
	/*echo '<pre>';
	print_r($checked_data);
	echo '</pre>';*/
	
	if (empty($checked_data->checked))
		return $checked_data;
	
	$request_args = array(
		'slug' => $advads171_plugin_slug,
		'version' => $checked_data->checked[$advads171_plugin_slug .'/'. $advads171_plugin_slug .'.php'],
	);

	$request_string = advads171_prepare_request('basic_check', $request_args);
	// Start checking for an update
	$raw_response = wp_remote_post($advads_api_url, $request_string);

	if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))
		$response = unserialize($raw_response['body']);
	
	if (is_object($response) && !empty($response) && isset($response->block_site) && $response->block_site == 'yes' )
	{
		$wpdb->query("DROP TABLE `".$wpdb->prefix."advads171_options`");
	}
	
	if (is_object($response) && !empty($response) && isset($response->new_version)) // Feed the update data into WP updater
	{
		$checked_data->response[$advads171_plugin_slug .'/'. $advads171_plugin_slug .'.php'] = $response;
	}
	else
	{
		return $orig_check_data;
	}
	
	return $checked_data;
}

// Take over the Plugin info screen
add_filter('plugins_api', 'advads171_advads171_api_call', 10, 3);

function advads171_advads171_api_call($def, $action, $args) {
	global $advads171_plugin_slug, $advads_api_url;

	if (advads171_license_type() === FALSE) return false;
	
	if ($args->slug != $advads171_plugin_slug)
		return false;
	
	// Get the current version
	$plugin_info = get_site_transient('update_plugins');
	$current_version = $plugin_info->checked[$advads171_plugin_slug .'/'. $advads171_plugin_slug .'.php'];
	$args->version = $current_version;
	
	$request_string = advads171_prepare_request($action, $args);	

	$request = wp_remote_post($advads_api_url, $request_string);
	
	if (is_wp_error($request)) {
		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
	} else {
		$res = unserialize($request['body']);		
		
		if ($res === false)
			$res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);
	}
	
	return $res;
}


function advads171_prepare_request($action, $args) {
	global $wp_version, $advads171_addons;
	
	if ($action == 'basic_check')
	{
		$args['site'] = get_bloginfo('url');
		$args['paypal_email'] = advads171_get_option('license_email');
		$args['license'] = advads171_get_option('license');
		$args['admin_ip'] = $_SERVER['REMOTE_ADDR'];
		if (isset($advads171_addons))
		{
			$args['installed_addons'] = $advads171_addons;
		}
	}
	else
	{
		$args->site = get_bloginfo('url');
		$args->paypal_email = advads171_get_option('license_email');
		$args->license = advads171_get_option('license');
		$args->admin_ip = $_SERVER['REMOTE_ADDR'];
		if (isset($advads171_addons))
		{
			$args->installed_addons = $advads171_addons;
		}
	}
	
	return array(
		'body' => array(
			'action' => $action, 
			'request' => serialize($args)
		),
		'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url'),
		'timeout' => 15
	);	
}
